/*
OuDiaSecond Copyright (C) 2017-2018 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// DiagramEdit.cpp : AvP[VpNX̋@\`s܂B
//$Id: DiagramEdit.cpp 418 2017-01-21 05:00:05Z okm $ 
/** @file */
#include "stdafx.h"


#include "str\strToInt.h"
#include "str\strToWstr.h"
#include "str\tstring.h"
#include "str\strprintf.h"
#include "dir\Directries.h"
#include "MfcUtil\MfcUtil.h"

#include "DiagramEdit.h"
#include "resource.h"
#include "CAboutBoxGpl.h"

#include "CDiagramEditDoc.h"
#include "CDiagramEditDoctmpl.h"

#include "entDed\CdDedJikoku.h"
#include "entDed\CdDedJikan.h"

#include "ViewEki\CEkiDoc.h"
#include "ViewEki\CEkiView.h"
#include "ViewRessyasyubetsu\CRessyasyubetsuDoc.h"
#include "ViewRessyasyubetsu\CRessyasyubetsuView.h"
#include "ViewJikokuhyou\CJikokuhyouDoc.h"
#include "ViewJikokuhyou\CJikokuhyouView.h"
#include "ViewDiagram\CDedDiagramDoc.h"
#include "ViewDiagram\CDedDiagramView.h"
#include "ViewComment\CDedCommentView.h"
#include "ViewEkiTrack2\CEkiTrack2Doc.h"
#include "ViewEkiTrack2\CEkiTrack2View.h"
#include "ViewOperationTable\COperationTableDoc.h"
#include "ViewOperationTable\COperationTableView.h"

#include "Print\CDlgPrintPageProp.h"
#include "ConvJikokuhyouCsv\CconvJikokuhyouCsv.h"
#include "ViewOperationTable\CconvOperationTableCsv.h"

using namespace std ;
using namespace OuMfc;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CDiagramEditApp
const TCHAR nameSection[] = _T( "AppProp" ) ;
const TCHAR namePrintPageProp[] = _T( "PrintPageProp" ) ;
const TCHAR nameLogLevel[] = _T( "LogLevel" ) ;

	// ================================
	//	֐
	// ================================
void CDiagramEditApp::readVersionResource( 
		tstring* pstrFileVersion , 
		tstring* pstrLegalCopyright )
{

	vector<TCHAR>	szInfo ;
	{
		TCHAR	szExeName[MAX_PATH] ;
		GetModuleFileName( NULL , szExeName , 
			sizeof(szExeName)/sizeof(szExeName[0]) ) ;
		DWORD	dwValue = 0 ;
		DWORD dwSize = GetFileVersionInfoSize( szExeName , &dwValue ) ;
		if ( dwSize > 0 )
		{ 
			szInfo.resize( dwSize ) ; 
			GetFileVersionInfo( szExeName , NULL , dwSize , &szInfo[0] ) ;
		}
	}
	tstring strFileVersion ;
	if ( szInfo.size() > 0 )
	{
		WORD	awVersion[4] = { 0 , 0 , 0 , 0 } ;
		VS_FIXEDFILEINFO*	pVS_FIXEDFILEINFO = NULL ;
		UINT uiLen = 0 ;
		VerQueryValue( &szInfo[0] , _T( "\\" ) , 
			(void**)&pVS_FIXEDFILEINFO , 
			&uiLen ) ;
		awVersion[0] = HIWORD( pVS_FIXEDFILEINFO->dwFileVersionMS ) ;
		awVersion[1] = LOWORD( pVS_FIXEDFILEINFO->dwFileVersionMS ) ;
		awVersion[2] = HIWORD( pVS_FIXEDFILEINFO->dwFileVersionLS ) ;
		awVersion[3] = LOWORD( pVS_FIXEDFILEINFO->dwFileVersionLS ) ;

		//	o[W𕶎
		int idxLength = 0 ;
		for ( idxLength = sizeof(awVersion) / sizeof(awVersion[0]) ;
			idxLength > 2 && awVersion[idxLength-1] == 0 ;
			idxLength -- ){}
		//idxLength = awVersion[] A0vf
		//	o[W 1.2.3.4 ȂA idxLength = 4
		//	o[W 1.2.3.0 ȂA idxLength = 3
		for ( int idx = 0 ; idx < idxLength ; idx ++ )
		{
			if ( !strFileVersion.empty() )
			{
				strFileVersion += _T(".") ;
			}

			if ( idx == 0 )
			{
				strFileVersion += strprintf(_T("%d") , awVersion[idx] ) ;
			}
			else
			{
				strFileVersion += strprintf(_T("%02d") , awVersion[idx] ) ;
			}
		}
	}
	tstring strLegalCopyright ;
	if ( szInfo.size() > 0 )
	{
		UINT uiLen = 0 ;
		const TCHAR* lpszLegalCopyright ;
		VerQueryValue( &szInfo[0] , _T( "\\StringFileInfo\\041104b0\\LegalCopyright" ) 
			, (void**)&lpszLegalCopyright , &uiLen ) ; 
		if ( uiLen > 0 )
		{
			strLegalCopyright = lpszLegalCopyright ;
		}
	}
	if ( pstrFileVersion != NULL ){	*pstrFileVersion = strFileVersion ;}
	if ( pstrLegalCopyright != NULL ){ *pstrLegalCopyright = strLegalCopyright ;}

}
	// ********************************
	//@name CDiagramEditApp-
	// ********************************
tstring CDiagramEditApp::getProgramVer()const 
{
	tstring strFileVersion ;
	readVersionResource( &strFileVersion , NULL  ) ; 
	return strFileVersion ;
}


// ********************************
//	CDiagramEditApp
// ********************************
CMainFrame*	CDiagramEditApp::getCMainFrame() 
{
	return ( (CMainFrame*)m_pMainWnd ) ;
}

CDlgRosenView*	CDiagramEditApp::getCDlgRosenView() 
{
	return ( getCMainFrame()->getCDlgRosenView() ) ;
}

CEkiDoc* CDiagramEditApp::openCEkiDoc( CEkiView** ppEkiView )
{
	if ( ppEkiView != NULL )
	{
		*ppEkiView = NULL ;
	}
	// --------------------------------
	CEkiDoc* pEkiDoc = (CEkiDoc*)m_pdoctmplEki->OpenDocumentFile( NULL ) ;

	if ( pEkiDoc != NULL && ppEkiView != NULL )
	{

		POSITION aPOSITION = pEkiDoc->GetFirstViewPosition() ;
		if ( aPOSITION != NULL ){
			*ppEkiView = (CEkiView*)pEkiDoc->GetNextView( aPOSITION ) ;
		}
	}
	return pEkiDoc ;
}

CRessyasyubetsuDoc* CDiagramEditApp::openCRessyasyubetsuDoc() 
{
	return (CRessyasyubetsuDoc*)m_pdoctmplResssyasyubetsu->OpenDocumentFile( NULL ) ;
}

CJikokuhyouDoc* CDiagramEditApp::openCJikokuhyouDoc( 
	const CentDedDia* pCentDedDia , 
	ERessyahoukou eRessyahoukou ,
	CJikokuhyouView** ppJikokuhyouView ) 
{
	int iRv = 0 ;
	CJikokuhyouDoc*	pCJikokuhyouDoc = NULL ;
	if ( ppJikokuhyouView != NULL )
	{
		*ppJikokuhyouView = NULL ;
	}
	// --------------------------------
	if ( iRv >= 0 )
	{
		const CentDedRosen* pCentDedRosen = 
			getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen() ;
		int idx = pCentDedRosen->getCentDedDiaCont()->findCentDedDiaByName( pCentDedDia->getName() ) ;
		if ( idx < 0 )
		{
			iRv = -1 ;	//	pCentDedDia ܂B
		}
	}
	if ( iRv >= 0 )
	{
		CString	strDocument ;
		strDocument.Format( _T("%s\n%d") , pCentDedDia->getName().c_str() , 
			(int)eRessyahoukou ) ;
		//strDocument= pCentDedDia ɑΉ"<_C>\n<ԕ>"
		
		CDocument*	pCDocument = m_pdoctmplJikokuhyou->OpenDocumentFile( strDocument ) ;
		if ( pCDocument != NULL )
		{
			pCJikokuhyouDoc = (CJikokuhyouDoc*)pCDocument ;
		}
		else
		{
			iRv = -2 ; //	pCentDedDia ɑΉ鎞\r[J܂B
		}
	}
	//pCJikokuhyouDoc = CJikokuhyouDocւ̃|C^
	if ( iRv >= 0 && ppJikokuhyouView != NULL )
	{
		POSITION aPOSITION = pCJikokuhyouDoc->GetFirstViewPosition() ;
		if ( aPOSITION != NULL ){
			*ppJikokuhyouView = (CJikokuhyouView*)pCJikokuhyouDoc
				->GetNextView( aPOSITION ) ;
		}
	}

	return ( pCJikokuhyouDoc ) ;
}

CDedDiagramDoc* CDiagramEditApp::openCDedDiagramDoc( const CentDedDia* pCentDedDia )
{
	const CentDedRosen* pCentDedRosen = 
		getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen() ;

	int idx = pCentDedRosen->getCentDedDiaCont()->findCentDedDiaByName( pCentDedDia->getName() ) ;
	if ( idx < 0 ){
		return NULL ;
	}

	CString	strDocument = pCentDedDia->getName().c_str() ;
	CDocument*	pCDocument = m_pdoctmplDiagram->OpenDocumentFile( strDocument ) ;
	
	return ( (CDedDiagramDoc*)pCDocument ) ;

}

CDedCommentDoc* CDiagramEditApp::openCDedCommentDoc() 
{
	return (CDedCommentDoc*)m_pdoctmplComment->OpenDocumentFile( NULL ) ;
}

CEkiTrack2Doc* CDiagramEditApp::openCEkiTrack2Doc(
	const CentDedEkiTrack2Cont* pCentDedEkiTrack2Cont,
	const int iEkiIndex)
{
	int iRv = 0;
	CEkiTrack2Doc*	pCEkiTrack2Doc = NULL;

	if (iEkiIndex < 0)
	{
		return NULL;
	}

	const CentDedRosen* pCentDedRosen =
		getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen();
	int iID = pCentDedRosen->getCentDedEkiCont()->get(iEkiIndex).getID();

	CString	strDocument;
	strDocument.Format (_T("%s\n%d\n%d"), pCentDedEkiTrack2Cont->getEki()->getEkimei().c_str(),
		iEkiIndex, iID);
	//strDocument= pCentDedEkiTrack2Cont ɑΉ"<w>\n<wIndex>\n<wID>"
	
	CDocument*	pCDocument = m_pdoctmplEkiTrack2->OpenDocumentFile(strDocument);
	return ((CEkiTrack2Doc*)pCDocument);
}

COperationTableDoc* CDiagramEditApp::openCOperationTableDoc(
	const CentDedDia* pCentDedDia,
	const tstring strOperationNumber)
{
	int iRv = 0;
	COperationTableDoc*	pCOperationTableDoc = NULL;

	if (strOperationNumber.empty())
	{
		return NULL;
	}

	CString	strDocument;
	strDocument.Format(_T("%s\n%s"), pCentDedDia->getName().c_str(),
		strOperationNumber.c_str());
	//strDocument= pCentDedDia ɑΉ"<_C>\n<^pԍ>"

	CDocument*	pCDocument = m_pdoctmplOperationTable->OpenDocumentFile(strDocument);
	return ((COperationTableDoc*)pCDocument);
}

CString CDiagramEditApp::getCFileDialogFilterOpen()
{
	//CString	strWinDIAFilter;
	//strWinDIAFilter.LoadString(IDS_WinDIAFilter);

	//OuDia
	//CString	strOriginalOuDiaFilter ;
	//strOriginalOuDiaFilter.LoadString( IDS_OriginalOuDiaFilter ) ;

	CString	strFilter;
	//OuDiaSecond
	//{
	//	CString	strFilterName;
	//	pRootDoctmpl()->GetDocString(strFilterName, CDocTemplate::filterName);
	//	CString	strExt;
	//	pRootDoctmpl()->GetDocString(strExt, CDocTemplate::filterExt);
	//	strFilter += strFilterName;
	//	strFilter += _T("|*");
	//	strFilter += strExt;
	//	strFilter += _T("|");

	//}
	//OuDia
	//{
	//	strFilter += strOriginalOuDiaFilter ;
	//}
	//OuDiaSecond&OuDia
	{
	//	CString	strFilterName;
	//	pRootDoctmpl()->GetDocString(strFilterName, CDocTemplate::filterName);
	//	CString	strExt;
	//	pRootDoctmpl()->GetDocString(strExt, CDocTemplate::filterExt);
	//	strFilter += strFilterName;
	//	strFilter += _T("|*");
	//	strFilter += strExt;
	//	strFilter += _T("|");
		strFilter = _T("OuDiaSecond ̧ (*.oud2;*.oud)|*.oud2;*.oud||");
	}
	//WinDIA
	//{
	//	strFilter += strWinDIAFilter;
	//}
	//all
	{
		CString allFilter;
		VERIFY(allFilter.LoadString(AFX_IDS_ALLFILTER));
		strFilter += allFilter;
		strFilter += _T("|");
		strFilter += _T("*.*");
		strFilter += _T("||");
	}
	return (strFilter);
}

CString CDiagramEditApp::getCFileDialogFilterSave()
{
	//OuDia
	CString	strOriginalOuDiaFilter;
	strOriginalOuDiaFilter.LoadString(IDS_OriginalOuDiaFilter);

	CString	strFilter;
	//OuDiaSecond
	{
		CString	strFilterName;
		pRootDoctmpl()->GetDocString(strFilterName, CDocTemplate::filterName);
		CString	strExt;
		pRootDoctmpl()->GetDocString(strExt, CDocTemplate::filterExt);
		strFilter += strFilterName;
		strFilter += _T("|*");
		strFilter += strExt;
		strFilter += _T("|");
	}
	//OuDia
	{
		strFilter += strOriginalOuDiaFilter;
	}
	//all
	{
		CString allFilter;
		VERIFY(allFilter.LoadString(AFX_IDS_ALLFILTER));
		strFilter += allFilter;
		strFilter += _T("|");
		strFilter += _T("*.*");
		strFilter += _T("||");
	}
	return (strFilter);
}


CString CDiagramEditApp::getCFileDialogFilterCsv() 
{
	CString	strWinDIAFilter ;
	strWinDIAFilter.LoadString( IDS_WinDIAFilter ) ;

	CString	strFilter ;
	//CSV
	{
		strFilter += MfcUtil::LoadCString( IDS_CSVFilter )  ;
	}
	//all
	{
		CString allFilter;
		VERIFY(allFilter.LoadString(AFX_IDS_ALLFILTER));
		strFilter += allFilter;
		strFilter += _T( "|" ) ;
		strFilter += _T("*.*");
		strFilter += _T( "||" ) ;
	}
	return ( strFilter ) ;
}

CconvJikokuhyouCsv CDiagramEditApp::createCconvJikokuhyouCsv() 
{
	return	CconvJikokuhyouCsv( 
		(LPCTSTR)MfcUtil::LoadCString( IDS_WORD_Kudari ) , 
		(LPCTSTR)MfcUtil::LoadCString( IDS_WORD_Nobori ) , 
		(LPCTSTR)MfcUtil::LoadCString( IDS_WORD_Ressyabangou ) , 
		(LPCTSTR)MfcUtil::LoadCString( IDS_WORD_RESSYASYUBETSU ) ,
		(LPCTSTR)MfcUtil::LoadCString( IDS_WORD_Ressyamei ) ,
		(LPCTSTR)MfcUtil::LoadCString( IDS_WORD_Gousuu ) ,
		(LPCTSTR)MfcUtil::LoadCString( IDS_WORD_GOUSUU2 ) ,
		(LPCTSTR)MfcUtil::LoadCString( IDS_WORD_Bikou ) ,
		(LPCTSTR)MfcUtil::LoadCString( IDS_WORD_Chaku ) ,
		(LPCTSTR)MfcUtil::LoadCString( IDS_WORD_Hatsu ) ,
		(LPCTSTR)MfcUtil::LoadCString( IDS_WORD_JIKOKUHYOU_TSUUKA ) , 
		(LPCTSTR)MfcUtil::LoadCString( IDS_WORD_JIKOKUHYOU_KEIYUNASI ), //"||"
		(LPCTSTR)MfcUtil::LoadCString( IDS_WORD_Track ) 
	);	

}

CconvOperationTableCsv CDiagramEditApp::createCconvOperationTableCsv()
{
	return	CconvOperationTableCsv(
		(LPCTSTR)MfcUtil::LoadCString(IDS_WORD_Ressyabangou),
		(LPCTSTR)MfcUtil::LoadCString(IDS_WORD_RESSYASYUBETSU),
		(LPCTSTR)MfcUtil::LoadCString(IDS_WORD_Ressyamei),
		(LPCTSTR)MfcUtil::LoadCString(IDS_WORD_Gousuu),
		(LPCTSTR)MfcUtil::LoadCString(IDS_WORD_GOUSUU2),
		(LPCTSTR)MfcUtil::LoadCString(IDS_WORD_Ekimei),
		(LPCTSTR)MfcUtil::LoadCString(IDS_WORD_Ekijikoku),
		(LPCTSTR)MfcUtil::LoadCString(IDS_WORD_KudariArrow),
		(LPCTSTR)MfcUtil::LoadCString(IDS_WORD_NoboriArrow)
	);

}
	// ********************************
	//@name	 - t@C
	// ********************************
CString CDiagramEditApp::makeProgramDirFilename( const CString& strFilename ) 
{
	CString	strProgramDir ;
	{
		TCHAR	szExe[MAX_PATH] ;
		GetModuleFileName( NULL , szExe , sizeof(szExe) ) ;
		strProgramDir = szExe ;
		int idx = strProgramDir.ReverseFind( _T( '\\' ) ) ;
		strProgramDir = strProgramDir.Left( idx + 1 ) ;
	}
	//strProgramDir = .exe t@ĈfBNg(:"c:\program files\oudia\" )B

	if ( strFilename.GetLength() > 0 )
	{
		strProgramDir += strFilename ;
	}
	return strProgramDir ;
}

CString CDiagramEditApp::makeLocalAppdataFilename( const CString& strFilename ) 
{
	CString	strLocalAppdataFolder ;
	{
		TCHAR	szPath[MAX_PATH] ;
		BOOL bResult = SHGetSpecialFolderPath( 
			NULL , 
			szPath , 
			CSIDL_LOCAL_APPDATA , 
			TRUE ) ;
		if ( bResult )
		{
			strLocalAppdataFolder = szPath ;
		}
		else
		{
			GetTempPath( sizeof(szPath) / sizeof(szPath[0] ) , szPath ) ;
			strLocalAppdataFolder = szPath ;
		}
		//	 '\\' ꍇ́A폜
		if ( strLocalAppdataFolder.GetLength() > 0 && 
			strLocalAppdataFolder[ strLocalAppdataFolder.GetLength() - 1 ] 
				== _T( '\\' ) )
		{
			strLocalAppdataFolder.Delete( 
				strLocalAppdataFolder.GetLength() - 1 ) ;
		}
	}
	//strLocalAppdataFolder = LocalAppData(擾łȂ΃e|fBNg)
	//	ɂ '\' ͂܂B

	strLocalAppdataFolder += _T( "\\OuDiaSecond\\" ) ; //edit_by_d_mania
	//strLocalAppdataFolder = OuDiaLocalAppDatatH_B
	//	ɂ '\\' ܂B
	//	̃fBNǵA쐬Ă܂B

	if ( strFilename.GetLength() > 0 )
	{
		strLocalAppdataFolder += strFilename ;
	}
	return strLocalAppdataFolder ;
}


CString CDiagramEditApp::makeHtmlHelpUrl( const CString& strTopic ) 
{
	CString strHtmlHelpUrl = makeProgramDirFilename( _T( "oudia.chm" ) ) ;
	if ( !strTopic.IsEmpty() )
	{
		strHtmlHelpUrl += _T( "::" ) ;
		strHtmlHelpUrl += strTopic ;
	}
	return strHtmlHelpUrl ;
}


	// ********************************
	//@name	- .ini t@C
	// ********************************
const TCHAR nameCWndDiagram_DiagramPosDgr[] = _T("DiagramPosDgr") ;
const TCHAR nameCWndDiagram_DcdPerDgrX[] = _T("DcdPerDgrX") ;
const TCHAR nameCWndDiagram_DcdPerDgrY[] = _T("DcdPerDgrY") ;

const TCHAR nameCWndDiagram_VlineMode[] = _T("DiagramVlineMode") ;
const TCHAR nameCWndDiagram_DisplayRessyabangou[] = 
	_T("DiagramDisplayRessyabangou") ;
const TCHAR nameCWndDiagram_DisplayRessyamei[] = 
	_T("DiagramDisplayRessyamei") ;
const TCHAR nameCWndDiagram_DisplayRessyasen[] = 
	_T("DiagramDisplayRessyasen") ;
const TCHAR nameCWndDiagram_HideIppanekiEkimei[] = 
	_T("DiagramHideIppanekiEkimei") ;
const TCHAR nameCWndDiagram_StopMarkDraw[] = 
	_T("DiagramStopMarkDraw") ;
const TCHAR nameCWndDiagram_KeepZoneDgrOnSize[] = 
	_T("DiagramKeepZoneDgrOnSize") ;
const TCHAR nameDisplayParentSyubetsu[] =
_T("DisplayParentSyubetsu");

int CDiagramEditApp::writeCWndDiagramViewProp( const CWndDiagram* pCWndDiagram )
{
	int iRv = 0 ;
	
	//擾
	CdDcdPosXy	posPosDgr = pCWndDiagram->getPosDgr() ;
	double	dDcdPerDgrX = pCWndDiagram->getDcdPerDgrX() ;
	double	dDcdPerDgrY = pCWndDiagram->getDcdPerDgrY() ;

	int idxVlineMode = pCWndDiagram->getVlineMode() ;
	bool	bDisplayRessyabangou = pCWndDiagram->getDisplayRessyabangou() ;
	bool	bDisplayRessyamei = pCWndDiagram->getDisplayRessyamei() ;
	bool bDisplayRessyasenKudari = 
		pCWndDiagram->getDisplayRessyasen( Ressyahoukou_Kudari ) ;
	bool bDisplayRessyasenNobori = 
		pCWndDiagram->getDisplayRessyasen( Ressyahoukou_Nobori ) ;
	bool bHideIppanekiEkimei = 
		pCWndDiagram->getHideIppanekiEkimei() ;
	CDcdDiagram::EStopMarkDraw eStopMarkDraw = pCWndDiagram->getStopMarkDraw() ;
	bool bKeepZoneDgrOnSize = pCWndDiagram->getKeepZoneDgrOnSize() ;
	bool bDisplayParentSyubetsu = pCWndDiagram->getDisplayParentSyubetsu();
	// --------------------------------
	//DiagramPosDgr
	if ( iRv >= 0 )
	{
		tstring	strValue ;
		strValue += stringOf( posPosDgr.getX() ) ;
		strValue += ',' ;
		strValue += stringOf( posPosDgr.getY() ) ;
		WriteProfileString( 
			nameSection , 
			nameCWndDiagram_DiagramPosDgr , 
			strValue.c_str() ) ;
	}
	//"DcdPerDgrX" ;
	{
		tstring	strValue ;
		strValue += stringOf( dDcdPerDgrX ) ;
		WriteProfileString( 
			nameSection , 
			nameCWndDiagram_DcdPerDgrX , 
			strValue.c_str() ) ;
	}

	//"DcdPerDgrY" ;
	{
		tstring	strValue ;
		strValue += stringOf( dDcdPerDgrY ) ;
		WriteProfileString( 
			nameSection , 
			nameCWndDiagram_DcdPerDgrY , 
			strValue.c_str() ) ;
	}


	//DiagramVlineMode
	if ( iRv >= 0 ){
		tstring	strValue ;
		strValue += stringOf( idxVlineMode ) ;
		WriteProfileString( nameSection , nameCWndDiagram_VlineMode , 
			strValue.c_str() ) ;
	}
	
	//DisplayRessyabangou
	if ( iRv >= 0 ){
		tstring	strValue ;
		strValue += stringOf( bDisplayRessyabangou ) ;
		WriteProfileString( nameSection , nameCWndDiagram_DisplayRessyabangou ,
			strValue.c_str() ) ;
	}
	
	//DisplayRessyamei
	if ( iRv >= 0 ){
		tstring	strValue ;
		strValue += stringOf( bDisplayRessyamei ) ;
		WriteProfileString( nameSection , nameCWndDiagram_DisplayRessyamei ,
			strValue.c_str() ) ;
	}
	
	//DisplayRessyasen
	if ( iRv >= 0 ){
		tstring	strValue ;
		strValue += ( bDisplayRessyasenKudari ? _T("1") : _T("0") ) ;
		strValue += ',' ;
		strValue += ( bDisplayRessyasenNobori ? _T("1") : _T("0") ) ;
		WriteProfileString( nameSection , nameCWndDiagram_DisplayRessyasen ,
			strValue.c_str() ) ;
	}
	//DiagramHideIppanekiEkimei
	if ( iRv >= 0 )
	{
		tstring	strValue = ( bHideIppanekiEkimei ? _T("1") : _T("0") ) ;
		WriteProfileString( nameSection , nameCWndDiagram_HideIppanekiEkimei ,
			strValue.c_str() ) ;
	}
	//DiagramStopMarkDraw
	if ( iRv >= 0 )
	{
		tstring strValue = stringOf( (int)eStopMarkDraw ) ;
		WriteProfileString( nameSection , nameCWndDiagram_StopMarkDraw , 
			strValue.c_str() ) ;
	}
	//DiagramKeepZoneDgrOnSize
	if ( iRv >= 0 )
	{
		tstring strValue = ( bKeepZoneDgrOnSize ? _T("1") : _T("0") ) ;
		WriteProfileString( nameSection , nameCWndDiagram_KeepZoneDgrOnSize ,
			strValue.c_str() ) ;
	}
	//DisplayParentSyubetsu
	if (iRv >= 0)
	{
		tstring strValue = (bDisplayParentSyubetsu ? _T("1") : _T("0"));
		WriteProfileString(nameSection, nameDisplayParentSyubetsu,
			strValue.c_str());
	}
	return ( iRv ) ;
}

int CDiagramEditApp::readCWndDiagramViewProp( CWndDiagram* pCWndDiagram ) 
{
	int iRv = 0 ;

	CdDcdPosXy	posPosDgr( 0 , 0 ) ;
	double	dDcdPerDgrX = CDcdDiagram::DEFAULT_DCD_PER_DGR_X() ;
	double	dDcdPerDgrY = CDcdDiagram::DEFAULT_DCD_PER_DGR_Y() ;

	int idxVlineMode = 1 ;
	bool bDisplayRessyabangou = false ;
	bool bDisplayRessyamei = false ;
	bool bDisplayRessyasenKudari = true ;
	bool bDisplayRessyasenNobori = true ;
	bool bHideIppanekiEkimei = false ;
	CDcdDiagram::EStopMarkDraw eStopMarkDraw = CDcdDiagram::EStopMarkDraw_Nothing ;
	bool bKeepZoneDgrOnSize = false ;
	bool bDisplayParentSyubetsu = false;
	// --------------------------------
	//DiagramPosDgr
	if ( iRv >= 0 )
	{
		tstring	strValue = GetProfileString( nameSection , 
			nameCWndDiagram_DiagramPosDgr ) ;
		deque<tstring>	contstrValue = 
			splitc< deque< tstring > >( ',' , strValue ) ;
		if ( contstrValue.size() != 2 )
		{
			iRv = -1 ;	//	DiagramPosDgr w肳Ă܂B
		}
		else
		{
			int iXPos  = intOf( contstrValue[0] ) ;
			int iYPos  = intOf( contstrValue[1] ) ;
			posPosDgr.setX( iXPos ).setY( iYPos ) ;
		}
	}
	//DcdPerDgrX
	if ( iRv >= 0 ){
		tstring	strValue = GetProfileString( nameSection , 
			nameCWndDiagram_DcdPerDgrX ) ;
		if ( strValue.empty() ){
			iRv = -2 ;	//	DcdPerDgrX w肳Ă܂B
		}	else	{
			dDcdPerDgrX = doubleOf( strValue ) ; 
		}
	}
	//DcdPerDgrY
	if ( iRv >= 0 ){
		tstring	strValue = GetProfileString( nameSection , 
			nameCWndDiagram_DcdPerDgrY ) ;
		if ( strValue.empty() ){
			iRv = -2 ;	//	DcdPerDgrY w肳Ă܂B
		}	else	{
			dDcdPerDgrY = doubleOf( strValue ) ; 
		}
	}



	//DiagramVlineMode
	if ( iRv >= 0 ){
		tstring	strValue = GetProfileString( nameSection , 
			nameCWndDiagram_VlineMode ) ;
		if ( strValue.empty() ){
			iRv = -2 ;	//	DiagramVlineMode w肳Ă܂B
		}	else	{
			idxVlineMode = intOf( strValue ) ; 
		}
	}

	//DisplayRessyabangou
	if ( iRv >= 0 )
	{
		tstring	strValue = GetProfileString( nameSection , 
			nameCWndDiagram_DisplayRessyabangou ) ;
		if ( strValue.empty() )
		{
			iRv = -3 ;	//	DisplayRessyabangou w肳Ă܂B
		}
		else
		{
			bDisplayRessyabangou = ( intOf( strValue ) != 0 ); 
		}
	}

	//DisplayRessyamei
	if ( iRv >= 0 ){
		tstring	strValue = GetProfileString( nameSection , 
			nameCWndDiagram_DisplayRessyamei ) ;
		if ( strValue.empty() ){
			iRv = -4 ;	//	DisplayRessyamei w肳Ă܂B
		}	else	{
			bDisplayRessyamei = ( intOf( strValue ) != 0 ); 
		}
	}
	//DisplayRessyasen
	if ( iRv >= 0 )
	{
		tstring	strValue = GetProfileString( 
			nameSection , nameCWndDiagram_DisplayRessyasen ) ;
		deque<tstring>	contstrValue = 
			splitc< deque< tstring > >( ',' , strValue ) ;
		if ( contstrValue.size() != 2 )
		{
			iRv = -5 ;	//	DisplayRessyasen w肳Ă܂B
		}
		else
		{
			bDisplayRessyasenKudari = ( contstrValue[0] == _T("1") ) ;
			bDisplayRessyasenNobori = ( contstrValue[1] == _T("1") ) ;
		}
	}
	//DiagramHideIppanekiEkimei
	if ( iRv >= 0 )
	{
		tstring	strValue = GetProfileString( 
			nameSection , nameCWndDiagram_HideIppanekiEkimei ) ;
		if ( strValue.empty() )
		{
			iRv = -6 ;	//	HideIppanekiEkimei w肳Ă܂B
		}
		else
		{
			bHideIppanekiEkimei = ( intOf( strValue ) != 0 ) ;
		}
	}
	//DiagramStopMarkDraw
	if ( iRv >= 0 )
	{
		tstring	strValue = GetProfileString( 
			nameSection , nameCWndDiagram_StopMarkDraw ) ;
		if ( strValue.empty() )
		{
			iRv = -7 ;	//	StopMarkDraw w肳Ă܂B
		}
		else
		{
			eStopMarkDraw = (CDcdDiagram::EStopMarkDraw)intOf( strValue ) ;
		}
	}
	//DiagramKeepZoneDgrOnSize
	if ( iRv >= 0 )
	{
		tstring	strValue = GetProfileString( 
			nameSection , nameCWndDiagram_KeepZoneDgrOnSize ) ;
		if ( strValue.empty() )
		{
			iRv = -8 ;	//	KeepZoneDgrOnSize w肳Ă܂B
		}
		else
		{
			bKeepZoneDgrOnSize = (intOf( strValue )!=0) ;
		}
	}
	//DisplayParentSyubetsu
	if (iRv >= 0)
	{
		tstring	strValue = GetProfileString(
			nameSection, nameDisplayParentSyubetsu);
		if (strValue.empty())
		{
			iRv = -9;	//	DisplayParentSyubetsu w肳Ă܂B
		}
		else
		{
			bDisplayParentSyubetsu = (intOf(strValue) != 0);
		}
	}
	// --------------------------------
	if ( iRv >= 0 )
	{
		pCWndDiagram->setPosDgr( posPosDgr ) ;
		pCWndDiagram->setDcdPerDgrX( dDcdPerDgrX ) ;
		pCWndDiagram->setDcdPerDgrY( dDcdPerDgrY ) ;

		pCWndDiagram->setVlineMode( idxVlineMode ) ;
		pCWndDiagram->setDisplayRessyabangou( bDisplayRessyabangou ) ;
		pCWndDiagram->setDisplayRessyamei( bDisplayRessyamei ) ;
		pCWndDiagram->setDisplayRessyasen( Ressyahoukou_Kudari , 
			 bDisplayRessyasenKudari ) ;
		pCWndDiagram->setDisplayRessyasen( Ressyahoukou_Nobori , 
			 bDisplayRessyasenNobori ) ;
		pCWndDiagram->setHideIppanekiEkimei( bHideIppanekiEkimei ) ;
		pCWndDiagram->setStopMarkDraw( eStopMarkDraw ) ;
		pCWndDiagram->setKeepZoneDgrOnSize( bKeepZoneDgrOnSize ) ;
		pCWndDiagram->setDisplayParentSyubetsu(bDisplayParentSyubetsu);
	}
	
	return ( iRv ) ;
}

const TCHAR nameCWndJikokuhyou_DisplayTsuukaEkiJikoku[] = 
	_T( "Jikokuhyou_DisplayTsuukaEkiJikoku" ) ;
const TCHAR nameCWndJikokuhyou_DisplayAllEkiJikoku[] = 
	_T( "Jikokuhyou_DisplayAllEkiJikoku" ) ;
const TCHAR nameCWndJikokuhyou_EkijikokuSort[] = 
	_T( "Jikokuhyou_EkijikokuSort" );
const TCHAR nameCWndJikokuhyou_ModifyEkijikoku[] = 
	_T( "Jikokuhyou_ModifyEkiJikoku" );
//add_by_d_mania
const TCHAR nameCWndJikokuhyou_DisplaySecondEkiJikoku[] = 
	_T( "Jikokuhyou_DisplaySecondEkiJikoku" ) ;
const TCHAR nameCWndJikokuhyou_StandardOperationTimeFunction[] = 
	_T( "Jikokuhyou_StandardOperationTimeFunction" ) ;
const TCHAR nameCWndJikokuhyou_DisplayAllTrack[] =
	_T("Jikokuhyou_DisplayAllTrack");
const TCHAR nameCWndJikokuhyou_DisplayShihatsuShuchakuEkimei[] =
	_T("Jikokuhyou_DisplayShihatsuShuchakuEkimei");
const TCHAR nameCWndJikokuhyou_DisplayColonEkiJikoku[] =
_T("Jikokuhyou_DisplayColonEkiJikoku");

int CDiagramEditApp::writeCWndJikokuhyouViewProp( const CWndJikokuhyou* pCWndJikokuhyou ) 
{
	int iRv = 0 ;
	
	//擾
	bool	bDisplayTsuukaEkiJikoku = pCWndJikokuhyou->getDisplayTsuukaEkiJikoku() ;
	bool	bDisplayAllEkiJikoku = pCWndJikokuhyou->getDisplayAllEkiJikoku() ;
	CWndJikokuhyou::EEkijikokuSort	eEkijikokuSort = pCWndJikokuhyou->getEkijikokuSort() ;
	bool bModifyEkijikoku = pCWndJikokuhyou->getModifyEkijikoku() ;
	//add_by_d_mania
	bool	bDisplaySecondEkiJikoku = pCWndJikokuhyou->getDisplaySecondEkiJikoku( );
	bool	bStandardOperationTimeFunction = pCWndJikokuhyou->getStandardOperationTimeFunction() ;
	bool	bDisplayAllTrack = pCWndJikokuhyou->getDisplayAllTrack();
	bool	bDisplayShihatsuShuchakuEkimei = pCWndJikokuhyou->getDisplayShihatsuShuchakuEkimei();
	bool	bDisplayColonEkiJikoku = pCWndJikokuhyou->getDisplayColonEkiJikoku();
	bool	bDisplayParentSyubetsu = pCWndJikokuhyou->getDisplayParentSyubetsu();
	// --------------------------------

	//DisplayTsuukaEkiJikoku
	if ( iRv >= 0 )
	{
		tstring	strValue ;
		strValue += stringOf( bDisplayTsuukaEkiJikoku ? 1 : 0 ) ;
		WriteProfileString( nameSection , nameCWndJikokuhyou_DisplayTsuukaEkiJikoku ,
			tstringOf( strValue ).c_str() ) ;
	}
	//DisplayAllEkiJikoku
	{
		tstring	strValue ;
		strValue += stringOf( bDisplayAllEkiJikoku ) ;
		WriteProfileString( nameSection , nameCWndJikokuhyou_DisplayAllEkiJikoku ,
			tstringOf( strValue ).c_str() ) ;
	}
	//EkijikokuSort
	if ( iRv >= 0 )
	{
		tstring strValue ;
		strValue += stringOf( (int)eEkijikokuSort ) ;
		WriteProfileString( nameSection , nameCWndJikokuhyou_EkijikokuSort ,
			tstringOf( strValue ).c_str() ) ;
	}

	//ModifyEkijikoku
	if ( iRv >= 0 )
	{
		tstring strValue ;
		strValue = ( bModifyEkijikoku ? _T( "1" ) : _T( "0" ) ) ;
		WriteProfileString( nameSection , nameCWndJikokuhyou_ModifyEkijikoku ,
			tstringOf( strValue ).c_str() ) ;
	}
	//DisplaySecondEkiJikoku//add_by_d_mania
	if ( iRv >= 0 )
	{
		tstring	strValue ;
		strValue += stringOf( bDisplaySecondEkiJikoku ? 1 : 0 ) ;
		WriteProfileString( nameSection , nameCWndJikokuhyou_DisplaySecondEkiJikoku ,
			tstringOf( strValue ).c_str() ) ;
	}
	//StandardOperationTimeFunction//add_by_d_mania
	if ( iRv >= 0 )
	{
		tstring	strValue ;
		strValue += stringOf( bStandardOperationTimeFunction ? 1 : 0 ) ;
		WriteProfileString( nameSection , nameCWndJikokuhyou_StandardOperationTimeFunction ,
			tstringOf( strValue ).c_str() ) ;
	}
	//DisplayAllTrack
	{
		tstring	strValue;
		strValue += stringOf(bDisplayAllTrack);
		WriteProfileString(nameSection, nameCWndJikokuhyou_DisplayAllTrack,
			tstringOf(strValue).c_str());
	}
	//DisplayShihatsuShuchakuEkimei
	{
		tstring	strValue;
		strValue += stringOf(bDisplayShihatsuShuchakuEkimei);
		WriteProfileString(nameSection, nameCWndJikokuhyou_DisplayShihatsuShuchakuEkimei,
			tstringOf(strValue).c_str());
	}
	//DisplayColonEkiJikoku
	if (iRv >= 0)
	{
		tstring	strValue;
		strValue += stringOf(bDisplayColonEkiJikoku ? 1 : 0);
		WriteProfileString(nameSection, nameCWndJikokuhyou_DisplayColonEkiJikoku,
			tstringOf(strValue).c_str());
	}
	//DisplayParentSyubetsu
	if (iRv >= 0)
	{
		tstring	strValue;
		strValue += stringOf(bDisplayParentSyubetsu ? 1 : 0);
		WriteProfileString(nameSection, nameDisplayParentSyubetsu,
			tstringOf(strValue).c_str());
	}
	return ( iRv ) ;
}
int CDiagramEditApp::readCWndJikokuhyouViewProp( CWndJikokuhyou* pCWndJikokuhyou ) 
{
	int iRv = 0 ;
	bool	bDisplayTsuukaEkiJikoku = true  ;
	bool 	bDisplayAllEkiJikoku = false ;
	CWndJikokuhyou::EEkijikokuSort	eEkijikokuSort = CWndJikokuhyou::EEkijikokuSort_Ekiatsukai ;
	bool	bModifyEkijikoku = true ;
	//add_by_d_mania
	bool	bDisplaySecondEkiJikoku = false ;
	bool	bStandardOperationTimeFunction = false ;
	bool 	bDisplayAllTrack = false;
	bool 	bDisplayShihatsuShuchakuEkimei = false;
	bool	bDisplayColonEkiJikoku = false;
	bool	bDisplayParentSyubetsu = false;
	

	// --------------------------------
	//DisplayTsuukaEkiJikoku
	if ( iRv >= 0 )
	{
		tstring	strValue = tstringOf( (LPCTSTR)GetProfileString( 
			nameSection , nameCWndJikokuhyou_DisplayTsuukaEkiJikoku ) ) ;
		if ( strValue.empty() )
		{
			iRv = -1 ;	//	DisplayTsuukaEkiJikoku w肳Ă܂B
		}
		else
		{
			bDisplayTsuukaEkiJikoku = ( intOf( strValue ) != 0 ) ;
		}
	}
	//DisplayAllEkiJikoku
	{
		tstring	strValue = tstringOf( (LPCTSTR)GetProfileString( 
			nameSection , nameCWndJikokuhyou_DisplayAllEkiJikoku ) );
		if ( strValue.empty() )
		{
			iRv = -1 ;	//	DisplayAllEkiJikoku w肳Ă܂B
		}
		else
		{
			bDisplayAllEkiJikoku = ( intOf( strValue ) != 0 ) ;
		}
	}
	//EkijikokuSort
	if ( iRv >= 0 )
	{
		tstring	strValue = tstringOf( (LPCTSTR)GetProfileString( 
			nameSection , nameCWndJikokuhyou_EkijikokuSort ) ) ;
		if ( strValue.empty() )
		{
			iRv = -1 ;	//	EkijikokuSort w肳Ă܂B
		}
		else
		{
			int iValue = intOf( strValue ) ;
			switch( iValue )
			{
			case (int)CWndJikokuhyou::EEkijikokuSort_Ekiatsukai :
				eEkijikokuSort = CWndJikokuhyou::EEkijikokuSort_Ekiatsukai ;
				break ;
			case (int)CWndJikokuhyou::EEkijikokuSort_Transfer :
				eEkijikokuSort = CWndJikokuhyou::EEkijikokuSort_Transfer ;
				break ;
			}
		}
	}
	//ModifyEkijikoku
	if ( iRv >= 0 )
	{
		tstring	strValue = GetProfileString( 
			nameSection , nameCWndJikokuhyou_ModifyEkijikoku ) ;
		if ( strValue.empty() )
		{
			iRv = -1 ;	//	ModifyEkijikoku w肳Ă܂B
		}
		else
		{
			int iValue = intOf( strValue ) ;
			bModifyEkijikoku = ( iValue != 0 ) ;
		}
	}
	//DisplaySecondEkiJikoku//add_by_d_mania
	if ( iRv >= 0 )
	{
		tstring	strValue = tstringOf( (LPCTSTR)GetProfileString( 
			nameSection , nameCWndJikokuhyou_DisplaySecondEkiJikoku ) ) ;
		if ( strValue.empty() )
		{
			iRv = -1 ;	//	DisplaySecondEkiJikoku w肳Ă܂B
		}
		else
		{
			bDisplaySecondEkiJikoku = ( intOf( strValue ) != 0 ) ;
		}
	}
	//StandardOperationTimeFunction//add_by_d_mania
	if ( iRv >= 0 )
	{
		tstring	strValue = tstringOf( (LPCTSTR)GetProfileString( 
			nameSection , nameCWndJikokuhyou_StandardOperationTimeFunction ) ) ;
		if ( strValue.empty() )
		{
			iRv = -1 ;	//	StandardOperationTimeFunction w肳Ă܂B
		}
		else
		{
			bStandardOperationTimeFunction = ( intOf( strValue ) != 0 ) ;
		}
	}
	//DisplayAllTrack
	if (iRv >= 0)
	{
		tstring	strValue = tstringOf((LPCTSTR)GetProfileString(
			nameSection, nameCWndJikokuhyou_DisplayAllTrack));
		if (strValue.empty())
		{
			iRv = -1;	//	DisplayAllTrack w肳Ă܂B
		}
		else
		{
			bDisplayAllTrack = (intOf(strValue) != 0);
		}
	}
	//DisplayShihatsuShuchakuEkimei
	if (iRv >= 0)
	{
		tstring	strValue = tstringOf((LPCTSTR)GetProfileString(
			nameSection, nameCWndJikokuhyou_DisplayShihatsuShuchakuEkimei));
		if (strValue.empty())
		{
			iRv = -1;	//	DisplayAllTrack w肳Ă܂B
		}
		else
		{
			bDisplayShihatsuShuchakuEkimei = (intOf(strValue) != 0);
		}
	}
	//DisplayColonEkiJikoku
	if (iRv >= 0)
	{
		tstring	strValue = tstringOf((LPCTSTR)GetProfileString(
			nameSection, nameCWndJikokuhyou_DisplayColonEkiJikoku));
		if (strValue.empty())
		{
			iRv = -1;	//	DisplayColonEkiJikoku w肳Ă܂B
		}
		else
		{
			bDisplayColonEkiJikoku = (intOf(strValue) != 0);
		}
	}
	//DisplayParentSyubetsu
	if (iRv >= 0)
	{
		tstring	strValue = tstringOf((LPCTSTR)GetProfileString(
			nameSection, nameDisplayParentSyubetsu));
		if (strValue.empty())
		{
			iRv = -1;	//	DisplayColonEkiJikoku w肳Ă܂B
		}
		else
		{
			bDisplayParentSyubetsu = (intOf(strValue) != 0);
		}
	}
	// --------------------------------
	if ( iRv >= 0 )
	{
		pCWndJikokuhyou->setDisplayTsuukaEkiJikoku( bDisplayTsuukaEkiJikoku ) ;
		pCWndJikokuhyou->setDisplayAllEkiJikoku( bDisplayAllEkiJikoku ) ;
		pCWndJikokuhyou->setEkijikokuSort( eEkijikokuSort ) ;
		pCWndJikokuhyou->setModifyEkijikoku( bModifyEkijikoku ) ;
		//add_by_d_mania
		pCWndJikokuhyou->setDisplaySecondEkiJikoku( bDisplaySecondEkiJikoku ) ;
		pCWndJikokuhyou->setStandardOperationTimeFunction( bStandardOperationTimeFunction ) ;
		pCWndJikokuhyou->setDisplayAllTrack(bDisplayAllTrack);
		pCWndJikokuhyou->setDisplayShihatsuShuchakuEkimei(bDisplayShihatsuShuchakuEkimei);
		pCWndJikokuhyou->setDisplayColonEkiJikoku(bDisplayColonEkiJikoku);
		pCWndJikokuhyou->setDisplayParentSyubetsu(bDisplayParentSyubetsu);
	}


	return ( iRv ) ;
}

int CDiagramEditApp::writeCWndDcdGridOperationTableViewProp(const CWndDcdGridOperationTable* pCWndDcdGridOperationTable)
{
	int iRv = 0;

	//擾
	bool	bDisplaySecondEkiJikoku = pCWndDcdGridOperationTable->getDisplaySecondEkiJikoku();
	bool	bDisplayColonEkiJikoku = pCWndDcdGridOperationTable->getDisplayColonEkiJikoku();
	bool	bDisplayParentSyubetsu = pCWndDcdGridOperationTable->getDisplayParentSyubetsu();
	// --------------------------------


	//DisplaySecondEkiJikoku//add_by_d_mania
	if (iRv >= 0)
	{
		tstring	strValue;
		strValue += stringOf(bDisplaySecondEkiJikoku ? 1 : 0);
		WriteProfileString(nameSection, nameCWndJikokuhyou_DisplaySecondEkiJikoku,
			tstringOf(strValue).c_str());
	}
	//DisplayColonEkiJikoku
	if (iRv >= 0)
	{
		tstring	strValue;
		strValue += stringOf(bDisplayColonEkiJikoku ? 1 : 0);
		WriteProfileString(nameSection, nameCWndJikokuhyou_DisplayColonEkiJikoku,
			tstringOf(strValue).c_str());
	}
	//DisplayParentSyubetsu
	if (iRv >= 0)
	{
		tstring	strValue;
		strValue += stringOf(bDisplayParentSyubetsu ? 1 : 0);
		WriteProfileString(nameSection, nameDisplayParentSyubetsu,
			tstringOf(strValue).c_str());
	}
	return (iRv);
}
int CDiagramEditApp::readCWndDcdGridOperationTableViewProp(CWndDcdGridOperationTable* pCWndDcdGridOperationTable)
{
	int iRv = 0;
	bool	bDisplaySecondEkiJikoku = false;
	bool	bDisplayColonEkiJikoku = false;
	bool	bDisplayParentSyubetsu = false;


	// --------------------------------

	//DisplaySecondEkiJikoku//add_by_d_mania
	if (iRv >= 0)
	{
		tstring	strValue = tstringOf((LPCTSTR)GetProfileString(
			nameSection, nameCWndJikokuhyou_DisplaySecondEkiJikoku));
		if (strValue.empty())
		{
			iRv = -1;	//	DisplaySecondEkiJikoku w肳Ă܂B
		}
		else
		{
			bDisplaySecondEkiJikoku = (intOf(strValue) != 0);
		}
	}

	//DisplayColonEkiJikoku
	if (iRv >= 0)
	{
		tstring	strValue = tstringOf((LPCTSTR)GetProfileString(
			nameSection, nameCWndJikokuhyou_DisplayColonEkiJikoku));
		if (strValue.empty())
		{
			iRv = -1;	//	DisplayColonEkiJikoku w肳Ă܂B
		}
		else
		{
			bDisplayColonEkiJikoku = (intOf(strValue) != 0);
		}
	}
	//DisplayParentSyubetsu
	if (iRv >= 0)
	{
		tstring	strValue = tstringOf((LPCTSTR)GetProfileString(
			nameSection, nameDisplayParentSyubetsu));
		if (strValue.empty())
		{
			iRv = -1;	//	DisplayColonEkiJikoku w肳Ă܂B
		}
		else
		{
			bDisplayParentSyubetsu = (intOf(strValue) != 0);
		}
	}
	// --------------------------------
	if (iRv >= 0)
	{
		pCWndDcdGridOperationTable->setDisplaySecondEkiJikoku(bDisplaySecondEkiJikoku);
		pCWndDcdGridOperationTable->setDisplayColonEkiJikoku(bDisplayColonEkiJikoku);
		pCWndDcdGridOperationTable->setDisplayParentSyubetsu(bDisplayParentSyubetsu);
	}


	return (iRv);
}

const TCHAR nameCWndDcdGridEkiProp_AdjustByEkijikokukeisiki[] = 
	_T( "EkiProp_AdjustByEkijikokukeisiki" ) ;


int CDiagramEditApp::writeCWndDcdGridEkiProp( 
		const CWndDcdGridEki* pCWndDcdGridEki ) 
{
	int iRv = 0 ;

	//擾
	bool bAdjustByEkijikokukeisiki = pCWndDcdGridEki->getAdjustByEkijikokukeisiki() ;
	// --------------------------------

	//EkiProp_AdjustByEkijikokukeisiki
	if ( iRv >= 0 )
	{
		tstring strValue ;
		strValue += stringOf( bAdjustByEkijikokukeisiki ? 1:0 ) ;
		WriteProfileString( nameSection , nameCWndDcdGridEkiProp_AdjustByEkijikokukeisiki ,
			tstringOf( strValue ).c_str() ) ;
	}


	return iRv ;
}
int CDiagramEditApp::readCWndDcdGridEkiProp( 
		CWndDcdGridEki* pCWndDcdGridEki ) 
{
	int iRv = 0 ;
	bool	bAdjustByEkijikokukeisiki = true  ;
	//EkiProp_AdjustByEkijikokukeisiki
	if ( iRv >= 0 )
	{
		tstring	strValue = tstringOf( (LPCTSTR)GetProfileString( 
			nameSection , nameCWndDcdGridEkiProp_AdjustByEkijikokukeisiki ) ) ;
		if ( strValue.empty() )
		{
			iRv = -1 ;	//	EkiProp_AdjustByEkijikokukeisiki w肳Ă܂B
		}
		else
		{
			bAdjustByEkijikokukeisiki = ( intOf( strValue ) != 0 ) ;
		}
	}
	// --------------------------------
	if ( iRv >= 0 )
	{
		pCWndDcdGridEki->setAdjustByEkijikokukeisiki( bAdjustByEkijikokukeisiki ) ;
	}
	return iRv ;
}

const TCHAR nameCDiagramEdit_BackupEnable[] =
_T("BackupEnable");

int CDiagramEditApp::writeCDiagramEditProp()
{
	int iRv = 0;

	//擾
	bool	bBackupEnable = getCDiagramEditDoc()->getBackupEnable();
	// --------------------------------


	//BackupEnable
	if (iRv >= 0)
	{
		tstring	strValue;
		strValue += stringOf(bBackupEnable ? 1 : 0);
		WriteProfileString(nameSection, nameCDiagramEdit_BackupEnable,
			tstringOf(strValue).c_str());
	}
	return (iRv);
}

int CDiagramEditApp::readCDiagramEditProp()
{
	int iRv = 0;
	bool	bBackupEnable = false;
	//BackupEnable
	if (iRv >= 0)
	{
		tstring	strValue = tstringOf((LPCTSTR)GetProfileString(
			nameSection, nameCDiagramEdit_BackupEnable));
		if (strValue.empty())
		{
			iRv = -1;	//	BackupEnable w肳Ă܂B
		}
		else
		{
			bBackupEnable = (intOf(strValue) != 0);
		}
	}
	// --------------------------------
	if (iRv >= 0)
	{
		getCDiagramEditDoc()->setBackupEnable(bBackupEnable);
	}


	return (iRv);
}


// ----------------------------------------------------------------
//	MFC
// ----------------------------------------------------------------


BEGIN_MESSAGE_MAP(CDiagramEditApp, CHidemdiApp)
	//{{AFX_MSG_MAP(CDiagramEditApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE, OnUpdateFileSave)
	ON_COMMAND(ID_FILE_PrintPageProp, OnFILEPrintPageProp)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_HELP, OnHelp)
//	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
//	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO, OnUpdateEditUndo)
	//}}AFX_MSG_MAP
	// W̃t@C{hLg R}h
	ON_COMMAND(ID_FILE_NEW, CHidemdiApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CHidemdiApp::OnFileOpen)
	// ẄZbgAbv R}h
	ON_COMMAND(ID_FILE_PRINT_SETUP, CHidemdiApp::OnFilePrintSetup)
//	ON_COMMAND(ID_EDIT_REDO, &CDiagramEditApp::OnEditRedo)
//	ON_UPDATE_COMMAND_UI(ID_EDIT_REDO, &CDiagramEditApp::OnUpdateEditRedo)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDiagramEditApp NX̍\z

CDiagramEditApp::CDiagramEditApp()
{
	m_pdoctmplEki = NULL ;
	m_pdoctmplResssyasyubetsu = NULL ;
	m_pdoctmplJikokuhyou = NULL ;
	m_pdoctmplDiagram = NULL ;
	m_pdoctmplComment = NULL ;
	m_pdoctmplEkiTrack2 = NULL;
	m_pdoctmplOperationTable = NULL;
}

/////////////////////////////////////////////////////////////////////////////
// B CDiagramEditApp IuWFNg

CDiagramEditApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CDiagramEditApp NX̏

BOOL CDiagramEditApp::InitInstance()
{
	// WIȏ
	// ̋@\gpAst@C̃TCY
	// Έȉ̓̏[`̒sKvȂ
	// 폜ĂB

#ifdef _AFXDLL
	//VisualStudio 2008
	//	warning C4996: 'CWinApp::Enable3dControls': 
	//	CWinApp::Enable3dControlsStatic is no longer needed. 
	//	You should remove this call.
	//Enable3dControls();		// L DLL ̒ MFC gpꍇɂ͂ĂяoĂB
#else
	//VisualStudio 2008
	//	warning C4996: 'CWinApp::Enable3dControlsStatic': 
	//	CWinApp::Enable3dControlsStatic is no longer needed. 
	//	You should remove this call.
	//Enable3dControlsStatic();	// MFC ƐÓIɃNĂꍇɂ͂ĂяoĂB
#endif

	// --------------------------------
	//	LocalAppData fBNg쐬
	// --------------------------------
	{
		CString	strLocalAppdataOudiaFolder ;
		strLocalAppdataOudiaFolder = makeLocalAppdataFilename( _T( "" ) ) ;

		//strLocalAppdataOudiaFolder = OuDiaLocalAppDatatH_B
		//	ɂ '\' ͂܂B
		//	̃fBNǵA쐬Ă܂B

		OuLib::Dir::mkdirs( tstringOf( (LPCTSTR)strLocalAppdataOudiaFolder ) );
	}
	//
	


	// --------------------------------
	//	LogMsg() t@C̃t@Cݒ
	// --------------------------------
	{
		logmsg_setFilename(makeLocalAppdataFilename(_T("OuDiaSecond.log")));
		//logmsg_setFilename( makeProgramDirFilename( _T("OuDiaSecond.log") ) ) ; //x[^łł͂gp

		//	LogLevel ́ÂƂ 
		//	.ini t@C[AppProp]LogLevel ǂݏo܂B
		logmsg_setLogLevel( 2 ) ;
	}

	// --------------------------------
	//	.Init@C̃t@Cݒ
	// --------------------------------
	//SetRegistryKey(_T("DiagramEdit"));
	{
		free((void*)m_pszProfileName);
		m_pszProfileName = _tcsdup(makeLocalAppdataFilename(_T("OuDiaSecond.ini")));
		//m_pszProfileName=_tcsdup( makeProgramDirFilename( _T("OuDiaSecond.ini") ) ); //x[^łł͂gp
	}
	LoadStdProfileSettings();  // W INI t@C̃IvV[ނ܂ (MRU ܂)

	// --------------------------------
	//	.Init@C̓ǂݍ
	// --------------------------------
	{
		//	y[Wݒ
		CString aStr = GetProfileString( nameSection , namePrintPageProp ) ;
		m_CdPrintPageProp.decode( (LPCTSTR)aStr ) ;

		//	LogLevelݒ
		logmsg_setLogLevel( GetProfileInt( nameSection , nameLogLevel , 0 ) );
		
	}

	// ----------------------------------------------------------------
	// AvP[Vp̃hLg ev[go^܂BhLg ev[g
	//  ̓hLgAt[ EBhEƃr[邽߂ɋ@\܂B

	{
		CHidemdiRootDoctmpl* pDocTemplate;
		pDocTemplate = new CDiagramEditDoctmpl(
			IDR_DIATYPE,
			RUNTIME_CLASS(CDiagramEditDoc));
		AddDocTemplate(pDocTemplate);
		RegisterRootDoctmpl( pDocTemplate ) ;
	}

	{
		CHidemdiSubDoctmpl* pNewDocTemplate = new CHidemdiDoctmplDocstrAlone(
			IDR_DOCVIEW_Eki,
			RUNTIME_CLASS(CEkiDoc),		// hLg NX
			RUNTIME_CLASS(CMDIChildWnd),		// t[ NX
			RUNTIME_CLASS(CEkiView));	// r[ NX
		AddDocTemplate(pNewDocTemplate);
		
		m_pdoctmplEki = pNewDocTemplate ;
			//	̃hLgev[gAAvP[VNX
			//	oϐɕۑ
	}

	{
		CHidemdiSubDoctmpl* pNewDocTemplate = new CHidemdiDoctmplDocstrAlone(
			IDR_DOCVIEW_Ressyasyubetsu,
			RUNTIME_CLASS(CRessyasyubetsuDoc),		// hLg NX
			RUNTIME_CLASS(CMDIChildWnd),		// t[ NX
			RUNTIME_CLASS(CRessyasyubetsuView));	// r[ NX
		AddDocTemplate(pNewDocTemplate);
		
		m_pdoctmplResssyasyubetsu = pNewDocTemplate ;
			//	̃hLgev[gAAvP[VNX
			//	oϐɕۑ
	}


	{
		CHidemdiSubDoctmpl* pNewDocTemplate = new CHidemdiDoctmplDocstrAlone(
			IDR_DOCVIEW_Jikokuhyou,
			RUNTIME_CLASS(CJikokuhyouDoc),		// hLg NX
			RUNTIME_CLASS(CMDIChildWnd),		// t[ NX
			RUNTIME_CLASS(CJikokuhyouView));	// r[ NX
		AddDocTemplate(pNewDocTemplate);
		
		m_pdoctmplJikokuhyou = pNewDocTemplate ;
			//	̃hLgev[gAAvP[VNX
			//	oϐɕۑ
	}
	{
		CHidemdiSubDoctmpl* pNewDocTemplate = new CHidemdiDoctmplDocstrAlone(
			IDR_DOCVIEW_Diagram,
			RUNTIME_CLASS(CDedDiagramDoc),		// hLg NX
			RUNTIME_CLASS(CMDIChildWnd),		// t[ NX
			RUNTIME_CLASS(CDedDiagramView));	// r[ NX
		AddDocTemplate(pNewDocTemplate);
		
		m_pdoctmplDiagram = pNewDocTemplate ;
			//	̃hLgev[gAAvP[VNX
			//	oϐɕۑ
	}
	{
		CHidemdiSubDoctmpl* pNewDocTemplate = new CHidemdiDoctmplDocstrAlone(
			IDR_DOCVIEW_Comment,
			RUNTIME_CLASS(CDedCommentDoc),		// hLg NX
			RUNTIME_CLASS(CMDIChildWnd),		// t[ NX
			RUNTIME_CLASS(CDedCommentView));	// r[ NX
		AddDocTemplate(pNewDocTemplate);
		
		m_pdoctmplComment = pNewDocTemplate ;
			//	̃hLgev[gAAvP[VNX
			//	oϐɕۑ
	}
	{
		CHidemdiSubDoctmpl* pNewDocTemplate = new CHidemdiDoctmplDocstrAlone(
			IDR_DOCVIEW_EkiTrack2,
			RUNTIME_CLASS(CEkiTrack2Doc),		// hLg NX
			RUNTIME_CLASS(CMDIChildWnd),		// t[ NX
			RUNTIME_CLASS(CEkiTrack2View));	// r[ NX
		AddDocTemplate(pNewDocTemplate);

		m_pdoctmplEkiTrack2 = pNewDocTemplate;
		//	̃hLgev[gAAvP[VNX
		//	oϐɕۑ
	}
	{
		CHidemdiSubDoctmpl* pNewDocTemplate = new CHidemdiDoctmplDocstrAlone(
			IDR_DOCVIEW_OperationTable,
			RUNTIME_CLASS(COperationTableDoc),		// hLg NX
			RUNTIME_CLASS(CMDIChildWnd),		// t[ NX
			RUNTIME_CLASS(COperationTableView));	// r[ NX
		AddDocTemplate(pNewDocTemplate);

		m_pdoctmplOperationTable = pNewDocTemplate;
		//	̃hLgev[gAAvP[VNX
		//	oϐɕۑ
	}


	// C MDI t[ EBhE쐬
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// hbO/hbv ̃I[v܂
	m_pMainWnd->DragAcceptFiles();

	// DDE Execute open gp\ɂ܂B
	EnableShellOpen();
	
	//	(̃AvP[V́At@C^CṽWXgւ̓o^
	//	s܂B
	//	o^́AVisualStudioInstaller ōs܂j
	// --------------------------------
	//	RegisterShellFileTypes(TRUE);

	// DDEAfile open ȂǕW̃VF R}h̃R}hC͂܂B
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// R}hCŃfBXpb` R}hw肵܂B
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// C EBhEꂽ̂ŁA\ƍXVs܂B
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	return TRUE;
}

//memo: ݂́AIDD_AboutBoxGpl ɑւ܂B
///////////////////////////////////////////////////////////////////////////////
//// AvP[Ṽo[WŎg CAboutDlg _CAO
//
///**
// @brief
//	o[W̃_CAÕNXłB
//*/
//class CAboutDlg : public CDialog
//{
//public:
//	CAboutDlg( const string& strProgramVer );
//
//// _CAO f[^
//	//{{AFX_DATA(CAboutDlg)
//	enum { IDD = IDD_ABOUTBOX };
//	CString	m_strSTATIC_VERSION;
//	//}}AFX_DATA
//
//	// ClassWizard z֐̃I[o[Ch𐶐܂B
//	//{{AFX_VIRTUAL(CAboutDlg)
//	protected:
//	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
//	//}}AFX_VIRTUAL
//
//// Cve[V
//protected:
//	//{{AFX_MSG(CAboutDlg)
//		// bZ[W nh͂܂B
//	//}}AFX_MSG
//	DECLARE_MESSAGE_MAP()
//};
//
//CAboutDlg::CAboutDlg( const string& strProgramVer ) : CDialog(CAboutDlg::IDD)
//{
//	//{{AFX_DATA_INIT(CAboutDlg)
//	m_strSTATIC_VERSION = "Ver. " ;
//	//}}AFX_DATA_INIT
//	m_strSTATIC_VERSION += strProgramVer.c_str() ;
//}
//
//void CAboutDlg::DoDataExchange(CDataExchange* pDX)
//{
//	CDialog::DoDataExchange(pDX);
//	//{{AFX_DATA_MAP(CAboutDlg)
//	DDX_Text(pDX, IDC_STATIC_VERSION, m_strSTATIC_VERSION);
//	//}}AFX_DATA_MAP
//}
//
//BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
//	//{{AFX_MSG_MAP(CAboutDlg)
//		// bZ[W nh͂܂B
//	//}}AFX_MSG_MAP
//END_MESSAGE_MAP()
//



// _CAOs邽߂̃AvP[V R}h
void CDiagramEditApp::OnAppAbout()
{
	tstring strProgramVer ;
	tstring strLegalCopyright ;
	readVersionResource( &strProgramVer , &strLegalCopyright ) ;


	CAboutBoxGpl aboutDlg( strProgramVer , strLegalCopyright ) ;

	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CDiagramEditApp bZ[W nh

void CDiagramEditApp::OnVIEWEki() 
{
	openCEkiDoc() ;
	
}

void CDiagramEditApp::OnUpdateFileSave(CCmdUI* pCmdUI) 
{
	CDocument*	pCDocument = getCDiagramEditDoc() ;
	BOOL	bIsModified = FALSE ;
	if ( pCDocument != NULL ){
		bIsModified = pCDocument->IsModified() ;
	}
	pCmdUI->Enable( bIsModified ) ;

	
}

int CDiagramEditApp::ExitInstance() 
{
	tstring	strPrintPageProp = m_CdPrintPageProp.encode() ;
	WriteProfileString( nameSection , namePrintPageProp , strPrintPageProp.c_str() ) ;

	return CHidemdiApp::ExitInstance();
}

void CDiagramEditApp::OnFILEPrintPageProp() 
{
	CDlgPrintPageProp	aDlg( m_CdPrintPageProp  ) ;
	if ( aDlg.DoModal() == IDOK ){
		m_CdPrintPageProp = aDlg.getCdPrintPageProp() ;
	}
	
}



void CDiagramEditApp::OnFileOpen() 
{
	CString	strExt ;
	pRootDoctmpl()->GetDocString( strExt , CDocTemplate::filterExt ) ;

	CFileDialog	aDlg( TRUE , strExt , NULL , 
	  OFN_HIDEREADONLY | OFN_FILEMUSTEXIST, getCFileDialogFilterOpen() , NULL ) ;
	if ( aDlg.DoModal() != IDOK ){
		return ;
	}	
	// --------------------------------

	AfxGetApp()->OpenDocumentFile(aDlg.GetPathName() );
		// if returns NULL, the user has already been alerted
	
}

#include <htmlhelp.h>

void CDiagramEditApp::OnHelp() 
{
	CString	strUrl = makeHtmlHelpUrl( _T( "" ) )  ;

	//	AvP[ṼCEChEɂƁA
	//	CEChE͏HTMLHelpEChȄɂȂ܂B
	HWND hwndCaller = NULL ;
	HWND hwnd =
		::HtmlHelp(
			hwndCaller ,
				strUrl , 
				 HH_DISPLAY_TOPIC,
	             NULL) ;
}
