/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// CWndDiagram.cpp : Cve[V t@C
//

#include "stdafx.h"

#include "DcdCd\Pos\CconvDcdPosOnZone_PosOrgAndRate.h"
#include "DcDraw\CConverter_WinGdi.h"
#include "DcDraw\CDcdTargetOnPaint.h"
#include "DcDraw\CDcdTargetGetDC.h"
#include "WinUtil\CconvWinUser.h"
#include "LogMsg\LogMsg.h"

#include "..\DiagramEdit.h"
#include "CWndDiagram.h"
#include "..\ViewJikokuhyou\CJikokuhyouView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace ViewDiagram{

using namespace DcDrawLib::WinUtil;

/////////////////////////////////////////////////////////////////////////////
// CWndDiagram
// ********************************
//	CWndDiagram
// ********************************
// --------------------------------
//@name ֐
// --------------------------------
bool CWndDiagram::update_adjustProp() 
{
	bool	bRv = false ;

	CDcdTargetGetDC	aTarget( GetSafeHwnd() ) ;

	LogMsg(_T("CWndDiagram::update_adjustProp() Target.GetZone()=X(%d,%d)Y(%d,%d)")  ,
		aTarget.getZone().getX().getPos() , 
		aTarget.getZone().getX().getSize() , 
		aTarget.getZone().getY().getPos() , 
		aTarget.getZone().getY().getSize() ) ;

	// --------------------------------		
	//	m_pCDcdDiagram->m_CconvContentPosToDcdTarget ̒l𐳋K
	// --------------------------------		
	{
		CdDcdZoneXy zoneDgrInDcd ;
		CdDcdZoneXy zoneDgr ;
		if ( m_pCDcdDiagram->getCentDedDgrDia() != NULL ){
			zoneDgr = m_pCDcdDiagram->getCentDedDgrDia()->getZone();
		}
		zoneDgrInDcd = m_pCDcdDiagram->getZone_Dgr( &aTarget ) ;
		//zoneDgr = _CO̍W͈̔
		//	(X=(0,24),Y=(0,I_̃_COW)
		//zoneDgrInDcd = EChEɕ\Ă͈͂
		//	_COW

		LogMsg(_T("\t zoneDgr=X(%d,%d)Y(%d,%d)")  ,
			zoneDgr.getX().getPos() , 
			zoneDgr.getX().getSize() , 
			zoneDgr.getY().getPos() , 
			zoneDgr.getY().getSize() ) ;

		LogMsg(_T("\t zoneDgrInDcd=X(%d,%d)Y(%d,%d)")  ,
			zoneDgrInDcd.getX().getPos() , 
			zoneDgrInDcd.getX().getSize() , 
			zoneDgrInDcd.getY().getPos() , 
			zoneDgrInDcd.getY().getSize() ) ;


		// --------------------------------		
		//	XW
		// --------------------------------		
		{

			LogMsg(_T("CWndDiagram::update_adjustProp() ")
				_T("zoneDgrInDcd.getX()=(%d,%d)")  ,
				zoneDgrInDcd.getX().getPos() ,
				zoneDgrInDcd.getX().getSize() ) ;

			//	Rec̉E()[A
			//	^[QbgDcDraw̉E()[()
			//	ĂāAE()ɋ󂫂ꍇ́A
			//	URecE()Ɋ񂹂܂B
			if ( zoneDgrInDcd.getX().getEndPos() 
					> zoneDgr.getX().getEndPos() ){
				CdDcdZone	aCdDcdZone = zoneDgrInDcd.getX() ;
				aCdDcdZone.setPos( 
					zoneDgr.getX().getEndPos() - zoneDgrInDcd.getX().getSize() ) ;
				zoneDgrInDcd.setX( aCdDcdZone ) ;
			}

			//	RecPos(()̒[)
			//	^[QbgDcDrawPos(())E()
			//	ĂāA()ɋ󂫂ꍇ́A
			//	Rec()Ɋ񂹂܂B
			if ( zoneDgrInDcd.getX().getPos() < zoneDgr.getX().getPos() ){
				CdDcdZone	aCdDcdZone = zoneDgrInDcd.getX() ;
				aCdDcdZone.setPos( zoneDgr.getX().getPos() ) ;
				zoneDgrInDcd.setX( aCdDcdZone ) ;
			}
		}
		// --------------------------------		
		//	YW
		// --------------------------------		
		{
			//	Rec̉E()[A
			//	^[QbgDcDraw̉E()[()
			//	ĂāAE()ɋ󂫂ꍇ́A
			//	URecE()Ɋ񂹂܂B
			if ( zoneDgrInDcd.getY().getEndPos() 
					> zoneDgr.getY().getEndPos() ){
				CdDcdZone	aCdDcdZone = zoneDgrInDcd.getY() ;
				aCdDcdZone.setPos( 
					zoneDgr.getY().getEndPos() - zoneDgrInDcd.getY().getSize() ) ;
				zoneDgrInDcd.setY( aCdDcdZone ) ;
			}

			//	RecPos(()̒[)
			//	^[QbgDcDrawPos(())E()
			//	ĂāA()ɋ󂫂ꍇ́A
			//	Rec()Ɋ񂹂܂B
			if ( zoneDgrInDcd.getY().getPos() < zoneDgr.getY().getPos() ){
				CdDcdZone	aCdDcdZone = zoneDgrInDcd.getY() ;
				aCdDcdZone.setPos( zoneDgr.getY().getPos() ) ;
				zoneDgrInDcd.setY( aCdDcdZone ) ;
			}
		}
		LogMsg(_T("\t zoneDgrInDcd=X(%d,%d)Y(%d,%d)")  ,
			zoneDgrInDcd.getX().getPos() , 
			zoneDgrInDcd.getX().getSize() , 
			zoneDgrInDcd.getY().getPos() , 
			zoneDgrInDcd.getY().getSize() ) ;
	
		// --------------------------------
		if ( zoneDgrInDcd != m_pCDcdDiagram->getZone_Dgr(  &aTarget  ) ){
			m_pCDcdDiagram->setZone_Dgr(  &aTarget , zoneDgrInDcd ) ;
			bRv = true ;
		}
	}

	return ( bRv ) ;
}

void CWndDiagram::update_updateScreen() 
{
	CDcdTargetGetDC	aTarget( GetSafeHwnd() ) ;

	CdDcdZoneXy zoneDgrInDcd ;
	CdDcdZoneXy zoneDgr ;
	{
		if ( m_pCDcdDiagram->getCentDedDgrDia() != NULL )
		{
			zoneDgr = m_pCDcdDiagram->getCentDedDgrDia()->getZone();
		}

		zoneDgrInDcd = m_pCDcdDiagram->getZone_Dgr( &aTarget ) ;
	}
	//zoneDgr=_COW̑S͈̔
	//zoneDgrInDcd = IfDcdTargetɕ`悷_COW͈

	CdDcdZoneXy	zoneDiagramZoneDcd = calcDiagramZoneDcd() ;
	//zoneDiagramZoneDcd = EChEŃ_CO`悳̈

	// --------------------------------		
	//	EChEXN[
	// --------------------------------	
	//@݂zoneDgrInDcd(IfDcdTargetɕ`悷_COW͈)
	//	Pos(n_ʒu)ƁA
	//	O(ݕ\)zoneDgrInDcdPos(n_ʒu)rA
	//	̍ƂɃEChẼXN[s܂B
	//wO(ݕ\)zoneDgrInDcdPos(n_ʒu)x
	//	XN[o[̈ʒu擾܂B
	{

		// --------------------------------		
		//	XEChEXN[sNŽvZ
		// --------------------------------
		int iXAmount = 0 ;
		if ( m_CdScrollbarPropX.getPos() != 
			zoneDgrInDcd.getX().getPos() )
		{
			int iXPos_DcdPrev = m_pCDcdDiagram->XDgrToDcd( 
				&aTarget , m_CdScrollbarPropX.getPos() ) ;  
			int iXPos_DcdNew  = m_pCDcdDiagram->XDgrToDcd( 
				&aTarget , zoneDgrInDcd.getX().getPos() ) ;  
			iXAmount = iXPos_DcdPrev - iXPos_DcdNew ;
		}
		// --------------------------------		
		//	YEChEXN[sNŽvZ
		// --------------------------------
		int iYAmount = 0 ;
		if ( m_CdScrollbarPropY.getPos() != 
			zoneDgrInDcd.getY().getPos() )
		{
			int iYPos_DcdPrev = m_pCDcdDiagram->YDgrToDcd( 
				&aTarget , m_CdScrollbarPropY.getPos() ) ;  
			int iYPos_DcdNew  = m_pCDcdDiagram->YDgrToDcd( 
				&aTarget , zoneDgrInDcd.getY().getPos() ) ;  
			iYAmount = iYPos_DcdPrev - iYPos_DcdNew ;
		}

		// --------------------------------		
		//	XN[
		// --------------------------------
		if ( iXAmount != 0 || iYAmount != 0 )
		{
			CConverter_WinGdi	aConverter_WinGdi ;
			//	_CÖ̃XN[
			{
				CdDcdZoneXy	zoneDcdDiagram = 
					m_pCDcdDiagram->calcDiagramZoneDcd( &aTarget ) ; 
				RECT	aRect = aConverter_WinGdi.RECTOf( zoneDcdDiagram );
				ScrollWindow( iXAmount , iYAmount , NULL , &aRect ) ;
			}
			//	ẅ̏cXN[
			{
				CdDcdZoneXy	zoneDcdEkimei = 
					m_pCDcdDiagram->calcEkimeiZoneDcd( &aTarget ) ; 
				RECT	aRect = aConverter_WinGdi.RECTOf( zoneDcdEkimei );
				ScrollWindow( 0 , iYAmount , NULL , &aRect ) ;
			}
			//	̈̉XN[
			{
				CdDcdZoneXy	zoneDcdJikoku = 
					m_pCDcdDiagram->calcJikokuZoneDcd( &aTarget ) ; 
				RECT	aRect = aConverter_WinGdi.RECTOf( zoneDcdJikoku );
				ScrollWindow( iXAmount , 0 , NULL , &aRect ) ;
			}
		}
	}


	// --------------------------------		
	//	XN[o[̕ύX
	// --------------------------------	
	{
		// --------------------------------		
		//	X̃XN[o[̕ύX
		// --------------------------------	
		CdScrollbarProp	aCdScrollbarPropX_New 
			= m_CdScrollbarPropX  ;
		if ( zoneDiagramZoneDcd.getX().getSize() > 0 )	
		{
			//	_CO\̈悪EChE
			aCdScrollbarPropX_New.setDisableNoScroll( false ) ;
			aCdScrollbarPropX_New.set(
					zoneDgr.getX().getPos() , 
					zoneDgr.getX().getEndPos() ,
					zoneDgrInDcd.getX().getSize() + 1 ,
					zoneDgrInDcd.getX().getPos() ) ;
		}
		else
		{
			//	_CO\̈悪EChEɂȂꍇ
			//	XN[o[͔\ɂ͂ɖɂ܂B
			//
			//yRzXN[o[_łԂ邽߂łB
			//ymemoz_COr[ŁAXN[o[_ł錻
			//	ȉ̓삪łB
			//(1)@NCAg̈̃TCY
			//@_CO\̈悪ANCAg̈ɂȂ
			//@XN[o[͔\
			//(2)@[U[NCAg̈̃TCYA_CO
			//	\̈悪\邭炢ɑ傫
			//@_CO\̈悪NCAg̈ɂȂ
			//@XN[o[\
			//(3)XN[o[\ꂽƂɂACWndDiagram
			//	NCAg̈悪ȂB
			//@_CO\̈悪ANCAg̈OɂȂ
			//	(XN[o[ɉB)
			//@XN[o[\ɂȂ
			//(4)XN[o[\ɂȂƂɂACWndDiagram
			//	NCAg̈悪傫Ȃ
			//@_CO\̈悪NCAg̈ɂȂ
			//@XN[o[\
			//(5)@(3)`(4)̌JԂŁAXN[o[_ł悤ɂȂB
			//
			//  邽߂ɁAȉ̂悤ɂ܂B
			//
			//  CWndDiagram ́A_CO\̈悪
			//	NCAg̈ɂȂƂ́AXN[o[
			//	\܂܂ŖɂB
			aCdScrollbarPropX_New.setDisableNoScroll( true ) ;
			aCdScrollbarPropX_New.setNull() ;

		}
		if ( !m_CdScrollbarPropX.isEqualTo( aCdScrollbarPropX_New ) )
		{
			m_CdScrollbarPropX = aCdScrollbarPropX_New ;
			SCROLLINFO	aScrollinfo = 
				CconvWinUser::SCROLLINFOof( m_CdScrollbarPropX ) ;

			//	SIF_DISABLENOSCROLL găXN[o[𖳌ɂꍇ́A
			//
			//	EnableScrollBar( (SB_HORZ or SB_VERT), ESB_ENABLE_BOTH ) ;
			//
			//	ĂяoĂA
			//
			//	SetScrollInfo()ĂяoĂB
			//	
			//	EnableScrollBar() ĂяoȂƁA
			//	ɂȂXN[o[
			//	XN[o[KvɂȂƂɂLɂȂ܂B
			EnableScrollBar( SB_HORZ ,  ESB_ENABLE_BOTH ) ;
			SetScrollInfo( SB_HORZ , &aScrollinfo ) ;
		}

		// --------------------------------		
		//	ỸXN[o[̕ύX
		// --------------------------------	
		CdScrollbarProp	aCdScrollbarPropY_New 
			= m_CdScrollbarPropY  ;
		if ( zoneDiagramZoneDcd.getY().getSize() > 0 )	
		{
			//	_CO\̈悪EChE
			aCdScrollbarPropY_New.setDisableNoScroll( false ) ;
			aCdScrollbarPropY_New.set(
					zoneDgr.getY().getPos() , 
					zoneDgr.getY().getEndPos() ,
					zoneDgrInDcd.getY().getSize() + 1 , 
					zoneDgrInDcd.getY().getPos() ) ;
		}
		else
		{
			//	_CO\̈悪EChEɂȂꍇ
			//	XN[o[͔\ɂ͂ɖɂ܂B
			//
			//yRzXN[o[_łԂ邽߂łB
			aCdScrollbarPropY_New.setDisableNoScroll( true ) ;
			aCdScrollbarPropY_New.setNull() ;
		}
		if ( !m_CdScrollbarPropY.isEqualTo( aCdScrollbarPropY_New ) )
		{
			m_CdScrollbarPropY = aCdScrollbarPropY_New ;
			SCROLLINFO	aScrollinfo = 
				CconvWinUser::SCROLLINFOof( m_CdScrollbarPropY ) ;
			EnableScrollBar( SB_VERT ,  ESB_ENABLE_BOTH ) ;
			SetScrollInfo( SB_VERT , &aScrollinfo ) ;
		}
	}
}
	// --------------------------------
	//@name MFCbZ[Wnh̉֐
	// --------------------------------
int CWndDiagram::OnLButtonDblClk_openJikokuhyouView( CPoint point) 
{
	int iRv = 0 ;


	CDcdTargetGetDC	aTarget( GetSafeHwnd() ) ;
	ERessyahoukou eRessyahoukou = Ressyahoukou_Kudari ;
	int iRessyaIdx = -1 ;
	int iRessyasenIdx = -1 ;
	{
		int iResult =  m_pCDcdDiagram->calcCentDedDgrRessyasenOfPoint( 
			&aTarget , 
			CdDcdPosXy( point.x , point.y ) , 2 , 
			&eRessyahoukou , 
			&iRessyaIdx , 
			&iRessyasenIdx ) ;
		if ( iResult != 1 )
		{
			iRv = -1 ;	//	point Ԑɂ܂B
		}
	}
	//eRessyahoukou = point ʂԐ̕ 
	//iRessyaIdx = point ʂԂ̗Index
	//iRessyasenIdx = point ̈ʒu̗ԐIndex

	const CentDedDia* pCentDedDia = NULL ;
	int iEkiOrder = -1 ;
	if ( iRv >= 0 )
	{
		int iDiaIndex = -1 ;
		// --------------------------------
		iEkiOrder = m_pCDcdDiagram->calcEkiOrderOfPoint( 
			&aTarget , eRessyahoukou , point.y ) ;

		//iEkiOrder = point ̈ʒu̒ỎwOrder
		iDiaIndex = getCDiagramEditDoc()->
			getCDedRosenFileData()->getCentDedRosen()->getCentDedDiaCont()
				->findCentDedDiaByName( 
					m_pCDcdDiagram->getCentDedDgrDia()->getName() ) ;
		if ( iDiaIndex < 0 )
		{
			iRv = -2 ;	//	_COr[ɑΉ 
						//	CentDedDia ܂B
		}
		else
		{
			pCentDedDia = getCDiagramEditDoc()->
					getCDedRosenFileData()->getCentDedRosen()->getCentDedDiaCont()
					->getMuPtr()->get( iDiaIndex ) ; 
		}
	}
	//pCentDedDia = H_CIuWFNg
	//iEkiOrder = ړ̉wOrder

	CJikokuhyouView* pCJikokuhyouView = NULL ;
	if ( iRv >= 0 )
	{
		CJikokuhyouDoc* pCJikokuhyouDoc = NULL ;
		pCJikokuhyouDoc = 
			getCDiagramEditApp()->openCJikokuhyouDoc( 
				pCentDedDia , eRessyahoukou ,
				&pCJikokuhyouView) ; 
		if ( pCJikokuhyouView == NULL )
		{
			iRv = -3 ;	//	\r[ĴɎs܂B
		}
		//pCJikokuhyouDoc = \hLg
		//pCJikokuhyouView = \r[
	}

	if ( iRv >= 0 )
	{
		//attention
		//	̍s͕svłiopenCJikokuhyouDoc() ŃANeBuɂȂjA
		//	Assert()Ɏs܂B
		//
		//	CMainFrame* pCMainFrame = (CMainFrame*)AfxGetMainWnd() ;
		//	pCMainFrame->SetActiveView( pCJikokuhyouView ) ;
	
		pCJikokuhyouView->setFocusToRessyaIndex( iRessyaIdx , iEkiOrder ) ;
		iRv = 1 ;	//	\r[ֈړ܂
	}

	return iRv ;
}

int CWndDiagram::OnLButtonDblClk_openDlgEkiProp( CPoint point)
{
	int iRv = 0 ;

	CDcdTargetGetDC	aTarget( GetSafeHwnd() ) ;
	CdDcdPosXy	posMouse( point.x , point.y ) ;

	//	point ẅɂ邱ƂmF
	if ( iRv >= 0 )
	{
		CdDcdZoneXy	zonexyEkimeiZone = 
			m_pCDcdDiagram->calcEkimeiZoneDcd( &aTarget ) ;
		if ( !zonexyEkimeiZone.IsInner( posMouse ) )
		{
			iRv = -1 ;	//	point ẅɂ܂B
		}
	}
	//	point ɑΉwIndex擾
	int iEkiIndex = -1 ;
	if ( iRv >= 0 )
	{
		iEkiIndex = m_pCDcdDiagram->calcEkiIndexOfPoint( 
			&aTarget , posMouse.getY() ) ;
		if ( iEkiIndex < 0 )
		{
			iRv = -2 ;	//	point ɑΉw܂B
		}
	}
	//	wViewJ
	CEkiView* pCEkiView = NULL ;
	if ( iRv >= 0 )
	{
		getCDiagramEditApp()->openCEkiDoc( 
			&pCEkiView ) ;
		if ( pCEkiView == NULL )
		{
			iRv = -3 ;	//	wr[ĴɎs܂B
		}
	}
	//	w̃vpeB_CAOJ
	if ( iRv >= 0 )
	{
		pCEkiView->openCDlgEkiProp( iEkiIndex ) ;
	}
	return iRv ;
}



	// ********************************
	//@name	CDcdDiagrem-֘A
	// ********************************
CentDedDgrDia* CWndDiagram::getCentDedDgrDia() 
{
	return m_pCDcdDiagram->getCentDedDgrDia() ;
}
CWndDiagram& CWndDiagram::setCentDedDgrDia( CentDedDgrDia* value ) 
{
	if ( m_pCDcdDiagram->getCentDedDgrDia() != value )
	{
		m_pCDcdDiagram->setCentDedDgrDia( value ) ;

		update_adjustProp() ;
		update_updateScreen() ;
	}	
	return *this ;
}
	// ********************************
	//@name CDcdDiagram--CdDedDispProp ɂ͂Ȃ
	// ********************************
bool CWndDiagram::getDisplayRessyabangou()const 
{
	return m_pCDcdDiagram->getDisplayRessyabangou() ;
}

int CWndDiagram::setDisplayRessyabangou( bool value ) 
{
	int iRv = 0 ;
	if ( value != m_pCDcdDiagram->getDisplayRessyabangou() ){
		m_pCDcdDiagram->setDisplayRessyabangou( value ) ;
		update_adjustProp() ;
		update_updateScreen() ;
		Invalidate() ;	

		//	.ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndDiagramViewProp( this ) ;


		iRv = 1 ;
	}
	return ( iRv ) ;
	
}
bool CWndDiagram::getDisplayRessyamei()const 
{
	return m_pCDcdDiagram->getDisplayRessyamei() ;
}
int CWndDiagram::setDisplayRessyamei( bool value ) 
{
	int iRv = 0 ;
	if ( value != m_pCDcdDiagram->getDisplayRessyamei() ){
		m_pCDcdDiagram->setDisplayRessyamei( value ) ;
		update_adjustProp() ;
		update_updateScreen() ;
		Invalidate() ;	

		//	.ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndDiagramViewProp( this ) ;

		iRv = 1 ;
	}
	return ( iRv ) ;
}

CdDcdPosXy	CWndDiagram::getPosDgr()const 
{
	return m_pCDcdDiagram->getPosDgr() ;
}
int CWndDiagram::setPosDgr( CdDcdPosXy value )
{
	int iRv = 0 ;
	if ( value != m_pCDcdDiagram->getPosDgr() )
	{
		m_pCDcdDiagram->setPosDgr( value ) ;
		update_adjustProp() ;
		update_updateScreen() ;
		Invalidate() ;	

		//	.ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndDiagramViewProp( this ) ;
		

		iRv = 1 ;
	}
	return iRv ;
}
double CWndDiagram::getDcdPerDgrX()const 
{
	CDcdTargetGetDC	aTarget( GetSafeHwnd() ) ;
	return m_pCDcdDiagram->getDcdPerDgrX(&aTarget) ;
}
int CWndDiagram::setDcdPerDgrX( double value ) 
{
	int iRv = 0 ;
	CDcdTargetGetDC	aTarget( GetSafeHwnd() ) ;
	if ( value != m_pCDcdDiagram->getDcdPerDgrX(&aTarget) )
	{
		m_pCDcdDiagram->setDcdPerDgrX( &aTarget , value ) ;
		update_adjustProp() ;
		update_updateScreen() ;
		Invalidate() ;	

		//	.ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndDiagramViewProp( this ) ;
		

		iRv = 1 ;
	}
	return iRv ;
}

double CWndDiagram::getDcdPerDgrY()const 
{
	CDcdTargetGetDC	aTarget( GetSafeHwnd() ) ;
	return m_pCDcdDiagram->getDcdPerDgrY(&aTarget) ;
}

int CWndDiagram::setDcdPerDgrY( double value ) 
{
	int iRv = 0 ;
	CDcdTargetGetDC	aTarget( GetSafeHwnd() ) ;
	if ( value != m_pCDcdDiagram->getDcdPerDgrY(&aTarget) )
	{
		m_pCDcdDiagram->setDcdPerDgrY( &aTarget , value ) ;
		update_adjustProp() ;
		update_updateScreen() ;
		Invalidate() ;	

		//	.ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndDiagramViewProp( this ) ;
		

		iRv = 1 ;
	}
	return iRv ;
}



int	CWndDiagram::getVlineMode()const 
{
	return m_pCDcdDiagram->getVlineMode() ;
	
}
int CWndDiagram::setVlineMode( int value ) 
{
	int iRv = 0 ;
	if ( value != m_pCDcdDiagram->getVlineMode() ){
		m_pCDcdDiagram->setVlineMode( value ) ;
		update_adjustProp() ;
		update_updateScreen() ;
		Invalidate() ;	

		//	.ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndDiagramViewProp( this ) ;


		iRv = 1 ;
	}
	return ( iRv ) ;
	
}

bool CWndDiagram::getDisplayRessyasen(  ERessyahoukou eRessyahoukou )const 
{
	return m_pCDcdDiagram->getDisplayRessyasen( eRessyahoukou ) ;
}
int CWndDiagram::setDisplayRessyasen( ERessyahoukou eRessyahoukou , 
		bool value ) 
{
	int iRv = 0 ;
	if ( value != m_pCDcdDiagram->getDisplayRessyasen( eRessyahoukou ) ){
		m_pCDcdDiagram->setDisplayRessyasen( eRessyahoukou , value ) ;
		update_adjustProp() ;
		update_updateScreen() ;
		Invalidate() ;	

		//	.ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndDiagramViewProp( this ) ;

		iRv = 1 ;
	}
	return ( iRv ) ;
	
}

CDcdDiagram::EStopMarkDraw	CWndDiagram::getStopMarkDraw()const
{
	return m_pCDcdDiagram->getStopMarkDraw() ;
};

int CWndDiagram::setStopMarkDraw( CDcdDiagram::EStopMarkDraw	value )
{
	int iRv = 0 ;
	if ( value != m_pCDcdDiagram->getStopMarkDraw() )
	{
		m_pCDcdDiagram->setStopMarkDraw( value ) ;
		update_adjustProp() ;
		update_updateScreen() ;
		Invalidate() ;	

		//	.ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndDiagramViewProp( this ) ;

		iRv = 1 ;
	}
	return ( iRv ) ;

};

int CWndDiagram::getVlineChoices( Mui<CDcdDiagram::VLINE>* pContVLINE ) 
{
	return m_pCDcdDiagram->getVlineChoices( pContVLINE )  ;
}

bool CWndDiagram::getDisplayParentSyubetsu() const
{
	return m_pCDcdDiagram->getDisplayParentSyubetsu();
}

int CWndDiagram::setDisplayParentSyubetsu(bool value)
{
	int iRv = 0;
	if (value != m_pCDcdDiagram->getDisplayParentSyubetsu()) {
		m_pCDcdDiagram->setDisplayParentSyubetsu(value);
		update_adjustProp();
		update_updateScreen();
		Invalidate();

		//	.ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndDiagramViewProp(this);


		iRv = 1;
	}
	return (iRv);
}



	// ********************************
	//@name	CDcdDiagrem-
	// ********************************
int CWndDiagram::readCdDedDispProp( const CdDedDispProp& value ) 
{
	int iRv = 0 ;
	m_pCDcdDiagram->readCdDedDispProp( value ) ;
	update_adjustProp() ;
	update_updateScreen() ;
	Invalidate() ;
	return ( iRv ) ;
}

CdDcdZoneXy	CWndDiagram::getZone_Dgr()const 
{
	CDcdTargetGetDC	aTarget( GetSafeHwnd() ) ;
	return m_pCDcdDiagram->getZone_Dgr( &aTarget ) ;
}
int CWndDiagram::setZone_Dgr( const CdDcdZoneXy& value ) 
{
	int iRv = 0 ;
	CDcdTargetGetDC	aTarget( GetSafeHwnd() ) ;
	if ( value != m_pCDcdDiagram->getZone_Dgr( &aTarget ) )
	{
		m_pCDcdDiagram->setZone_Dgr(  &aTarget , value ) ;
		update_adjustProp() ;
		update_updateScreen() ;
		Invalidate() ;	

		//	.ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndDiagramViewProp( this ) ;

		iRv = 1 ;
	}
	return ( iRv ) ;
}

bool CWndDiagram::getKeepZoneDgrOnSize()const
{
	return m_pCDcdDiagram->getKeepZoneDgrOnSize() ;
};
int CWndDiagram::setKeepZoneDgrOnSize( bool value )
{
	int iRv = 0 ;
	if ( value != m_pCDcdDiagram->getKeepZoneDgrOnSize() )
	{
		m_pCDcdDiagram->setKeepZoneDgrOnSize( value ) ;

		update_adjustProp() ;
		update_updateScreen() ;
		Invalidate() ;	

		//	.ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndDiagramViewProp( this ) ;

		iRv = 1 ;
	}
	return ( iRv ) ;
};

	// ********************************
	//@name	CDcdDiagrem2-
	// ********************************

bool CWndDiagram::getHideIppanekiEkimei()const 
{
	return m_pCDcdDiagram->getHideIppanekiEkimei() ;
}
int CWndDiagram::setHideIppanekiEkimei( bool value )  
{
	int iRv = 0 ;
	if ( value != m_pCDcdDiagram->getHideIppanekiEkimei() )
	{
		m_pCDcdDiagram->setHideIppanekiEkimei( value ) ;
		update_adjustProp() ;
		update_updateScreen() ;
		Invalidate() ;	

		//	.ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndDiagramViewProp( this ) ;

		iRv = 1 ;
	}
	return ( iRv ) ;
}

	// ********************************
	//@name	CDcdDiagrem2-
	// ********************************
CdDcdZoneXy CWndDiagram::calcDiagramZoneDcd()const 
{
	CDcdTargetGetDC	aTarget( GetSafeHwnd() ) ;

	CdDcdZoneXy	zoneDiagramZoneDcd = 
		m_pCDcdDiagram->calcDiagramZoneDcd( &aTarget ) ;
	return zoneDiagramZoneDcd ;
}


	// ********************************
	//@name	CWndDiagram-
	// ********************************

	// ********************************
	//@name	CWndDiagram-
	// ********************************
CDcdDiagram2* CWndDiagram::getCDcdDiagram() 
{
	return m_pCDcdDiagram ;
}

	// ********************************
	//@name	CWndDiagram-\z
	// ********************************
BOOL CWndDiagram::Create( const RECT& rect, CWnd* pParentWnd, UINT nID )
{
	return CreateEx( 0 
		, AfxRegisterWndClass( CS_DBLCLKS //| CS_HREDRAW | CS_VREDRAW 
			, LoadCursor( NULL , IDC_ARROW ) 
			, (HBRUSH)GetStockObject( WHITE_BRUSH ) 
			, NULL ) 
		, _T("CWndDiagram")	//	̕񂪕\邱Ƃ͂܂
		, WS_CHILD | WS_VSCROLL | WS_HSCROLL | WS_TABSTOP
		, rect
		, pParentWnd
		, nID
		, NULL ) ;
}

BOOL CWndDiagram::Create( CWnd* pParentWnd, UINT nID )
{
	return CreateEx( 0 
		, AfxRegisterWndClass( CS_DBLCLKS //| CS_HREDRAW | CS_VREDRAW 
			, LoadCursor( NULL , IDC_ARROW ) 
			, (HBRUSH)GetStockObject( WHITE_BRUSH ) 
			, NULL ) 
		, _T("CWndDiagram")	//	̕񂪕\邱Ƃ͂܂
		, WS_CHILD | WS_VSCROLL | WS_HSCROLL | WS_TABSTOP
		, CRect( 0 , 0 , 0 , 0 ) 
		, pParentWnd
		, nID
		, NULL ) ;
}
	// ********************************
	//@name	CWndDiagram-
	// ********************************

void CWndDiagram::onUpdateCentDedDgrDia() 
{
	if ( !m_bReadCWndDiagramDefault )
	{
		//	ŏɃ_CO\Ƃɂ́A
		//	.ini t@CAXN[ʒu
		//	r̐ݒǂݍ
		getCDiagramEditApp()->readCWndDiagramViewProp( this ) ;

		m_bReadCWndDiagramDefault = true ;
	}

	// --------------------------------		
	update_adjustProp() ;
	update_updateScreen() ;
	Invalidate() ;
}
	
void CWndDiagram::onUpdateCentDedDgrRessya() 
{
	Invalidate() ;
}

// ----------------------------------------------------------------

CWndDiagram::CWndDiagram():
	m_pCDcdDiagram( NULL ) , 
	m_bReadCWndDiagramDefault( false ) 
{
	m_CdScrollbarPropX.setAdjustPosByPage( true ) ;
	m_CdScrollbarPropY.setAdjustPosByPage( true ) ;
}

CWndDiagram::~CWndDiagram()
{
}


BEGIN_MESSAGE_MAP(CWndDiagram, CWnd)
	//{{AFX_MSG_MAP(CWndDiagram)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	ON_WM_KEYDOWN()
	ON_WM_MOUSEWHEEL()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_CONTEXTMENU()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CWndDiagram bZ[W nh

int CWndDiagram::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (super::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	m_pCDcdDiagram = new CDcdDiagram2() ;
	
	return 0;
}

void CWndDiagram::OnDestroy() 
{
	if ( m_pCDcdDiagram != NULL ){
		delete m_pCDcdDiagram ;
		m_pCDcdDiagram = NULL ;
	}
	
	super::OnDestroy();
	
}

void CWndDiagram::OnPaint() 
{
	CPaintDC dc(this); // `p̃foCX ReLXg
	CDcdTargetOnPaint	aTarget( GetSafeHwnd() , &dc.m_ps ) ;
	if ( m_pCDcdDiagram != NULL ){
		m_pCDcdDiagram->DcDraw( &aTarget ) ;
	}
}

void CWndDiagram::OnSize(UINT nType, int cx, int cy) 
{
	LogMsg(_T("CWndDiagram::OnSize(%d,%d,%d)") , nType , cx , cy ) ;

	CDcdTargetGetDC	aTarget( GetSafeHwnd() ) ;

	//memo: CWndDiagram::OnSize()ł́ASIZE_RESTOREDȊO͔Ȃ
	//̃EChEł́A 
	//SIZE_RESTOREDȊO(SIZE_MAXIMIZED,SIZE_MINIMIZEDȂ)
	//͔܂B
	//yRz
	//̃EChE͎qEChEłBʒuTCÝA
	//eEChEłCDcdDiagramViewɂ
	//䂳Ă܂B
	//eEChÉA̎qEChEɑ΂
	//ŏEő剻s܂B

	if ( ( nType == SIZE_MAXIMIZED      //	EBhE͍ő\Ă܂
	    || nType == SIZE_RESTORED )     //	EBhE̓TCYύX
	    								//	܂A
		                                //	TCYύX̎ނ SIZE_MINIMIZED 
		                                //	ł SIZE_MAXIMIZED 
										//	ł܂B
		&& cx > 0 && cy > 0 )
	{
		//	EChETCY1ȏŕ\ĂꍇB
		//	(EChEŏ̏ꍇE
		//	܂̓TCY0ɂȂꍇ́As܂B)

		CdDcdSizeXy	sizeClientSize ; 

		////memo: CWndDiagram::OnSize()ł IsWindowVisible() ̌ʁB
		////	u\Ăv̔ɁÃR[h
		////	ʂ܂(F\EEChE̍ő剻Ȃ)
		//if ( !IsWindowVisible() )
		//{
		//	LogMsg( "\tNOT_VISIBLE" ) ;
		//}
		//else 

		{

			CdDcdZoneXy	zoneZone_Dgr = getZone_Dgr() ;

			LogMsg(_T("CWndDiagram::OnSize(%d,%d)") , cx , cy ) ;
			CdDcdZoneXy	zoneDiagramZoneDcd 
				= getCDcdDiagram()->calcDiagramZoneDcd( &aTarget ) ;
			if ( zoneDiagramZoneDcd.getX().getSize() > 0 &&
				zoneDiagramZoneDcd.getY().getSize() > 0 )
			{
				sizeClientSize.setX( cx ).setY( cy ) ;
			}
			else
			{
				LogMsg(_T("\tsizeClientSize NOT AVAILABLE") ) ;
			}
		}
		//sizeClientSize = NCAg̈TCYB
		//	A_COr[̈̃TCY 
		//	x,y ̂ꂩ	0ȂA0łB
		//yRz_COr[̈̃TCY0̏ꍇ́A
		//	getZone_Dgr() 삵Ȃ߂łB

		{
			update_adjustProp() ;

			//XN[o[͈̓͂AVEChETCYɍ킹܂B
			update_updateScreen() ;

			//memo: CWndDiagram::OnSize() ł́AInvalidate()̕Kv
			//	EChETCYύXɁA
			//	\̑傫(_COW1DcDrawW)
			//	ύXȂ̂ȂA
			//	Invalidate() ( EChȆSʍĕ` )͕Kv܂B
		}

	}
	// --------------------------------
	super::OnSize(nType, cx, cy);

	LogMsg(_T("CWndDiagram::OnSize()=") ) ;
}

void CWndDiagram::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CDcdTargetGetDC	aTarget( GetSafeHwnd() ) ;

	CdDcdZoneXy	zoneDiagramZoneDcd = m_pCDcdDiagram->calcDiagramZoneDcd( &aTarget ) ;
	//zoneDiagramZoneDcd = EChEŁA_CO\̈

	//	Xł́A_CO̓_COr[ɕ\܂B
	if ( zoneDiagramZoneDcd.getX().getSize() <= 0 )
	{
		return ;
	}

	if ( pScrollBar == NULL )
	{
		CdDcdZone	zoneCentDedDgrDia = m_pCDcdDiagram->getCentDedDgrDia()->getZone().getX()  ;
		CdDcdZone	zoneCDcdDiagram = m_pCDcdDiagram->getZone_Dgr( &aTarget ).getX() ;
		CdDcdZone	zoneCDcdDiagramPrev = zoneCDcdDiagram ;


		switch( nSBCode ){
		 case SB_LEFT :	//   [փXN[B
			{
				zoneCDcdDiagram.setPos( zoneCentDedDgrDia.getPos() ) ;
			}
			break ;
		 case SB_RIGHT :	//   E[փXN[B
			{
				zoneCDcdDiagram.setPos( zoneCentDedDgrDia.getEndPos() - 
					zoneCDcdDiagram.getSize() ) ;
			}
			break ;
		 case SB_LINELEFT :		//   փXN[B
			{
				zoneCDcdDiagram.setPos( zoneCDcdDiagram.getPos() - 
					m_pCDcdDiagram->getVlinePitch() ) ;
			}
			break ;
		 case SB_LINERIGHT :	//   EփXN[B
			{
				zoneCDcdDiagram.setPos( zoneCDcdDiagram.getPos() + 
					m_pCDcdDiagram->getVlinePitch() ) ;
			}
			break ;
		 case SB_PAGELEFT :	// 1 y[WփXN[B
			{
				zoneCDcdDiagram.setPos( zoneCDcdDiagram.getPos() - 
					zoneCDcdDiagram.getSize() ) ;
			}
			break ;
		 case SB_PAGERIGHT :	//   1 y[WEփXN[B
			{
				zoneCDcdDiagram.setPos( zoneCDcdDiagram.getPos() + 
					zoneCDcdDiagram.getSize() ) ;
			}
			break ;
		 case SB_THUMBPOSITION :	//  ΈʒuփXN[B݈ʒu͈ nPos Ŏw肳܂B
			{
				SCROLLINFO	aSCROLLINFO ;
				memset( &aSCROLLINFO , 0 , sizeof(aSCROLLINFO) ) ;
				aSCROLLINFO.cbSize = sizeof(aSCROLLINFO) ;			
				GetScrollInfo( SB_HORZ , &aSCROLLINFO , SIF_ALL ) ;
				int iPos = aSCROLLINFO.nPos ;
				zoneCDcdDiagram.setPos( iPos ) ;
			}
			break ;
		 case SB_THUMBTRACK :	//   XN[ {bNXwʒuփhbO܂B݈ʒu͈ nPos Ŏw肳܂
			{
				SCROLLINFO	aSCROLLINFO ;
				memset( &aSCROLLINFO , 0 , sizeof(aSCROLLINFO) ) ;
				aSCROLLINFO.cbSize = sizeof(aSCROLLINFO) ;			
				GetScrollInfo( SB_HORZ , &aSCROLLINFO , SIF_ALL ) ;
				int iPos = aSCROLLINFO.nTrackPos ;
				zoneCDcdDiagram.setPos( iPos ) ;
			}
			break ;

		 case SB_ENDSCROLL :	//   XN[IB
			break ;
		}
		if ( zoneCDcdDiagramPrev != zoneCDcdDiagram )
		{
			//memo: CWndDiagram XN[ setZone_Dgr()Ăяo
			//	update_updateScreen() ɂEChEXN[A
			//	XN[ŖɂȂ̈ɑ΂Ăĕ`悪ł悤
			//	Ȃ܂B
			//	ɂAInvalidate() ĂяoKv͂ȂȂ܂B
			//	CWndDiagram::setZone_Dgr() ͓ Invalidate() 
			//	Ăяo߁ǍĂяo͔邱Ƃɂ܂B

			//setZone_Dgr( 
			//	CdDcdZoneXy( zoneCDcdDiagram , getZone_Dgr().getY() ) ) ;
			m_pCDcdDiagram->setZone_Dgr( &aTarget , 
				CdDcdZoneXy( zoneCDcdDiagram , getZone_Dgr().getY() ) ) ;

			update_adjustProp() ;
			update_updateScreen() ;
		}
		return ;
	}
	
	super::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CWndDiagram::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CDcdTargetGetDC	aTarget( GetSafeHwnd() ) ;

	CdDcdZoneXy	zoneDiagramZoneDcd = m_pCDcdDiagram->calcDiagramZoneDcd( &aTarget ) ;
	//zoneDiagramZoneDcd = EChEŁA_CO\̈

	//	Ył́A_CO̓_COr[ɕ\܂B
	if ( zoneDiagramZoneDcd.getY().getSize() <= 0 )
	{
		return ;
	}

	if ( pScrollBar == NULL )
	{
		CdDcdZone	zoneCentDedDgrDia = m_pCDcdDiagram->getCentDedDgrDia()->getZone().getY()  ;
		CdDcdZone	zoneCDcdDiagram = m_pCDcdDiagram->getZone_Dgr( &aTarget ).getY() ;
		CdDcdZone	zoneCDcdDiagramPrev = zoneCDcdDiagram ;


		switch( nSBCode ){
		 case SB_TOP :	// ԏ܂ŃXN[B 
			{
				zoneCDcdDiagram.setPos( zoneCentDedDgrDia.getPos() ) ;
			}
			break ;
		 case SB_BOTTOM :	//  ԉ܂ŃXN[B
			{
				zoneCDcdDiagram.setPos( zoneCentDedDgrDia.getEndPos() - 
					zoneCDcdDiagram.getSize() ) ;
			}
			break ;
		 case SB_LINEUP :	//  1 sփXN[B
			{
				zoneCDcdDiagram.setPos( zoneCDcdDiagram.getPos() - 
					m_pCDcdDiagram->getVlinePitch() ) ;
			}
			break ;
		 case SB_LINEDOWN : // 1 sփXN[B
			{
				zoneCDcdDiagram.setPos( zoneCDcdDiagram.getPos() + 
					m_pCDcdDiagram->getVlinePitch() ) ;
			}
			break ;
		 case SB_PAGEUP :	//  1 y[WփXN[B
			{
				zoneCDcdDiagram.setPos( zoneCDcdDiagram.getPos() - 
					zoneCDcdDiagram.getSize() ) ;
			}
			break ;
		 case SB_PAGEDOWN :	//  1 y[WփXN[B
			{
				zoneCDcdDiagram.setPos( zoneCDcdDiagram.getPos() + 
					zoneCDcdDiagram.getSize() ) ;
			}
			break ;
		 case SB_THUMBPOSITION :	//  ΈʒuփXN[B݈ʒu͈ nPos Ŏw肳܂B
			{
				SCROLLINFO	aSCROLLINFO ;
				memset( &aSCROLLINFO , 0 , sizeof(aSCROLLINFO) ) ;
				aSCROLLINFO.cbSize = sizeof(aSCROLLINFO) ;			
				GetScrollInfo( SB_VERT , &aSCROLLINFO , SIF_ALL ) ;
				int iPos = aSCROLLINFO.nPos ;
				zoneCDcdDiagram.setPos( iPos ) ;
			}
			break ;
		 case SB_THUMBTRACK :	//   XN[ {bNXwʒuփhbO܂B݈ʒu͈ nPos Ŏw肳܂
			{
				SCROLLINFO	aSCROLLINFO ;
				memset( &aSCROLLINFO , 0 , sizeof(aSCROLLINFO) ) ;
				aSCROLLINFO.cbSize = sizeof(aSCROLLINFO) ;			
				GetScrollInfo( SB_VERT , &aSCROLLINFO , SIF_ALL ) ;
				int iPos = aSCROLLINFO.nTrackPos ;
				zoneCDcdDiagram.setPos( iPos ) ;
			}
			break ;

		 case SB_ENDSCROLL :	//   XN[IB
			break ;
		}
		if ( zoneCDcdDiagramPrev != zoneCDcdDiagram )
		{
			//memo: CWndDiagram XN[ setZone_Dgr()Ăяo
			//	update_updateScreen() ɂEChEXN[A
			//	XN[ŖɂȂ̈ɑ΂Ăĕ`悪ł悤
			//	Ȃ܂B
			//	ɂAInvalidate() ĂяoKv͂ȂȂ܂B
			//	CWndDiagram::setZone_Dgr() ͓ Invalidate() 
			//	Ăяo߁ǍĂяo͔邱Ƃɂ܂B

			//setZone_Dgr( 
			//	 CdDcdZoneXy( getZone_Dgr().getX() , zoneCDcdDiagram ) ) ;
			m_pCDcdDiagram->setZone_Dgr( &aTarget , 
				CdDcdZoneXy( getZone_Dgr().getX() , zoneCDcdDiagram )  ) ;

			update_adjustProp() ;
			update_updateScreen() ;
		}
		return ;
	}
	
	
	super::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CWndDiagram::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	bool bRv = false ;
	CDcdTargetGetDC	aTarget( GetSafeHwnd() ) ;



	// --------------------------------
	//	̃L[{[hɂXN[ʂ
	//	\͈͂vZ
	// --------------------------------
	{
		CdDcdZone	zoneCentDedDgrDia = m_pCDcdDiagram->getCentDedDgrDia()->getZone().getX()  ;
		CdDcdZone	zoneCDcdDiagram = m_pCDcdDiagram->getZone_Dgr( &aTarget ).getX() ;
		CdDcdZone	zoneCDcdDiagramPrev = zoneCDcdDiagram ;
		//zoneCDcdDiagram=݂̕\͈

		switch( nChar ){
		 case VK_LEFT :		//WM_HSCROLL SB_LINELEFT Ɠł
			{
				zoneCDcdDiagram.setPos( zoneCDcdDiagram.getPos() - 
						m_pCDcdDiagram->getVlinePitch() ) ;
			}
			break ;
		 case VK_RIGHT :	//WM_HSCROLL SB_LINERIGHT Ɠł
			{
				zoneCDcdDiagram.setPos( zoneCDcdDiagram.getPos() + 
						m_pCDcdDiagram->getVlinePitch() ) ;
			}
			break ;
		 case VK_HOME :	//WM_HSCROLL SB_PAGELEFT ƓłB
			{
				zoneCDcdDiagram.setPos( zoneCDcdDiagram.getPos() - 
						zoneCDcdDiagram.getSize() ) ;
			}
			break ;
		 case VK_END ://WM_HSCROLL SB_PAGERIGHT ƓłB
			{
				zoneCDcdDiagram.setPos( zoneCDcdDiagram.getPos() + 
						zoneCDcdDiagram.getSize() ) ;
			}
			break ;
		}
		//	\͈͕ύXv΁A
		//	CDcdDiagram2ɓe𔽉fA
		//	EChEXN[
		if ( zoneCDcdDiagramPrev != zoneCDcdDiagram )
		{
			//memo: CWndDiagram XN[ setZone_Dgr()Ăяo
			//	update_updateScreen() ɂEChEXN[A
			//	XN[ŖɂȂ̈ɑ΂Ăĕ`悪ł悤
			//	Ȃ܂B
			//	ɂAInvalidate() ĂяoKv͂ȂȂ܂B
			//	CWndDiagram::setZone_Dgr() ͓ Invalidate() 
			//	Ăяo߁ǍĂяo͔邱Ƃɂ܂B

			//setZone_Dgr(  
			//	CdDcdZoneXy( zoneCDcdDiagram , getZone_Dgr().getY() ) ) ;
			m_pCDcdDiagram->setZone_Dgr( &aTarget , 
				CdDcdZoneXy( zoneCDcdDiagram , getZone_Dgr().getY() ) ) ;

			update_adjustProp() ;
			update_updateScreen() ;

			bRv = true ;
		}
	}
	// --------------------------------
	//	̃L[{[hɂXN[ʂvZ
	// --------------------------------
	{
		CdDcdZone	zoneCentDedDgrDia = m_pCDcdDiagram->getCentDedDgrDia()->getZone().getY()  ;
		CdDcdZone	zoneCDcdDiagram = m_pCDcdDiagram->getZone_Dgr( &aTarget ).getY() ;
		CdDcdZone	zoneCDcdDiagramPrev = zoneCDcdDiagram ;
		//zoneCDcdDiagram=݂̕\͈

		switch( nChar ){
		 case VK_UP :	//	WM_VSCROLL SB_LINEUP 
			{
				zoneCDcdDiagram.setPos( zoneCDcdDiagram.getPos() - 
					m_pCDcdDiagram->getVlinePitch() ) ;
			}
			break ;
		 case VK_DOWN :	//	WM_VSCROLL SB_LINEDOWN
			{
				zoneCDcdDiagram.setPos( zoneCDcdDiagram.getPos() + 
					m_pCDcdDiagram->getVlinePitch() ) ;
			}
			break ;
		 case VK_PRIOR ://	WM_VSCROLL SB_PAGEUP 
			{
				zoneCDcdDiagram.setPos( zoneCDcdDiagram.getPos() - 
					zoneCDcdDiagram.getSize() ) ;
			}
			break ;
		 case VK_NEXT :	//	WM_VSCROLL SB_PAGEDOWN
			{
				zoneCDcdDiagram.setPos( zoneCDcdDiagram.getPos() + 
					zoneCDcdDiagram.getSize() ) ;
			}
			break ;
		}
		//	\͈͕ύXv΁A
		//	CDcdDiagram2ɓe𔽉fA
		//	EChEXN[
		if ( zoneCDcdDiagramPrev != zoneCDcdDiagram )
		{
			//memo: CWndDiagram XN[ setZone_Dgr()Ăяo
			//	update_updateScreen() ɂEChEXN[A
			//	XN[ŖɂȂ̈ɑ΂Ăĕ`悪ł悤
			//	Ȃ܂B
			//	ɂAInvalidate() ĂяoKv͂ȂȂ܂B
			//	CWndDiagram::setZone_Dgr() ͓ Invalidate() 
			//	Ăяo߁ǍĂяo͔邱Ƃɂ܂B

			//setZone_Dgr(  
			//	CdDcdZoneXy( getZone_Dgr().getX() , zoneCDcdDiagram) ) ;
			m_pCDcdDiagram->setZone_Dgr( &aTarget , 
				CdDcdZoneXy( getZone_Dgr().getX() , zoneCDcdDiagram ) ) ;

			update_adjustProp() ;
			update_updateScreen() ;

			bRv = true ;
		}
	}
	//zoneCDcdDiagram=V\͈

	// --------------------------------
	if ( !bRv )
	{
		super::OnKeyDown(nChar, nRepCnt, nFlags);
	}
}

BOOL CWndDiagram::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	CDcdTargetGetDC	aTarget( GetSafeHwnd() ) ;
	if ( nFlags == 0 )
	{
		int iYMove = zDelta / (-WHEEL_DELTA) ;
		//iYMove = YɈړ鐔B


		CdDcdZone	zoneCentDedDgrDia = 
			m_pCDcdDiagram->getCentDedDgrDia()->getZone().getY()  ;
		CdDcdZone	zoneCDcdDiagram = 
			m_pCDcdDiagram->getZone_Dgr( &aTarget ).getY() ;
		CdDcdZone	zoneCDcdDiagramPrev = zoneCDcdDiagram ;
		zoneCDcdDiagram.setPos( zoneCDcdDiagram.getPos() + 
					m_pCDcdDiagram->getVlinePitch() * iYMove ) ;
		if ( zoneCDcdDiagramPrev != zoneCDcdDiagram )
		{
			//memo: CWndDiagram XN[ setZone_Dgr()Ăяo
			//	update_updateScreen() ɂEChEXN[A
			//	XN[ŖɂȂ̈ɑ΂Ăĕ`悪ł悤
			//	Ȃ܂B
			//	ɂAInvalidate() ĂяoKv͂ȂȂ܂B
			//	CWndDiagram::setZone_Dgr() ͓ Invalidate() 
			//	Ăяo߁A
			//	̌Ăяo͔邱Ƃɂ܂B
			
			//setZone_Dgr( 
			//	CdDcdZoneXy( getZone_Dgr().getX() , zoneCDcdDiagram ) ) ;
			m_pCDcdDiagram->setZone_Dgr( &aTarget , 
				CdDcdZoneXy( getZone_Dgr().getX() , zoneCDcdDiagram )  ) ;

			update_adjustProp() ;
			update_updateScreen() ;

			
		}


		return ( TRUE ) ;
	}	
	return super::OnMouseWheel(nFlags, zDelta, pt);
}

void CWndDiagram::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	int iRv = 0 ;
	CWaitCursor	aCursor ;

	//	\r[ւ̈ړs
	{
		int iResult = OnLButtonDblClk_openJikokuhyouView( point ); 
		if ( iResult >= 1 )
		{
			iRv = 1 ;
		}
	}
	//	\r[JȂꍇ́A
	//	w̃vpeB_CAÕI[vs
	if ( iRv <= 0 )	
	{
		int iResult = OnLButtonDblClk_openDlgEkiProp( point ) ;
		if ( iResult >= 1 )
		{
			iRv = 1 ;
		}
		
	}
	//	ǂ̃r[JȂꍇ́A
	//	ftHg
	if ( iRv <= 0 )
	{
		CWnd::OnLButtonDblClk(nFlags, point);
	}
}

void CWndDiagram::OnContextMenu(CWnd* pWnd, CPoint point)
{
	//	_COr[̃ReLXgj[́A
	//	݂̂Ƃ\܂B
	{
		super::OnContextMenu(pWnd, point);
	}
}
} //namespace ViewDiagram
