/*
OuDiaSecond Copyright (C) 2017-2018 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// ****************************************************************
//	$Id: CPropEditUi_Eki.cpp
// ****************************************************************

/** @file */
#include "stdafx.h"
#include "CPropEditUi_Eki.h"
#include <tchar.h>

namespace ViewEki {


	// ********************************
	//@name G[bZ[W
	// ********************************
	/// w܂
const TCHAR* const CPropEditUi_Eki::ERRMSG_EKIMEI_TOO_LONG = _T("Ekimei is too long(Limit is 58 characters).") ;

/// wݒON̎́AΏۉwIĂ
const TCHAR* const CPropEditUi_Eki::ERRMSG_BRUNCH_EKIINDEX = _T("To enable Brunch-Func need ekiindex.");

/// wݒON̎́AwK͂vwɂĂ
const TCHAR* const CPropEditUi_Eki::ERRMSG_BRUNCH_EKIKIBO = _T("To enable Brunch-Func need Syuyoueki.");

/// wݒONΏۉwI_̏ꍇ́Aw`蒅ɂĂ
const TCHAR* const CPropEditUi_Eki::ERRMSG_BRUNCH_EKIJIKOKUKEISIKI_DOWNCHAKU = _T("To enable Brunch-Func need down-chakujikoku.");

/// wݒONΏۉwN_̏ꍇ́Aw`蒅ɂĂ
const TCHAR* const CPropEditUi_Eki::ERRMSG_BRUNCH_EKIJIKOKUKEISIKI_UPCHAKU = _T("To enable Brunch-Func need up-chakujikoku.");

/// ݒON̎́AN_wIĂ
const TCHAR* const CPropEditUi_Eki::ERRMSG_LOOP_EKIINDEX = _T("To enable Loop-Func need ekiindex.");

/// ݒON̎́AwK͂vwɂĂ
const TCHAR* const CPropEditUi_Eki::ERRMSG_LOOP_EKIKIBO = _T("To enable Loop-Func need Syuyoueki.");

/// ݒON̎́Aw`𔭒܂͉蒅ɂĂ
const TCHAR* const CPropEditUi_Eki::ERRMSG_LOOP_EKIJIKOKUKEISIKI_HATSUCHAKU_DOWNCHAKU = _T("To enable Loop-Func need hatsu-chaku or down-chakujikoku.");
// ʖw肳Ă܂
const TCHAR* const CPropEditUi_Eki::ERRMSG_EKIMEI_EMPTY = _T("EKIMEI is empty.");


//	// ================================
//	//@name ֐
//	// ================================
//
void CPropEditUi_Eki::InitUiData(UIDATA * pUiData)
{
	const CentDedEki* pTarget = m_pTarget->get(0);
	pUiData->iEkijikokukeisiki = (int)pTarget->getEkijikokukeisiki();
	EkiTrack2 aEkiTrack2;

	aEkiTrack2.strTrackName = _T("1Ԑ");
	aEkiTrack2.strTrackRyakusyou = _T("1");
	aEkiTrack2.strTrackNoboriRyakusyou = _T("");
	aEkiTrack2.iMainTrack = 1;
	pUiData->sEkiTrack2.push_back(aEkiTrack2);

	aEkiTrack2.strTrackName = _T("2Ԑ");
	aEkiTrack2.strTrackRyakusyou = _T("2");
	aEkiTrack2.strTrackNoboriRyakusyou = _T("");
	aEkiTrack2.iMainTrack = 2;
	pUiData->sEkiTrack2.push_back(aEkiTrack2);

}
//void CPropEditUi_Eki::UiDataFromTarget( 
//		UIDATA* pUiData , 
//		const CentDedEki* pTarget ) 
//{
//	// w 
//	pUiData->strEkimei = pTarget->getEkimei() ;
//
//	// w` 
//	pUiData->iEkijikokukeisiki = (int)pTarget->getEkijikokukeisiki() ;
//	
//	// wK 
//	pUiData->iEkikibo = (int)pTarget->getEkikibo() ;
//
//	// E 
//	pUiData->iKyoukaisen = (int)pTarget->getKyoukaisen() ;
//
//	// _COԏ\ij 
//	pUiData->iDiagramRessyajouhouHyoujiKudari = (int)pTarget->getDiagramRessyajouhouHyoujiKudari() ;
//
//	// _COԏ\ij 
//	pUiData->iDiagramRessyajouhouHyoujiNobori = (int)pTarget->getDiagramRessyajouhouHyoujiNobori() ;
//
//}
//
//int CPropEditUi_Eki::UiDataToTarget( 
//		const UIDATA& aUiDataPrev , 
//		const UIDATA& aUiDataModified , 
//		CentDedEki* pTarget  ) 
//{
//	int iRv = 0 ;
//	// w 
//	if ( iRv >= 0 
//		&& aUiDataPrev.strEkimei != pUiData->strEkimei )
//	{
//		pTarget->setEkimei( pUiData->strEkimei ) ;
//	}
//
//	// w` 
//	if ( iRv >= 0 
//		&& aUiDataPrev.iEkijikokukeisiki 
//			!= aUiDataModified.iEkijikokukeisiki )
//	{
//		pTarget->setEkijikokukeisiki( 
//			(CentDedEki::EEkijikokukeisiki)aUiDataModified.iEkijikokukeisiki ) ;
//	}
//	// wK 
//	if ( iRv >= 0 
//		&& aUiDataPrev.iEkikibo != aUiDataModified.iEkikibo )
//	{
//		pTarget->setEkikibo( (CentDedEki::EEkikibo)aUiDataModified.iEkikibo ) ;
//	}
//
//	// E 
//	if ( iRv >= 0 
//		&& aUiDataPrev.iKyoukaisen 
//			!= aUiDataModified.iKyoukaisen )
//	{
//		pTarget->setKyoukaisen( aUiDataModified.iKyoukaisen != 0 );
//	}
//
//	// _COԏ\ij 
//	if ( iRv >= 0 
//		&& aUiDataPrev.iDiagramRessyajouhouHyoujiKudari
//			!= aUiDataModified.iDiagramRessyajouhouHyoujiKudari )
//	{
//		pTarget->setDiagramRessyajouhouHyoujiKudari(
//			(CentDedEki::EDiagramRessyajouhouHyouji)aUiDataModified.iDiagramRessyajouhouHyoujiKudari ) ;
//	}
//
//	// _COԏ\ij 
//	if ( iRv >= 0 
//		&& aUiDataPrev.iDiagramRessyajouhouHyoujiNobori 
//			!= aUiDataModified.iDiagramRessyajouhouHyoujiNobori )
//	{
//		pTarget->setDiagramRessyajouhouHyoujiNobori(
//			(CentDedEki::EDiagramRessyajouhouHyouji)aUiDataModified.iDiagramRessyajouhouHyoujiNobori ) ;
//	}
//
//	return iRv ;
//}
	// ================================
	//	I[o[Cg̕Kvȃ\bh1-TargetɈˑ鏈
	// ================================
void CPropEditUi_Eki::UiDataFromTarget( UIDATA* pUiData ) 
{
	for ( int i = 0 ; i < m_pTarget->size() ; i ++ )
	{
		const CentDedEki* pTarget = m_pTarget->get( i ) ; 
		// w 
		if ( i == 0 )
		{
			pUiData->strEkimei = pTarget->getEkimei() ;
		}
		else if ( pUiData->strEkimei != pTarget->getEkimei() )
		{
			pUiData->strEkimei = _T("") ;
		}

		// w` 
		if ( i == 0 )
		{
			pUiData->iEkijikokukeisiki = (int)pTarget->getEkijikokukeisiki() ;
		}
		else if ( pUiData->iEkijikokukeisiki != (int)pTarget->getEkijikokukeisiki() )
		{
			pUiData->iEkijikokukeisiki = -1 ;	//-1 : s
		}
		// wK 
		if ( i == 0 )
		{
			pUiData->iEkikibo = (int)pTarget->getEkikibo() ;
		}
		else if ( pUiData->iEkikibo != (int)pTarget->getEkikibo() )
		{
			pUiData->iEkikibo = -1 ;	//	s
		}
		// E 
		//if ( i == 0 )
		//{
		//	pUiData->iKyoukaisen = (int)pTarget->getKyoukaisen() ;
		//}
		//else if ( pUiData->iKyoukaisen != (int)pTarget->getKyoukaisen() )
		//{
		//	pUiData->iKyoukaisen = -1 ;	// s
		//}
		// _COԏ\ij
		if ( i == 0 )
		{
			pUiData->iDiagramRessyajouhouHyoujiKudari = (int)pTarget->getDiagramRessyajouhouHyoujiKudari() ;
		}
		else if ( pUiData->iDiagramRessyajouhouHyoujiKudari != (int)pTarget->getDiagramRessyajouhouHyoujiKudari() )
		{
			pUiData->iDiagramRessyajouhouHyoujiKudari = -1 ;	//-1: s
		}
		// _COԏ\ij 
		if ( i == 0 )
		{
			pUiData->iDiagramRessyajouhouHyoujiNobori = (int)pTarget->getDiagramRessyajouhouHyoujiNobori() ;
		}
		else if ( pUiData->iDiagramRessyajouhouHyoujiNobori != (int)pTarget->getDiagramRessyajouhouHyoujiNobori() )
		{
			pUiData->iDiagramRessyajouhouHyoujiNobori = -1 ;	// s
		}
		//// {ݒij
		//if (i == 0)
		//{
		//	pUiData->iDownMain = (int)pTarget->getDownMain();
		//}
		//else// if (pUiData->iDiagramRessyajouhouHyoujiKudari != (int)pTarget->getDiagramRessyajouhouHyoujiKudari())
		//{
		//	pUiData->iDownMain = -1;	//-1: s
		//}
		//// {ݒij
		//if (i == 0)
		//{
		//	pUiData->iUpMain = (int)pTarget->getUpMain();
		//}
		//else// if (pUiData->iDiagramRessyajouhouHyoujiKudari != (int)pTarget->getDiagramRessyajouhouHyoujiKudari())
		//{
		//	pUiData->iUpMain = -1;	//-1: s
		//}
		//wݒ,wݒ̗L
		if (m_bBrunchFunctionEnable)
		{
			if (pTarget->getLoopOriginEkiIndex() >= 0)
			{
				pUiData->bBrunchFunctionEnable = false;
				pUiData->bBrunch = false;
				//pUiData->iBrunchCoreEkiIndex = 0;
				pUiData->iBrunchCoreEkiIndex = -1;
				pUiData->bBrunchOpposite = false;
			}
			else
			{
				pUiData->bBrunchFunctionEnable = true;
				pUiData->bBrunch = (pTarget->getBrunchCoreEkiIndex() >= 0);
				if (pUiData->bBrunch)
				{
					pUiData->iBrunchCoreEkiIndex = pTarget->getBrunchCoreEkiIndex();
					pUiData->bBrunchOpposite = pTarget->getBrunchOpposite();
				}
				else
				{
					//pUiData->iBrunchCoreEkiIndex = 0;
					pUiData->iBrunchCoreEkiIndex = -1;
					pUiData->bBrunchOpposite = false;
				}
			}
		}
		else
		{
			pUiData->bBrunchFunctionEnable = false;
			pUiData->bBrunch = false;	//-1: s
			pUiData->iBrunchCoreEkiIndex = -1;	//-1: s
			pUiData->bBrunchOpposite = false;
		}
		//ݒ,ݒ̗L
		if (m_bLoopFunctionEnable)
		{
			if (pTarget->getBrunchCoreEkiIndex() >= 0)
			{
				pUiData->bLoopFunctionEnable = false;
				pUiData->bLoop = false;	
				//pUiData->iLoopOriginEkiIndex = 0;
				pUiData->iLoopOriginEkiIndex = -1;
				pUiData->bLoopOpposite = false;
			}
			else
			{
				pUiData->bLoopFunctionEnable = true;
				pUiData->bLoop = (pTarget->getLoopOriginEkiIndex() >= 0);
				if (pUiData->bLoop)
				{
					pUiData->iLoopOriginEkiIndex = pTarget->getLoopOriginEkiIndex();
					pUiData->bLoopOpposite = pTarget->getLoopOpposite();
				}
				else
				{
					//pUiData->iLoopOriginEkiIndex = 0;
					pUiData->iLoopOriginEkiIndex = -1;
					pUiData->bLoopOpposite = false;
				}
			}
		}
		else
		{
			pUiData->bLoopFunctionEnable = false;
			pUiData->bLoop = false;	//-1: s
			pUiData->iLoopOriginEkiIndex = -1;	//0: s
			pUiData->bLoopOpposite = false;
		}


		//莞\r[Ԑ\
		if (i == 0)
		{
			if ((int)pTarget->getEkijikokukeisiki() == 1 ||
				(int)pTarget->getEkijikokukeisiki() == 2 ||
				(int)pTarget->getEkijikokukeisiki() == 3 ||
				(int)pTarget->getEkijikokukeisiki() == 4)
			{
				pUiData->iJikokuhyouTrackDisplayKudari = (int)pTarget->getJikokuhyouTrackDisplayKudari();
				pUiData->bJikokuhyouTrackDisplayKudariEnable = true;
			}
			else
			{
				pUiData->iJikokuhyouTrackDisplayKudari = 0;
				pUiData->bJikokuhyouTrackDisplayKudariEnable = false;
			}
		}
		else
		{
			pUiData->iJikokuhyouTrackDisplayKudari = 0;
			pUiData->bJikokuhyouTrackDisplayKudariEnable = false;
		}
		//莞\r[Ԑ\
		if (i == 0)
		{
			if ((int)pTarget->getEkijikokukeisiki() == 1 ||
				(int)pTarget->getEkijikokukeisiki() == 2 ||
				(int)pTarget->getEkijikokukeisiki() == 3 ||
				(int)pTarget->getEkijikokukeisiki() == 5)
			{
				pUiData->iJikokuhyouTrackDisplayNobori = (int)pTarget->getJikokuhyouTrackDisplayNobori();
				pUiData->bJikokuhyouTrackDisplayNoboriEnable = true;
			}
			else
			{
				pUiData->iJikokuhyouTrackDisplayNobori = 0;
				pUiData->bJikokuhyouTrackDisplayNoboriEnable = false;
			}
		}
		else
		{
			pUiData->iJikokuhyouTrackDisplayNobori = 0;
			pUiData->bJikokuhyouTrackDisplayNoboriEnable = false;
		}


		//_COr[Ԑ\
		if (i == 0)
		{
			if (((int)pTarget->getEkijikokukeisiki() == 1 ||
				(int)pTarget->getEkijikokukeisiki() == 2 || 
				(int)pTarget->getEkijikokukeisiki() == 3 )&&
				(int)pTarget->getEkikibo() == 1)
			{
				pUiData->iDiagramTrackDisplay = (int)pTarget->getDiagramTrackDisplay();
				pUiData->bDiagramTrackDisplayEnable = true;
			}
			else
			{
				pUiData->iDiagramTrackDisplay = 0;
				pUiData->bDiagramTrackDisplayEnable = false;
			}
		}
		//IA܂ݒ肪LŁAw`ȊOȂAݒ肪LB
		//I͖ɁB
		//else if (((int)pTarget->getEkijikokukeisiki() == 1 ||
		//	(int)pTarget->getEkijikokukeisiki() == 2 ||
		//	(int)pTarget->getEkijikokukeisiki() == 3) &&
		//	(int)pTarget->getEkikibo() == 1 &&
		//	pUiData->bDiagramTrackDisplayEnable )
		//{
		//	if (pUiData->iDiagramTrackDisplay != (int)pTarget->getDiagramTrackDisplay())
		//	{
		//		pUiData->iDiagramTrackDisplay = -1;
		//	}
		//}
		else
		{
			pUiData->iDiagramTrackDisplay = 0;
			pUiData->bDiagramTrackDisplayEnable = false;
		}

		//EkiTrack2
		if (i == 0 && m_pTarget->size() == 1)
		{
			const CentDedEkiTrack2Cont* pCentDedEkiTrack2Cont = pTarget->getEkiTrack2Cont();
			for (int idx = 0; idx < pCentDedEkiTrack2Cont->size(); idx++)
			{
				const CentDedEkiTrack2 aCentDedEkiTrack2 = pCentDedEkiTrack2Cont->get(idx);
				EkiTrack2 aEkiTrack2;
				aEkiTrack2.strTrackName = aCentDedEkiTrack2.getTrackName();
				aEkiTrack2.strTrackRyakusyou = aCentDedEkiTrack2.getTrackRyakusyou();
				aEkiTrack2.strTrackNoboriRyakusyou = aCentDedEkiTrack2.getTrackNoboriRyakusyou();
				if (pTarget->getDownMain() == idx + 1)
				{
					if (pTarget->getUpMain() == idx + 1)
					{
						//㉺{
						aEkiTrack2.iMainTrack = 3;
					}
					else
					{
						//{
						aEkiTrack2.iMainTrack = 1;
					}
				}
				else
				{
					if (pTarget->getUpMain() == idx + 1)
					{
						//{");
						aEkiTrack2.iMainTrack = 2;
					}
					else
					{
						//{/");
						aEkiTrack2.iMainTrack = 0;
					}
				}
				pUiData->sEkiTrack2.push_back(aEkiTrack2);
			}
		}
		//OuterTerminalEkimei
		if (i == 0 && m_pTarget->size() == 1)
		{
			int iSize = pTarget->getOuterTerminalEkimeiCount();
			for (int idx = 0; idx < iSize; idx++)
			{
				pUiData->sOuterTerminalEkimei.push_back(pTarget->getOuterTerminalEkimei(idx));
			}
		}

		// w܂ł̋ 
		if (i == 0)
		{
			pUiData->iNextEkiDistance = pTarget->getNextEkiDistance();
		}
		else if (pUiData->iNextEkiDistance != pTarget->getNextEkiDistance())
		{
			pUiData->iNextEkiDistance = 0;
		}

		//Ԑ\ȗݒ
		if (i == 0)
		{
			if ((int)pTarget->getEkijikokukeisiki() == 0 ||
				(int)pTarget->getEkijikokukeisiki() == 4 ||
				(int)pTarget->getEkijikokukeisiki() == 5)
			{
				pUiData->iJikokuhyouTrackOmit = (int)pTarget->getJikokuhyouTrackOmit();
				pUiData->bJikokuhyouTrackOmitEnable = true;
			}
			else
			{
				pUiData->iJikokuhyouTrackOmit = 0;
				pUiData->bJikokuhyouTrackOmitEnable = false;
			}
		}
		else
		{
			pUiData->iJikokuhyouTrackOmit = 0;
			pUiData->bJikokuhyouTrackOmitEnable = false;
		}
	}

	// [ww`ŐK]̐ݒ
	pUiData->bAdjustByEkijikokukeisiki = *m_pbAdjustByEkijikokukeisiki ;
}
	
void CPropEditUi_Eki::AdjustUiData( 
		UIDATA* pUiData , 
		const UIDATA* pUiDataPrev , 
		bool bStartEdit )
{
	/* w */
	if ( bStartEdit || pUiDataPrev->strEkimei != pUiData->strEkimei)
	{
		// pUiData->o[ ̐KsR[hB
	}
	/* w` */
	if ( bStartEdit || pUiDataPrev->iEkijikokukeisiki != pUiData->iEkijikokukeisiki)
	{
		if (pUiData->iEkikibo == 1 && !pUiData->bBrunch &&
			m_pTarget->size() == 1 &&
			(pUiData->iEkijikokukeisiki == 1 ||
				pUiData->iEkijikokukeisiki == 2 ||
				pUiData->iEkijikokukeisiki == 3))
		{
			pUiData->bDiagramTrackDisplayEnable = true;
		}
		else
		{
			pUiData->bDiagramTrackDisplayEnable = false;
		}

		if (m_pTarget->size() == 1 &&
			(pUiData->iEkijikokukeisiki == 1 ||
			pUiData->iEkijikokukeisiki == 2 ||
			pUiData->iEkijikokukeisiki == 3 ||
			pUiData->iEkijikokukeisiki == 4 )
			)
		{
			pUiData->bJikokuhyouTrackDisplayKudariEnable = true;
		}
		else if (pUiData->iEkijikokukeisiki == 0 ||
			pUiData->iEkijikokukeisiki == 5)
		{
			pUiData->bJikokuhyouTrackDisplayKudariEnable = false;
		}

		if (m_pTarget->size() == 1 &&
			(pUiData->iEkijikokukeisiki == 1 ||
				pUiData->iEkijikokukeisiki == 2 ||
				pUiData->iEkijikokukeisiki == 3 ||
				pUiData->iEkijikokukeisiki == 5)
			)
		{
			pUiData->bJikokuhyouTrackDisplayNoboriEnable = true;
		}
		else if (pUiData->iEkijikokukeisiki == 0 ||
			pUiData->iEkijikokukeisiki == 4)
		{
			pUiData->bJikokuhyouTrackDisplayNoboriEnable = false;
		}

		if (m_pTarget->size() == 1 &&
			(pUiData->iEkijikokukeisiki == 0 ||
				pUiData->iEkijikokukeisiki == 4 ||
				pUiData->iEkijikokukeisiki == 5)
			)
		{
			pUiData->bJikokuhyouTrackOmitEnable = true;
		}
		else if (pUiData->iEkijikokukeisiki == 1 ||
			pUiData->iEkijikokukeisiki == 2 ||
			pUiData->iEkijikokukeisiki == 3)
		{
			pUiData->bJikokuhyouTrackOmitEnable = false;
		}

		/*if (pUiData->iEkijikokukeisiki == 0)
		{
			pUiData->bJikokuhyouTrackDisplayEnable = false;
			pUiData->bDiagramTrackDisplayEnable = false;
		}
		else if (pUiData->iEkijikokukeisiki == 1)
		{
			pUiData->bJikokuhyouTrackDisplayEnable = true;
			pUiData->bDiagramTrackDisplayEnable = true;

		}
		else if (pUiData->iEkijikokukeisiki == 2 &&
			pUiData->iEkijikokukeisiki == 3)
		{
			pUiData->bJikokuhyouTrackDisplayEnable = true;
			if (pUiData->bBrunch)
			{
				pUiData->bDiagramTrackDisplayEnable = false;
			}
			else
			{
				pUiData->bDiagramTrackDisplayEnable = true;
			}

		}
		else if (pUiData->iEkijikokukeisiki == 4 &&
			pUiData->iEkijikokukeisiki == 5)
		{
			pUiData->bJikokuhyouTrackDisplayEnable = true;
			pUiData->bDiagramTrackDisplayEnable = false;

		}*/
		// pUiData->o[ ̐KsR[hB
	}
	/* wK */
	if ( bStartEdit || pUiDataPrev->iEkikibo != pUiData->iEkikibo)
	{
		// pUiData->o[ ̐KsR[hB
		if (pUiData->iEkikibo == 1 && !pUiData->bBrunch &&
			m_pTarget->size() == 1 &&
			(pUiData->iEkijikokukeisiki == 1 ||
			pUiData->iEkijikokukeisiki == 2 ||
			pUiData->iEkijikokukeisiki == 3))
		{
			pUiData->bDiagramTrackDisplayEnable = true;
		}
		else
		{
			pUiData->bDiagramTrackDisplayEnable = false;
		}
	}

	/* E */
	//if ( bStartEdit || pUiDataPrev->iKyoukaisen != pUiData->iKyoukaisen)
	//{
	//	// pUiData->o[ ̐KsR[hB
	//}

	/* _COԏ\ij */
	if ( bStartEdit || pUiDataPrev->iDiagramRessyajouhouHyoujiKudari != pUiData->iDiagramRessyajouhouHyoujiKudari)
	{
		// pUiData->o[ ̐KsR[hB
	}

	/* _COԏ\ij */
	if ( bStartEdit || pUiDataPrev->iDiagramRessyajouhouHyoujiNobori != pUiData->iDiagramRessyajouhouHyoujiNobori)
	{
		// pUiData->o[ ̐KsR[hB
	}

	/*	[ww`ŐK]̐ݒłB*/
	if ( bStartEdit || pUiDataPrev->bAdjustByEkijikokukeisiki != pUiData->bAdjustByEkijikokukeisiki)
	{
		// pUiData->o[ ̐KsR[hB
	}

	///* {ݒij */
	//if (bStartEdit || pUiDataPrev->iDownMain != pUiData->iDownMain)
	//{
	//	// pUiData->o[ ̐KsR[hB
	//}

	///* {ݒij */
	//if (bStartEdit || pUiDataPrev->iUpMain != pUiData->iUpMain)
	//{
	//	// pUiData->o[ ̐KsR[hB
	//}

	//wݒ
	if (bStartEdit || pUiDataPrev->bBrunch != pUiData->bBrunch)
	{
		if (pUiData->iEkikibo == 1 && !pUiData->bBrunch &&
			m_pTarget->size() == 1 &&
			(pUiData->iEkijikokukeisiki == 1 ||
				pUiData->iEkijikokukeisiki == 2 ||
				pUiData->iEkijikokukeisiki == 3))
		{
			pUiData->bDiagramTrackDisplayEnable = true;
		}
		else
		{
			pUiData->bDiagramTrackDisplayEnable = false;
		}

		if (pUiData->bBrunch)
		{
			pUiData->iEkikibo = 1;//vwɂB
			//w`蒅ȊȌꍇAl蒅ɁB
			if (pUiData->iEkijikokukeisiki != 3 )
			{
				pUiData->iEkijikokukeisiki = 2;
			}
			if (m_bLoopFunctionEnable)
			{
				pUiData->bLoopFunctionEnable = false;
			}
		}
		else
		{
			if (m_bLoopFunctionEnable)
			{
				pUiData->bLoopFunctionEnable = true;
			}
		}
	}
	//wݒwIndex
	if (bStartEdit || pUiDataPrev->iBrunchCoreEkiIndex != pUiData->iBrunchCoreEkiIndex)
	{

	}
	//ݒ
	if (bStartEdit || pUiDataPrev->bLoop != pUiData->bLoop)
	{
		//if (pUiData->iEkikibo == 1 && !pUiData->bLoop &&
		//	m_pTarget->size() == 1 &&
		//	(pUiData->iEkijikokukeisiki == 1 ||
		//		pUiData->iEkijikokukeisiki == 2 ||
		//		pUiData->iEkijikokukeisiki == 3))
		//{
		//	pUiData->bDiagramTrackDisplayEnable = true;
		//}
		//else
		//{
		//	pUiData->bDiagramTrackDisplayEnable = false;
		//}

		if (pUiData->bLoop)
		{
			pUiData->iEkikibo = 1;//vwɂB
								  //w`蒅ȊȌꍇAl𔭒ɁB
			if (pUiData->iEkijikokukeisiki != 2)
			{
				pUiData->iEkijikokukeisiki = 1;
			}
			if (m_bBrunchFunctionEnable)
			{
				pUiData->bBrunchFunctionEnable = false;
			}
		}
		else
		{
			if (m_bBrunchFunctionEnable)
			{
				pUiData->bBrunchFunctionEnable = true;
			}

		}
	}
	//Index
	if (bStartEdit || pUiDataPrev->iLoopOriginEkiIndex != pUiData->iLoopOriginEkiIndex)
	{

	}
	//莞\r[Ԑ\
	if (bStartEdit || pUiDataPrev->iJikokuhyouTrackDisplayKudari != pUiData->iJikokuhyouTrackDisplayKudari)
	{
	/*if (pUiData->iEkijikokukeisiki != 0)
	{
		pUiData->bJikokuhyouTrackDisplayEnable = true;
	}
	else
	{
		pUiData->bJikokuhyouTrackDisplayEnable = false;

	}*/
	}
	//莞\r[Ԑ\
	if (bStartEdit || pUiDataPrev->iJikokuhyouTrackDisplayNobori != pUiData->iJikokuhyouTrackDisplayNobori)
	{
	}
	//_COr[Ԑ\
	if (bStartEdit || pUiDataPrev->bDiagramTrackDisplayEnable != pUiData->bDiagramTrackDisplayEnable)
	{
	/*if ((pUiData->iEkijikokukeisiki == 1 ||
		pUiData->iEkijikokukeisiki == 2 ||
		pUiData->iEkijikokukeisiki == 3) &&
		pUiData->iEkikibo == 1 	)
	{
		if (pUiData->bBrunch)
		{
			pUiData->bDiagramTrackDisplayEnable = false;
		}
		else
		{
			pUiData->bDiagramTrackDisplayEnable = true;
		}
	}
	else
	{
		pUiData->bDiagramTrackDisplayEnable = false;

	}*/
	}
}

int CPropEditUi_Eki::CheckUiData( 
		bool bNewItem , 
		const UIDATA* pUiData , 
		const UIDATA* pUiDataStartEdit ) 
{
	int iRv = 0 ; 
	/* w */
	if ( iRv >= 0 )
	{
		if ( bNewItem || pUiDataStartEdit->strEkimei != pUiData->strEkimei)
		{
			if ( pUiData->strEkimei.length() > 58 )
			{
				ShowError( ERRMSG_EKIMEI_TOO_LONG ) ;
				SetFocus( offsetof( UIDATA , strEkimei )) ;
				iRv = -1 ;	//	w܂B
			}
			else if (pUiData->strEkimei.length() == 0)
			{
				iRv = -1;      //  ww肳Ă܂
				ShowError(ERRMSG_EKIMEI_EMPTY);
				SetFocus(offsetof(UIDATA, strEkimei));
			}
		}
	}
	/* w` */
	if ( iRv >= 0 )
	{
		if ( bNewItem || pUiDataStartEdit->iEkijikokukeisiki != pUiData->iEkijikokukeisiki)
		{
			// pUiData->o[ ̃G[`FbNsR[hB
		}
	}
	/* wK */
	if ( iRv >= 0 )
	{
		if ( bNewItem || pUiDataStartEdit->iEkikibo != pUiData->iEkikibo)
		{
			// pUiData->o[ ̃G[`FbNsR[hB
		}
	}
	/* E */
	//if ( iRv >= 0 )
	//{
	//	if ( bNewItem || pUiDataStartEdit->iKyoukaisen != pUiData->iKyoukaisen)
	//	{
	//		// pUiData->o[ ̃G[`FbNsR[hB
	//	}
	//}
	/* _COԏ\ij */
	if ( iRv >= 0 )
	{
		if ( bNewItem || pUiDataStartEdit->iDiagramRessyajouhouHyoujiKudari != pUiData->iDiagramRessyajouhouHyoujiKudari)
		{
			// pUiData->o[ ̃G[`FbNsR[hB
		}
	}
	/* _COԏ\ij */
	if ( iRv >= 0 )
	{
		if ( bNewItem || pUiDataStartEdit->iDiagramRessyajouhouHyoujiNobori != pUiData->iDiagramRessyajouhouHyoujiNobori)
		{
			// pUiData->o[ ̃G[`FbNsR[hB
		}
	}
	/*	[ww`ŐK]̐ݒłB*/
	if ( iRv >= 0 )
	{
		if ( bNewItem || pUiDataStartEdit->bAdjustByEkijikokukeisiki != pUiData->bAdjustByEkijikokukeisiki)
		{
			// pUiData->o[ ̃G[`FbNsR[hB
		}
	}
	///* {ݒij */
	//if (iRv >= 0)
	//{
	//	if (bNewItem || pUiDataStartEdit->iDownMain != pUiData->iDownMain)
	//	{
	//		// pUiData->o[ ̃G[`FbNsR[hB
	//	}
	//}
	///* {ݒij */
	//if (iRv >= 0)
	//{
	//	if (bNewItem || pUiDataStartEdit->iUpMain != pUiData->iUpMain)
	//	{
	//		// pUiData->o[ ̃G[`FbNsR[hB
	//	}
	//}
	//wݒ
	if (iRv >= 0 && m_pTarget->size() == 1)
	{
		if (pUiData->bBrunch)
		{
			if (pUiData->iBrunchCoreEkiIndex < 0)
			{
				ShowError(ERRMSG_BRUNCH_EKIINDEX);
				SetFocus(offsetof(UIDATA, iBrunchCoreEkiIndex));
				iRv = -2;//wݒON̎́Aww肵ĂB
			}
			//wƑΏۉw̃CfNXrA召֌WɂāAw̔s
			else if (m_iEkiIndex > pUiData->iBrunchCoreEkiIndex)
			{
				if (pUiData->iEkijikokukeisiki != 3)//3=蒅
				{
					ShowError(ERRMSG_BRUNCH_EKIJIKOKUKEISIKI_UPCHAKU);
					SetFocus(offsetof(UIDATA, iEkijikokukeisiki));
					iRv = -3;//wݒON̎́Aw`蒅ɂĂB
				}
			}
			else if (m_iEkiIndex < pUiData->iBrunchCoreEkiIndex)
			{
				if (pUiData->iEkijikokukeisiki != 2)//2=蒅
				{
					ShowError(ERRMSG_BRUNCH_EKIJIKOKUKEISIKI_DOWNCHAKU);
					SetFocus(offsetof(UIDATA, iEkijikokukeisiki));
					iRv = -4;//wݒON̎́Aw`蒅ɂĂB
				}
			}

			if (pUiData->iEkikibo != 1)
			{
				ShowError(ERRMSG_BRUNCH_EKIKIBO);
				SetFocus(offsetof(UIDATA, iEkikibo));
				iRv = -5;//wݒON̎́AwK͎͂vwɂĂ
			}
		}
	}
	//ݒ
	if (iRv >= 0 && m_pTarget->size() == 1)
	{
		if (pUiData->bLoop)
		{
			if (pUiData->iLoopOriginEkiIndex < 0)
			{
				ShowError(ERRMSG_LOOP_EKIINDEX);
				SetFocus(offsetof(UIDATA, iLoopOriginEkiIndex));
				iRv = -2;//ݒON̎́AN_ww肵ĂB
			}
			//wƑΏۉw̃CfNXrA召֌WɂāAw̔s
			//else if (m_iEkiIndex > pUiData->iBrunchCoreEkiIndex)
			//{

			//w̔s
			if (pUiData->iEkijikokukeisiki != 1 && //1=
				pUiData->iEkijikokukeisiki != 2)//3=蒅
			{
				ShowError(ERRMSG_LOOP_EKIJIKOKUKEISIKI_HATSUCHAKU_DOWNCHAKU);
				SetFocus(offsetof(UIDATA, iEkijikokukeisiki));
				iRv = -3;//ݒON̎́Aw`𔭒܂͏蒅ɂĂB
			}

			//}
			//else if (m_iEkiIndex < pUiData->iBrunchCoreEkiIndex)
			//{
			//	if (pUiData->iEkijikokukeisiki != 2)//2=蒅
			//	{
			//		ShowError(ERRMSG_BRUNCH_EKIJIKOKUKEISIKI_DOWNCHAKU);
			//		SetFocus(offsetof(UIDATA, iEkijikokukeisiki));
			//		iRv = -4;//wݒON̎́Aw`蒅ɂĂB
			//	}
			//}

			if (pUiData->iEkikibo != 1)
			{
				ShowError(ERRMSG_LOOP_EKIKIBO);
				SetFocus(offsetof(UIDATA, iEkikibo));
				iRv = -5;//ݒON̎́AwK͎͂vwɂĂ
			}
		}
	}
	return iRv ;
}




int CPropEditUi_Eki::UiDataToTarget( 
		bool bNewItem , 
		const UIDATA* pUiData , 
		const UIDATA* pUiDataStartEdit ) 
{
	int iRv = 0 ;
	for ( int i = 0 ; iRv >= 0 && i < m_pTarget->size() ; i ++ )
	{
		CentDedEki* pTarget= m_pTarget->get( i ) ; 
		/* w */
		if ( bNewItem || pUiDataStartEdit->strEkimei != pUiData->strEkimei)
		{
			pTarget->setEkimei( pUiData->strEkimei ) ;
		}
		/* w` */
		if ( bNewItem || pUiDataStartEdit->iEkijikokukeisiki != pUiData->iEkijikokukeisiki)
		{
			pTarget->setEkijikokukeisiki( 
				(CentDedEki::EEkijikokukeisiki)pUiData->iEkijikokukeisiki ) ;
		}
		/* wK */
		if ( bNewItem || pUiDataStartEdit->iEkikibo != pUiData->iEkikibo)
		{
			pTarget->setEkikibo( (CentDedEki::EEkikibo)pUiData->iEkikibo ) ;
		}
		/* E */
		//if ( bNewItem || pUiDataStartEdit->iKyoukaisen != pUiData->iKyoukaisen)
		//{
		//	pTarget->setKyoukaisen( pUiData->iKyoukaisen != 0 );
		//}
		/* _COԏ\ij */
		if ( bNewItem || pUiDataStartEdit->iDiagramRessyajouhouHyoujiKudari != pUiData->iDiagramRessyajouhouHyoujiKudari)
		{
			pTarget->setDiagramRessyajouhouHyoujiKudari(
				(CentDedEki::EDiagramRessyajouhouHyouji)pUiData->iDiagramRessyajouhouHyoujiKudari ) ;
		}
		/* _COԏ\ij */
		if ( bNewItem || pUiDataStartEdit->iDiagramRessyajouhouHyoujiNobori != pUiData->iDiagramRessyajouhouHyoujiNobori)
		{
			pTarget->setDiagramRessyajouhouHyoujiNobori(
				(CentDedEki::EDiagramRessyajouhouHyouji)pUiData->iDiagramRessyajouhouHyoujiNobori ) ;
		}
		//if (m_pTarget->size() == 1)
		//{
		//	/* {ݒij */
		//	if (bNewItem || pUiDataStartEdit->iDownMain != pUiData->iDownMain)
		//	{
		//		pTarget->setDownMain((int)pUiData->iDownMain);
		//	}
		//	/* {ݒij */
		//	if (bNewItem || pUiDataStartEdit->iUpMain != pUiData->iUpMain)
		//	{
		//		pTarget->setUpMain((int)pUiData->iUpMain);
		//	}
		//}

		//wݒ
		if (m_pTarget->size() == 1)
		{
			if (pUiData->bBrunchFunctionEnable)
			{
				if (pUiData->bBrunch)
				{
					pTarget->setBrunchCoreEkiIndex(pUiData->iBrunchCoreEkiIndex);
					pTarget->setBrunchOpposite(pUiData->bBrunchOpposite);
				}
				else
				{
					pTarget->setBrunchCoreEkiIndex(-1);
					pTarget->setBrunchOpposite(false);
				}
			}
			else
			{
				pTarget->setBrunchCoreEkiIndex(-1);
				pTarget->setBrunchOpposite(false);
			}
		}
		//ݒ
		if (m_pTarget->size() == 1)
		{
			if (pUiData->bLoopFunctionEnable)
			{
				if (pUiData->bLoop)
				{
					pTarget->setLoopOriginEkiIndex(pUiData->iLoopOriginEkiIndex);
					pTarget->setLoopOpposite(pUiData->bLoopOpposite);
				}
				else
				{
					pTarget->setLoopOriginEkiIndex(-1);
					pTarget->setLoopOpposite(false);
				}
			}
			else
			{
				pTarget->setLoopOriginEkiIndex(-1);
				pTarget->setLoopOpposite(false);
			}
		}
		//莞\r[Ԑ\
		if (bNewItem)
		{
			pTarget->setJikokuhyouTrackDisplayKudari(pUiData->iJikokuhyouTrackDisplayKudari != 0);
		}
		else if ( pUiDataStartEdit->iJikokuhyouTrackDisplayKudari != pUiData->iJikokuhyouTrackDisplayKudari &&
			pUiData->bJikokuhyouTrackDisplayKudariEnable)
		{
			pTarget->setJikokuhyouTrackDisplayKudari(pUiData->iJikokuhyouTrackDisplayKudari != 0);
		}
		else if(!pUiData->bJikokuhyouTrackDisplayKudariEnable)
		{
			pTarget->setJikokuhyouTrackDisplayKudari( false );
		}
		//莞\r[Ԑ\
		if (bNewItem)
		{
			pTarget->setJikokuhyouTrackDisplayNobori(pUiData->iJikokuhyouTrackDisplayNobori != 0);
		}
		else if (pUiDataStartEdit->iJikokuhyouTrackDisplayNobori != pUiData->iJikokuhyouTrackDisplayNobori &&
			pUiData->bJikokuhyouTrackDisplayNoboriEnable)
		{
			pTarget->setJikokuhyouTrackDisplayNobori(pUiData->iJikokuhyouTrackDisplayNobori != 0);
		}
		else if (!pUiData->bJikokuhyouTrackDisplayNoboriEnable)
		{
			pTarget->setJikokuhyouTrackDisplayNobori(false);
		}
		//_COr[Ԑ\
		if (bNewItem)
		{
			pTarget->setDiagramTrackDisplay(pUiData->iDiagramTrackDisplay != 0);
		}
		else if (pUiDataStartEdit->iDiagramTrackDisplay != pUiData->iDiagramTrackDisplay &&
			pUiData->bDiagramTrackDisplayEnable)
		{
			pTarget->setDiagramTrackDisplay(pUiData->iDiagramTrackDisplay != 0);
		}
		else if (!pUiData->bDiagramTrackDisplayEnable)
		{
			pTarget->setDiagramTrackDisplay(false);
		}

		//EkiTrack2
		if (m_pTarget->size() == 1)
		{
			CentDedEkiTrack2Cont* pCentDedEkiTrack2Cont = pTarget->getEkiTrack2Cont();
			int iMainDown = 0;
			int iMainUp = 0;
			for (int idx = 0; idx < (int)pUiData->sEkiTrack2.size(); idx++)
			{
				CentDedEkiTrack2 aCentDedEkiTrack2(
					pUiData->sEkiTrack2[idx].strTrackName,
					pUiData->sEkiTrack2[idx].strTrackRyakusyou,
					pUiData->sEkiTrack2[idx].strTrackNoboriRyakusyou);
				if (iMainDown == 0 &&
					(pUiData->sEkiTrack2[idx].iMainTrack == 1 ||
					pUiData->sEkiTrack2[idx].iMainTrack == 3))
				{
					iMainDown = idx + 1;
				}
				if (iMainUp == 0 &&
					(pUiData->sEkiTrack2[idx].iMainTrack == 2 ||
						pUiData->sEkiTrack2[idx].iMainTrack == 3))
				{
					iMainUp = idx + 1;
				}
				if (idx < pCentDedEkiTrack2Cont->size())
				{
					pCentDedEkiTrack2Cont->set(aCentDedEkiTrack2, idx);
				}
				else
				{
					pCentDedEkiTrack2Cont->insert(aCentDedEkiTrack2);
				}

			}
			if ((int)pUiData->sEkiTrack2.size() < pCentDedEkiTrack2Cont->size())
			{
				pCentDedEkiTrack2Cont->erase(pUiData->sEkiTrack2.size(), INT_MAX);
			}
			if (iMainDown > 0)
			{
				pTarget->setDownMain(iMainDown);
			}
			if (iMainUp > 0)
			{
				pTarget->setUpMain(iMainUp);
			}
		}
		//OuterTerminalEkimei
		if (m_pTarget->size() == 1)
		{
			for (int idx = 0; idx < (int)pUiData->sOuterTerminalEkimei.size(); idx++)
			{
				if (idx < pTarget->getOuterTerminalEkimeiCount())
				{
					pTarget->setOuterTerminalEkimei(pUiData->sOuterTerminalEkimei[idx], idx);
				}
				else
				{
					pTarget->insertOuterTerminalEkimei(pUiData->sOuterTerminalEkimei[idx]);
				}
			}
			if ((int)pUiData->sOuterTerminalEkimei.size() < pTarget->getOuterTerminalEkimeiCount())
			{
				pTarget->eraseOuterTerminalEkimei(pUiData->sOuterTerminalEkimei.size(), INT_MAX);
			}
		}
		/* w܂ł̋  */
		if (bNewItem || pUiDataStartEdit->iNextEkiDistance != pUiData->iNextEkiDistance)
		{
			pTarget->setNextEkiDistance(pUiData->iNextEkiDistance);
		}
		//Ԑ\ȗݒ
		if (bNewItem)
		{
			pTarget->setJikokuhyouTrackOmit(pUiData->iJikokuhyouTrackOmit != 0);
		}
		else if (pUiDataStartEdit->iJikokuhyouTrackOmit != pUiData->iJikokuhyouTrackOmit &&
			pUiData->bJikokuhyouTrackOmitEnable)
		{
			pTarget->setJikokuhyouTrackOmit(pUiData->iJikokuhyouTrackOmit != 0);
		}
		else if (!pUiData->bJikokuhyouTrackOmitEnable)
		{
			pTarget->setJikokuhyouTrackOmit(false);
		}
	}
	/*	[ww`ŐK]̐ݒłB*/
	if ( iRv >= 0 )
	{
		if ( bNewItem || pUiDataStartEdit->bAdjustByEkijikokukeisiki != pUiData->bAdjustByEkijikokukeisiki)
		{
			// [ww`ŐK]̐ݒ
			*m_pbAdjustByEkijikokukeisiki = pUiData->bAdjustByEkijikokukeisiki ;
		}
	}
	return iRv ;
}


	// ********************************
	//	RXgN^
	// ********************************
CPropEditUi_Eki::CPropEditUi_Eki( 
	bool bNewItem , 
	Mu<CentDedEki*>* pTarget ,
	bool* pbAdjustByEkijikokukeisiki,
	int iEkiIndex,
	bool bEkijikokukeisikiAndEkikiboEnable,
	bool bBrunchFunctionEnable,
	bool bLoopFunctionEnable)
	: CPropEditUi2( bNewItem ) 
	, m_pTarget( pTarget ) 
	, m_pbAdjustByEkijikokukeisiki( pbAdjustByEkijikokukeisiki )
	, m_iEkiIndex(iEkiIndex)
	, m_bEkijikokukeisikiAndEkikiboEnable(bEkijikokukeisikiAndEkikiboEnable)
	, m_bBrunchFunctionEnable(bBrunchFunctionEnable)
	, m_bLoopFunctionEnable(bLoopFunctionEnable)
{	
};

} //namespace ViewEki 



