/*
OuDiaSecond Copyright (C) 2017-2018 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// ****************************************************************
//	$Id: CPropEditUI_Ekijikoku.cpp 357 2016-08-18 16:59:16Z okm $
// ****************************************************************

/** @file */

#include "stdafx.h"
#include "NsMu\CConvTable.h"
#include "CPropEditUi_EkiJikoku.h"
#include "str\CStrCharSizeMb.h"
#include "str\strLf.h"
//#include "Str\tstring.h"
#include "Str\strToWstr.h"

namespace ViewJikokuhyou{
	using namespace OuLib::Str;

		
/** _CAO{bNXւ̎̏ێ܂B */
const CdDedJikoku::CConv	g_CdDedJikokuConv(
	true ,		//	NoColon 
	CdDedJikoku::CConv::EHour_ZeroToNone ,		//	HourZeroToNone 
	CdDedJikoku::CConv::ESecond_NotIfZero ) ;	//	NoSecond


/**
	UI`߂āAɕϊ܂B
	GfBbgRg[̓e2̏ꍇ́A
	ỎwOrderƂɁA⊮܂B
@param strUIJikoku [in]
	UI`̎w肵ĂB
@param jikokuRevOrder [in]
	ÓwwxB
	̒ĺAstrControl̂(2)̏ꍇA⊮̂Ɏg܂B
	wNULLԁx̏ꍇA̕⊮͍s܂B
@param pCdDedJikoku [out]
	̊֐́Ả߂ɐA̓eϊ
	ɏ݂܂B
@param bBefore
	truȅꍇAjikokuRevOrderO̎Ƃ悤ɕϊ܂
@return
	 0 ȏBւ̕ϊłȂΕ̐łB
	-	-1 ;	//	ڐsĂ܂B
	-	-2 ;	//	EEb̕\LsłB
*/
static int	getJikokuFromUI( 
	const tstring& strUIJikoku , 
	const CdDedJikoku& jikokuRevOrder , 
	CdDedJikoku* pCdDedJikoku ,
	const bool bBefore) 
{
	int	iRv = 0 ;
	CdDedJikoku	aCdDedJikoku ;
	tstring	strControl = tstringOf(CStrCharSizeMb::strToSingleByte( 
		stringOf(OuLib::Str::strTrim( strUIJikoku) ) ) ) ;

	int iResult = aCdDedJikoku.decode( strControl ) ;
	if ( iResult < 0 )
	{
		iRv = iResult ;
		//	񂪉߂ł܂B
	}
	//iRv = 
	//-	-1 ;	//	ڐsĂ܂B
	//-	-2 ;	//	EEb̕\LsłB

	//	2ŁAỎwꍇ́A
	//	Ɏ⊮
	if ( iRv == -1 && 
		 !jikokuRevOrder.isNull() && 
		strControl.size() == 2 && 
		isdigit( strControl[0] ) && 
		isdigit( strControl[1] ) )
	{
		if (bBefore)
		{
			int iMin = _ttoi(strControl.c_str());
			if (0 <= iMin && iMin < 60)
			{
				aCdDedJikoku.setTime(jikokuRevOrder.getHour(), iMin);
				CdDedJikan	jikanSub = aCdDedJikoku.subJikoku(
					jikokuRevOrder);
				if (jikanSub.getTotalSeconds() > 0)
				{
					aCdDedJikoku = aCdDedJikoku.getTotalSeconds() - 60 * 60;
				}
				//aCdDedJikoku = ݓ͂ꂽ2̕ɁA
				//	jikokuRevOrder ȌƂȂ鎞⊮

				iRv = 0;	//	⊮ɐ܂B 
			}
		}
		else
		{
			int iMin = _ttoi(strControl.c_str());
			if (0 <= iMin && iMin < 60)
			{
				aCdDedJikoku.setTime(jikokuRevOrder.getHour(), iMin);
				CdDedJikan	jikanSub = aCdDedJikoku.subJikoku(
					jikokuRevOrder);
				if (jikanSub.getTotalSeconds() < 0)
				{
					aCdDedJikoku = aCdDedJikoku.getTotalSeconds() + 60 * 60;
				}
				//aCdDedJikoku = ݓ͂ꂽ2̕ɁA
				//	jikokuRevOrder ȌƂȂ鎞⊮

				iRv = 0;	//	⊮ɐ܂B 
			}
		}
	}

	// --------------------------------
	if ( pCdDedJikoku != NULL )
	{
		*pCdDedJikoku = aCdDedJikoku ;
	}
	return iRv ;
}

	// ********************************
	//@name G[bZ[W
	// ********************************
const TCHAR* const CPropEditUi_EkiJikoku::ERRMSG_INVALID_CHAKUJIKOKU = _T("Invalid ChakuJikoku.");
const TCHAR* const CPropEditUi_EkiJikoku::ERRMSG_INVALID_HATSUJIKOKU = _T("Invalid HatsuJikoku.");
const TCHAR* const CPropEditUi_EkiJikoku::ERRMSG_INVALID_SHUNTTRACK = _T("Invalid ShuntTrack.");
const TCHAR* const CPropEditUi_EkiJikoku::ERRMSG_INVALID_OPERATIONHATSUJIKOKU = _T("Invalid OperationHatsuJikoku.");
const TCHAR* const CPropEditUi_EkiJikoku::ERRMSG_INVALID_OPERATIONCHAKUJIKOKU = _T("Invalid OperationChakuJikoku.");
const TCHAR* const CPropEditUi_EkiJikoku::ERRMSG_INVALID_OUTERHATSUCHAKUJIKOKU = _T("Invalid OuterHatsuChakuJikoku.");




	// ================================
	//@name ֐
	// ================================


const CConvTable<CentDedEkiJikoku::EEkiatsukai,int>& getEkiatsukaiConvTable()
{
	static CConvTable<CentDedEkiJikoku::EEkiatsukai,int>	aTable ;
	if ( aTable.size() == 0 )
	{
		aTable.add( CentDedEkiJikoku::Ekiatsukai_None     , 0 ) ;//	^sȂ
		aTable.add( CentDedEkiJikoku::Ekiatsukai_Teisya   , 1 ) ;//	
		aTable.add( CentDedEkiJikoku::Ekiatsukai_Tsuuka   , 2 ) ;//	ʉ
		aTable.add( CentDedEkiJikoku::Ekiatsukai_Keiyunasi, 3 ) ;// oRȂ
	}
	return aTable ;
}

const CConvTable<CentDedRessyaTrack::EOperation, int>& getOperationConvTable()
{
	static CConvTable<CentDedRessyaTrack::EOperation, int>	aTable;
	if (aTable.size() == 0)
	{
		aTable.add(CentDedRessyaTrack::Operation_None, 0);//	ƂȂ
		aTable.add(CentDedRessyaTrack::Operation_Shunt, 1);//	
		aTable.add(CentDedRessyaTrack::Operation_InOut, 2);//	o
		aTable.add(CentDedRessyaTrack::Operation_Outer, 3);//	HO
	}
	return aTable;
}
	// ================================
	//@name UiData - TargetԂ̃f[^]
	// ================================

	

void CPropEditUi_EkiJikoku::UiDataFromTarget( UIDATA* pUiData ) 
{
	CdDedJikoku::CConv	aJikokuConv( g_CdDedJikokuConv ) ;
	for (int i = 0; i < m_pTarget->size(); i++)
	{
		CentDedRessya* pRessya = m_pTarget->get(i);
		CentDedEkiJikoku aEkiJikoku
			= pRessya->getCentDedEkiJikoku(m_iEkiOrder);
		CentDedRessyaTrack aRessyaTrack
			= pRessya->getCentDedRessyaTrack(m_iEkiOrder);

		/*	 w
			 -	 0: ^sȂ
			 -	 1: 
			 -	 2: ʉ
			 -	 3: oRȂ
			 -	-1: IȂ
		*/
		if (i == 0)
		{
			pUiData->iEkiatsukai = getEkiatsukaiConvTable().rightFrom(
				aEkiJikoku.getEkiatsukai());
		}
		else if (pUiData->iEkiatsukai != getEkiatsukaiConvTable().rightFrom(
			aEkiJikoku.getEkiatsukai()))
		{
			pUiData->iEkiatsukai = -1;
		}

		/* 	*/
		if (i == 0)
		{
			//	PIA
			//	wʉ߁EԂȂALETarget𔽉f
			//@@oRȂȂL
			//@@^sȂȂL
			if (pUiData->iEkiatsukai == 1		// 
				|| pUiData->iEkiatsukai == 2)	// ʉ
			{
				pUiData->strChakujikoku = aJikokuConv.encode(
					aEkiJikoku.getChakujikoku());
			}
			pUiData->bChakujikokuIsEnable = true;
		}
		else
		{
			//ÍA͋E
			pUiData->strChakujikoku = _T("");
			pUiData->bChakujikokuIsEnable = false;
		}

		/* 	*/
		if (i == 0)
		{
			//	PIA
			//	wʉ߁EԂȂALETarget𔽉f
			//@@oRȂȂL
			//@@^sȂȂL
			if (pUiData->iEkiatsukai == 1		// 
				|| pUiData->iEkiatsukai == 2)	// ʉ
			{
				pUiData->strHatsujikoku
					= aJikokuConv.encode(aEkiJikoku.getHatsujikoku());
			}
			pUiData->bHatsujikokuIsEnable = true;
		}
		else
		{
			//ÍA͋E
			pUiData->strHatsujikoku = _T("");
			pUiData->bHatsujikokuIsEnable = false;
		}

		/* Ԑ*/
		if (i == 0 && (pUiData->iEkiatsukai == 1 || pUiData->iEkiatsukai == 2))
		{
			pUiData->iRessyaTrack = aRessyaTrack.getRessyaTrackIndex();
			pUiData->iRessyaTrackIsEnable = 1;
			//pUiData->bRessyaTrackIsEnable = true;
		}
		else if (pUiData->iEkiatsukai == 0 || pUiData->iEkiatsukai == 3
			|| pUiData->iEkiatsukai == -1)
		{
			pUiData->iRessyaTrack = -1;
			pUiData->iRessyaTrackIsEnable = 0;
		}
		else if (pUiData->iRessyaTrack != aRessyaTrack.getRessyaTrackIndex())
		{
			pUiData->iRessyaTrack = -1;		
			//pUiData->iRessyaTrackIsEnable = false;
		}

		if (m_pTarget->size() > 1 &&
			aRessyaTrack.getOperation() == CentDedRessyaTrack::Operation_Shunt)
		{
			pUiData->iRessyaTrackIsEnable = -1;
		}

		if (m_iEkiOrder == pRessya->getSihatsuEki()
			|| m_iEkiOrder == pRessya->getSyuuchakuEki())
		{
			/* nwEIw*/
			//PƎ̂ݗL
			if (i == 0)
			{
				pUiData->iOperation = getOperationConvTable().rightFrom(
					aRessyaTrack.getOperation());
				pUiData->bOperationIsEnable = true;
			}
			else /*if (pUiData->iOperation != getOperationConvTable().rightFrom(
				aRessyaTrack.getOperation()))*/
			{
				pUiData->iOperation = -1;//	IȂ
				pUiData->bOperationIsEnable = false;
			}
			/* Ԑ */
			//PÎݗLA
			if (i == 0 && pUiData->iOperation == 1)
			{
				//if (pUiData->iOperation == 1)	// 
				//{
				pUiData->iShuntTrack = aRessyaTrack.getShuntTrackIndex();
				//}
				pUiData->bShuntTrackIsEnable = true;
			}
			//else if (pUiData->iOperation == 1 &&
			//	pUiData->iShuntTrack != aRessyaTrack.getShuntTrackIndex())
			//{
			//	pUiData->iShuntTrack = -1;	//	IȂ
			//}
			else/* if (pUiData->iOperation != 1)*/
			{
				pUiData->iShuntTrack = 0;
				pUiData->bShuntTrackIsEnable = false;
			}
			/* Ɣ	*/
			//	PIAƂȂL
			if (i == 0 && pUiData->iOperation == 1)
			{
				pUiData->strOperationHatsuJikoku
					= aJikokuConv.encode(aRessyaTrack.getOperationHatsuJikoku());
				pUiData->strOperationChakuJikoku
					= aJikokuConv.encode(aRessyaTrack.getOperationChakuJikoku(false));
				pUiData->bOperationJikokuIsEnable = true;
			}
			else
			{
				pUiData->strOperationHatsuJikoku = _T("");
				pUiData->strOperationChakuJikoku = _T("");
				pUiData->bOperationJikokuIsEnable = false;
			}
			/* ƒ	*/
			//	PIAƂȂL
			//if (i == 0 && pUiData->iOperation == 1)
			//{
			//	pUiData->bOperationJikokuIsEnable = true;
			//}
			//else
			//{
			//	pUiData->bOperationJikokuIsEnable = false;
			//}
			/* ^pԍ */
			//PIAƂoEHOn̎L
			if (i == 0 && 
				(pUiData->iOperation == 2 ||
					pUiData->iOperation == 3) &&
				m_iEkiOrder == pRessya->getSihatsuEki())
			{
				pUiData->strOperationNumber = aRessyaTrack.getOperationNumber();
				pUiData->bOperationNumberIsEnable = true;
			}
			else
			{
				pUiData->strOperationNumber = _T("");
				pUiData->bOperationNumberIsEnable = false;
			}
			/* HOwIndex */
			//PÎݗLA
			if (m_iOuterTerminalCount == 0)
			{
				pUiData->iOuterTerminalIndexIsEnable = -1;
			}
			else if (i == 0 && pUiData->iOperation == 3)
			{
				pUiData->iOuterTerminalIndex = aRessyaTrack.getOuterTerminalIndex();
				pUiData->iOuterTerminalIndexIsEnable = 1;
			}
			else
			{
				pUiData->iOuterTerminalIndex = -1;
				pUiData->iOuterTerminalIndexIsEnable = 0;

			}
			/* HOw	*/
			//	PIAƂȂL
			if (m_iOuterTerminalCount == 0)
			{
				pUiData->iOuterHatsuChakuJikokuIsEnable= -1;
			}
			else if (i == 0 && pUiData->iOperation == 3)
			{
				pUiData->strOuterHatsuChakuJikoku
					= aJikokuConv.encode(aRessyaTrack.getOuterHatsuChakuJikoku());
				pUiData->iOuterHatsuChakuJikokuIsEnable = 1;
			}
			else
			{
				pUiData->strOuterHatsuChakuJikoku = _T("");
				pUiData->iOuterHatsuChakuJikokuIsEnable = 0;
			}
		}
		else
		{
			pUiData->iOperation = -1;
			pUiData->bOperationIsEnable = false;
			pUiData->strOperationHatsuJikoku = _T("");
			pUiData->strOperationChakuJikoku = _T("");
			pUiData->bOperationJikokuIsEnable = false;
			pUiData->iShuntTrack = -1;
			pUiData->bShuntTrackIsEnable = false;
			pUiData->strOperationNumber = _T("");
			pUiData->bOperationNumberIsEnable = false;
			pUiData->iOuterTerminalIndex = 0;
			pUiData->iOuterTerminalIndexIsEnable = -1;
			pUiData->strOuterHatsuChakuJikoku = _T("");
			pUiData->iOuterHatsuChakuJikokuIsEnable = -1;

		}
		
	}
	// --------------------------------

	//	 ̌JグEJ艺ON/OFFB
	pUiData->bModifyHatsujikoku = *m_pbModifyHatsujikoku ;

}
void CPropEditUi_EkiJikoku::AdjustUiData( 
		UIDATA* pUiData , 
		const UIDATA* pUiDataPrev , 
		bool bStartEdit )
{
	//	w
	if ( bStartEdit || pUiDataPrev->iEkiatsukai != pUiData->iEkiatsukai )
	{
	}
	
	//	wɊ֌W鐳K
	{
		//[PI]
		if ( m_pTarget->size() == 1 )
		{
			//@ywzw^sȂEoRȂŁA
			//	ύXꂽAw͒Ԃɂ
			{
				if ( ( pUiData->iEkiatsukai == 0 || pUiData->iEkiatsukai == 3 )
					&& !bStartEdit
					&& ( pUiDataPrev->strChakujikoku != pUiData->strChakujikoku
					 || pUiDataPrev->strHatsujikoku != pUiData->strHatsujikoku)
				 )
				{
					pUiData->iEkiatsukai = 1 ;	
				}
			}
			//@yEzw^sȂEoRȂɕύXꂽA
			//	E͖ɂ
			//@yEzwԁEʉ߂ɕύXꂽA
			//	E͗LɂB
			{
				if ( !bStartEdit 
					&& pUiDataPrev->iEkiatsukai !=  pUiData->iEkiatsukai )
				{
					if ( pUiData->iEkiatsukai == 0 
						|| pUiData->iEkiatsukai == 3 )
					{
						pUiData->bChakujikokuIsEnable = false ;
						pUiData->bHatsujikokuIsEnable = false ;
					}
					else 
					{
						pUiData->bChakujikokuIsEnable = true ;
						pUiData->bHatsujikokuIsEnable = true ;
					}
				}
			}
		}
		//mI]
		else if ( m_pTarget->size() > 1 )
		{
			//@yEzE͖E
			pUiData->bChakujikokuIsEnable = false ;
			pUiData->bHatsujikokuIsEnable = false ;
		}
	}


	//	O̎Order̉w擾
	//	̒ĺAȗĕ݂̂͂ꂽƂɁA
	//	⊮̂Ɏg܂B
	CdDedJikoku jikokuRevOrder ;
	if ( pUiData->bChakujikokuIsEnable )
	{
		CentDedRessya* pRessya = m_pTarget->get( 0 ) ;
		CdDedJikokuOrder aJikokuOrderRev = pRessya->findrevJikoku( 
			CdDedJikokuOrder( m_iEkiOrder - 1 , 
				CdDedJikokuOrder::EkiJikokuItem_Hatsu ) ) ;
		if ( !aJikokuOrderRev.getIsNull() )
		{
			jikokuRevOrder = pRessya->getEkiJikoku( aJikokuOrderRev ) ;
		}
	}
	//jikokuRevOrder = O̎Order̉w

	/*  	*/
	if ( bStartEdit || pUiDataPrev->strChakujikoku != pUiData->strChakujikoku )
	{
		//@yzύXꂽA
		//@@(1)𔼊pɕϊ
		//@@(2)2͂ȂA⊮܂B
		if ( pUiData->bChakujikokuIsEnable )
		{
			CdDedJikoku aJikoku ;
			int iResult = getJikokuFromUI( 
				pUiData->strChakujikoku , 
				jikokuRevOrder , 
				&aJikoku ,
				false) ;
			if ( iResult >= 0 )
			{
				pUiData->strChakujikoku = g_CdDedJikokuConv.encode( aJikoku ) ;
			}
		}
	}
	
	//	O̎Order𒅎ōXVB
	//	̒ĺAȗĕ݂̂͂ꂽƂɁA
	//	⊮̂Ɏg܂B
	{
		CdDedJikoku aJikoku( pUiData->strChakujikoku ) ;
		if ( !aJikoku.isNull() )
		{
			jikokuRevOrder = aJikoku ;
		}
	}
		//jikokuRevOrder = O̎Order̉wB
		//	AA̓͂΁AB

	/* 	*/
	if ( bStartEdit || pUiDataPrev->strHatsujikoku != pUiData->strHatsujikoku )
	{
		//@yzύXꂽA
		//@@(1)𔼊pɕϊ
		//@@(2)2͂ȂA⊮܂B
		if ( pUiData->bHatsujikokuIsEnable )
		{
			CdDedJikoku aJikoku ;
			int iResult = getJikokuFromUI( 
				pUiData->strHatsujikoku , 
				jikokuRevOrder , 
				&aJikoku ,
				false) ;
			if ( iResult >= 0 )
			{
				pUiData->strHatsujikoku = g_CdDedJikokuConv.encode( aJikoku ) ;
			}
		}
	}
	//@yzύXAw̌JグEJ艺x=wLxŁA
	//		͍ς݂ȂǍJグEJ艺s܂B@
	if ( !bStartEdit 
		&& pUiDataPrev->strChakujikoku != pUiData->strChakujikoku )
	{
		if ( pUiData->bModifyHatsujikoku )
		{
			//	̑OlEݒlE̓͂擾
			CdDedJikoku	jikokuChakuPrev( pUiDataPrev->strChakujikoku ) ;
			CdDedJikoku	jikokuChaku( pUiData->strChakujikoku ) ;
			CdDedJikoku jikokuHatsu( pUiData->strHatsujikoku ) ;
			if ( !jikokuChakuPrev.isNull() 
				&& !jikokuChaku.isNull()
				&& !jikokuHatsu.isNull() )
			{
				jikokuHatsu.addSeconds( jikokuChaku.subJikoku( jikokuChakuPrev ) );
				pUiData->strHatsujikoku = g_CdDedJikokuConv.encode( jikokuHatsu ) ;
			}
		}
	}
	/* (I)	*/
	if (bStartEdit || pUiDataPrev->strOperationHatsuJikoku != pUiData->strOperationHatsuJikoku)
	{
		//@yzύXꂽA
		//@@(1)𔼊pɕϊ
		//@@(2)2͂ȂAɎ⊮܂B
		if (pUiData->bOperationJikokuIsEnable &&
			m_iEkiOrder == m_pTarget->get(0)->getSyuuchakuEki())
		{
			CdDedJikoku aJikoku;
			int iResult = getJikokuFromUI(
				pUiData->strOperationHatsuJikoku,
				jikokuRevOrder,
				&aJikoku,
				false);
			if (iResult >= 0)
			{
				pUiData->strOperationHatsuJikoku = g_CdDedJikokuConv.encode(aJikoku);
			}
		}
	}
	//	O̎OrderōXVB
	//	̒ĺAȗĕ݂̂͂ꂽƂɁA
	//	̎⊮̂Ɏg܂B
	{
		CdDedJikoku aJikoku(pUiData->strOperationHatsuJikoku);
		if (!aJikoku.isNull())
		{
			jikokuRevOrder = aJikoku;
		}
	}
	/* (I)	*/
	if (bStartEdit || pUiDataPrev->strOperationChakuJikoku != pUiData->strOperationChakuJikoku)
	{
		//@yzύXꂽA
		//@@(1)𔼊pɕϊ
		//@@(2)2͂ȂAɎ⊮܂B
		if (pUiData->bOperationJikokuIsEnable &&
			m_iEkiOrder == m_pTarget->get(0)->getSyuuchakuEki())
		{
			CdDedJikoku aJikoku;
			int iResult = getJikokuFromUI(
				pUiData->strOperationChakuJikoku,
				jikokuRevOrder,
				&aJikoku,
				false);
			if (iResult >= 0)
			{
				pUiData->strOperationChakuJikoku = g_CdDedJikokuConv.encode(aJikoku);
			}
		}
	}
	//@yzύXAw̌JグEJ艺x=wLxŁA
	//		IwA͍ς݂ȂǍJグEJ艺s܂B@
	if (!bStartEdit
		&& pUiDataPrev->strChakujikoku != pUiData->strChakujikoku)
	{
		if (pUiData->bModifyHatsujikoku &&
			pUiData->bOperationJikokuIsEnable &&
			m_iEkiOrder == m_pTarget->get(0)->getSyuuchakuEki())
		{
			//	̑OlEݒlE̓͂擾
			CdDedJikoku	jikokuChakuPrev(pUiDataPrev->strChakujikoku);
			CdDedJikoku	jikokuChaku(pUiData->strChakujikoku);
			CdDedJikoku jikokuOperationHatsu(pUiData->strOperationHatsuJikoku);
			if (!jikokuChakuPrev.isNull()
				&& !jikokuChaku.isNull()
				&& !jikokuOperationHatsu.isNull())
			{
				jikokuOperationHatsu.addSeconds(jikokuChaku.subJikoku(jikokuChakuPrev));
				pUiData->strOperationHatsuJikoku = g_CdDedJikokuConv.encode(jikokuOperationHatsu);
			}
		}
	}
	//@yzύXAw̌JグEJ艺x=wLxŁA
	//		IwA͍ς݂ȂǍJグEJ艺s܂B@
	if (!bStartEdit
		&& pUiDataPrev->strOperationHatsuJikoku != pUiData->strOperationHatsuJikoku)
	{
		if (pUiData->bModifyHatsujikoku &&
			pUiData->bOperationJikokuIsEnable &&
			m_iEkiOrder == m_pTarget->get(0)->getSyuuchakuEki())
		{
			//	̑OlEݒlE̓͂擾
			CdDedJikoku	jikokuOperationHatsuPrev(pUiDataPrev->strOperationHatsuJikoku);
			CdDedJikoku	jikokuOperationHatsu(pUiData->strOperationHatsuJikoku);
			CdDedJikoku jikokuOperationChaku(pUiData->strOperationChakuJikoku);
			if (!jikokuOperationHatsuPrev.isNull()
				&& !jikokuOperationHatsu.isNull()
				&& !jikokuOperationChaku.isNull())
			{
				jikokuOperationChaku.addSeconds(jikokuOperationHatsu.subJikoku(jikokuOperationHatsuPrev));
				pUiData->strOperationChakuJikoku = g_CdDedJikokuConv.encode(jikokuOperationChaku);
			}
		}
	}


	//	O̎Order𔭎ōXVB
	//	̒ĺAȗĕ݂̂͂ꂽƂɁA
	//	̎⊮̂Ɏg܂B
	{
		CdDedJikoku aJikoku(pUiData->strHatsujikoku);
		if (!aJikoku.isNull())
		{
			jikokuRevOrder = aJikoku;
		}
	}

	/* (n)	*/
	if (bStartEdit || pUiDataPrev->strOperationChakuJikoku != pUiData->strOperationChakuJikoku)
	{
		//@yzύXꂽA
		//@@(1)𔼊pɕϊ
		//@@(2)2͂ȂAɎ⊮܂B
		if (pUiData->bOperationJikokuIsEnable &&
			m_iEkiOrder == m_pTarget->get(0)->getSihatsuEki())
		{
			CdDedJikoku aJikoku;
			int iResult = getJikokuFromUI(
				pUiData->strOperationChakuJikoku,
				jikokuRevOrder,
				&aJikoku,
				true);
			if (iResult >= 0)
			{
				pUiData->strOperationChakuJikoku = g_CdDedJikokuConv.encode(aJikoku);
			}
		}
	}

	//	O̎OrderōXVB
	//	̒ĺAȗĕ݂̂͂ꂽƂɁA
	//	̎⊮̂Ɏg܂B
	{
		CdDedJikoku aJikoku(pUiData->strOperationChakuJikoku);
		if (!aJikoku.isNull())
		{
			jikokuRevOrder = aJikoku;
		}
	}

	/* (n)	*/
	if (bStartEdit || pUiDataPrev->strOperationHatsuJikoku != pUiData->strOperationHatsuJikoku)
	{
		//@yzύXꂽA
		//@@(1)𔼊pɕϊ
		//@@(2)2͂ȂAɎ⊮܂B
		if (pUiData->bOperationJikokuIsEnable && 
			m_iEkiOrder == m_pTarget->get(0)->getSihatsuEki())
		{
			CdDedJikoku aJikoku;
			int iResult = getJikokuFromUI(
				pUiData->strOperationHatsuJikoku,
				jikokuRevOrder,
				&aJikoku,
				true);
			if (iResult >= 0)
			{
				pUiData->strOperationHatsuJikoku = g_CdDedJikokuConv.encode(aJikoku);
			}
		}
	}
	//@yzύXAw̌JグEJ艺x=wLxŁA
	//		nwA͍ς݂ȂǍJグEJ艺s܂B@
	if (!bStartEdit
		&& pUiDataPrev->strHatsujikoku != pUiData->strHatsujikoku)
	{
		if (pUiData->bModifyHatsujikoku &&
			pUiData->bOperationJikokuIsEnable &&
			m_iEkiOrder == m_pTarget->get(0)->getSihatsuEki())
		{
			//	̑OlEݒlE̓͂擾
			CdDedJikoku	jikokuHatsuPrev(pUiDataPrev->strHatsujikoku);
			CdDedJikoku	jikokuHatsu(pUiData->strHatsujikoku);
			//CdDedJikoku jikokuOperationChaku(pUiData->strOperationChakuJikoku);
			//if (!jikokuHatsuPrev.isNull()
			//	&& !jikokuHatsu.isNull()
			//	&& !jikokuOperationChaku.isNull())
			//{
			//	jikokuOperationChaku.addSeconds(jikokuHatsu.subJikoku(jikokuHatsuPrev));
			//	pUiData->strOperationChakuJikoku = g_CdDedJikokuConv.encode(jikokuOperationChaku);
			//}
			CdDedJikoku jikokuOperationHatsu(pUiData->strOperationHatsuJikoku);
			if (!jikokuHatsuPrev.isNull()
				&& !jikokuHatsu.isNull()
				&& !jikokuOperationHatsu.isNull())
			{
				jikokuOperationHatsu.addSeconds(jikokuHatsu.subJikoku(jikokuHatsuPrev));
				pUiData->strOperationHatsuJikoku = g_CdDedJikokuConv.encode(jikokuOperationHatsu);
			}
		}
	}
	//@yzύXAw̌JグEJ艺x=wLxŁA
	//		nwA͍ς݂ȂǍJグEJ艺s܂B@
	if (!bStartEdit
		&& pUiDataPrev->strOperationHatsuJikoku != pUiData->strOperationHatsuJikoku)
	{
		if (pUiData->bModifyHatsujikoku &&
			pUiData->bOperationJikokuIsEnable &&
			m_iEkiOrder == m_pTarget->get(0)->getSihatsuEki())
		{
			//	̑OlEݒlE̓͂擾
			CdDedJikoku	jikokuOperationHatsuPrev(pUiDataPrev->strOperationHatsuJikoku);
			CdDedJikoku	jikokuOperationHatsu(pUiData->strOperationHatsuJikoku);
			CdDedJikoku jikokuOperationChaku(pUiData->strOperationChakuJikoku);
			if (!jikokuOperationHatsuPrev.isNull()
				&& !jikokuOperationHatsu.isNull()
				&& !jikokuOperationChaku.isNull())
			{
				jikokuOperationChaku.addSeconds(jikokuOperationHatsu.subJikoku(jikokuOperationHatsuPrev));
				pUiData->strOperationChakuJikoku = g_CdDedJikokuConv.encode(jikokuOperationChaku);
			}
		}
	}

	/* HOw	*/
	if (bStartEdit || pUiDataPrev->strOuterHatsuChakuJikoku != pUiData->strOuterHatsuChakuJikoku)
	{
		//@yHOwzHOwύXꂽA
		//@@(1)𔼊pɕϊ
		//	HȌꍇAƐݒwHOw܂ł̎
		//	1Ԃ𒴂ꍇ\l̂ŁA̕⊮͍s܂B
		if (pUiData->iOuterHatsuChakuJikokuIsEnable > 0/* &&
			m_iEkiOrder == m_pTarget->get(0)->getSihatsuEki()*/)
		{
			CdDedJikoku aJikoku;
			int iResult = getJikokuFromUI(
				pUiData->strOuterHatsuChakuJikoku,
				CdDedJikoku(),
				&aJikoku,
				true);
			if (iResult >= 0)
			{
				pUiData->strOuterHatsuChakuJikoku = g_CdDedJikokuConv.encode(aJikoku);
			}
		}
	}
	//@yHOw(I1)zύXA͂ŁAw̌JグEJ艺x=wLxŁA
	//		IwAHOw͍ς݂ȂAHOw̌JグEJ艺s܂B@
	if (!bStartEdit
		&& pUiDataPrev->strChakujikoku != pUiData->strChakujikoku)
	{
		if (pUiData->bModifyHatsujikoku &&
			pUiData->strHatsujikoku.empty() &&
			pUiData->iOuterHatsuChakuJikokuIsEnable &&
			m_iEkiOrder == m_pTarget->get(0)->getSyuuchakuEki())
		{
			//	̑OlEݒlE̓͂擾
			CdDedJikoku	jikokuChakuPrev(pUiDataPrev->strChakujikoku);
			CdDedJikoku	jikokuChaku(pUiData->strChakujikoku);
			CdDedJikoku jikokuOuterHatsuChaku(pUiData->strOuterHatsuChakuJikoku);
			if (!jikokuChakuPrev.isNull()
				&& !jikokuChaku.isNull()
				&& !jikokuOuterHatsuChaku.isNull())
			{
				jikokuOuterHatsuChaku.addSeconds(jikokuChaku.subJikoku(jikokuChakuPrev));
				pUiData->strOuterHatsuChakuJikoku = g_CdDedJikokuConv.encode(jikokuOuterHatsuChaku);
			}
		}
	}
	//@yHOw(I2)zύXAw̌JグEJ艺x=wLxŁA
	//		IwAHOw͍ς݂ȂAHOw̌JグEJ艺s܂B@
	//		ŒύXɂȂꍇ́AʕŔVtĝŁA肠܂
	if (!bStartEdit
		&& pUiDataPrev->strHatsujikoku != pUiData->strHatsujikoku)
	{
		if (pUiData->bModifyHatsujikoku &&
			pUiData->iOuterHatsuChakuJikokuIsEnable &&
			m_iEkiOrder == m_pTarget->get(0)->getSyuuchakuEki())
		{
			//	̑OlEݒlE̓͂擾
			CdDedJikoku	jikokuHatsuPrev(pUiDataPrev->strHatsujikoku);
			CdDedJikoku	jikokuHatsu(pUiData->strHatsujikoku);
			CdDedJikoku jikokuOuterHatsuChaku(pUiData->strOuterHatsuChakuJikoku);
			if (!jikokuHatsuPrev.isNull()
				&& !jikokuHatsu.isNull()
				&& !jikokuOuterHatsuChaku.isNull())
			{
				jikokuOuterHatsuChaku.addSeconds(jikokuHatsu.subJikoku(jikokuHatsuPrev));
				pUiData->strOuterHatsuChakuJikoku = g_CdDedJikokuConv.encode(jikokuOuterHatsuChaku);
			}
		}
	}
	//@yHOw(n1)zύXA͂ŁAw̌JグEJ艺x=wLxŁA
	//		nwAHOw͍ς݂ȂAHOw̌JグEJ艺s܂B@
	if (!bStartEdit
		&& pUiDataPrev->strHatsujikoku != pUiData->strHatsujikoku)
	{
		if (pUiData->bModifyHatsujikoku &&
			pUiData->strChakujikoku.empty() &&
			pUiData->iOuterHatsuChakuJikokuIsEnable &&
			m_iEkiOrder == m_pTarget->get(0)->getSihatsuEki())
		{
			//	̑OlEݒlE̓͂擾
			CdDedJikoku	jikokuHatsuPrev(pUiDataPrev->strHatsujikoku);
			CdDedJikoku	jikokuHatsu(pUiData->strHatsujikoku);
			CdDedJikoku jikokuOuterHatsuChaku(pUiData->strOuterHatsuChakuJikoku);
			if (!jikokuHatsuPrev.isNull()
				&& !jikokuHatsu.isNull()
				&& !jikokuOuterHatsuChaku.isNull())
			{
				jikokuOuterHatsuChaku.addSeconds(jikokuHatsu.subJikoku(jikokuHatsuPrev));
				pUiData->strOuterHatsuChakuJikoku = g_CdDedJikokuConv.encode(jikokuOuterHatsuChaku);
			}
		}
	}
	//@yHOw(I2)zύXAw̌JグEJ艺x=wLxŁA
	//		nwAHOw͍ς݂ȂAHOw̌JグEJ艺s܂B@
	if (!bStartEdit
		&& pUiDataPrev->strChakujikoku != pUiData->strChakujikoku)
	{
		if (pUiData->bModifyHatsujikoku &&
			pUiData->iOuterHatsuChakuJikokuIsEnable &&
			m_iEkiOrder == m_pTarget->get(0)->getSihatsuEki())
		{
			//	̑OlEݒlE̓͂擾
			CdDedJikoku	jikokuChakuPrev(pUiDataPrev->strChakujikoku);
			CdDedJikoku	jikokuChaku(pUiData->strChakujikoku);
			CdDedJikoku jikokuOuterHatsuChaku(pUiData->strOuterHatsuChakuJikoku);
			if (!jikokuChakuPrev.isNull()
				&& !jikokuChaku.isNull()
				&& !jikokuOuterHatsuChaku.isNull())
			{
				jikokuOuterHatsuChaku.addSeconds(jikokuChaku.subJikoku(jikokuChakuPrev));
				pUiData->strOuterHatsuChakuJikoku = g_CdDedJikokuConv.encode(jikokuOuterHatsuChaku);
			}
		}
	}

	//wA^sEoRԁEʉ߂ɂȂƂ́AԐ{ɐݒ肷
	//Ver1.02.93 Ԑm_iStandardRessyaTrackIndexɐݒ肷B
	//m_iStandardRessyaTrackIndex́A^]_C璊oAԐ
	if (!bStartEdit)
	{
		if ((pUiDataPrev->iEkiatsukai == 0 || pUiDataPrev->iEkiatsukai == 3) &&
			pUiData->iEkiatsukai == 1 &&
			pUiData->iRessyaTrackIsEnable != -1)
		{
			pUiData->iRessyaTrackIsEnable = 1;
			if (pUiData->iRessyaTrack == -1)
			{
				pUiData->iRessyaTrack = m_iStandardRessyaTrackIndex[0];
			}
		}
		else if ((pUiDataPrev->iEkiatsukai == 0 || pUiDataPrev->iEkiatsukai == 3) &&
			pUiData->iEkiatsukai == 2 &&
			pUiData->iRessyaTrackIsEnable != -1)
		{
			pUiData->iRessyaTrackIsEnable = 1;
			if (pUiData->iRessyaTrack == -1)
			{
				pUiData->iRessyaTrack = m_iStandardRessyaTrackIndex[1];
			}
		}
		else if (/*(pUiDataPrev->iEkiatsukai == 1 || pUiDataPrev->iEkiatsukai == 2) &&*/
			(pUiData->iEkiatsukai == 0 || pUiData->iEkiatsukai == 3) &&
			pUiData->iRessyaTrackIsEnable != -1)
		{
			pUiData->iRessyaTrackIsEnable = 0;
		}
	}
	//wA^sAoRɂȂƂ́AԐnI[NA
	{
		//[PI]
		if (m_pTarget->size() == 1 &&
			(m_iEkiOrder == m_pTarget->get(0)->getSihatsuEki() ||
			m_iEkiOrder == m_pTarget->get(0)->getSyuuchakuEki()))
		{
			if (pUiData->iEkiatsukai == 0 || pUiData->iEkiatsukai == 3)
			{
				pUiData->bOperationIsEnable = false;
				pUiData->bShuntTrackIsEnable = false;
				pUiData->bOperationJikokuIsEnable = false;
				pUiData->bOperationNumberIsEnable = false;
				if (pUiData->iOuterTerminalIndexIsEnable >= 0)
				{
					pUiData->iOuterTerminalIndexIsEnable = 0;
				}
				if (pUiData->iOuterHatsuChakuJikokuIsEnable >= 0)
				{
					pUiData->iOuterHatsuChakuJikokuIsEnable = 0;
				}
			}
			else if (pUiData->iEkiatsukai == 1 || pUiData->iEkiatsukai == 2)
			{
				//pUiData->iRessyaTrack = 0;
				//pUiData->iOperation = 0;
				pUiData->bOperationIsEnable = true;
				if (pUiData->iOperation == 0)
				{
					pUiData->bShuntTrackIsEnable = false;
					pUiData->bOperationJikokuIsEnable = false;
					pUiData->bOperationNumberIsEnable = false;
					if (pUiData->iOuterTerminalIndexIsEnable >= 0)
					{
						pUiData->iOuterTerminalIndexIsEnable = 0;
					}
					if (pUiData->iOuterHatsuChakuJikokuIsEnable >= 0)
					{
						pUiData->iOuterHatsuChakuJikokuIsEnable = 0;
					}
				}
				else if (pUiData->iOperation == 1)
				{
					if (pUiData->iShuntTrack == 0)
					{
						pUiData->iShuntTrack = 1;
					}
					pUiData->bShuntTrackIsEnable = true;
					pUiData->bOperationJikokuIsEnable = true;
					pUiData->bOperationNumberIsEnable = false;
					if (pUiData->iOuterTerminalIndexIsEnable >= 0)
					{
						pUiData->iOuterTerminalIndexIsEnable = 0;
					}
					if (pUiData->iOuterHatsuChakuJikokuIsEnable >= 0)
					{
						pUiData->iOuterHatsuChakuJikokuIsEnable = 0;
					}
				}
				else if (pUiData->iOperation == 2 )
				{
					pUiData->bShuntTrackIsEnable = false;
					pUiData->bOperationJikokuIsEnable = false;
					if (m_iEkiOrder == m_pTarget->get(0)->getSihatsuEki())
					{
						pUiData->bOperationNumberIsEnable = true;
					}
					else
					{
						pUiData->bOperationNumberIsEnable = false;
					}

					if (pUiData->iOuterTerminalIndexIsEnable >= 0)
					{
						pUiData->iOuterTerminalIndexIsEnable = 0;
					}
					if (pUiData->iOuterHatsuChakuJikokuIsEnable >= 0)
					{
						pUiData->iOuterHatsuChakuJikokuIsEnable = 0;
					}
				}
				else if (pUiData->iOperation == 3)
				{
					pUiData->bShuntTrackIsEnable = false;
					pUiData->bOperationJikokuIsEnable = false;
					if (pUiData->iOuterTerminalIndexIsEnable >= 0)
					{
						pUiData->iOuterTerminalIndexIsEnable = 1;
					}
					if (pUiData->iOuterHatsuChakuJikokuIsEnable >= 0)
					{
						pUiData->iOuterHatsuChakuJikokuIsEnable = 1;
					}
					if (m_iEkiOrder == m_pTarget->get(0)->getSihatsuEki())
					{
						pUiData->bOperationNumberIsEnable = true;
					}
					else
					{
						pUiData->bOperationNumberIsEnable = false;
					}
					if (pUiData->iOuterTerminalIndex == -1)
					{
						pUiData->iOuterTerminalIndex = 0;
					}
				}
				//pUiData->iShuntTrack = -1;
				//pUiData->strOperationJikoku = "";
				//pUiData->strOperationNumber = "";
			}
		}
		//mI]
		//else if (m_pTarget->size() > 1)
		//{
		//	if (pUiData->iEkiatsukai == 0 || pUiData->iEkiatsukai == 3)
		//	{
		//		pUiData->iRessyaTrack = -1;
		//		pUiData->iOperation = -1;
		//		pUiData->bOperationIsEnable = false;
		//		pUiData->iShuntTrack = -1;
		//		pUiData->bShuntTrackIsEnable = false;
		//		pUiData->strOperationJikoku = "";
		//		pUiData->bOperationJikokuIsEnable = false;
		//		pUiData->strOperationNumber = "";
		//		pUiData->bOperationNumberIsEnable = false;
		//	}
		//	else if (pUiData->iEkiatsukai == 1 || pUiData->iEkiatsukai == 2)
		//	{
		//		//pUiData->iRessyaTrack = -1;
		//		//pUiData->iOperation = -1;
		//		pUiData->bOperationIsEnable = true;
		//		//pUiData->iShuntTrack = -1;
		//		//pUiData->bShuntTrackIsEnable = false;
		//		//pUiData->strOperationJikoku = "";
		//		//pUiData->bOperationJikokuIsEnable = false;
		//		//pUiData->strOperationNumber = "";
		//		//pUiData->bOperationNumberIsEnable = false;
		//	}
		//}

	}
	//iOperation0̂Ƃ́Aʃ_CAOfalse
	//1,2̎́AKvȂƂTrueAÍAfalse
	//{
	//	//[PI]
	//	if (m_pTarget->size() == 1)
	//	{
	//		if (pUiData->iOperation == 0 )
	//		{
	//			//pUiData->iShuntTrack = -1;
	//			pUiData->bShuntTrackIsEnable = false;
	//			//pUiData->strOperationJikoku = "";
	//			pUiData->bOperationJikokuIsEnable = false;
	//			//pUiData->strOperationNumber = "";
	//			pUiData->bOperationNumberIsEnable = false;
	//		}
	//		else if (pUiData->iOperation == 1 )
	//		{
	//			if (pUiData->iShuntTrack == 0)
	//			{
	//				pUiData->iShuntTrack = 1;
	//			}
	//			pUiData->bShuntTrackIsEnable = true;
	//			//pUiData->strOperationJikoku = "";
	//			pUiData->bOperationJikokuIsEnable = true;
	//			//pUiData->strOperationNumber = "";
	//			pUiData->bOperationNumberIsEnable = false;
	//		}
	//		else if (pUiData->iOperation == 2)
	//		{
	//			//pUiData->iShuntTrack = -1;
	//			pUiData->bShuntTrackIsEnable = false;
	//			//pUiData->strOperationJikoku = "";
	//			pUiData->bOperationJikokuIsEnable = false;
	//			//pUiData->strOperationNumber = "";
	//			pUiData->bOperationNumberIsEnable = true;
	//		}
	//	}
	//}

}	

int CPropEditUi_EkiJikoku::CheckUiData( 
		bool bNewItem , 
		const UIDATA* pUiData , 
		const UIDATA* pUiDataStartEdit ) 
{
	int iRv = 0 ; 
	//	w
	if ( iRv >= 0 )
	{
		if ( bNewItem || pUiDataStartEdit->iEkiatsukai != pUiData->iEkiatsukai )
		{
		}
	}
	//	
	if ( iRv >= 0 )
	{
		if ( bNewItem 
			|| pUiDataStartEdit->strChakujikoku != pUiData->strChakujikoku )
		{
			//@yz󕶎łȂȂA
			//	l̎ւ̕ϊ݂āAsȂG[\
			CdDedJikoku aJikoku ;
			int iResult = aJikoku.decode( pUiData->strChakujikoku ) ;
			if ( iResult < 0 )
			{
				iRv =  -11 ;
			}
		}
	}
	//	
	if ( iRv >= 0 )
	{
		if ( bNewItem 
			|| pUiDataStartEdit->strHatsujikoku != pUiData->strHatsujikoku )
		{

			//@yz󕶎łȂȂA
			//	l̎ւ̕ϊ݂āAsȂG[\
			CdDedJikoku aJikoku ;
			int iResult = aJikoku.decode( pUiData->strHatsujikoku ) ;
			if ( iResult < 0 )
			{
				iRv = -12 ;
			}
		}
	}
	// ShuntTrack
	// ԔԐƓԐvꍇ̓G[
	if (iRv >= 0)
	{
		if (pUiData->iOperation == 1 &&
			pUiData->bOperationIsEnable == true)
		{
			if (pUiData->iRessyaTrack == 0)
			{
				if (m_iMainTrack == pUiData->iShuntTrack)
				{
					iRv = -21;
				}
			}
			else
			{
				if (pUiData->iRessyaTrack == pUiData->iShuntTrack)
				{
					iRv = -21;
				}

			}
		}
	}
	//if (pUiData->strOperationHatsuJikoku.empty() && !pUiData->strOperationChakuJikoku.empty())
	//{
	//	pUiData->strOperationHatsuJikoku = pUiData->strOperationChakuJikoku;
	//	pUiData->strOperationChakuJikoku.erase();
	//}
	//	
	if (iRv >= 0)
	{
		if (bNewItem
			|| pUiDataStartEdit->strOperationHatsuJikoku != pUiData->strOperationHatsuJikoku)
		{
			if (pUiData->bOperationJikokuIsEnable == true)
			{

				//@yz󕶎łȂȂA
				//	l̎ւ̕ϊ݂āAsȂG[\
				CdDedJikoku aJikoku;
				int iResult = aJikoku.decode(pUiData->strOperationHatsuJikoku);
				if (iResult < 0)
				{
					iRv = -31;
				}
			}
		}
	}
	//	
	if (iRv >= 0)
	{
		if (bNewItem
			|| pUiDataStartEdit->strOperationChakuJikoku != pUiData->strOperationChakuJikoku)
		{
			if (pUiData->bOperationJikokuIsEnable == true)
			{

				//@yz󕶎łȂȂA
				//	l̎ւ̕ϊ݂āAsȂG[\
				CdDedJikoku aJikoku;
				int iResult = aJikoku.decode(pUiData->strOperationChakuJikoku);
				if (iResult < 0)
				{
					iRv = -32;
				}
			}
		}
	}

	//	HOw
	if (iRv >= 0)
	{
		//if (bNewItem
		//	|| pUiDataStartEdit->strOuterHatsuChakuJikoku != pUiData->strOuterHatsuChakuJikoku)
		//{
			if (pUiData->iOuterHatsuChakuJikokuIsEnable > 0)
			{
				if (pUiData->strOuterHatsuChakuJikoku.empty())
				{
					iRv = -33;
				}
				else
				{
					//@yHOwz󕶎łȂȂA
					//	l̎ւ̕ϊ݂āAsȂG[\
					CdDedJikoku aJikoku;
					int iResult = aJikoku.decode(pUiData->strOuterHatsuChakuJikoku);
					if (iResult < 0)
					{
						iRv = -33;
					}
				}
			}
		//}
	}

	// --------------------------------
	//	G[bZ[W\܂
	// --------------------------------
	if ( iRv < 0 )
	{
		switch( iRv )
		{
		case -11 :
			ShowError( ERRMSG_INVALID_CHAKUJIKOKU ) ;
			SetFocus( offsetof( UIDATA , strChakujikoku )) ;
			break ;
		case -12 :
			ShowError( ERRMSG_INVALID_HATSUJIKOKU ) ;
			SetFocus( offsetof( UIDATA , strHatsujikoku ) );
			break ;
		case -21:
			ShowError(ERRMSG_INVALID_SHUNTTRACK);
			SetFocus(offsetof(UIDATA, iShuntTrack));
			break;
		case -31:
			ShowError(ERRMSG_INVALID_OPERATIONHATSUJIKOKU);
			SetFocus(offsetof(UIDATA, strOperationHatsuJikoku));
			break;
		case -32:
			ShowError(ERRMSG_INVALID_OPERATIONCHAKUJIKOKU);
			SetFocus(offsetof(UIDATA, strOperationChakuJikoku));
			break;
		case -33:
			ShowError(ERRMSG_INVALID_OUTERHATSUCHAKUJIKOKU);
			SetFocus(offsetof(UIDATA, strOuterHatsuChakuJikoku));
			break;
		}
	}
	return iRv ;
}

int CPropEditUi_EkiJikoku::UiDataToTarget( 
		bool bNewItem , 
		const UIDATA* pUiData , 
		const UIDATA* pUiDataStartEdit ) 
{

	int iRv = 0 ; 
	for ( int i = 0 ; iRv >= 0 && i < m_pTarget->size() ; i ++ )
	{
		CentDedRessya* pRessya = m_pTarget->get( i ) ; 
		CentDedEkiJikoku aEkiJikoku 
			= pRessya->getCentDedEkiJikoku( m_iEkiOrder ) ;
		CentDedRessyaTrack aRessyaTrack
			= pRessya->getCentDedRessyaTrack(m_iEkiOrder);
		
		if ( bNewItem 
			|| pUiDataStartEdit->iEkiatsukai != pUiData->iEkiatsukai )
		{
			aEkiJikoku.setEkiatsukai( 
				getEkiatsukaiConvTable().leftFrom(  pUiData->iEkiatsukai ) ) ;
		}
		// strChakujikoku
		if ( bNewItem 
			|| pUiDataStartEdit->strChakujikoku != pUiData->strChakujikoku )
		{
			if ( pUiData->bChakujikokuIsEnable )
			{
				CdDedJikoku	aJikoku ;
				int iResult = aJikoku.decode( pUiData->strChakujikoku ) ;
				if ( iResult >= 0 )
				{
					aEkiJikoku.setChakujikoku( aJikoku ) ;
				}
			}
		}
		// strHatsujikoku
		if ( bNewItem 
			|| pUiDataStartEdit->strHatsujikoku != pUiData->strHatsujikoku )
		{
			if ( pUiData->bHatsujikokuIsEnable )
			{
				CdDedJikoku	aJikoku ;
				int iResult = aJikoku.decode( pUiData->strHatsujikoku ) ;
				if ( iResult >= 0 )
				{
					aEkiJikoku.setHatsujikoku( aJikoku ) ;
				}
			}
		}
		// --------------------------------
		//	Ԃɉw(JグEJ艺̏ꍇ܂)
		if ( pUiData->bModifyHatsujikoku )
		{
			pRessya->modifyCentDedEkiJikoku( m_iEkiOrder , aEkiJikoku ) ;
		}
		else
		{
			pRessya->setCentDedEkiJikoku( m_iEkiOrder , aEkiJikoku ) ;
		}
		//iRessyaTrack
		if (pUiData->iRessyaTrack == 0 &&
			pUiData->iOperation == 1)
		{
			aRessyaTrack.setRessyaTrackIndex(m_iMainTrack);
		}
		else if (bNewItem
			|| pUiDataStartEdit->iRessyaTrack != pUiData->iRessyaTrack)
		{
			aRessyaTrack.setRessyaTrackIndex(pUiData->iRessyaTrack);
		}
		//iOperation
		if (bNewItem
			|| pUiDataStartEdit->iOperation != pUiData->iOperation)
		{
			if (pUiData->bOperationIsEnable)
			{
				aRessyaTrack.setOperation(
					getOperationConvTable().leftFrom(pUiData->iOperation));
			}
		}

		if (pUiData->strOperationHatsuJikoku.empty() && !pUiData->strOperationChakuJikoku.empty())
		{
			//strOperationHatsuJikoku
			if (bNewItem
				|| pUiDataStartEdit->strOperationHatsuJikoku != pUiData->strOperationChakuJikoku)
			{
				if (pUiData->bOperationJikokuIsEnable)
				{
					CdDedJikoku	aJikoku;
					int iResult = aJikoku.decode(pUiData->strOperationChakuJikoku);
					if (iResult >= 0)
					{
						aRessyaTrack.setOperationHatsuJikoku(aJikoku);
					}
				}
				//else
				//{
				//	aRessyaTrack.setOperationHatsuJikoku(CdDedJikoku());
				//}
			}

			//strOperationChakuJikoku
			//{
			//	aRessyaTrack.setOperationChakuJikoku(CdDedJikoku());
			//}

		}
		else
		{
			//strOperationHatsuJikoku
			if (bNewItem
				|| pUiDataStartEdit->strOperationHatsuJikoku != pUiData->strOperationHatsuJikoku)
			{
				if (pUiData->bOperationJikokuIsEnable)
				{
					CdDedJikoku	aJikoku;
					int iResult = aJikoku.decode(pUiData->strOperationHatsuJikoku);
					if (iResult >= 0)
					{
						aRessyaTrack.setOperationHatsuJikoku(aJikoku);
					}
				}
				//else
				//{
				//	aRessyaTrack.setOperationHatsuJikoku(CdDedJikoku());
				//}
			}

			//strOperationChakuJikoku
			if (bNewItem
				|| pUiDataStartEdit->strOperationChakuJikoku != pUiData->strOperationChakuJikoku)
			{
				if (pUiData->bOperationJikokuIsEnable)
				{
					CdDedJikoku	aJikoku;
					int iResult = aJikoku.decode(pUiData->strOperationChakuJikoku);
					if (iResult >= 0)
					{
						aRessyaTrack.setOperationChakuJikoku(aJikoku);
					}
				}
				//else
				//{
				//	aRessyaTrack.setOperationChakuJikoku(CdDedJikoku());
				//}
			}

		}
		//iShuntTrack
		if (bNewItem
			|| pUiDataStartEdit->iShuntTrack != pUiData->iShuntTrack)
		{
			if (pUiData->bShuntTrackIsEnable)
			{
				aRessyaTrack.setShuntTrackIndex(pUiData->iShuntTrack);
			}
		}
		//strOperationNumber
		if (bNewItem
			|| pUiDataStartEdit->strOperationNumber != pUiData->strOperationNumber)
		{
			if (pUiData->bOperationNumberIsEnable)
			{
				aRessyaTrack.setOperationNumber(pUiData->strOperationNumber);
			}
		}
		//iOuterTerminalIndex
		if (bNewItem
			|| pUiDataStartEdit->iOuterTerminalIndex != pUiData->iOuterTerminalIndex)
		{
			if (pUiData->iOuterTerminalIndexIsEnable > 0)
			{
				aRessyaTrack.setOuterTerminalIndex(pUiData->iOuterTerminalIndex);
			}
		}
		//strOuterHatsuChakuJikoku
		if (bNewItem
			|| pUiDataStartEdit->strOuterHatsuChakuJikoku != pUiData->strOuterHatsuChakuJikoku)
		{
			if (pUiData->iOuterHatsuChakuJikokuIsEnable > 0)
			{
				CdDedJikoku	aJikoku;
				int iResult = aJikoku.decode(pUiData->strOuterHatsuChakuJikoku);
				if (iResult >= 0)
				{
					aRessyaTrack.setOuterHatsuChakuJikoku(aJikoku);
				}
			}
			//else
			//{
			//	aRessyaTrack.setOuterHatsuChakuJikoku(CdDedJikoku());
			//}
		}
		//ԂRessyaTrack
		pRessya->setCentDedRessyaTrack(m_iEkiOrder, aRessyaTrack);
		pRessya->adjustRessyaTrack();
	}
	
	if (  bNewItem || pUiDataStartEdit->bModifyHatsujikoku != pUiData->bModifyHatsujikoku  )
	{
		*m_pbModifyHatsujikoku = pUiData->bModifyHatsujikoku ;
	}
	return iRv ;
}	



	// ********************************
	//	RXgN^
	// ********************************
CPropEditUi_EkiJikoku::CPropEditUi_EkiJikoku( 
		bool bNewItem , 
		Mu<CentDedRessya*>* pTarget , 
		bool* pbModifyHatsujikoku ,
		int iEkiOrder ,
		int iMainTrack,
		int iStandardRessyaTrackIndex[],
		int iOuterTerminalCount)
		: CPropEditUi2( bNewItem ) 
		, m_pTarget( pTarget ) 
		, m_pbModifyHatsujikoku( pbModifyHatsujikoku )
		, m_iEkiOrder( iEkiOrder )
		, m_iMainTrack(iMainTrack)
		, m_iOuterTerminalCount(iOuterTerminalCount)
{
	m_iStandardRessyaTrackIndex[0] = iStandardRessyaTrackIndex[0];
	m_iStandardRessyaTrackIndex[1] = iStandardRessyaTrackIndex[1];
}



} //namespace ViewJikokuhyou

