/*
OuDiaSecond Copyright (C) 2017 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// CDlgDiaProp.cpp : Cve[V t@C
//

#include "stdafx.h"

#include "DcDraw/CDcdTargetOnPaint.h"
#include "DcDraw/CaDcdTargetItemPosition.h"
#include "DcDraw/CConverter_WinGdi.h"
#include "..\DiagramEdit.h"
#include "CDlgDiaProp.h"
#include "MfcUtil\MfcUtil.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace ViewRosen{

using namespace OuMfc::MfcUtil;
using namespace std ;

/////////////////////////////////////////////////////////////////////////////
// CDlgDiaProp _CAO


void CDlgDiaProp::updateUIState()
{
	// --------------------------------
	//	J[
	// --------------------------------
	{
		CComboBox* pComboBox = (CComboBox*)GetDlgItem(IDC_COMBO_JikokuhyouMainBackColorIndex);

		int idx = pComboBox->GetCurSel();
		//COLORREF*	pColor = NULL;
		if (0 <= idx && idx < sizeof(m_ColorpropJikokuhyouColor) / sizeof(m_ColorpropJikokuhyouColor[0]))
		{
			m_pdcdrawMainBackColor->setCdBrushProp(m_ColorpropJikokuhyouColor[idx]);
			//pColor = &m_ColorpropJikokuhyouColor[idx];
		}
		// --------------------------------
		//if (pColor != NULL)
		//{
		//	CConverter_WinGdi	aConv;
		//	m_pdcdrawColor->setCdBrushProp(CdBrushProp(aConv.CdColorPropOf(*pColor)));
		//}

		CRect	aRect = GetDlgControlRect(this, IDC_STATIC_JikokuhyouMainBackColor);
		InvalidateRect(&aRect);
	}
	{
		CComboBox* pComboBox = (CComboBox*)GetDlgItem(IDC_COMBO_JikokuhyouSubBackColorIndex);

		int idx = pComboBox->GetCurSel();
		if (0 <= idx && idx < sizeof(m_ColorpropJikokuhyouColor) / sizeof(m_ColorpropJikokuhyouColor[0]))
		{
			m_pdcdrawSubBackColor->setCdBrushProp(m_ColorpropJikokuhyouColor[idx]);
		}
		CRect	aRect = GetDlgControlRect(this, IDC_STATIC_JikokuhyouSubBackColor);
		InvalidateRect(&aRect);
	}
}

CDlgDiaProp::CDlgDiaProp(
		const tstring& strName ,
		const int &iJikokuhyouMainBackColorIndex,
		const int &iJikokuhyouSubBackColorIndex,
		const int &iJikokuhyouBackPatternIndex,
		const CdDedDispProp&	aCdDedDispProp,
		CWnd* pParent )
	: CDialog(CDlgDiaProp::IDD, pParent)
	, m_strName( strName )
	, m_iJikokuhyouMainBackColorIndex(iJikokuhyouMainBackColorIndex)
	, m_iJikokuhyouSubBackColorIndex(iJikokuhyouSubBackColorIndex)
	, m_iJikokuhyouBackPatternIndex(iJikokuhyouBackPatternIndex)
	, m_pdcdrawMainBackColor(NULL)
	, m_pdcdrawSubBackColor(NULL)
{
	//{{AFX_DATA_INIT(CDlgDiaProp)
	m_strEDIT_Name = _T("");
	//}}AFX_DATA_INIT
	m_strEDIT_Name = m_strName.c_str() ;

	for (int idx = 0; idx < CentDedDia::JIKOKUHYOUCOLOR_COUNT; idx++)
	{
		m_ColorpropJikokuhyouColor[idx] = aCdDedDispProp.getJikokuhyouBackColor(idx);
	}
}


void CDlgDiaProp::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgDiaProp)
	DDX_Text(pDX, IDC_EDIT_Name, m_strEDIT_Name);
	DDX_CBIndex(pDX, IDC_COMBO_JikokuhyouMainBackColorIndex, m_iJikokuhyouMainBackColorIndex);
	DDX_CBIndex(pDX, IDC_COMBO_JikokuhyouSubBackColorIndex, m_iJikokuhyouSubBackColorIndex);
	DDX_CBIndex(pDX, IDC_COMBO_JikokuhyouBackPatternIndex, m_iJikokuhyouBackPatternIndex);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgDiaProp, CDialog)
	//{{AFX_MSG_MAP(CDlgDiaProp)
	ON_WM_PAINT()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	ON_CBN_SELCHANGE(IDC_COMBO_JikokuhyouMainBackColorIndex, &CDlgDiaProp::OnCbnSelchangeComboJikokuhyoumainbackcolorindex)
	ON_CBN_SELCHANGE(IDC_COMBO_JikokuhyouSubBackColorIndex, &CDlgDiaProp::OnCbnSelchangeComboJikokuhyousubbackcolorindex)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgDiaProp bZ[W nh

void CDlgDiaProp::OnOK() 
{
	UpdateData() ;
	int iRv = 0 ;
	CString	strError ;
	if ( iRv >= 0 ){
		if ( m_strEDIT_Name.GetLength() == 0 ){
			GetDlgItemText( IDC_STATIC_ERROR_NameNotSet , strError ) ; 
			iRv = -1 ;	//	_Cݒ肳Ă܂B
		}	else	{
			m_strName = (LPCTSTR)m_strEDIT_Name ;
		}
	}
	if ( iRv >= 0 ){
		CDialog::OnOK();
	}	else	{
		MessageBox( strError , NULL , MB_OK | MB_ICONEXCLAMATION ) ;
	}
}

BOOL CDlgDiaProp::OnInitDialog() 
{
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ

	m_pdcdrawMainBackColor = new CDcdRectangle(
		CdPenProp(1));
	m_pdcdrawSubBackColor = new CDcdRectangle(
		CdPenProp(1));

	// R{{bNX
	{
		CComboBox*	pCComboBox = (CComboBox*)GetDlgItem(IDC_COMBO_JikokuhyouMainBackColorIndex);
		CComboBox*	pCComboBox2 = (CComboBox*)GetDlgItem(IDC_COMBO_JikokuhyouSubBackColorIndex);

		tstring strTemp = _T("1");
		pCComboBox->AddString(strTemp.c_str());
		pCComboBox2->AddString(strTemp.c_str());
		strTemp = _T("2");
		pCComboBox->AddString(strTemp.c_str());
		pCComboBox2->AddString(strTemp.c_str());
		strTemp = _T("3");
		pCComboBox->AddString(strTemp.c_str());
		pCComboBox2->AddString(strTemp.c_str());
		strTemp = _T("4");
		pCComboBox->AddString(strTemp.c_str());
		pCComboBox2->AddString(strTemp.c_str());
		//1;2;3;4;
	}
	// R{{bNX
	{
		CComboBox*	pCComboBox = (CComboBox*)GetDlgItem(IDC_COMBO_JikokuhyouBackPatternIndex);

		tstring strTemp = _T("PF");
		pCComboBox->AddString(strTemp.c_str());
		strTemp = _T("ʐF");
		pCComboBox->AddString(strTemp.c_str());
		strTemp = _T("c");
		pCComboBox->AddString(strTemp.c_str());
		strTemp = _T("");
		pCComboBox->AddString(strTemp.c_str());
		strTemp = _T("s͗l");
		pCComboBox->AddString(strTemp.c_str());
		//PF;ʐF;c;;s͗l;
	}

	CDialog::OnInitDialog();

	// --------------------------------
	updateUIState();

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CDlgDiaProp::OnPaint()
{
	CPaintDC dc(this); // `p̃foCX ReLXg

	CDcdTargetOnPaint	aDcdTarget(GetSafeHwnd(), &dc.m_ps);
	// --------------------------------
	//	F̌{\
	// --------------------------------
	{
		CRect	aRect = GetDlgControlRect(this, IDC_STATIC_JikokuhyouMainBackColor);

		CaDcdTargetItemPosition	aDcdTargetItemPosition(&aDcdTarget,
			CdDcdZoneXy(CdDcdZone(aRect.left, aRect.right - aRect.left),
				CdDcdZone(aRect.top, aRect.bottom - aRect.top)));

		m_pdcdrawMainBackColor->DcDraw(&aDcdTargetItemPosition);
	}
	{
		CRect	aRect = GetDlgControlRect(this, IDC_STATIC_JikokuhyouSubBackColor);

		CaDcdTargetItemPosition	aDcdTargetItemPosition(&aDcdTarget,
			CdDcdZoneXy(CdDcdZone(aRect.left, aRect.right - aRect.left),
				CdDcdZone(aRect.top, aRect.bottom - aRect.top)));

		m_pdcdrawSubBackColor->DcDraw(&aDcdTargetItemPosition);
	}
}

void CDlgDiaProp::OnDestroy()
{
	if (m_pdcdrawMainBackColor != NULL) {
		delete m_pdcdrawMainBackColor;
		m_pdcdrawMainBackColor = NULL;
	}
	if (m_pdcdrawSubBackColor != NULL) {
		delete m_pdcdrawSubBackColor;
		m_pdcdrawSubBackColor = NULL;
	}
	CDialog::OnDestroy();



}
} //namespace ViewRosen


void ViewRosen::CDlgDiaProp::OnCbnSelchangeComboJikokuhyoumainbackcolorindex()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	updateUIState();
}


void ViewRosen::CDlgDiaProp::OnCbnSelchangeComboJikokuhyousubbackcolorindex()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	updateUIState();
}
