/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
//$Id: CDlgRosenCreateSubRosen.h 261 2016-01-23 03:59:53Z okm $
/** @file */
#pragma once
#include <deque>


#include "..\entDed\CentDedEkiCont.h"
#include "afxwin.h"

namespace ViewRosen{

// CDlgRosenCreateSubRosen _CAO
class CDlgRosenCreateSubRosen : public CDialog
{
private:
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
		HɊ܂܂wێ܂B
		RXgN^Ō܂܂B
	*/
	std::deque<tstring>	m_arstrEkimei ;
	
	/**
		_CAOŐݒ肳ꂽAnw̃CfNXB
		OnOK() Ō܂܂B
	*/
	int m_iSihatsuEkiIndex ;
	/**
		_CAOŐݒ肳ꂽAIw̃CfNXB
		OnOK() Ō܂܂B
	*/
	int m_iSyuuchakuEkiIndex ;
	/**
		_CAOŐݒ肳ꂽA؂o͈͊OHOƂɂ邩ۂB
		OnOK() Ō܂܂B
	*/
	bool m_bEnableOuter;

public:
	// ********************************
	///@name 
	// ********************************
	///@{
	int getSihatsuEkiIndex()const{	return m_iSihatsuEkiIndex ;};
	int getSyuuchakuEkiIndex()const{	return m_iSyuuchakuEkiIndex ;};
	bool getEnableOuter()const { return m_bEnableOuter; };



	
// --------------------------------
	DECLARE_DYNAMIC(CDlgRosenCreateSubRosen)

public:
	/**
	@param aCentDedEkiCont [in]
		wIndexƂɂẅꗗێRei
		w肵ĂB
	@param pParent [in]
		eEChEw肵ĂB
	*/
	CDlgRosenCreateSubRosen(
		const CentDedEkiCont&	aCentDedEkiCont , 
		CWnd* pParent = NULL);   // WRXgN^
	virtual ~CDlgRosenCreateSubRosen();

// _CAO f[^
	enum { IDD = IDD_FILE_ROSEN_CREATE_SUB_ROSEN };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
protected:
	virtual void OnOK();
private:
	CComboBox m_wndCOMBO_SIHATSU_EKIINDEX;
	CComboBox m_wndCOMBO_SYUUCHAKU_EKIINDEX;
	int m_bEDIT_EnableOuter;
};
} //namespace ViewRosen
