/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CDedRessyaSoater.cpp
//	$Id: CDedRessyaSoater.cpp 378 2016-11-16 21:10:54Z okm $
// ****************************************************************
*/
/** @file */
#include "stdafx.h"
#include <vector>
#include "NsMu\CMup_vector.h"
#include "CDedRessyaSoater.h"

namespace entDed{


	// --------------------------------
	//@name sort ̉֐(templatep^[)
	// --------------------------------
void CDedRessyaSoater::makeRessyaIndex( 
		int iRessyaIndex , int iRessyaCount , 
		Mui<int>* muRessyaIndexOrder ) 
{
	muRessyaIndexOrder->erase( 0 , INT_MAX ) ;
	for ( int idx = 0 ; idx < iRessyaCount ; idx ++ )
	{
		muRessyaIndexOrder->insert( iRessyaIndex + idx ) ; 
	}
}




void CDedRessyaSoater::sortRessyaByRessyaIndexOrder( 
		const Mu<int>* muRessyaIndexOrder,
		CentDedRessyaCont* pRessyaCont ) 
{
	std::vector<int>	contiRessyaIndexOrder ;
	contiRessyaIndexOrder.resize( muRessyaIndexOrder->size() ) ;
	for ( int idx = 0 ; idx < muRessyaIndexOrder->size() ; idx ++ )
	{
		contiRessyaIndexOrder[idx] = muRessyaIndexOrder->get( idx ) ;
	}
	//contiRessyaIndexOrder=muRessyaIndexOrder ̕B݉\B

	for ( int idxBeforeSort = 0 ; 
		idxBeforeSort < (int)contiRessyaIndexOrder.size() - 1 ; 
		idxBeforeSort ++ )
	{
		int idxMin = idxBeforeSort ;

		for ( int idxCompare = idxMin + 1 ; 
			idxCompare < (int)contiRessyaIndexOrder.size() ;
			idxCompare ++ )
		{
			if ( contiRessyaIndexOrder[idxMin] > 
				contiRessyaIndexOrder[idxCompare] )
			{
				idxMin = idxCompare ;
			}
		}
		//idxMin = contRessyaIndexOrder[idxBeforeSortȍ~]̒ŁA
		//	ŏ̒lCfNX
		//contRessyaIndexOrder[idxBeforeSort],
		//contRessyaIndexOrder[idxMin] = ւ̕Kv̂Index

		// --------------------------------
		//	pRessyaCont ̓eւ	
		// --------------------------------
		{
			CentDedRessya	aRessya1 = pRessyaCont->get( contiRessyaIndexOrder[idxBeforeSort] ) ;
			CentDedRessya	aRessya2 = pRessyaCont->get( contiRessyaIndexOrder[idxMin] ) ;
			pRessyaCont->set( aRessya2 , contiRessyaIndexOrder[idxBeforeSort] ) ;
			pRessyaCont->set( aRessya1 , contiRessyaIndexOrder[idxMin] ) ;
		}
		// --------------------------------
		//	contiRessyaIndexOrder ̓eւ	
		// --------------------------------
		{
			int i1 = contiRessyaIndexOrder[idxBeforeSort] ;
			int i2 = contiRessyaIndexOrder[idxMin] ;
			contiRessyaIndexOrder[idxBeforeSort] = i2 ;
			contiRessyaIndexOrder[idxMin] = i1 ;
		}
	}
}





	// ********************************
	//@name 
	// ********************************
void CDedRessyaSoater::sort( 
		CentDedRessyaCont* pRessyaCont ,
		IfProgress* pIfProgress ) 
{
	// --------------------------------
	//	\[gsIndexێReiɁA
	//	AԂ̗Indexi[܂B
	CMup_vector<int>	muRessyaIndexOrder ;	
	makeRessyaIndex( 0 , pRessyaCont->size() , &muRessyaIndexOrder ) ;

	// --------------------------------
	//	w肳ꂽIndex̗ԂA
	//	w肳ꂽwOrderŃ\[g܂B
	sortRessyaIndex( 
		pRessyaCont ,
		&muRessyaIndexOrder ,
		pIfProgress ) ;

	// --------------------------------
	//	 index (int)ێReiɏ]āA
	//	ԃRei̗Ԃ̕яA
	//	ւ܂B
	sortRessyaByRessyaIndexOrder( 
		&muRessyaIndexOrder , 
		pRessyaCont ) ;
}

} //namespace entDed
