/*
	OuDiaSecond Copyright (C) 2017-2018 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CconvCentDed.cpp
// ****************************************************************
*/
#include "stdafx.h"
#include <vector>
#include <map>
using namespace std ;

#include "str\strToInt.h"
#include "str\stringSplit.h"
#include "str\tstring.h"
#include "NsOu\OuNew.h"
#include "NsOu\dynamic_castOu.h"
#include "NsMu\CaMui.h"
#include "DcdCd\DcDrawProp\CconvDcDrawProp.h"
#include "CconvCentDed.h"

using namespace OuLib::Str ;
using namespace OuLib::Str::OuPropertiesText;
using namespace OuLib::Str::OuPropertiesText::ErrorInfo;

/*delete x̂ŗ}~
#ifndef _CONSOLE
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static TCHAR THIS_FILE[] = __FILE__;
#endif
#endif
*/

namespace entDed{

/** ̏ێ܂B */
const CdDedJikoku::CConv	g_CdDedJikokuConv(
	true ,		//	NoColon 
	CdDedJikoku::CConv::EHour_ZeroToNone ,
	CdDedJikoku::CConv::ESecond_NotIfZero ) ;
// ********************************
//	CdColorProp
// ********************************

/**
	aCdColorProp 𕶎ɕϊ܂B
@param aCdColorProp [in]
	ϊ̒lw肵ĂB
@return
	ϊʂԂ܂B
*/
static tstring CdColorProp_to_string( const CdColorProp& aCdColorProp )
{
	CconvDcDrawProp	aConv ;
	return aConv.CdColorProp_to_string( aCdColorProp ) ;
	
}


/**
	 aCdColorProp ɕϊ܂B
@param aString [in]
	ϊ̒lw肵ĂB
@return
	ϊʂԂ܂B
 */
static CdColorProp CdColorProp_from_string( const tstring& aString  )
{
	CconvDcDrawProp	aConv ;
	return aConv.CdColorProp_from_string( aString ) ;
}

// ********************************
//	CentDedEkiTrack2
// ********************************
const TCHAR nameTrackName[] = _T("TrackName");
const TCHAR nameTrackRyakusyou[] = _T("TrackRyakusyou");
const TCHAR nameTrackNoboriRyakusyou[] = _T("TrackNoboriRyakusyou");

int CconvCentDed::CentDedEkiTrack2_To_OuPropertiesText(
	const CentDedEkiTrack2& aCentDedEkiTrack2,
	OuPropertiesText::CNodeContainer* pCNodeContainer)
{
	int iRv = 0;
	// --------------------------------	
	//1.nameTrackName
	if (iRv >= 0) {
		if (aCentDedEkiTrack2.getTrackName().empty())
		{
			iRv = -11;	//	TrackName w肳Ă܂B
		}
		else
		{
			pCNodeContainer->setValue(nameTrackName,
				aCentDedEkiTrack2.getTrackName());
		}
	}
	//2.TrackRyakusyou
	if (iRv >= 0) {
		if (aCentDedEkiTrack2.getTrackRyakusyou().empty())
		{
			iRv = -21;	//	TrackRyakusyou w肳Ă܂B
		}
		else
		{
			pCNodeContainer->setValue(nameTrackRyakusyou,
				aCentDedEkiTrack2.getTrackRyakusyou());
		}
	}
	//3.TrackNoboriRyakusyou
	//藪̂́A󔒂̏ꍇo͂܂B
	if (iRv >= 0) {
		if (!aCentDedEkiTrack2.getTrackNoboriRyakusyou().empty())
		{
			pCNodeContainer->setValue(nameTrackNoboriRyakusyou,
				aCentDedEkiTrack2.getTrackNoboriRyakusyou());
		}
	}
	// --------------------------------	
	return (iRv);
}

int CconvCentDed::CentDedEkiTrack2_From_OuPropertiesText(
	CentDedEkiTrack2* pCentDedEkiTrack2,
	const OuPropertiesText::IfNodeContainerConst* pCNodeContainer,
	OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer)
{
	int iRv = 0;

	CentDedEkiTrack2	aCentDedEkiTrack2;
	// --------------------------------	
	//1.TrackName
	if (iRv >= 0)
	{
		tstring strValue = pCNodeContainer->getValue(nameTrackName);
		if (strValue.empty())
		{
			COuErrorInfo	aCOuErrorInfo(ERRREASON_TrackNameIsInvalid());
			aCOuErrorInfo.getProp()->setValue(nameTrackName, strValue);
			pCOuErrorInfoContainer->insert(aCOuErrorInfo);
			iRv = -11;	//	TrackName w肳Ă܂B
		}
		else
		{
			aCentDedEkiTrack2.setTrackName(strValue);
		}
	}
	//2.TrackRyakusyou
	if (iRv >= 0)
	{
		tstring strValue = pCNodeContainer->getValue(nameTrackRyakusyou);
		if (strValue.empty())
		{
			COuErrorInfo	aCOuErrorInfo(ERRREASON_TrackRyakusyouIsInvalid());
			aCOuErrorInfo.getProp()->setValue(nameTrackRyakusyou, strValue);
			pCOuErrorInfoContainer->insert(aCOuErrorInfo);
			iRv = -21;	//	TrackRyakusyou w肳Ă܂B
		}
		else
		{
			aCentDedEkiTrack2.setTrackRyakusyou(strValue);
		}
	}
	//3.TrackNoboriRyakusyou
	if (iRv >= 0)
	{
		tstring strValue = pCNodeContainer->getValue(nameTrackNoboriRyakusyou);
		//if (strValue.empty())
		//{
		//	COuErrorInfo	aCOuErrorInfo(ERRREASON_TrackNoboriRyakusyouIsInvalid());
		//	aCOuErrorInfo.getProp()->setValue(nameTrackNoboriRyakusyou, strValue);
		//	pCOuErrorInfoContainer->insert(aCOuErrorInfo);
		//	iRv = -31;	//	TrackNoboriRyakusyou w肳Ă܂B
		//}
		//else
		if (!strValue.empty())
		{
			aCentDedEkiTrack2.setTrackNoboriRyakusyou(strValue);
		}
	}
	// --------------------------------
	if (iRv >= 0) {
		*pCentDedEkiTrack2 = aCentDedEkiTrack2;
	}
	return (iRv);
}

// ********************************
//	CentDedEkiTrack2Cont
// ********************************
const TCHAR nameEkiTrack2[] = _T("EkiTrack2");

int CconvCentDed::CentDedEkiTrack2Cont_To_OuPropertiesText(
	const CentDedEkiTrack2Cont& aCentDedEkiTrack2Cont,
	OuPropertiesText::CNodeContainer* pCNodeContainer)
{
	int iRv = 0;
	if (iRv >= 0)
	{
		for (int idx = 0; iRv >= 0 && idx < aCentDedEkiTrack2Cont.size(); idx++)
		{
			Ou<CDirectory> pCDirectory = OuNew<CDirectory>(new CDirectory(nameEkiTrack2));
			int iResult = CentDedEkiTrack2_To_OuPropertiesText(
				aCentDedEkiTrack2Cont.get(idx),
				pCDirectory->getCNodeContainer());
			if (iResult < 0)
			{
				iRv = iResult;
				//	-	-11 ;	//	TrackName w肳Ă܂B
				//	-	-21 ;	//	TrackRyakusyou w肳Ă܂B
				//	-	-31 ;	//	TrackNoboriRyakusyou w肳Ă܂B
			}
			else
			{
				pCNodeContainer->insert(pCDirectory);
			}
		}
	}
	return iRv;
}


int CconvCentDed::CentDedEkiTrack2Cont_From_OuPropertiesText(
	CentDedEkiTrack2Cont* pCentDedEkiTrack2Cont,
	const OuPropertiesText::IfNodeContainerConst* pCNodeContainer,
	OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer)
{
	int iRv = 0;
	if (iRv >= 0)
	{
		int a = pCNodeContainer->sizeInName(nameEkiTrack2);
		for (int idx = 0; iRv >= 0 && idx < pCNodeContainer->sizeInName(nameEkiTrack2); idx++)
		{
			Ou<const CDirectory> pCDirectory;
			if (iRv >= 0)
			{
				pCDirectory = dynamic_castOu<const CDirectory>(
					pCNodeContainer->getInName(nameEkiTrack2, idx));
				if (pCDirectory == NULL)
				{
					COuErrorInfo aCOuErrorInfo(ERRREASON_EkiIsNotDirectory());
					aCOuErrorInfo.getProp()->setValue(
						ERRPROP_Index(), stringOf(idx));
					pCOuErrorInfoContainer->insert(aCOuErrorInfo);
					iRv = -101;	//	EkiTrack2 fBNgł͂܂B

				}
			}
			//pCDirectory = ΉfBNg

			CentDedEkiTrack2 aCentDedEkiTrack2;
			if (iRv >= 0)
			{
				int iResult = CentDedEkiTrack2_From_OuPropertiesText(
					&aCentDedEkiTrack2,
					pCDirectory->getIfNodeContainerConst(),
					pCOuErrorInfoContainer);
				if (iResult < 0)
				{
					iRv = iResult;
					//	-	-11 ;	//	TrackName w肳Ă܂B
					//	-	-21 ;	//	TrackRyakusyou w肳Ă܂B
					//	-	-31 ;	//	TrackNoboriRyakusyou w肳Ă܂B
				}
			}
			//aCentDedEki = Directory ̓e𔽉f܂B
			if (iRv >= 0)
			{
				pCentDedEkiTrack2Cont->insert(aCentDedEkiTrack2);
			}

		}
	}
	return iRv;
}

// ********************************
//	CentDedEki
// ********************************
const TCHAR nameEkimei[] = _T("Ekimei") ;
const TCHAR nameEkijikokukeisiki[] = _T("Ekijikokukeisiki") ;
const TCHAR nameEkikibo[] = _T("Ekikibo") ;
const TCHAR nameKyoukaisen[] = _T("Kyoukaisen") ;
const TCHAR nameDiagramRessyajouhouHyoujiKudari[] = _T("DiagramRessyajouhouHyoujiKudari") ;
const TCHAR nameDiagramRessyajouhouHyoujiNobori[] = _T("DiagramRessyajouhouHyoujiNobori") ;
const TCHAR nameDownMain[] = _T("DownMain");
const TCHAR nameUpMain[] = _T("UpMain");
const TCHAR nameBrunchCoreEkiIndex[] = _T("BrunchCoreEkiIndex");
const TCHAR nameBrunchOpposite[] = _T("BrunchOpposite");
const TCHAR nameLoopOriginEkiIndex[] = _T("LoopOriginEkiIndex");
const TCHAR nameLoopOpposite[] = _T("LoopOpposite");
const TCHAR nameJikokuhyouTrackDisplayKudari[] = _T("JikokuhyouTrackDisplayKudari");
const TCHAR nameJikokuhyouTrackDisplayNobori[] = _T("JikokuhyouTrackDisplayNobori");
const TCHAR nameDiagramTrackDisplay[] = _T("DiagramTrackDisplay");
const TCHAR nameEkiTrack2Cont[] = _T("EkiTrack2Cont");
const TCHAR nameOuterTerminal[] = _T("OuterTerminal");
const TCHAR nameOuterTerminalEkimei[] = _T("OuterTerminalEkimei");
const TCHAR nameNextEkiDistance[] = _T("NextEkiDistance");
const TCHAR nameJikokuhyouTrackOmit[] = _T("JikokuhyouTrackOmit");


const CEnumToString< CentDedEki::EEkijikokukeisiki >& 
CconvCentDed::getEEkijikokukeisikiToString()
{
	static CEnumToString< CentDedEki::EEkijikokukeisiki >	aCEnumToString ;
	if ( aCEnumToString.size() == 0 )
	{
		aCEnumToString.add( CentDedEki::Jikokukeisiki_Hatsu , _T("Jikokukeisiki_Hatsu") ) ;
		aCEnumToString.add( CentDedEki::Jikokukeisiki_Hatsuchaku , _T("Jikokukeisiki_Hatsuchaku") ) ;
		aCEnumToString.add( CentDedEki::Jikokukeisiki_KudariChaku , _T("Jikokukeisiki_KudariChaku") ) ;
		aCEnumToString.add( CentDedEki::Jikokukeisiki_NoboriChaku , _T("Jikokukeisiki_NoboriChaku")  ) ;
		//17.4.14 add_by_d_mania
		aCEnumToString.add( CentDedEki::Jikokukeisiki_KudariHatsuchaku , _T("Jikokukeisiki_KudariHatsuchaku") ) ;
		aCEnumToString.add( CentDedEki::Jikokukeisiki_NoboriHatsuchaku , _T("Jikokukeisiki_NoboriHatsuchaku")  ) ;
	}
	return aCEnumToString ;
}


const CEnumToString< CentDedEki::EEkikibo >& 
CconvCentDed::getEEkikiboToString()
{
	static CEnumToString< CentDedEki::EEkikibo >	aCEnumToString ;
	if ( aCEnumToString.size() == 0 )
	{
		aCEnumToString.add( CentDedEki::Ekikibo_Ippan , _T("Ekikibo_Ippan") ) ;
		aCEnumToString.add( CentDedEki::Ekikibo_Syuyou , _T("Ekikibo_Syuyou") ) ;
	}
	return aCEnumToString ;
}


const CEnumToString< CentDedEki::EDiagramRessyajouhouHyouji >& 
CconvCentDed::getEDiagramRessyajouhouHyoujiToString()
{
	static CEnumToString< CentDedEki::EDiagramRessyajouhouHyouji >	aCEnumToString ;
	if ( aCEnumToString.size() == 0 )
	{
		aCEnumToString.add( CentDedEki::DiagramRessyajouhouHyouji_Origin , 
			_T("") ) ;
		aCEnumToString.add( CentDedEki::DiagramRessyajouhouHyouji_Anytime , 
			_T("DiagramRessyajouhouHyouji_Anytime") ) ;
		aCEnumToString.add( CentDedEki::DiagramRessyajouhouHyouji_Not , 
			_T("DiagramRessyajouhouHyouji_Not") ) ;
	}
	return aCEnumToString ;
}



int CconvCentDed::CentDedEki_To_OuPropertiesText( 
			const CentDedEki& aCentDedEki , 
			OuPropertiesText::CNodeContainer* pCNodeContainer ) 
{
	int iRv = 0 ;
	// --------------------------------	
	//1.Ekimei
	if ( iRv >= 0 ){
		//memo:
		//	ȑÓA󕶎̉w̓G[łA
		//	݂͂F߂悤ɂȂ܂B
		pCNodeContainer->setValue( nameEkimei , 
			aCentDedEki.getEkimei() ) ;
	}
	//2.Ekijikokukeisiki
	if ( iRv >= 0 )
	{
		tstring strValue = getEEkijikokukeisikiToString().stringOf( 
			aCentDedEki.getEkijikokukeisiki() ) ;
		pCNodeContainer->setValue( nameEkijikokukeisiki , strValue ) ;
	}

	//3.Ekikibo
	if ( iRv >= 0 )
	{
		tstring strValue = getEEkikiboToString().stringOf( 
			aCentDedEki.getEkikibo() ) ;
		pCNodeContainer->setValue( nameEkikibo , 
				strValue ) ;
	}
	//4.Kyoukaisen
	if ( iRv >= 0 )
	{
		if ( aCentDedEki.getKyoukaisen() )
		{
			pCNodeContainer->setValue( nameKyoukaisen ,_T("1") ) ;
		}
	}
	//5. m_bDiagramRessyajouhouHyoujiKudari ;
	if ( iRv >= 0 )
	{
		tstring strValue = getEDiagramRessyajouhouHyoujiToString().stringOf( 
					aCentDedEki.getDiagramRessyajouhouHyoujiKudari() ) ;
		if ( !strValue.empty() )
		{
			pCNodeContainer->setValue( 
				nameDiagramRessyajouhouHyoujiKudari , strValue ) ;
		}
	}
	//6.m_bDiagramRessyajouhouHyoujiNobori
	if ( iRv >= 0 )
	{
		tstring strValue = getEDiagramRessyajouhouHyoujiToString().stringOf( 
					aCentDedEki.getDiagramRessyajouhouHyoujiNobori() ) ;
		if ( !strValue.empty() )
		{
			pCNodeContainer->setValue( nameDiagramRessyajouhouHyoujiNobori ,strValue) ;
		}
	}

	//7.DownMain ;
	if (iRv >= 0)
	{
		pCNodeContainer->setValue(
			nameDownMain,
			stringOf(
				aCentDedEki.getDownMain()
			)
		);
	}
	//8.UpMain ;
	if (iRv >= 0)
	{
		pCNodeContainer->setValue(
			nameUpMain,
			stringOf(
				aCentDedEki.getUpMain()
			)
		);
	}
	//9.BrunchCoreEkiIndex,BrunchOpposite
	if (iRv >= 0)
	{
		if (aCentDedEki.getBrunchCoreEkiIndex()>=0)
		{
			pCNodeContainer->setValue(
				nameBrunchCoreEkiIndex,
				stringOf(aCentDedEki.getBrunchCoreEkiIndex()));
			if (aCentDedEki.getBrunchOpposite())
			{
				pCNodeContainer->setValue(
					nameBrunchOpposite,
					_T("1"));
			}
		}
	}
	//10.LoopOriginEkiIndex
	if (iRv >= 0)
	{
		if (aCentDedEki.getLoopOriginEkiIndex() >= 0)
		{
			pCNodeContainer->setValue(
				nameLoopOriginEkiIndex,
				stringOf(aCentDedEki.getLoopOriginEkiIndex()));
			if (aCentDedEki.getLoopOpposite())
			{
				pCNodeContainer->setValue(
					nameLoopOpposite,
					_T("1"));
			}
		}
	}
	//11.JikokuhyouTrackDisplayKudari
	if (iRv >= 0)
	{
		if (aCentDedEki.getJikokuhyouTrackDisplayKudari())
		{
			pCNodeContainer->setValue(nameJikokuhyouTrackDisplayKudari, _T("1"));
		}
	}
	//12.JikokuhyouTrackDisplayNobori
	if (iRv >= 0)
	{
		if (aCentDedEki.getJikokuhyouTrackDisplayNobori())
		{
			pCNodeContainer->setValue(nameJikokuhyouTrackDisplayNobori, _T("1"));
		}
	}
	//13.DiagramTrackDisplay
	if (iRv >= 0)
	{
		if (aCentDedEki.getDiagramTrackDisplay())
		{
			pCNodeContainer->setValue(nameDiagramTrackDisplay, _T("1"));
		}
	}

	//14.EkiTrack2Cont
	if (iRv >= 0)
	{
		Ou<CDirectory> pCDirectory = OuNew<CDirectory>(
			new CDirectory(nameEkiTrack2Cont));
		int iResult = CentDedEkiTrack2Cont_To_OuPropertiesText(
			*aCentDedEki.getEkiTrack2Cont(),
			pCDirectory->getCNodeContainer());
			//pCNodeContainer);
		//	-	-22 ;	//	Ekijikokukeisiki ̒lsłB
		//	-	-32 ;	//	Ekikibo ̒lsłB
		if (iResult < 0)
		{
			//	-	-22 ;	//	Ekijikokukeisiki ̒lsłB
			//	-	-32 ;	//	Ekikibo ̒lsłB
			iRv = iResult;
		}
		else
		{
			pCNodeContainer->insert(pCDirectory);
		}
	}
	//15.OuterTerminal
	if (iRv >= 0)
	{
		for (int idx = 0; idx < aCentDedEki.getOuterTerminalEkimeiCount(); idx++)
		{
			Ou<CDirectory> pCDirectory = OuNew<CDirectory>(new CDirectory(nameOuterTerminal));
			//15.1.OuterTerminalEkimei
			if (iRv >= 0)
			{
				pCDirectory->getCNodeContainer()->setValue(nameOuterTerminalEkimei,
					aCentDedEki.getOuterTerminalEkimei(idx));
			}

			if (iRv >= 0)
			{
				pCNodeContainer->insert(pCDirectory);
			}

		}
	}
	//16.NextEkiDistance
	if (iRv >= 0)
	{
		if (!aCentDedEki.getNextEkiDistanceIsDefault())
		{
			pCNodeContainer->setValue(
				nameNextEkiDistance,
				stringOf(aCentDedEki.getNextEkiDistance()));
		}
	}
	//17.JikokuhyouTrackOmit
	if (iRv >= 0)
	{
		if (aCentDedEki.getJikokuhyouTrackOmit())
		{
			pCNodeContainer->setValue(nameJikokuhyouTrackOmit, _T("1"));
		}
	}

	// --------------------------------	
	return ( iRv ) ;
}

int CconvCentDed::CentDedEki_From_OuPropertiesText( 
			CentDedEki* pCentDedEki ,
			const OuPropertiesText::IfNodeContainerConst* pCNodeContainer ,
			OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer ) 
{
	int iRv = 0 ;
	
	CentDedEki	aCentDedEki ; 
	// --------------------------------	
	//1.Ekimei
	if ( iRv >= 0 )
	{
		tstring strValue = pCNodeContainer->getValue( nameEkimei ) ;
		//memo:
		//	ȑÓA󕶎̉w̓G[łA
		//	݂͂F߂悤ɂȂ܂B

		aCentDedEki.setEkimei( strValue ) ;
	}

	//2.Ekijikokukeisiki
	if ( iRv >= 0 )
	{
		tstring	strValue = pCNodeContainer->getValue( nameEkijikokukeisiki );
		CentDedEki::EEkijikokukeisiki eValue = CentDedEki::Jikokukeisiki_Hatsu ;
		if ( getEEkijikokukeisikiToString().fromString( strValue , &eValue ) < 0 )
		{
			COuErrorInfo aCOuErrorInfo( ERRREASON_EkijikokukeisikiIsInvalid() ) ;
			aCOuErrorInfo.getProp()->setValue( nameEkijikokukeisiki , strValue ) ;
			pCOuErrorInfoContainer->insert( aCOuErrorInfo ) ;
			iRv = -22 ;	//	Ekijikokukeisiki ̒lsłB
		}
		else
		{
			aCentDedEki.setEkijikokukeisiki( eValue ) ; 
		}

	}

	//3.Ekikibo
	if ( iRv >= 0 )
	{
		tstring	strValue = pCNodeContainer->getValue( nameEkikibo );
		CentDedEki::EEkikibo eValue = CentDedEki::Ekikibo_Ippan ;
		if ( getEEkikiboToString().fromString( strValue , &eValue ) < 0 )
		{
			COuErrorInfo aCOuErrorInfo( ERRREASON_EkikiboIsInvalid() ) ;
			aCOuErrorInfo.getProp()->setValue( nameEkikibo , strValue ) ;
			pCOuErrorInfoContainer->insert( aCOuErrorInfo ) ;
			iRv = -32 ;	//	Ekikibo ̒lsłB
		}
		else
		{
			aCentDedEki.setEkikibo( eValue ) ; 
		}
	}
	//4.Kyoukaisen
	if ( iRv >= 0 )
	{
		tstring	strValue = pCNodeContainer->getValue( nameKyoukaisen ) ; 
		aCentDedEki.setKyoukaisen(_ttoi( strValue.c_str() ) == 1 ) ;
	}

	//5. m_eDiagramRessyajouhouHyoujiKudari ;
	if ( iRv >= 0 )
	{
		tstring	strValue = pCNodeContainer->getValue( nameDiagramRessyajouhouHyoujiKudari ) ; 
		CentDedEki::EDiagramRessyajouhouHyouji eValue = 
			CentDedEki::DiagramRessyajouhouHyouji_Origin ;
		if ( strValue.length() > 0 && 
			getEDiagramRessyajouhouHyoujiToString().fromString( strValue , &eValue ) < 0 )
		{
			COuErrorInfo aCOuErrorInfo( ERRREASON_DiagramRessyajouhouHyoujiIsInvalid() ) ;
			aCOuErrorInfo.getProp()->setValue( nameDiagramRessyajouhouHyoujiKudari , strValue ) ;
			pCOuErrorInfoContainer->insert( aCOuErrorInfo ) ;
			iRv = -41 ;	//	DiagramRessyajouhouHyoujiKudari ̒lsłB
		}
		else
		{
			aCentDedEki.setDiagramRessyajouhouHyoujiKudari( eValue ) ;
		}
	}
	//6.m_eDiagramRessyajouhouHyoujiNobori
	if ( iRv >= 0 )
	{
		tstring	strValue = pCNodeContainer->getValue( nameDiagramRessyajouhouHyoujiNobori ) ; 
		CentDedEki::EDiagramRessyajouhouHyouji eValue = 
			CentDedEki::DiagramRessyajouhouHyouji_Origin ;
		if ( strValue.length() > 0 && 
			getEDiagramRessyajouhouHyoujiToString().fromString( strValue , &eValue ) < 0 )
		{
			COuErrorInfo aCOuErrorInfo( ERRREASON_DiagramRessyajouhouHyoujiIsInvalid() ) ;
			aCOuErrorInfo.getProp()->setValue( nameDiagramRessyajouhouHyoujiNobori , strValue ) ;
			pCOuErrorInfoContainer->insert( aCOuErrorInfo ) ;
			iRv = -42 ;	//	DiagramRessyajouhouHyoujiNobori ̒lsłB
		}
		else
		{
			aCentDedEki.setDiagramRessyajouhouHyoujiNobori( eValue ) ;
		}
	}

	//7.DownMain 
	if (iRv >= 0)
	{
		tstring	strValue = pCNodeContainer->getValue(
			nameDownMain);
		int iValue = _ttoi(strValue.c_str());
		aCentDedEki.setDownMain(iValue);
	}
	//8.UpMain 
	if (iRv >= 0)
	{
		tstring	strValue = pCNodeContainer->getValue(
			nameUpMain);
		int iValue = _ttoi(strValue.c_str());
		aCentDedEki.setUpMain(iValue);
	}
	//9.BrunchCoreEkiIndex,BrunchOpposite
	if (iRv >= 0)
	{
		tstring	strValue = pCNodeContainer->getValue(
			nameBrunchCoreEkiIndex);
		int iValue;
		if (strValue == _T(""))
		{
			 iValue = -1;
		}
		else
		{
			 iValue = _ttoi(strValue.c_str());
		}
		aCentDedEki.setBrunchCoreEkiIndex(iValue);
		if (iValue >= 0)
		{
			tstring	strValueO = pCNodeContainer->getValue(
				nameBrunchOpposite);
			aCentDedEki.setBrunchOpposite(_ttoi(strValueO.c_str()) == 1);
		}
	}
	//10.LoopOriginEkiIndex
	if (iRv >= 0)
	{
		tstring	strValue = pCNodeContainer->getValue(
			nameLoopOriginEkiIndex);
		int iValue;
		if (strValue == _T(""))
		{
			iValue = -1;
		}
		else
		{
			iValue = _ttoi(strValue.c_str());
		}
		aCentDedEki.setLoopOriginEkiIndex(iValue);
		if (iValue >= 0)
		{
			tstring	strValueO = pCNodeContainer->getValue(
				nameLoopOpposite);
			aCentDedEki.setLoopOpposite(_ttoi(strValueO.c_str()) == 1);
		}
	}
	//11.JikokuhyouTrackDisplayKudari
	if (iRv >= 0)
	{
		tstring	strValue = pCNodeContainer->getValue(nameJikokuhyouTrackDisplayKudari);
		aCentDedEki.setJikokuhyouTrackDisplayKudari(_ttoi(strValue.c_str()) == 1);
	}
	//12.JikokuhyouTrackDisplayNobori
	if (iRv >= 0)
	{
		tstring	strValue = pCNodeContainer->getValue(nameJikokuhyouTrackDisplayNobori);
		aCentDedEki.setJikokuhyouTrackDisplayNobori(_ttoi(strValue.c_str()) == 1);
	}
	//13.DiagramTrackDisplay
	if (iRv >= 0)
	{
		tstring	strValue = pCNodeContainer->getValue(nameDiagramTrackDisplay);
		aCentDedEki.setDiagramTrackDisplay(_ttoi(strValue.c_str()) == 1);
	}
	//15.OuterTerminalEkimei
	if (iRv >= 0)
	{
		int iSize = pCNodeContainer->sizeInName(nameOuterTerminal);
		for (int idx = 0; idx < iSize; idx++)
		{
			Ou<const CDirectory> pCDirectory;
			if (iRv >= 0)
			{
				pCDirectory = dynamic_castOu<const CDirectory>(
					pCNodeContainer->getInName(nameOuterTerminal, idx));
				tstring strValue = pCDirectory->getIfNodeContainerConst()->getValue(
					nameOuterTerminalEkimei);
				if (!strValue.empty())
				{
					aCentDedEki.insertOuterTerminalEkimei(strValue, INT_MAX);
				}
			}

		}
	}
	//16.NextEkiDistance
	if (iRv >= 0)
	{
		tstring	strValue = pCNodeContainer->getValue(
			nameNextEkiDistance);
		int iValue;
		if (strValue == _T(""))
		{
			iValue = 0;
		}
		else
		{
			iValue = _ttoi(strValue.c_str());
		}
		aCentDedEki.setNextEkiDistance(iValue);
	}
	//17.JikokuhyouTrackOmit
	if (iRv >= 0)
	{
		tstring	strValue = pCNodeContainer->getValue(nameJikokuhyouTrackOmit);
		aCentDedEki.setJikokuhyouTrackOmit(_ttoi(strValue.c_str()) == 1);
	}


	// --------------------------------

	CentDedEkiTrack2Cont	aCentDedEkiTrack2Cont;
	if (iRv >= 0)
	{
		Ou<const CDirectory> pCDirectory = dynamic_castOu<const CDirectory>(
			pCNodeContainer->getInName(nameEkiTrack2Cont, 0));
			//pCNodeContainer->getInName(nameEkiTrack2, 0));
		if (pCDirectory != NULL)
		{
			int iResult = CentDedEkiTrack2Cont_From_OuPropertiesText(
				&aCentDedEkiTrack2Cont,
				pCDirectory->getIfNodeContainerConst(),
				pCOuErrorInfoContainer);
			//iResult = ݁A̒l̐ɂȂ邱Ƃ͂܂
			if (iResult < 0)
			{
				iRv = iResult;
			}
			//else
			//{
			//	//CaMui<CentDedEkiTrack2>	aCaCont(aCentDedEki.getEkiTrack2Cont());
			//	//CaMui<CentDedEkiTrack2>	aCaCont(pCentDedEki->getEkiTrack2Cont());
			//	//aCaCont.insert(&aCentDedEkiTrack2Cont);
			//	//*pCentDedEki->getEkiTrack2Cont() = aCentDedEkiTrack2Cont;
			//	//pCentDedRessyaCont->insert(aCentDedRessya);
			//}
		}
	}

	if ( iRv >= 0 ){
		*pCentDedEki = aCentDedEki ;
		*pCentDedEki->getEkiTrack2Cont() = aCentDedEkiTrack2Cont;
	}
	return ( iRv ) ;
}

	// ********************************
	//	CentDedEkiCont
	// ********************************
const TCHAR nameEki[] = _T("Eki") ;
	
int CconvCentDed::CentDedEkiCont_To_OuPropertiesText( 
			const CentDedEkiCont& aCentDedEkiCont , 
			OuPropertiesText::CNodeContainer* pCNodeContainer ) 
{
	int iRv = 0 ;
	if ( iRv >= 0 )
	{
		for ( int idxEki = 0 ; iRv >= 0 && idxEki < aCentDedEkiCont.size() ; idxEki ++ )
		{
			Ou<CDirectory> pCDirectory = OuNew<CDirectory>( new CDirectory( nameEki ) ) ;
			int iResult = CentDedEki_To_OuPropertiesText(
				aCentDedEkiCont.get( idxEki ) ,
				pCDirectory->getCNodeContainer() ) ;
			if ( iResult < 0 )
			{
				iRv = iResult ;
			}
			else
			{
				pCNodeContainer->insert( pCDirectory ) ;
			}
		}
	}
	return iRv ;
}
	

int CconvCentDed::CentDedEkiCont_From_OuPropertiesText( 
			CentDedEkiCont* pCentDedEkiCont ,
			const OuPropertiesText::IfNodeContainerConst* pCNodeContainer ,
			OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer ) 
{
	int iRv = 0 ;
	if ( iRv >= 0 )
	{
		for ( int idxEki = 0 ; iRv >= 0 && idxEki < pCNodeContainer->sizeInName( nameEki )  ; idxEki ++ )
		{
			Ou<const CDirectory> pCDirectory ; 
			if ( iRv >= 0 )
			{
				pCDirectory = dynamic_castOu<const CDirectory>( 
					pCNodeContainer->getInName( nameEki , idxEki ) ) ;
				if ( pCDirectory == NULL )
				{
					COuErrorInfo aCOuErrorInfo( ERRREASON_EkiIsNotDirectory() ) ;
					aCOuErrorInfo.getProp()->setValue( 
						ERRPROP_Index() , stringOf( idxEki ) ) ;
					pCOuErrorInfoContainer->insert( aCOuErrorInfo ) ;
					iRv = -101 ;	//	Eki fBNgł͂܂B

				}
			}
			//pCDirectory = ΉfBNg

			CentDedEki aCentDedEki ;
			if ( iRv >= 0 )
			{
				int iResult = CentDedEki_From_OuPropertiesText( 
					&aCentDedEki , 
					pCDirectory->getIfNodeContainerConst() , 
					pCOuErrorInfoContainer ) ;
				if ( iResult < 0 )
				{
					iRv = iResult ;
					//	-	-22 ;	//	Ekijikokukeisiki ̒lsłB
					//	-	-32 ;	//	Ekikibo ̒lsłB
					//	-	-41 ;	//	DiagramRessyajouhouHyoujiKudari ̒lsłB
					//	-	-42 ;	//	DiagramRessyajouhouHyoujiNobori ̒lsłB
				}
			}
			//aCentDedEki = Directory ̓e𔽉f܂B
			if ( iRv >= 0 )
			{
				pCentDedEkiCont->insert( aCentDedEki ) ;
			}
				
		}
	}
	return iRv ;
}


// ********************************
//	CentDedRessyasyubetsu
// ********************************

const TCHAR nameSyubetsumei[]=_T("Syubetsumei") ;
const TCHAR nameRyakusyou[]=_T("Ryakusyou") ;
const TCHAR nameJikokuhyouMojiColor[]=_T("JikokuhyouMojiColor") ;
const TCHAR nameJikokuhyouFontIndex[] = _T("JikokuhyouFontIndex") ;
const TCHAR nameJikokuhyouBackColor[] = _T("JikokuhyouBackColor");
const TCHAR nameDiagramSenColor[]=_T("DiagramSenColor") ;
const TCHAR nameDiagramSenStyle[]=_T("DiagramSenStyle") ;
const TCHAR nameDiagramSenIsBold[]=_T("DiagramSenIsBold") ;
const TCHAR nameDiagramRessyaFont[] = _T("DiagramRessyaFont") ;
const TCHAR nameStopMarkDrawType[] = _T("StopMarkDrawType") ;
const TCHAR nameParentSyubetsuIndex[] = _T("ParentSyubetsuIndex");

const CEnumToString< CentDedRessyasyubetsu::ESenStyle >& 
CconvCentDed::getESenStyleToString()
{
	static CEnumToString< CentDedRessyasyubetsu::ESenStyle >	aCEnumToString ;
	if ( aCEnumToString.size() == 0 )
	{
		aCEnumToString.add( CentDedRessyasyubetsu::SenStyle_Jissen , _T("SenStyle_Jissen") ) ;
		aCEnumToString.add( CentDedRessyasyubetsu::SenStyle_Hasen , _T("SenStyle_Hasen") ) ;
		aCEnumToString.add( CentDedRessyasyubetsu::SenStyle_Tensen , _T("SenStyle_Tensen")) ;
		aCEnumToString.add( CentDedRessyasyubetsu::SenStyle_Ittensasen , _T("SenStyle_Ittensasen") ) ;
	}
	return aCEnumToString ;
}

const CEnumToString< CentDedRessyasyubetsu::EStopMarkDrawType >& 
CconvCentDed::getEStopMarkDrawTypeToString()
{
	static CEnumToString< CentDedRessyasyubetsu::EStopMarkDrawType >	aCEnumToString ;
	if ( aCEnumToString.size() == 0 )
	{
		aCEnumToString.add( CentDedRessyasyubetsu::EStopMarkDrawType_DrawOnStop , _T("EStopMarkDrawType_DrawOnStop") ) ;
		aCEnumToString.add( CentDedRessyasyubetsu::EStopMarkDrawType_Nothing , _T("EStopMarkDrawType_Nothing") ) ;
		aCEnumToString.add( CentDedRessyasyubetsu::EStopMarkDrawType_DrawOnPass , _T("EStopMarkDrawType_DrawOnPass")) ;
	}
	return aCEnumToString ;
}

int CconvCentDed::CdDiagramLineStyle_To_OuPropertiesText( 
	const CentDedRessyasyubetsu::CdDiagramLineStyle& aCdDiagramLineStyle , 
	OuPropertiesText::CNodeContainer* pCNodeContainer ) 
{
	int iRv = 0 ;

	// --------------------------------	
	//5.DiagramSenColor
	if ( iRv >= 0 )
	{
		pCNodeContainer->setValue( nameDiagramSenColor , 
			CdColorProp_to_string( aCdDiagramLineStyle.getDiagramSenColor() ) ) ;
	}

	//6.DiagramSenStyle
	if ( iRv >= 0 )
	{
		tstring strValue = getESenStyleToString().stringOf( aCdDiagramLineStyle.getDiagramSenStyle() ) ;
		pCNodeContainer->setValue( nameDiagramSenStyle , strValue ) ;

	}

	//7.DiagramSenIsBold
	if ( iRv >= 0 )
	{
		bool bValue = aCdDiagramLineStyle.getDiagramSenIsBold();
		if ( bValue )
		{
			pCNodeContainer->setValue( nameDiagramSenIsBold , _T("1") ) ;
		}
	}
	return iRv ;
}

int CconvCentDed::CdDiagramLineStyle_From_OuPropertiesText( 
	CentDedRessyasyubetsu::CdDiagramLineStyle* pCdDiagramLineStyle ,
	const OuPropertiesText::IfNodeContainerConst* pCNodeContainer ,
	OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer ) 
{
	int iRv = 0 ;

	CentDedRessyasyubetsu::CdDiagramLineStyle aCdDiagramLineStyle;

	// --------------------------------	
	//5.DiagramSenColor
	if ( iRv >= 0 ){
		tstring	strValue = pCNodeContainer->getValue( 
			nameDiagramSenColor ) ;
		aCdDiagramLineStyle.setDiagramSenColor( 
			CdColorProp_from_string( strValue ) ) ;
	}
	
	//6.DiagramSenStyle
	if ( iRv >= 0 )
	{
		tstring	strValue = pCNodeContainer->getValue( 
			nameDiagramSenStyle ) ;
		CentDedRessyasyubetsu::ESenStyle eValue = CentDedRessyasyubetsu::SenStyle_Jissen ;
		if ( getESenStyleToString().fromString( strValue , &eValue ) < 0 )
		{
			COuErrorInfo	aCOuErrorInfo( ERRREASON_DiagramSenStyleIsInvalid() ) ;
			aCOuErrorInfo.getProp()->setValue( nameDiagramSenStyle , strValue ) ;
			pCOuErrorInfoContainer->insert( aCOuErrorInfo ) ;
			iRv = -52 ;	//	DiagramSenStyle ̒lsłB
		}
		else
		{
			aCdDiagramLineStyle.setDiagramSenStyle( eValue ) ;
		}
	}

	//7.DiagramSenIsBold
	if ( iRv >= 0 )
	{
		tstring	strValue = pCNodeContainer->getValue( 
			nameDiagramSenIsBold ) ;
		unsigned long iValue = _tcstoul( strValue.c_str() , NULL , 10 ) ;
		aCdDiagramLineStyle.setDiagramSenIsBold( iValue != 0 ) ;
	}
	// --------------------------------
	if ( iRv >= 0 )
	{
		*pCdDiagramLineStyle = aCdDiagramLineStyle ;
	}
	return iRv ;
}


int CconvCentDed::CentDedRessyasyubetsu_To_OuPropertiesText( 
			const CentDedRessyasyubetsu& aCentDedRessyasyubetsu , 
			OuPropertiesText::CNodeContainer* pCNodeContainer ) 
{
	int iRv = 0 ;

	// --------------------------------	
	//1.Syubetsumei
	if ( iRv >= 0 )
	{
		if ( aCentDedRessyasyubetsu.getSyubetsumei().empty() )
		{
			iRv = -11 ;	//	Syubetsumei w肳Ă܂B
		}
		else
		{
			pCNodeContainer->setValue( nameSyubetsumei , 
				aCentDedRessyasyubetsu.getSyubetsumei() ) ;
		}
	}


	//2.Ryakusyou
	if ( iRv >= 0 )
	{
		if ( aCentDedRessyasyubetsu.getRyakusyou().empty() )
		{

		}
		else
		{
			pCNodeContainer->setValue( nameRyakusyou , 
				aCentDedRessyasyubetsu.getRyakusyou() ) ;
		}
	}

	//3.JikokuhyouMojiColor
	if ( iRv >= 0 )
	{
		pCNodeContainer->setValue( nameJikokuhyouMojiColor , 
			CdColorProp_to_string( aCentDedRessyasyubetsu.getJikokuhyouMojiColor() ) ) ;
	}
	//4.JikokuhyouFontIndex
	if ( iRv >= 0 )
	{
		int iValue = aCentDedRessyasyubetsu.getJikokuhyouFontIndex() ;
		{
			pCNodeContainer->setValue( 
				nameJikokuhyouFontIndex , 
				stringOf( iValue ) ) ;
		}
	}
	//4.1.JikokuhyouMojiColor
	if (iRv >= 0)
	{
		pCNodeContainer->setValue(nameJikokuhyouBackColor,
			CdColorProp_to_string(aCentDedRessyasyubetsu.getJikokuhyouBackColor()));
	}
	//5.DiagramSenColor
	//6.DiagramSenStyle
	//7.DiagramSenIsBold
	if ( iRv >= 0 )
	{
		CdDiagramLineStyle_To_OuPropertiesText( 
			aCentDedRessyasyubetsu.getCdDiagramLineStyle() ,
			pCNodeContainer ) ;
	}

	//9 StopMarkDrawType
	if ( iRv >= 0 )
	{
		tstring strValue = getEStopMarkDrawTypeToString().stringOf( aCentDedRessyasyubetsu.getStopMarkDrawType() ) ;
		pCNodeContainer->setValue( nameStopMarkDrawType , strValue ) ;
	}

	//10.ParentSyubetsuIndex
	if (iRv >= 0)
	{
		if (aCentDedRessyasyubetsu.getParentSyubetsuIndex() >= 0)
		{
			pCNodeContainer->setValue(
				nameParentSyubetsuIndex,
				stringOf(aCentDedRessyasyubetsu.getParentSyubetsuIndex()));
		}
	}

	return ( iRv ) ;
}


int CconvCentDed::CentDedRessyasyubetsu_From_OuPropertiesText( 
			CentDedRessyasyubetsu* pCentDedRessyasyubetsu ,
			const OuPropertiesText::IfNodeContainerConst* pCNodeContainer ,
			OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer ) 
{
	int iRv = 0 ;

	CentDedRessyasyubetsu aCentDedRessyasyubetsu ;

	// --------------------------------	
	//1.Syubetsumei
	if ( iRv >= 0 )
	{
		tstring	strValue = pCNodeContainer->getValue( nameSyubetsumei ) ;
		if ( strValue.empty() )
		{
			COuErrorInfo	aCOuErrorInfo( ERRREASON_SyubetsumeiIsInvalid() ) ;
			aCOuErrorInfo.getProp()->setValue( nameSyubetsumei , strValue ) ;
			pCOuErrorInfoContainer->insert( aCOuErrorInfo ) ;
			iRv = -11 ;	//	Syubetsumei w肳Ă܂B
		}
		else
		{
			aCentDedRessyasyubetsu.setSyubetsumei( strValue ) ;
		}
	}
	
	//2.Ryakusyou
	if ( iRv >= 0 ){
		tstring	strValue = pCNodeContainer->getValue( nameRyakusyou ) ;
		if ( strValue.empty() ){
		}	else	{
			aCentDedRessyasyubetsu.setRyakusyou( strValue ) ;
		}
	}
	
	//3.JikokuhyouMojiColor
	if ( iRv >= 0 )
	{
		tstring	strValue = pCNodeContainer->getValue( 
			nameJikokuhyouMojiColor ) ;
		aCentDedRessyasyubetsu.setJikokuhyouMojiColor( 
			CdColorProp_from_string( strValue ) ) ;
	}
	//4.JikokuhyouFontIndex
	if ( iRv >= 0 )
	{
		tstring strValue = pCNodeContainer->getValue( 
			nameJikokuhyouFontIndex ) ;
		if ( !strValue.empty() )
		{
			int iValue = intOf( strValue ) ;
			if ( !( 0 <= iValue && iValue < CentDedRessyasyubetsu::JIKOKUHYOUFONT_COUNT ) )
			{
				COuErrorInfo	aCOuErrorInfo( ERRREASON_InvalidValueFormat() ) ;
				aCOuErrorInfo.getProp()->setValue( ERRPROP_Name() , nameJikokuhyouFontIndex ) ;
				aCOuErrorInfo.getProp()->setValue( ERRPROP_Value() , strValue ) ;
				pCOuErrorInfoContainer->insert( aCOuErrorInfo ) ;
				iRv = -101 ;	//	ľ`܂B
			}
			else
			{
				aCentDedRessyasyubetsu.setJikokuhyouFontIndex( iValue ) ;
			}
		}
	}
	//4.1.JikokuhyouBackColor
	if (iRv >= 0)
	{
		tstring	strValue = pCNodeContainer->getValue(
			nameJikokuhyouBackColor);
		if (strValue != _T(""))
		{
			aCentDedRessyasyubetsu.setJikokuhyouBackColor(
				CdColorProp_from_string(strValue));
		}
	}
	//5.DiagramSenColor
	//6.DiagramSenStyle
	//7.DiagramSenIsBold
	{
		CentDedRessyasyubetsu::CdDiagramLineStyle	aCdDiagramLineStyle ;
		int iResult = CdDiagramLineStyle_From_OuPropertiesText( 
			&aCdDiagramLineStyle ,
			pCNodeContainer ,
			pCOuErrorInfoContainer ) ;
		//iResult = 
		//	-52 ;	//	DiagramSenStyle ̒lsłB
		if ( iResult < 0 )
		{
			iRv = iResult ;
			//iRv = 
			//	-52 ;	//	DiagramSenStyle ̒lsłB
		}
		else
		{
			aCentDedRessyasyubetsu.setCdDiagramLineStyle( aCdDiagramLineStyle ) ;
		}
	}
	

	//9 StopMarkDrawType
	if ( iRv >= 0 )
	{
		CentDedRessyasyubetsu::EStopMarkDrawType eStopMarkDrawType = 
			CentDedRessyasyubetsu::EStopMarkDrawType_DrawOnStop ;
		tstring strValue = pCNodeContainer->getValue( nameStopMarkDrawType ) ;
		if ( !strValue.empty() )
		{
			getEStopMarkDrawTypeToString().fromString( strValue , &eStopMarkDrawType ) ;
		}
		aCentDedRessyasyubetsu.setStopMarkDrawType( eStopMarkDrawType ) ;
	}

	//10.ParentSyubetsuIndex
	if (iRv >= 0)
	{
		tstring	strValue = pCNodeContainer->getValue(
			nameParentSyubetsuIndex);
		int iValue;
		if (strValue == _T(""))
		{
			iValue = -1;
		}
		else
		{
			iValue = _ttoi(strValue.c_str());
		}
		aCentDedRessyasyubetsu.setParentSyubetsuIndex(iValue);
	}

	// --------------------------------
	if ( iRv >= 0 )
	{
		*pCentDedRessyasyubetsu = aCentDedRessyasyubetsu ;
	}

	return ( iRv ) ;
}

void CconvCentDed::CentDedRessyasyubetsu_to_CDcdFreeLineProp(
		const CentDedRessyasyubetsu::CdDiagramLineStyle& aLineStyle , 
		CdDcdFreeLineProp* pCdLineProp )
{
	pCdLineProp->setColor( aLineStyle.getDiagramSenColor() ) ;
	switch( aLineStyle.getDiagramSenStyle() ){
		 //  
		 case CentDedRessyasyubetsu::SenStyle_Jissen :
			pCdLineProp->setLinestyle( LINESTYLE_SOLID ) ;
			break ;
		 // j
		 case CentDedRessyasyubetsu::SenStyle_Hasen :
			pCdLineProp->setLinestyle( LINESTYLE_DASH ) ;
			break ;
		 // _
		 case CentDedRessyasyubetsu::SenStyle_Tensen :
			pCdLineProp->setLinestyle( LINESTYLE_DOT ) ;
			break ;
		 // _
		 case CentDedRessyasyubetsu::SenStyle_Ittensasen :
			pCdLineProp->setLinestyle( LINESTYLE_DASH_DOT ) ;
			break ;
	}
	pCdLineProp->setLogicalunitWidth( aLineStyle.getDiagramSenIsBold() ? 2 : 1 ) ;

}

	// ********************************
	//	CentDedRessyasyubetsuCont
	// ********************************
const TCHAR nameRessyasyubetsu[] = _T("Ressyasyubetsu") ;
	

int CconvCentDed::CentDedRessyasyubetsuCont_To_OuPropertiesText( 
			const CentDedRessyasyubetsuCont& aCentDedRessyasyubetsuCont , 
			OuPropertiesText::CNodeContainer* pCNodeContainer ) 
{
	int iRv = 0 ;
	if ( iRv >= 0 )
	{
		for ( int idx = 0 ; iRv >= 0 && idx < aCentDedRessyasyubetsuCont.size() ; idx ++ )
		{
			Ou<CDirectory> pCDirectory = OuNew<CDirectory>( new CDirectory( nameRessyasyubetsu ) ) ;
			int iResult = CentDedRessyasyubetsu_To_OuPropertiesText(
				aCentDedRessyasyubetsuCont.get( idx ) ,
				pCDirectory->getCNodeContainer() ) ;
			//	-	-11 ;	//	Syubetsumei w肳Ă܂B
			//	-	-52 ;	//	DiagramSenStyle ̒lsłB
			if ( iResult < 0 )
			{
				//	-	-11 ;	//	Syubetsumei w肳Ă܂B
				//	-	-52 ;	//	DiagramSenStyle ̒lsłB
				iRv = iResult ;
			}
			else
			{
				pCNodeContainer->insert( pCDirectory ) ;
			}
		}
	}
	return iRv ;
}
	
int CconvCentDed::CentDedRessyasyubetsuCont_From_OuPropertiesText( 
			CentDedRessyasyubetsuCont* pCentDedRessyasyubetsuCont ,
			const OuPropertiesText::IfNodeContainerConst* pCNodeContainer ,
			OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer ) 
{
	int iRv = 0 ;
	if ( iRv >= 0 )
	{
		for ( int idx = 0 ; iRv >= 0 && idx < pCNodeContainer->sizeInName( nameRessyasyubetsu )  ; idx ++ )
		{
			Ou<const CDirectory> pCDirectory ; 
			if ( iRv >= 0 )
			{
				pCDirectory = dynamic_castOu<const CDirectory>( 
					pCNodeContainer->getInName( nameRessyasyubetsu , idx ) ) ;
				if ( pCDirectory == NULL )
				{
					COuErrorInfo aCOuErrorInfo( ERRREASON_RessyasyubetsuIsNotDirectory() ) ;
					aCOuErrorInfo.getProp()->setValue( 
						ERRPROP_Index() , stringOf( idx ) ) ;
					pCOuErrorInfoContainer->insert( aCOuErrorInfo ) ;
					iRv = -101 ;	//	Ressyasyubetsu fBNgł͂܂B

				}
			}
			//pCDirectory = ΉfBNg

			CentDedRessyasyubetsu aCentDedRessyasyubetsu ;
			if ( iRv >= 0 )
			{
				int iResult = CentDedRessyasyubetsu_From_OuPropertiesText( 
					&aCentDedRessyasyubetsu , 
					pCDirectory->getIfNodeContainerConst() , 
					pCOuErrorInfoContainer ) ;
				//	-	-11 ;	//	Syubetsumei w肳Ă܂B
				//	-	-52 ;	//	DiagramSenStyle ̒lsłB
				if ( iResult < 0 )
				{
					iRv = iResult ;
					//	-	-11 ;	//	Syubetsumei w肳Ă܂B
					//	-	-52 ;	//	DiagramSenStyle ̒lsłB
				}
			}
			//aCentDedRessyasyubetsu = Directory ̓e𔽉f܂B
			if ( iRv >= 0 )
			{
				//	ԎʃReiɊɃf[^ꍇ́A㏑܂
				//	ԎʃReíAȂƂ1̗vfĂ܂B
				if ( idx < pCentDedRessyasyubetsuCont->size() )
				{
					pCentDedRessyasyubetsuCont->set( aCentDedRessyasyubetsu , idx ) ;
				}
				else
				{
					pCentDedRessyasyubetsuCont->insert( aCentDedRessyasyubetsu ) ;
				}
			}
				
		}
	}
	return iRv ;
}

	// ********************************
	//	CentDedEkiJikoku
	// ********************************
tstring CconvCentDed::CentDedEkiJikoku_To_string( 
			const CentDedEkiJikoku* pCentDedEkiJikoku ) 
{
	tstring	strEkiatsukai ;
	tstring strChaku ;
	tstring strHatsu ;
	//	w
	if ( pCentDedEkiJikoku->getEkiatsukai() != CentDedEkiJikoku::Ekiatsukai_None )
	{
		strEkiatsukai = stringOf( 
			(int)pCentDedEkiJikoku->getEkiatsukai() ) ;
	}
	//	
	if ( !pCentDedEkiJikoku->getChakujikoku().isNull() )
	{
		strChaku = g_CdDedJikokuConv.encode( pCentDedEkiJikoku->getChakujikoku() ) ;
	}
	//	
	if ( !pCentDedEkiJikoku->getHatsujikoku().isNull() )
	{
		strHatsu = g_CdDedJikokuConv.encode( pCentDedEkiJikoku->getHatsujikoku() ) ;
	}

	tstring	strEkijikoku ;
	strEkijikoku.reserve( 32 ) ;
	if ( !strEkiatsukai.empty() )
	{
		strEkijikoku += strEkiatsukai ;
		if ( !strChaku.empty() || !strHatsu.empty() )
		{
			strEkijikoku += ';' ;
			if ( !strChaku.empty() )
			{
				strEkijikoku += strChaku ;
				strEkijikoku += '/' ;
			}
			strEkijikoku += strHatsu ;
		}
	}
	return strEkijikoku ;
}

int CconvCentDed::CentDedEkiJikoku_From_string( 
			CentDedEkiJikoku* pCentDedEkiJikoku , 
			const tstring strValue ) 
{
	int iRv = 0 ;
	// --------------------------------
	tstring strEkijikoku = strValue ;
	tstring	strEkiatsukai ;
	tstring strChaku ;
	tstring strHatsu ;
	
	tstring::size_type pos = 0 ;
	pos = strEkijikoku.find( ';' ) ;
	if ( pos != tstring::npos )
	{
		strEkiatsukai = strEkijikoku.substr( 0 , pos ) ;
		strEkijikoku.erase( 0 , pos + 1 ) ;
		
		pos = strEkijikoku.find( '/' ) ;
		if ( pos != tstring::npos )
		{
			strChaku = strEkijikoku.substr( 0 , pos ) ;
			strEkijikoku.erase( 0 , pos + 1 ) ;
		}
		strHatsu = strEkijikoku ;
	}
	else
	{
		strEkiatsukai = strEkijikoku ;
	}
	//strEkiatsukai = wE󕶎́w^sȂxB"1"`"3" ;
	//strChaku = 
	//strHatsu = 
	
	int iEkiatsukai = 0 ;
	if ( !strEkiatsukai.empty() )
	{
		iEkiatsukai = _ttoi( strEkiatsukai.c_str() ) ;
	}
	if ( !( 0 <= iEkiatsukai && iEkiatsukai < 4 ) )
	{
		iEkiatsukai = 0 ;
	}
	CdDedJikoku jikokuChaku( strChaku ) ;
	CdDedJikoku jikokuHatsu( strHatsu ) ;
	CentDedEkiJikoku	aCentDedEkiJikoku( 
		(CentDedEkiJikoku::EEkiatsukai)iEkiatsukai , 
		jikokuChaku , jikokuHatsu ) ;

	// --------------------------------
	if ( pCentDedEkiJikoku != NULL )
	{
		*pCentDedEkiJikoku = aCentDedEkiJikoku ;
	}
	return iRv ;
}

// ********************************
//	CentDedRessyaTrack
// ********************************
tstring CconvCentDed::CentDedRessyaTrack_To_string(
	const CentDedRessyaTrack* pCentDedRessyaTrack,
	const CentDedEkiJikoku* pCentDedEkijikoku)
{
	tstring strRessyaTrackIndex;
	tstring strOperation;
	tstring strOperationPara1;
	tstring strOperationPara2;
	tstring strOperationPara3;
	//@Ԑ
	if (pCentDedEkijikoku->getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Teisya ||
		pCentDedEkijikoku->getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Tsuuka)
	{
		strRessyaTrackIndex = stringOf(pCentDedRessyaTrack->getRessyaTrackIndex());
	}
	// 
	//strOperationPara1 = "";
	//strOperationPara2 = "";
	if ((int)pCentDedRessyaTrack->getOperation() > 0)
	{
		strOperation = stringOf((int)pCentDedRessyaTrack->getOperation());
	}
	if (strOperation == _T("1"))
	{
		strOperationPara1 = stringOf(pCentDedRessyaTrack->getShuntTrackIndex());
		if (!pCentDedRessyaTrack->getOperationHatsuJikoku().isNull())
		{
			strOperationPara2 =
				g_CdDedJikokuConv.encode(pCentDedRessyaTrack->getOperationHatsuJikoku());
		}
		if (!pCentDedRessyaTrack->getOperationChakuJikoku().isNull())
		{
			strOperationPara3 =
				g_CdDedJikokuConv.encode(pCentDedRessyaTrack->getOperationChakuJikoku());
		}
	}
	else if (strOperation == _T("2") &&
		!pCentDedRessyaTrack->getOperationNumber().empty())
	{
		strOperationPara1 = pCentDedRessyaTrack->getOperationNumber();
	}
	else if (strOperation == _T("3"))
	{
		strOperationPara1 = stringOf(pCentDedRessyaTrack->getOuterTerminalIndex());
		strOperationPara2 =
			g_CdDedJikokuConv.encode(pCentDedRessyaTrack->getOuterHatsuChakuJikoku());
		if (!pCentDedRessyaTrack->getOperationNumber().empty())
		{
			strOperationPara3 = pCentDedRessyaTrack->getOperationNumber();
		}
	}

	tstring strRessyaTrack;
	strRessyaTrack.reserve(32);
	strRessyaTrack += strRessyaTrackIndex;
	if (!strOperation.empty())
	{
		strRessyaTrack += ';';
		strRessyaTrack += strOperation;
		if (!strOperationPara1.empty())
		{
			strRessyaTrack += '/';
			strRessyaTrack += strOperationPara1;
			if (!strOperationPara2.empty())
			{
				strRessyaTrack += '$';
				strRessyaTrack += strOperationPara2;
				if (!strOperationPara3.empty())
				{
					strRessyaTrack += '/';
					strRessyaTrack += strOperationPara3;
				}
			}
		}
	}
	return strRessyaTrack;
}

int CconvCentDed::CentDedRessyaTrack_From_string(
	CentDedRessyaTrack* pCentDedRessyaTrack,
	const int iEkiTrack2Size,
	const tstring strValue)
{
	int iRv = 0;
	// --------------------------------
	tstring strRessyaTrack = strValue;
	tstring strRessyaTrackIndex;
	tstring strOperation;
	tstring strOperationPara1;
	tstring strOperationPara2;
	tstring strOperationPara3;

	tstring::size_type pos = 0;
	pos = strRessyaTrack.find(';');
	if (pos != tstring::npos)
	{
		strRessyaTrackIndex = strRessyaTrack.substr(0, pos);
		strRessyaTrack.erase(0, pos + 1);

		pos = strRessyaTrack.find('/');
		if (pos != tstring::npos)
		{
			strOperation = strRessyaTrack.substr(0, pos);
			strRessyaTrack.erase(0, pos + 1);
			pos = strRessyaTrack.find('$');
			if (pos != tstring::npos)
			{
				strOperationPara1 = strRessyaTrack.substr(0, pos);
				strRessyaTrack.erase(0, pos + 1);
				pos = strRessyaTrack.find('/');
				if (pos != tstring::npos)
				{
					strOperationPara2 = strRessyaTrack.substr(0, pos);
					strRessyaTrack.erase(0, pos + 1);
					strOperationPara3 = strRessyaTrack;
				}
				else
				{
					strOperationPara2 = strRessyaTrack;
				}

			}
			else
			{
				strOperationPara1 = strRessyaTrack;
			}

		}
		else
		{
			strOperation = strRessyaTrack;
		}
	}
	else
	{
		strRessyaTrackIndex = strRessyaTrack;
	}
	//strRessyaTrackIndex = ԔԐIndexAw^s̏ꍇ
	//strOperation = ƁA0-2
	//strOperationPara1 = Ƃɂ镍A0:̏ꍇ͖A1:̏ꍇ͔ԐA
	//2:ȍꍇ́A܂͏ȍꍇ̂݉^
	//strOperationPara2 = Ƃɂ镍A0:̏ꍇ͖A1:̏ꍇ͔͂ȂA
	//2:ȍꍇ͖
	//strOperationPara3 = Ƃɂ镍A0:̏ꍇ͖A1:̏ꍇ͒͂ȂA
	//2:ȍꍇ͖

	int iRessyaTrackIndex = 0;
	if (!strRessyaTrackIndex.empty())
	{
		iRessyaTrackIndex = _ttoi(strRessyaTrackIndex.c_str());
	}
	if (!(0 <= iRessyaTrackIndex && iRessyaTrackIndex <= iEkiTrack2Size))
	{
		iRessyaTrackIndex = 0;
	}
	int iOperation = 0;
	if (!strOperation.empty())
	{
		iOperation = _ttoi(strOperation.c_str());
	}
	if (!(0 <= iOperation && iOperation < 4))
	{
		iOperation = 0;
	}
	int iShuntTrackIndex = 0;
	CdDedJikoku OperationHatsuJikoku;
	CdDedJikoku OperationChakuJikoku;
	tstring strOperationNumber;

	if (iOperation == 1)
	{
		if (!strOperationPara1.empty())
		{
			iShuntTrackIndex = _ttoi(strOperationPara1.c_str());
		}
		if (!(0 <= iShuntTrackIndex && iShuntTrackIndex <= iEkiTrack2Size))
		{
			iShuntTrackIndex = 0;
		}
		OperationHatsuJikoku.decode(strOperationPara2);
		OperationChakuJikoku.decode(strOperationPara3);


	}
	else if (iOperation == 2)
	{
		if (!strOperationPara1.empty())
		{
			strOperationNumber = strOperationPara1;
		}
	}
	else if (iOperation == 3)
	{
		iShuntTrackIndex = _ttoi(strOperationPara1.c_str());
		OperationHatsuJikoku.decode(strOperationPara2);

		if (!strOperationPara3.empty())
		{
			strOperationNumber = strOperationPara3;
		}
	}
	CentDedRessyaTrack aCentDedRessyaTrack(
		iRessyaTrackIndex, (CentDedRessyaTrack::EOperation)iOperation,
		iShuntTrackIndex, OperationHatsuJikoku, OperationChakuJikoku, strOperationNumber
	);


	// --------------------------------
	if (pCentDedRessyaTrack != NULL)
	{
		*pCentDedRessyaTrack = aCentDedRessyaTrack;
	}
	return iRv;
}

// ********************************
//	CentDedRessya
// ********************************

const CEnumToString<ERessyahoukou>& CconvCentDed::getERessyahoukouToString()
{
	static CEnumToString<ERessyahoukou> aEnumToString ;
	if ( aEnumToString.size() == 0 )
	{
		aEnumToString.add( Ressyahoukou_Kudari , _T("Kudari") ) ;
		aEnumToString.add( Ressyahoukou_Nobori , _T("Nobori") ) ;
	}
	return aEnumToString ;
};
const TCHAR nameRessyahoukou[]=_T("Houkou") ;
const TCHAR nameRessyasyubetsuIndex[]=_T("Syubetsu") ;
const TCHAR nameEkiJikoku3[]=_T("EkiJikoku") ;
const TCHAR nameRessyabangou[]=_T("Ressyabangou") ;
const TCHAR nameRessyamei[]=_T("Ressyamei") ;
const TCHAR nameGousuu[]=_T("Gousuu") ;
const TCHAR nameBikou[]=_T("Bikou") ;
const TCHAR nameRessyaTrack[] = _T("RessyaTrack");
const TCHAR nameOperationNumber[] = _T("OperationNumber");





int CconvCentDed::CentDedRessya_To_OuPropertiesText( 
			const CentDedRessya* pCentDedRessya , 
			const bool bEnableOperation,
			OuPropertiesText::CNodeContainer* pCNodeContainer ) 
{
	int iRv = 0 ;
	// --------------------------------
	//0.IsNull
	bool bIsNull = false ;
	if ( iRv >= 0 )
	{
		bIsNull = pCentDedRessya->isNull() ;
	}

	if ( !bIsNull )
	{
		//1.Ressyahoukou
		if ( iRv >= 0 )
		{
			tstring strValue = getERessyahoukouToString().stringOf( 
				pCentDedRessya->getRessyahoukou() ) ;
			if ( strValue.empty() )
			{
				iRv = -12 ;	//	Ressyahoukou ̒lsłB
			}
			else
			{
				pCNodeContainer->setValue( nameRessyahoukou , 
					strValue ) ;
			}
		}
		//2.RessyasyubetsuIndex ;
		if ( iRv >= 0 )
		{
			pCNodeContainer->setValue( 
				nameRessyasyubetsuIndex , 
				stringOf( 
					pCentDedRessya->getRessyasyubetsuIndex() 
				) 
			) ;
		}


		//4."Ressyabangou" ;
		if ( iRv >= 0 )
		{
			tstring strValue = pCentDedRessya->getRessyabangou() ;
			if ( !strValue.empty() )
			{
				pCNodeContainer->setValue( nameRessyabangou , 
					strValue ) ;
			}
		}
		//5."Ressyamei" ;
		if ( iRv >= 0 )
		{
			tstring strValue = pCentDedRessya->getRessyamei() ;
			if ( !strValue.empty() )
			{
				pCNodeContainer->setValue( nameRessyamei , 
					 strValue) ;
			}
		}
		//6."Gousuu" ;
		if ( iRv >= 0 )
		{
			tstring strValue = pCentDedRessya->getGousuu() ;
			if ( !strValue.empty() )
			{
				pCNodeContainer->setValue( nameGousuu , 
					strValue ) ;
			}
		}
		//3.EkiJikoku3
		if ( iRv >= 0 )
		{
			vector<tstring>	contstrEkijikoku ;
			int iEkiOrder ;
			for ( iEkiOrder = 0 ; 
					iEkiOrder <= pCentDedRessya->getSyuuchakuEki() ; 
					iEkiOrder ++ )
			{
				CentDedEkiJikoku	aCentDedEkiJikoku = 
					pCentDedRessya->getCentDedEkiJikoku( iEkiOrder ) ;
				tstring	strEkijikoku = CentDedEkiJikoku_To_string(
					&aCentDedEkiJikoku ) ;
				
				contstrEkijikoku.push_back( strEkijikoku ) ;
			}
			tstring strEkijikoku2 = joinc( ',' , contstrEkijikoku ) ;
			pCNodeContainer->setValue( nameEkiJikoku3 ,
						strEkijikoku2 ) ; 
		}
		//8.RessyaTrack
		if (iRv >= 0)
		{
			vector<tstring>	contstrRessyaTrack;
			int iEkiOrder;
			for (iEkiOrder = 0;
				iEkiOrder <= pCentDedRessya->getSyuuchakuEki();
				iEkiOrder++)
			{
				CentDedRessyaTrack	aCentDedRessyaTrack =
					pCentDedRessya->getCentDedRessyaTrack(iEkiOrder);
				CentDedEkiJikoku	aCentDedEkiJikoku =
					pCentDedRessya->getCentDedEkiJikoku(iEkiOrder);
				tstring	strRessyaTrack = CentDedRessyaTrack_To_string(
					&aCentDedRessyaTrack,
					&aCentDedEkiJikoku);

				contstrRessyaTrack.push_back(strRessyaTrack);
			}
			tstring strRessyaTrack = joinc(',', contstrRessyaTrack);
			pCNodeContainer->setValue(nameRessyaTrack,
				strRessyaTrack);
		}

		//7."Bikou" ;
		if ( iRv >= 0 )
		{
			tstring strValue = pCentDedRessya->getBikou() ;
			if ( !strValue.empty() )
			{
				pCNodeContainer->setValue( nameBikou , 
					strValue ) ;
			}
		}
		//9."OperationNumber" ;
		if (iRv >= 0 && bEnableOperation)
		{
			tstring strValue = pCentDedRessya->getOperationNumber();
			if (!strValue.empty())
			{
				pCNodeContainer->setValue(nameOperationNumber,
					strValue);
			}
		}
	}
	// --------------------------------
	return ( iRv ) ;
}

int CconvCentDed::CentDedRessya_From_OuPropertiesText( 
			CentDedRessya* pCentDedRessya ,
			deque<int>& iEkiTrack2SizeCont,
			const OuPropertiesText::IfNodeContainerConst* pCNodeContainer ,
			OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer ) 
{
	int iRv = 0 ;
	// --------------------------------
	bool	bIsNull = false ;
	ERessyahoukou	eRessyahoukou = Ressyahoukou_Kudari ;

	//1.Ressyahoukou
	if ( iRv >= 0 )
	{
		tstring	strValue = pCNodeContainer->getValue( nameRessyahoukou );
		int iResult = getERessyahoukouToString().fromString( 
			strValue , &eRessyahoukou ) ;
		if ( iResult < 0 )
		{
			bIsNull = true ;
		}
	}
	//bIsNull = ̗ԂɊւLqȂꍇ́A^łB
	//eRessyahoukou = 1.Ressyahoukou̒lB
	//	AAbIsNull ^̏ꍇ́A̒l͖łB
	
	if ( !bIsNull )
	{
		int iRessyasyubetsuIndex = -1 ; 
		//2.RessyasyubetsuIndex ;
		if ( iRv >= 0 )
		{
			tstring	strValue = pCNodeContainer->getValue( 
				nameRessyasyubetsuIndex ) ;
			int iValue = _ttoi( strValue.c_str() ) ;
			pCentDedRessya->setRessyasyubetsuIndex( iValue ) ;
		}
		
		//iRessyasyubetsuIndex = 2.RessyasyubetsuIndex̒lB
		//	AAbIsNull ^̏ꍇ́A̒l͖łB

		//4."Ressyabangou" ;
		if ( iRv >= 0 )
		{
			tstring	strValue = pCNodeContainer->getValue( nameRessyabangou ) ;
			pCentDedRessya->setRessyabangou( strValue ) ;
		}
		//5."Ressyamei" ;
		if ( iRv >= 0 ){
			tstring	strValue = pCNodeContainer->getValue( nameRessyamei ) ;
			pCentDedRessya->setRessyamei( strValue ) ;
		}
		//6."Gousuu" ;
		if ( iRv >= 0 ){
			tstring	strValue = pCNodeContainer->getValue( nameGousuu ) ;
			pCentDedRessya->setGousuu( strValue ) ;
		}
		//3.EkiJikoku3
		if ( iRv >= 0 )
		{
			tstring strEkijikoku2 = pCNodeContainer->getValue( 
				nameEkiJikoku3 ) ;
			if ( !strEkijikoku2.empty() )
			{
				deque<tstring>	contstrEkijikoku = 
					splitc< deque< tstring > >( ',' , strEkijikoku2 ) ;
					
				int iEkiOrder ;
				for ( iEkiOrder = 0 ; iRv >= 0 && 
					iEkiOrder < (int)contstrEkijikoku.size()  ;
					iEkiOrder ++ )
				{
					tstring strEkijikoku = contstrEkijikoku[iEkiOrder] ;
					CentDedEkiJikoku	aCentDedEkiJikoku ;
					int iResult = CentDedEkiJikoku_From_string( 
						&aCentDedEkiJikoku , 
						strEkijikoku ) ;
					assert( iResult >= 0 ) ;
					if ( iEkiOrder < pCentDedRessya->getCentDedEkiJikokuCont()->size() )
					{
						pCentDedRessya->setCentDedEkiJikoku( iEkiOrder , 
							aCentDedEkiJikoku ) ;
					}
					else
					{
						pCentDedRessya->getCentDedEkiJikokuCont()->insert( aCentDedEkiJikoku ) ;
					}
				}
			}
		}
		//8.RessyaTrack
		if (iRv >= 0) 
		{
			tstring strRessyaTrack = pCNodeContainer->getValue(
				nameRessyaTrack);
			if (!strRessyaTrack.empty())
			{
				deque<tstring>	contstrRessyaTrack =
					splitc< deque< tstring > >(',', strRessyaTrack);

				int iEkiOrder;
				for (iEkiOrder = 0; iRv >= 0 &&
					iEkiOrder < (int)contstrRessyaTrack.size();
					iEkiOrder++)
				{
					tstring strRessyaTrack = contstrRessyaTrack[iEkiOrder];
					CentDedRessyaTrack	aCentDedRessyaTrack;
					int iResult = CentDedRessyaTrack_From_string(
						&aCentDedRessyaTrack,
						iEkiTrack2SizeCont[iEkiOrder],
						strRessyaTrack);
					assert(iResult >= 0);
					if (iEkiOrder < pCentDedRessya->getCentDedRessyaTrackCont()->size())
					{
						pCentDedRessya->setCentDedRessyaTrack(iEkiOrder,
							aCentDedRessyaTrack);
					}
					else
					{
						pCentDedRessya->getCentDedRessyaTrackCont()->insert(aCentDedRessyaTrack);
					}
				}
			}
		}
		//7."Bikou" ;
		if ( iRv >= 0 ){
			tstring	strValue = pCNodeContainer->getValue( nameBikou ) ;
			pCentDedRessya->setBikou( strValue ) ;
		}
	}
	return ( iRv ) ;
}


// ********************************
//	CentDedRessyaCont
// ********************************
const TCHAR nameRessya[]=_T("Ressya") ;

int CconvCentDed::CentDedRessyaCont_To_OuPropertiesText( 
			const CentDedRessyaCont* pCentDedRessyaCont ,
			const bool bEnableOperation,
			OuPropertiesText::CNodeContainer* pCNodeContainer ) 
{
	int iRv = 0 ;
	
		
	int idxRessya ;
	for ( idxRessya = 0 ; idxRessya < pCentDedRessyaCont->size() ; 
			idxRessya ++ )
	{
		Ou<CDirectory> pCDirectory = OuNew<CDirectory>( new CDirectory( nameRessya ) ) ;

		const CentDedRessya*	pCentDedRessya = 
			pCentDedRessyaCont->getMuPtr()->get( idxRessya );
		int iResult = CentDedRessya_To_OuPropertiesText( 
			pCentDedRessya , bEnableOperation , pCDirectory->getCNodeContainer() ) ;
		//	-	-12 ;	//	Ressyahoukou ̒lsłB
		if ( iResult < 0 )
		{
			iRv = iResult ;
		}
		else
		{
			pCNodeContainer->insert( pCDirectory ) ;
		}
	}
	
	return ( iRv ) ;
}
int CconvCentDed::CentDedRessyaCont_From_OuPropertiesText( 
			CentDedRessyaCont* pCentDedRessyaCont ,
			deque<int>& iEkiTrack2SizeCont,
			const OuPropertiesText::IfNodeContainerConst* pCNodeContainer ,
			OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer ) 
{
	int iRv = 0 ;

	int iRessyaCount = 0 ;

	if ( iRv >= 0 )
	{
		int idxRessya ;
		int iRessyaSize = pCNodeContainer->sizeInName(nameRessya);
#pragma omp parallel for ordered schedule(dynamic) 
		for ( idxRessya = 0 ; /*iRv >= 0 && */
			idxRessya < iRessyaSize;
				idxRessya ++ )
		{
			Ou<const CDirectory> pCDirectory = dynamic_castOu<const CDirectory>( 
				pCNodeContainer->getInName( nameRessya , idxRessya ) ) ;
			if ( pCDirectory != NULL )
			{
				CentDedRessya	aCentDedRessya( pCentDedRessyaCont->createNullRessya() );
				int iResult = CentDedRessya_From_OuPropertiesText( 
					&aCentDedRessya , 
					iEkiTrack2SizeCont,
					pCDirectory->getIfNodeContainerConst() , 
					pCOuErrorInfoContainer ) ;
				//iResult = ݁A̒l̐ɂȂ邱Ƃ͂܂
				if (iResult < 0)
				{
					iRv = iResult;
					break;
				}
				else
				{
#pragma omp ordered 
					pCentDedRessyaCont->insert(aCentDedRessya);
				}
			}
		}
	}
	return ( iRv ) ;
}



// ********************************
//	CentDedDia
// ********************************
const TCHAR nameDiaName[]=_T("DiaName") ;
const TCHAR nameMainBackColorIndex[] = _T("MainBackColorIndex");
const TCHAR nameSubBackColorIndex[] = _T("SubBackColorIndex");
const TCHAR nameBackPatternIndex[] = _T("BackPatternIndex");

int CconvCentDed::CentDedDia_To_OuPropertiesText( 
			const CentDedDia* pCentDedDia ,
			const bool bEnableOperation,
			OuPropertiesText::CNodeContainer* pCNodeContainer ) 
{
	int iRv = 0 ;

	//1.DiaName
	if ( iRv >= 0 )
	{
		pCNodeContainer->setValue( nameDiaName , 
			pCentDedDia->getName() ) ;
	}
	//2.MainBackColorIndex
	if (iRv >= 0)
	{
		pCNodeContainer->setValue(nameMainBackColorIndex,
			stringOf(pCentDedDia->getMainBackColorIndex()));
	}
	//2.1.SubBackColorIndex
	if (iRv >= 0)
	{
		pCNodeContainer->setValue(nameSubBackColorIndex,
			stringOf(pCentDedDia->getSubBackColorIndex()));
	}
	//2.2.BackPatternIndex
	if (iRv >= 0)
	{
		pCNodeContainer->setValue(nameBackPatternIndex,
			stringOf(pCentDedDia->getBackPatternIndex()));
	}
	//3.Kudari
	//  Nobori
	if ( iRv >= 0 )
	{
		int iRessyahoukou = 0 ; 
		for ( iRessyahoukou = Ressyahoukou_Kudari ; 
				iRessyahoukou <= Ressyahoukou_Nobori ; 
				iRessyahoukou ++ )
		{
			ERessyahoukou eRessyahoukou = (ERessyahoukou)iRessyahoukou ;
			tstring	strRessyahoukou = 
				getERessyahoukouToString().stringOf( eRessyahoukou ) ;
			
			Ou<CDirectory> pCDirectory = OuNew<CDirectory>( 
				new CDirectory( strRessyahoukou ) ) ;
			int iResult = CentDedRessyaCont_To_OuPropertiesText( 
				pCentDedDia->getCentDedRessyaCont( (ERessyahoukou)iRessyahoukou ) , 
				bEnableOperation,
				pCDirectory->getCNodeContainer() );
			//iResult = 
			//	-12 ;	//	Ressyahoukou ̒lsłB
			if ( iResult < 0 )
			{
				iRv = iResult ;
			}
			else
			{
				pCNodeContainer->insert( pCDirectory ) ;
			}
		}
	}
	
	return ( iRv ) ;
}



int CconvCentDed::CentDedDia_From_OuPropertiesText( 
			CentDedDia* pCentDedDia ,
			const CentDedEkiCont* pCentDedEkiCont,
			const OuPropertiesText::IfNodeContainerConst* pCNodeContainer ,
			OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer ) 
{
	int iRv = 0 ;
	
	int iEkiCount = pCentDedDia->getEkiCount() ;

	//1.DiaName
	tstring	strDiaName ;
	if ( iRv >= 0 )
	{
		tstring	strValue = pCNodeContainer->getValue( nameDiaName ) ;
		if ( strValue.length() == 0 )
		{
			ErrorInfo::COuErrorInfo aCOuErrorInfo( ERRREASON_DiaNameInvalid() ) ;
			pCOuErrorInfoContainer->insert( aCOuErrorInfo ) ;
			iRv = -11 ;	//	DiaName w肳Ă܂B
		}
		else
		{
			strDiaName = strValue ;
			pCentDedDia->setName( strDiaName ) ;
		}
	}
	//2.MainBackColorIndex
	if (iRv >= 0)
	{
		tstring	strValue = pCNodeContainer->getValue(nameMainBackColorIndex);
		if (strValue.length() != 0)
		{
			pCentDedDia->setMainBackColorIndex(intOf(strValue));
		}
	}
	//2.1.SubBackColorIndex
	if (iRv >= 0)
	{
		tstring	strValue = pCNodeContainer->getValue(nameSubBackColorIndex);
		if (strValue.length() != 0)
		{
			pCentDedDia->setSubBackColorIndex(intOf(strValue));
		}
	}
	//2.2.BackPatternIndex
	if (iRv >= 0)
	{
		tstring	strValue = pCNodeContainer->getValue(nameBackPatternIndex);
		if (strValue.length() != 0)
		{
			pCentDedDia->setBackPatternIndex(intOf(strValue));
		}
	}

	//3.Ressya[Ressyahoukou_Kudari][]
	//  Ressya[Ressyahoukou_Nobori][]
	if ( iRv >= 0 )
	{
		int iRessyahoukou = 0 ; 
		for ( iRessyahoukou = Ressyahoukou_Kudari ; 
				iRessyahoukou <= Ressyahoukou_Nobori ; 
				iRessyahoukou ++ )
		{
			ERessyahoukou eRessyahoukou = (ERessyahoukou)iRessyahoukou ;
			tstring	strRessyahoukou = 
				getERessyahoukouToString().stringOf( eRessyahoukou ) ;
			const Mu<CentDedEkiCont::CdDedEki>* pCdDedEkiCont = pCentDedEkiCont->getMuPtr(eRessyahoukou);
			deque<int> iEkiTrack2SizeCont;
			for (int idxEki = 0; idxEki < pCdDedEkiCont->size(); idxEki++)
			{
				const CentDedEkiCont::CdDedEki aCdDedEki = pCdDedEkiCont->get(idxEki);
				iEkiTrack2SizeCont.push_back(aCdDedEki.getCentDedEkiTrack2Cont().size());
			}

			Ou<const CDirectory> pCDirectory ;
			if ( iRv >= 0 )
			{
				pCDirectory = dynamic_castOu< const CDirectory >( 
					pCNodeContainer->getInName( strRessyahoukou , 0 ) ) ;
				if ( pCDirectory == NULL )
				{
					ErrorInfo::COuErrorInfo aCOuErrorInfo( ERRREASON_ResyaContIsNotExist() ) ;
					aCOuErrorInfo.getProp()->setValue( ERRPROP_Ressyahoukou() , strRessyahoukou ) ;
					pCOuErrorInfoContainer->insert( aCOuErrorInfo ) ;
					iRv = -12 ;	//	RessyaCont܂B
				}
			}
			//pCDirectory = Kudari,NoboriRessyaCont
			if ( iRv >= 0 )
			{
				CentDedRessyaCont	aCentDedRessyaCont( 
					pCentDedDia->getCentDedRessyaCont( (ERessyahoukou)iRessyahoukou )->createEmptyCont() ) ; 

				int iResult = CentDedRessyaCont_From_OuPropertiesText( 
					&aCentDedRessyaCont , 
					iEkiTrack2SizeCont,
					pCDirectory->getIfNodeContainerConst() , 
					pCOuErrorInfoContainer );
				if ( iResult < 0 )
				{
				}
				else
				{
					*pCentDedDia->getCentDedRessyaCont( (ERessyahoukou)iRessyahoukou ) 
						= aCentDedRessyaCont ; 
				}
			}
		}
	}
	return ( iRv ) ;
}
	// ********************************
	//	CentDedDiaCont
	// ********************************
const TCHAR nameDia[] = _T("Dia") ;
	
int CconvCentDed::CentDedDiaCont_To_OuPropertiesText( 
			const CentDedDiaCont* pCentDedDiaCont ,
			const bool bEnableOperation,
			OuPropertiesText::CNodeContainer* pCNodeContainer ) 
{
	int iRv = 0 ;
	for ( int idxDia = 0 ; iRv >= 0 && idxDia < pCentDedDiaCont->size() ; idxDia ++ )
	{
		Ou<CDirectory> pCDirectory = OuNew<CDirectory>( new CDirectory( nameDia ) ) ;
		CentDedDia aCentDedDia = pCentDedDiaCont->get( idxDia ) ; 
		if ( iRv >= 0 )
		{
			int iResult = CentDedDia_To_OuPropertiesText( 
				&aCentDedDia , 
				bEnableOperation,
				pCDirectory->getCNodeContainer() ) ;
			if ( iResult < 0 )
			{
				//	-	-12 ;	//	DiagramEkiatsukai ̒lsłB
				iRv = iResult ;
			}
			else
			{
				pCNodeContainer->insert( pCDirectory ) ;
			}
		}
	}
	return iRv ;
}
	
int CconvCentDed::CentDedDiaCont_From_OuPropertiesText( 
			CentDedDiaCont* pCentDedDiaCont ,
			const CentDedEkiCont* pCentDedEkiCont,
			const OuPropertiesText::IfNodeContainerConst* pCNodeContainer ,
			OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer ) 
{
	int iRv = 0 ;
	if ( iRv >= 0 )
	{
		for ( int idxDia = 0 ; 
			iRv >= 0 && idxDia < pCNodeContainer->sizeInName( nameDia ) ;
			idxDia ++ )
		{
			Ou<const CDirectory> pCDirectory = dynamic_castOu<const CDirectory>( 
				pCNodeContainer->getInName( nameDia , idxDia ) ) ;
			if ( pCDirectory != NULL )
			{
				CentDedDia aCentDedDia ;

				int iResult = CentDedDia_From_OuPropertiesText( 
					&aCentDedDia , 
					pCentDedEkiCont,
					pCDirectory->getIfNodeContainerConst() , 
					pCOuErrorInfoContainer ) ;
				//	-	-11 ;	//	DiaName w肳Ă܂B
				//	-	-12 ;	//	RessyaCont܂B
				if ( iResult < 0 )
				{
					//	-	-11 ;	//	DiaName w肳Ă܂B
					//	-	-12 ;	//	RessyaCont܂B
					iRv = iResult ;
				}
				else
				{
					pCentDedDiaCont->insert( aCentDedDia ) ;
				}
			}
		}
	}
	return iRv ;
}

// ********************************
//	CentDedRosen
// ********************************
const TCHAR nameRosenmei[] = _T("Rosenmei") ;
const TCHAR nameKudariDiaAlias[] = _T("KudariDiaAlias");
const TCHAR nameNoboriDiaAlias[] = _T("NoboriDiaAlias");
const TCHAR nameKitenJikoku[] = _T("KitenJikoku") ;
const TCHAR nameDiagramDgrYZahyouKyoriDefault[] = _T("DiagramDgrYZahyouKyoriDefault") ;
const TCHAR nameEnableOperation[] = _T("EnableOperation");
const TCHAR nameComment[] = _T("Comment") ;


int CconvCentDed::CentDedRosen_To_OuPropertiesText( 
			const CentDedRosen* pCentDedRosen , 
			OuPropertiesText::CNodeContainer* pCNodeContainer ) 
{
	int iRv = 0 ;

	//1.Rosenmei
	if ( iRv >= 0 )
	{
		pCNodeContainer->setValue( nameRosenmei , 
			pCentDedRosen->getName() ) ;
	}
	//1.1.KudariDiaAlias
	if (iRv >= 0)
	{
		pCNodeContainer->setValue(nameKudariDiaAlias,
			pCentDedRosen->getKudariDiaAlias());
	}
	//1.2.NoboriDiaAlias
	if (iRv >= 0)
	{
		pCNodeContainer->setValue(nameNoboriDiaAlias,
			pCentDedRosen->getNoboriDiaAlias());
	}
	//2.Eki[]
	if ( iRv >= 0 )
	{
		int iResult = CentDedEkiCont_To_OuPropertiesText( 
			*pCentDedRosen->getCentDedEkiCont() , 
			pCNodeContainer ) ;
		//	-	-22 ;	//	Ekijikokukeisiki ̒lsłB
		//	-	-32 ;	//	Ekikibo ̒lsłB
		if ( iResult < 0 )
		{
			//	-	-22 ;	//	Ekijikokukeisiki ̒lsłB
			//	-	-32 ;	//	Ekikibo ̒lsłB
			iRv = iResult ;
		}
	}
	

	//3.Ressyasyubetsu[]
	if ( iRv >= 0 )
	{
		int iResult = CentDedRessyasyubetsuCont_To_OuPropertiesText( 
			*pCentDedRosen->getCentDedRessyasyubetsuCont() , 
			pCNodeContainer ) ;
		//	-	-11 ;	//	Syubetsumei w肳Ă܂B
		//	-	-52 ;	//	DiagramSenStyle ̒lsłB
		if ( iResult < 0 )
		{
			//	-	-111 ;	//	Syubetsumei w肳Ă܂B
			//	-	-152 ;	//	DiagramSenStyle ̒lsłB
			iRv = iResult - 100 ;
		}
	}
	
	//4.Dia[]
	if ( iRv >= 0 )
	{
		int iResult = CentDedDiaCont_To_OuPropertiesText( 
			pCentDedRosen->getCentDedDiaCont() , 
			pCentDedRosen->getEnableOperation(),
			pCNodeContainer ) ;
		//	-	-12 ;	//	DiagramEkiatsukai ̒lsłB
		if ( iResult < 0 )
		{
			//	-	-212 ;	//	DiagramEkiatsukai ̒lsłB
			iRv = iResult - 200 ;
		}
	}
	//5.KitenJikoku
	if ( iRv >= 0 )
	{
		pCNodeContainer->setValue( nameKitenJikoku , 
			g_CdDedJikokuConv.encode( pCentDedRosen->getKitenJikoku() ) ) ;
		
	}
	//6.DiagramDgrYZahyouKyoriDefault
	if ( iRv >= 0 )
	{
		pCNodeContainer->setValue( nameDiagramDgrYZahyouKyoriDefault , 
			stringOf( pCentDedRosen->getDiagramDgrYZahyouKyoriDefault() ) ) ;
	}
	//6.1.EnableOperation
	if (iRv >= 0)
	{
		if (pCentDedRosen->getEnableOperation())
		{
			pCNodeContainer->setValue(nameEnableOperation, _T("1"));
		}
	}
	//7.Comment
	if ( iRv >= 0 )
	{
		pCNodeContainer->setValue( nameComment ,pCentDedRosen->getComment() ) ;
	}
	return ( iRv ) ;
}

int CconvCentDed::CentDedRosen_From_OuPropertiesText( 
			CentDedRosen* pCentDedRosen ,
			const OuPropertiesText::IfNodeContainerConst* pCNodeContainer ,
			OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer ) 
{
	int iRv = 0 ;

	pCentDedRosen->clear() ;

	//1.Rosenmei
	if ( iRv >= 0 )
	{
		tstring	strValue = pCNodeContainer->getValue( nameRosenmei ) ;
		pCentDedRosen->setName( strValue ) ;
	}
	//1.1.KudariDiaAlias
	if (iRv >= 0)
	{
		tstring	strValue = pCNodeContainer->getValue(nameKudariDiaAlias);
		pCentDedRosen->setKudariDiaAlias(strValue);
	}
	//1.2.NoboriDiaAlias
	if (iRv >= 0)
	{
		tstring	strValue = pCNodeContainer->getValue(nameNoboriDiaAlias);
		pCentDedRosen->setNoboriDiaAlias(strValue);
	}
	//2.Eki[]
	if ( iRv >= 0 )
	{
		CentDedEkiCont aCentDedEkiCont ;
		int iResult = CentDedEkiCont_From_OuPropertiesText( 
			&aCentDedEkiCont , 
			pCNodeContainer , 
			pCOuErrorInfoContainer ) ;
		//	-	-22 ;	//	Ekijikokukeisiki ̒lsłB
		//	-	-32 ;	//	Ekikibo ̒lsłB
		//	-	-41 ;	//	DiagramRessyajouhouHyoujiKudari ̒lsłB
		//	-	-42 ;	//	DiagramRessyajouhouHyoujiNobori ̒lsłB
		//	-	-101 ;	//	Eki fBNgł͂܂B
		if ( iResult < 0 )
		{
			//	-	-22 ;	//	Ekijikokukeisiki ̒lsłB
			//	-	-32 ;	//	Ekikibo ̒lsłB
			//	-	-41 ;	//	DiagramRessyajouhouHyoujiKudari ̒lsłB
			//	-	-42 ;	//	DiagramRessyajouhouHyoujiNobori ̒lsłB
			//	-	-101 ;	//	Eki fBNgł͂܂B
			iRv = iResult ;
		}
		else
		{
			//*pCentDedRosen->getCentDedEkiCont() = aCentDedEkiCont ;
			CaMui<CentDedEki>	aCaCont( pCentDedRosen->getCentDedEkiCont() ) ; 
			aCaCont.insert( &aCentDedEkiCont ) ;
		}
	}

	//3.Ressyasyubetsu[]
	if ( iRv >= 0 )
	{
		CentDedRessyasyubetsuCont aCentDedRessyasyubetsuCont ;
		int iResult = CentDedRessyasyubetsuCont_From_OuPropertiesText( 
			&aCentDedRessyasyubetsuCont , 
			pCNodeContainer , 
			pCOuErrorInfoContainer ) ;
		//	-	-11 ;	//	Syubetsumei w肳Ă܂B
		//	-	-52 ;	//	DiagramSenStyle ̒lsłB
		//	-	-101 ;	//	Ressyasyubetsu fBNgł͂܂B
		if ( iResult < 0 )
		{
			//	-	-111 ;	//	Syubetsumei w肳Ă܂B
			//	-	-152 ;	//	DiagramSenStyle ̒lsłB
			//	-	-201 ;	//	Ressyasyubetsu fBNgł͂܂B
			iRv = iResult - 100 ;
		}
		else
		{
			*pCentDedRosen->getCentDedRessyasyubetsuCont() = aCentDedRessyasyubetsuCont ;
		}
	}
	
	//4.Dia[]
	if ( iRv >= 0 )
	{
		CentDedDiaCont aCentDedDiaCont ;

		int iResult = CentDedDiaCont_From_OuPropertiesText( 
			&aCentDedDiaCont , 
			pCentDedRosen->getCentDedEkiCont(),
			pCNodeContainer , 
			pCOuErrorInfoContainer ) ;
		//	-	-11 ;	//	DiaName w肳Ă܂B
		//	-	-12 ;	//	RessyaCont܂B
		if ( iResult < 0 )
		{
			//	-	-211 ;	//	DiaName w肳Ă܂B
			//	-	-212 ;	//	RessyaCont܂B
			iRv = iResult - 200 ;
		}
		else
		{
			//*pCentDedRosen->getCentDedDiaCont() = aCentDedDiaCont ;

			CaMui<CentDedDia>	aCaCont( pCentDedRosen->getCentDedDiaCont() ) ; 
			aCaCont.insert( &aCentDedDiaCont ) ;
		}
	}
	//5.KitenJikoku
	if ( iRv >= 0 )
	{
		tstring	strValue = pCNodeContainer->getValue( nameKitenJikoku ) ;
		CdDedJikoku	aCdDedJikoku ;
		if ( !strValue.empty() )
		{
			if ( aCdDedJikoku.decode( strValue ) < 0 )
			{
				ErrorInfo::COuErrorInfo aCOuErrorInfo( ERRREASON_KitenjikokuIsInvalid() ) ;
				aCOuErrorInfo.getProp()->setValue( ERRPROP_Jikoku() , strValue ) ;
				pCOuErrorInfoContainer->insert( aCOuErrorInfo ) ;
				iRv = -352 ;	//	N_̐ݒ肪sK؂łB
			}
		}
		if ( iRv >= 0 )
		{
			pCentDedRosen->setKitenJikoku( aCdDedJikoku ) ;
		}
	}
	//6.DiagramDgrYZahyouKyoriDefault
	if ( iRv >= 0 )
	{
		tstring	strValue = pCNodeContainer->getValue( nameDiagramDgrYZahyouKyoriDefault ) ;
		int iDiagramDgrYZahyouKyoriDefault = 60 ;
		if ( !strValue.empty() )
		{
			iDiagramDgrYZahyouKyoriDefault = _ttoi( strValue.c_str() ) ;
			if ( !( 0 <= iDiagramDgrYZahyouKyoriDefault ) )
			{
				ErrorInfo::COuErrorInfo aCOuErrorInfo( ERRREASON_DiagramDgrYZahyouKyoriDefaultIsInvalid() ) ;
				aCOuErrorInfo.getProp()->setValue( ERRPROP_Value() , strValue ) ;
				pCOuErrorInfoContainer->insert( aCOuErrorInfo ) ;
				iRv = -353 ;	//	_CO̊̉wԕsłB
			}
		}
		if ( iRv >= 0 )
		{
			pCentDedRosen->setDiagramDgrYZahyouKyoriDefault( iDiagramDgrYZahyouKyoriDefault ) ;
		}
	}
	//6.1.EnableOperation
	if (iRv >= 0)
	{
		tstring	strValue = pCNodeContainer->getValue(nameEnableOperation);
		if (strValue == _T("1"))
		{
			pCentDedRosen->setEnableOperation(true);
			//if (!(0 <= iDiagramDgrYZahyouKyoriDefault))
			//{
			//	ErrorInfo::COuErrorInfo aCOuErrorInfo(ERRREASON_DiagramDgrYZahyouKyoriDefaultIsInvalid());
			//	aCOuErrorInfo.getProp()->setValue(ERRPROP_Value(), strValue);
			//	pCOuErrorInfoContainer->insert(aCOuErrorInfo);
			//	iRv = -354;	//	_CO̊̉wԕsłB
			//}
		}
		else
		{
			pCentDedRosen->setEnableOperation(false);
		}
		//if (iRv >= 0)
		//{
		//	pCentDedRosen->setDiagramDgrYZahyouKyoriDefault(iDiagramDgrYZahyouKyoriDefault);
		//}
	}
	//7.Comment
	if ( iRv >= 0 ){
		tstring	strValue = pCNodeContainer->getValue( nameComment )  ;
		if ( iRv >= 0 )
		{
			pCentDedRosen->setComment( strValue ) ;
		}
	}

	if (iRv >= 0 && pCentDedRosen->getEnableOperation())
	{
		for (int idxDia = 0; idxDia < pCentDedRosen->getCentDedDiaCont()->size(); idxDia++)
		{
			pCentDedRosen->OperationConnect(idxDia);
		}
	}

	return ( iRv ) ;
}

} //namespace entDed


