/*
OuDiaSecond Copyright (C) 2017-2018 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedRessyaTrack.cpp
//	$Id: CentDedRessyaTrack.cpp  $
// ****************************************************************
*/
/** @file */
#include "stdafx.h"
#include "CentDedRessya.h"
#include "CentDedRessyaTrack.h"
#include "CentDedRessyaTrackCont.h"
#include <tchar.h>

namespace entDed{


// ****************************************************************
//	CentDedRessyaTrack
// ****************************************************************


// ********************************
//	RXgN^
// ********************************
	CentDedRessyaTrack::CentDedRessyaTrack() :
		m_iRessyaTrackIndex( 0 ),
		m_eOperation(Operation_None),
		m_iShuntTrackIndex(0)

{
};
CentDedRessyaTrack::CentDedRessyaTrack(
	int iRessyaTrackIndex,
	EOperation	eOperation,
	int iShuntTrackIndex,
	CdDedJikoku	OperationHatsuJikoku,
	CdDedJikoku	OperationChakuJikoku,
	tstring strOperationNumber)
{
	set(iRessyaTrackIndex, eOperation, iShuntTrackIndex, 
		OperationHatsuJikoku, OperationChakuJikoku, strOperationNumber) ;
};

CentDedRessyaTrack& CentDedRessyaTrack::operator=( const CentDedRessyaTrack& value )
{
	CentDedRessyaTrackCont* pRessyaTrackCont = dynamic_cast<CentDedRessyaTrackCont*>( getParent() ) ;
	if ( pRessyaTrackCont != NULL )
	{
		int iResult = pRessyaTrackCont->setable( value , pRessyaTrackCont->getIndex( this ) ) ;
		if ( iResult < 0 ){
			throw( LException() ) ;
		}
	}
	super::operator=( value ) ; 

	// --------------------------------
	m_iRessyaTrackIndex = value.m_iRessyaTrackIndex;
	m_eOperation = value.m_eOperation;
	m_iShuntTrackIndex = value.m_iShuntTrackIndex;
	m_OperationHatsuJikoku = value.m_OperationHatsuJikoku;
	m_OperationChakuJikoku = value.m_OperationChakuJikoku;
	m_strOperationNumber = value.m_strOperationNumber;

	return *this ;
}

	// ********************************
	//@name CParentBase-
	// ********************************
void CentDedRessyaTrack::setParent( CParentBase* pParent )
{
	super::setParent( pParent ) ; 
}


	// ********************************
	//@name CentDedRessyaTrack-
	// ********************************
int CentDedRessyaTrack::getRessyaTrackIndex()const
{
	return m_iRessyaTrackIndex;
};

CentDedRessyaTrack& CentDedRessyaTrack::setRessyaTrackIndex(const int value)
{
	m_iRessyaTrackIndex = value;
	return *this;
};

CentDedRessyaTrack::EOperation	CentDedRessyaTrack::getOperation()const
{
	return m_eOperation;
};

CentDedRessyaTrack& CentDedRessyaTrack::setOperation(const CentDedRessyaTrack::EOperation value)
{
	m_eOperation = value;
	if (m_eOperation == Operation_None)
	{
		//ƂȂ̏ꍇA:NULLA^:emptyAړԐ:
		m_iShuntTrackIndex = 0;
		m_OperationHatsuJikoku.setNull();
		m_OperationChakuJikoku.setNull();
		m_strOperationNumber = _T("");
	}
	else if (m_eOperation == Operation_Shunt)
	{
		//̏ꍇA:[U[wA^:emptyAړԐ:K{
		m_strOperationNumber = _T("");

	}
	else if (m_eOperation == Operation_InOut)
	{
		//ȍꍇA:NULLA^:ȍꍇ[U[wAړԐ:
		m_iShuntTrackIndex = 0;
		m_OperationHatsuJikoku.setNull();
		m_OperationChakuJikoku.setNull();

	}
	else if (m_eOperation == Operation_Outer)
	{
		m_OperationChakuJikoku.setNull();
	}
	return *this ; 
} ;

int CentDedRessyaTrack::getShuntTrackIndex() const
{
	if (m_eOperation != Operation_Shunt)
	{
		return 0;
	}
	return m_iShuntTrackIndex;
};

CentDedRessyaTrack& CentDedRessyaTrack::setShuntTrackIndex(const int value)
{
	if (m_eOperation == Operation_Shunt)
	{
		m_iShuntTrackIndex = value;
	}
	//if (m_eOperation != Operation_Shunt)
	//{
	//	m_iShuntTrackIndex = 0;
	//}
	//else
	//{
	//	m_iShuntTrackIndex = value;
	//}
	return *this;
}

int CentDedRessyaTrack::getOuterTerminalIndex() const
{
	if (m_eOperation != Operation_Outer)
	{
		return 0;
	}
	return m_iShuntTrackIndex;
};

CentDedRessyaTrack& CentDedRessyaTrack::setOuterTerminalIndex(const int value)
{
	if (m_eOperation == Operation_Outer)
	{
		m_iShuntTrackIndex = value;
	}
	//if (m_eOperation != Operation_Outer)
	//{
	//	m_iShuntTrackIndex = 0;
	//}
	//else
	//{
	//	m_iShuntTrackIndex = value;
	//}
	return *this;
}

CdDedJikoku	CentDedRessyaTrack::getOperationHatsuJikoku()const
{
	CdDedJikoku NullJikoku = CdDedJikoku();
	if (m_eOperation != Operation_Shunt)
	{
		return NullJikoku;
	}
	else
	{
		return m_OperationHatsuJikoku;
	}
};

CentDedRessyaTrack& CentDedRessyaTrack::setOperationHatsuJikoku( const CdDedJikoku& value)
{
	if (m_eOperation == Operation_Shunt)
	{
		m_OperationHatsuJikoku = value;
	}
	//CdDedJikoku NullJikoku = CdDedJikoku();
	//if (m_eOperation != Operation_Shunt)
	//{
	//	m_OperationHatsuJikoku = NullJikoku;
	//}
	//else
	//{
	//	m_OperationHatsuJikoku = value;
	//}
	return *this ;
}

CdDedJikoku	CentDedRessyaTrack::getOperationChakuJikoku(bool bHatsuIfNull)const
{
	CdDedJikoku NullJikoku = CdDedJikoku();
	if (m_eOperation != Operation_Shunt)
	{
		return NullJikoku;
	}
	else if(bHatsuIfNull && m_OperationChakuJikoku.isNull())
	{
		return m_OperationHatsuJikoku;
	}
	return m_OperationChakuJikoku;
	
};

CentDedRessyaTrack& CentDedRessyaTrack::setOperationChakuJikoku(const CdDedJikoku& value)
{
	if (m_eOperation == Operation_Shunt)
	{
		m_OperationChakuJikoku = value;
	}
	//CdDedJikoku NullJikoku = CdDedJikoku();
	//if (m_eOperation != Operation_Shunt)
	//{
	//	m_OperationChakuJikoku = NullJikoku;
	//}
	//else
	//{
	//	m_OperationChakuJikoku = value;
	//}
	return *this;
}

CdDedJikoku	CentDedRessyaTrack::getOuterHatsuChakuJikoku()const
{
	CdDedJikoku NullJikoku = CdDedJikoku();
	if (m_eOperation != Operation_Outer)
	{
		return NullJikoku;
	}
	else
	{
		return m_OperationHatsuJikoku;
	}
};

CentDedRessyaTrack& CentDedRessyaTrack::setOuterHatsuChakuJikoku(const CdDedJikoku& value)
{
	if (m_eOperation == Operation_Outer)
	{
		m_OperationHatsuJikoku = value;
	}
	//CdDedJikoku NullJikoku = CdDedJikoku();
	//if (m_eOperation != Operation_Outer)
	//{
	//	m_OperationHatsuJikoku = NullJikoku;
	//}
	//else
	//{
	//	m_OperationHatsuJikoku = value;
	//}
	return *this;
}

tstring CentDedRessyaTrack::getOperationNumber() const
{
	if (m_eOperation != Operation_InOut &&
		m_eOperation != Operation_Outer)
	{
		return _T("");
	}
	else
	{
		return m_strOperationNumber;
	}
}
CentDedRessyaTrack & CentDedRessyaTrack::setOperationNumber(const tstring & value)
{
	if (m_eOperation == Operation_InOut ||
		m_eOperation == Operation_Outer)
	{
		m_strOperationNumber = value;
	}
	//if (m_eOperation != Operation_InOut &&
	//	m_eOperation != Operation_Outer)
	//{
	//	m_strOperationNumber = _T("");
	//}
	//else
	//{
	//	m_strOperationNumber = value;
	//}
	return *this;
}
;


CentDedRessyaTrack& CentDedRessyaTrack::set(
	int	iRessyaTrackIndex,
	EOperation	eOperation,
	int	iShuntTrackIndex,
	CdDedJikoku	OperationHatsuJikoku,
	CdDedJikoku	OperationChakuJikoku,
	tstring	strOperationNumber)
{
	m_iRessyaTrackIndex = iRessyaTrackIndex;
	m_eOperation = eOperation;
	if (m_eOperation == CentDedRessyaTrack::Operation_Shunt)
	{
		m_OperationHatsuJikoku = OperationHatsuJikoku;
		m_OperationChakuJikoku = OperationChakuJikoku;
		m_iShuntTrackIndex = iShuntTrackIndex;
	}
	else if (m_eOperation == CentDedRessyaTrack::Operation_InOut)
	{
		m_strOperationNumber = strOperationNumber;
	}
	else if (m_eOperation == CentDedRessyaTrack::Operation_Outer)
	{
		m_iShuntTrackIndex = iShuntTrackIndex;
		m_OperationHatsuJikoku = OperationHatsuJikoku;
		m_strOperationNumber = strOperationNumber;
	}

	//m_OperationHatsuJikoku = OperationHatsuJikoku;
	//m_OperationChakuJikoku = OperationChakuJikoku;
	//m_iShuntTrackIndex = iShuntTrackIndex;
	//m_strOperationNumber = strOperationNumber;
	
	return ( *this ) ;
};

void CentDedRessyaTrack::onEkiTrack2Insert(int iEkiTrack2Index)
{
	if (iEkiTrack2Index <= m_iRessyaTrackIndex  )
	{
		m_iRessyaTrackIndex++;
	}
	if (m_eOperation == Operation_Shunt &&
		iEkiTrack2Index <= m_iShuntTrackIndex)
	{
		m_iShuntTrackIndex++;
	}
}

void CentDedRessyaTrack::onEkiTrack2Erase(int iEkiTrack2Index)
{
	if (iEkiTrack2Index < m_iRessyaTrackIndex  )
	{
		m_iRessyaTrackIndex--;
	}
	if (m_eOperation == Operation_Shunt &&
		iEkiTrack2Index <= m_iShuntTrackIndex)
	{
		m_iShuntTrackIndex--;
	}
}

} //namespace entDed
