/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CDedOperationConnecter.cpp
// ****************************************************************
*/
/** @file */
#include "stdafx.h"
//#include <algorithm>
#include "CDedOperationConnecter.h"
#include "NsMu\CaMui.h"
#include "NsMu\CMup_vector.h"
#include "NsMu\CaMup_vector.h"
#include "CentDedDgrRessya.h"



namespace entDgr{
using namespace std ;

// ****************************************************************
//	CDedOperationConnecter
// ****************************************************************
	// --------------------------------
	//@name ֐
	// --------------------------------



	// ********************************
	//	RXgN^
	// ********************************
CDedOperationConnecter::CDedOperationConnecter(
	const CentDedRosen* pDedRosen , 
	CentDedDia* pDedDia ) :  
	m_bIsValid( false ) ,
	m_pDedRosen( pDedRosen ) ,
	m_pDedDia( pDedDia ) 
{
	m_KitenJikoku = m_pDedRosen->getKitenJikoku();
}

CDedOperationConnecter::~CDedOperationConnecter()
{
	invalidate() ;
}
	


int CDedOperationConnecter::validate()
{
	if ( isValid() )
	{
		return 0 ;
	}
	// --------------------------------
	int iRv = 1 ;
	//\[gΏۂ̗ԃReiA莞ԂێԂ𐶐
	//@\[gΏۂ̗ԃRei܂ CentDedDia ACentDedDgrDia 𐶐
	//@\[gΏۂ̗Ԃ̐莞CentDedRessyaCont𐶐
	//@@	\[gΏۂ̑SԂ̃[v
	//@@@@	CentDedDgrRessyaA莞CentDedRessya𐶐AReiɒǉ
	if ( iRv >= 1 )
	{
		m_CentDedDgrDia.readCentDedRosen(
			m_pDedRosen , 
			m_pDedDia );

	}


	// --------------------------------
	if ( iRv >= 1 )
	{
		m_bIsValid = true ;
	}
	else
	{
		invalidate() ;
	}
	return iRv ;
}
	
void CDedOperationConnecter::invalidate()
{
	m_bIsValid = false ;
}
	
bool CDedOperationConnecter::isValid()
{
	return m_bIsValid ;
}
	// ********************************
	//@name 
	// ********************************


bool CDedOperationConnecter::RessyaConnectCheck(
	const int iEkiOrder, 
	const CentDedRessya * pRessyaSearch, 
	const CentDedRessya * pRessyaSearchEstimate,
	const int idxRessya,
	const RessyaProperty * sRessyaBefore, 
	const int iTrackIndexTer, 
	RessyaProperty * sRessyaCurrent, 
	const int iMainTrack, 
	const bool bAlreadyNumbered)
{
	if (pRessyaSearch->getSihatsuEki() == iEkiOrder)
	{
		CentDedRessyaTrack aRessyaTrackSearch = pRessyaSearch->getCentDedRessyaTrack(iEkiOrder);
		if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_Shunt)
		{
			if (aRessyaTrackSearch.getShuntTrackIndex() != iTrackIndexTer &&
				aRessyaTrackSearch.getRessyaTrackIndex() != iTrackIndexTer)
			{
				return true;
			}
		}
		else// if(aCentDedRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_NoneorInOut)
		{
			int iRessyaTrackSearch = aRessyaTrackSearch.getRessyaTrackIndex();
			if (iRessyaTrackSearch == 0)
			{
				iRessyaTrackSearch = iMainTrack;
			}
			if (iRessyaTrackSearch != iTrackIndexTer)
			{
				return true;
			}
		}

		CentDedEkiJikoku aEkiJikokuSearch = pRessyaSearch->getCentDedEkiJikoku(iEkiOrder);

		if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_None ||
			aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_InOut)
		{
			if (aEkiJikokuSearch.getHatsujikoku(true).compare(sRessyaBefore->aJikoku, m_KitenJikoku) >= 0 &&
				sRessyaCurrent->aJikoku.compare(aEkiJikokuSearch.getHatsujikoku(true), m_KitenJikoku) > 0)
			{
				sRessyaCurrent->aJikoku = aEkiJikokuSearch.getHatsujikoku(true);
				if (bAlreadyNumbered)
				{
					sRessyaCurrent->iRessyaidx = INT_MIN;
				}
				else
				{
					sRessyaCurrent->iRessyaidx = idxRessya;
					sRessyaCurrent->eRessyahoukou = pRessyaSearch->getRessyahoukou();
				}
			}
			//else
			//{
			//	continue;
			//}
		}
		else if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_Shunt&&
			aRessyaTrackSearch.getShuntTrackIndex() == iTrackIndexTer)
		{
			CdDedJikoku aJikokuOperationHatsu;
			if (aRessyaTrackSearch.getOperationHatsuJikoku().isNull())
			{
				aJikokuOperationHatsu = aEkiJikokuSearch.getHatsujikoku(true);
				aJikokuOperationHatsu.addSeconds(-60);
			}
			else
			{
				aJikokuOperationHatsu = aRessyaTrackSearch.getOperationHatsuJikoku();
			}

			if (aJikokuOperationHatsu.compare(sRessyaBefore->aJikoku, m_KitenJikoku) >= 0 &&
				sRessyaCurrent->aJikoku.compare(aJikokuOperationHatsu, m_KitenJikoku) > 0)
			{
				sRessyaCurrent->aJikoku = aJikokuOperationHatsu;
				if (bAlreadyNumbered)
				{
					sRessyaCurrent->iRessyaidx = INT_MIN;
				}
				else
				{
					sRessyaCurrent->iRessyaidx = idxRessya;
					sRessyaCurrent->eRessyahoukou = pRessyaSearch->getRessyahoukou();
				}
			}
			//else
			//{
			//	continue;
			//}
		}
		else if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_Shunt &&
			aRessyaTrackSearch.getRessyaTrackIndex() == iTrackIndexTer)
		{
			CdDedJikoku aJikokuOperationChaku;
			if (aRessyaTrackSearch.getOperationChakuJikoku(true).isNull())
			{
				aJikokuOperationChaku = aEkiJikokuSearch.getHatsujikoku(true);
				aJikokuOperationChaku.addSeconds(-60);
			}
			else
			{
				aJikokuOperationChaku = aRessyaTrackSearch.getOperationChakuJikoku(true);
			}

			if (aEkiJikokuSearch.getHatsujikoku(true).compare(sRessyaBefore->aJikoku, m_KitenJikoku) < 0)
			{
				return true;
			}
			else if (aJikokuOperationChaku.compare(sRessyaBefore->aJikoku, m_KitenJikoku) < 0)
			{
				//bContinueSearch = false;
				//break;
				return false;
				//Tł؂
			}
			else if (aJikokuOperationChaku.compare(sRessyaCurrent->aJikoku, m_KitenJikoku) < 0)
			{
				sRessyaCurrent->aJikoku = aJikokuOperationChaku;
				sRessyaCurrent->iRessyaidx = INT_MIN;
			}
			//else
			//{
			//	continue;
			//}
		}
	}
	else if (pRessyaSearch->getSyuuchakuEki() == iEkiOrder)
	{
		CentDedRessyaTrack aRessyaTrackSearch = pRessyaSearch->getCentDedRessyaTrack(iEkiOrder);
		if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_Shunt)
		{
			if (aRessyaTrackSearch.getShuntTrackIndex() != iTrackIndexTer &&
				aRessyaTrackSearch.getRessyaTrackIndex() != iTrackIndexTer)
			{
				return true;
			}
		}
		else// if(aCentDedRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_NoneorInOut)
		{
			int iRessyaTrackSearch = aRessyaTrackSearch.getRessyaTrackIndex();
			if (iRessyaTrackSearch == 0)
			{
				iRessyaTrackSearch = iMainTrack;
			}
			if (iRessyaTrackSearch != iTrackIndexTer)
			{
				return true;
			}
		}

		CentDedEkiJikoku aEkiJikokuSearch = pRessyaSearch->getCentDedEkiJikoku(iEkiOrder);

		if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_None ||
			aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_InOut)
		{
			if (aEkiJikokuSearch.getChakujikoku(true).compare(sRessyaBefore->aJikoku, m_KitenJikoku) >= 0 &&
				sRessyaCurrent->aJikoku.compare(aEkiJikokuSearch.getChakujikoku(true), m_KitenJikoku) > 0)
			{
				sRessyaCurrent->aJikoku = aEkiJikokuSearch.getChakujikoku(true);
				sRessyaCurrent->iRessyaidx = INT_MIN;
			}
			//else
			//{
			//	continue;
			//}
		}
		else if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_Shunt&&
			aRessyaTrackSearch.getShuntTrackIndex() == iTrackIndexTer)
		{
			CdDedJikoku aJikokuOperationChaku;
			if (aRessyaTrackSearch.getOperationChakuJikoku(true).isNull())
			{
				aJikokuOperationChaku = aEkiJikokuSearch.getChakujikoku(true);
				aJikokuOperationChaku.addSeconds(60);
			}
			else
			{
				aJikokuOperationChaku = aRessyaTrackSearch.getOperationChakuJikoku(true);
			}

			if (aJikokuOperationChaku.compare(sRessyaBefore->aJikoku, m_KitenJikoku) >= 0 &&
				sRessyaCurrent->aJikoku.compare(aJikokuOperationChaku, m_KitenJikoku) > 0)
			{
				sRessyaCurrent->aJikoku = aJikokuOperationChaku;
				sRessyaCurrent->iRessyaidx = INT_MIN;
			}
			//else
			//{
			//	continue;
			//}
		}
		else if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_Shunt &&
			aRessyaTrackSearch.getRessyaTrackIndex() == iTrackIndexTer)
		{
			CdDedJikoku aJikokuOperationHatsu;
			if (aRessyaTrackSearch.getOperationHatsuJikoku().isNull())
			{
				aJikokuOperationHatsu = aEkiJikokuSearch.getChakujikoku(true);
				aJikokuOperationHatsu.addSeconds(60);
			}
			else
			{
				aJikokuOperationHatsu = aRessyaTrackSearch.getOperationHatsuJikoku();
			}

			if (aJikokuOperationHatsu.compare(sRessyaBefore->aJikoku, m_KitenJikoku) < 0)
			{
				//continue;
				return true;
			}
			else if (aEkiJikokuSearch.getChakujikoku(true).compare(sRessyaBefore->aJikoku, m_KitenJikoku) < 0)
			{
				//bContinueSearch = false;
				//break;
				return false;
				//Tł؂
			}
			else if (aEkiJikokuSearch.getChakujikoku(true).compare(sRessyaCurrent->aJikoku, m_KitenJikoku) < 0)
			{
				sRessyaCurrent->aJikoku = aEkiJikokuSearch.getChakujikoku(true);
				sRessyaCurrent->iRessyaidx = INT_MIN;
			}
			//else
			//{
			//	continue;
			//}
		}

	}
	else if (pRessyaSearch->getCentDedEkiJikoku(iEkiOrder).getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Teisya ||
		pRessyaSearch->getCentDedEkiJikoku(iEkiOrder).getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Tsuuka)
	{
		CentDedRessyaTrack aRessyaTrackSearch = pRessyaSearch->getCentDedRessyaTrack(iEkiOrder);
		int iRessyaTrackSearch = aRessyaTrackSearch.getRessyaTrackIndex();
		if (iRessyaTrackSearch == 0)
		{
			iRessyaTrackSearch = iMainTrack;
		}
		if (iRessyaTrackSearch != iTrackIndexTer)
		{
			return true;
		}

		CentDedEkiJikoku aEkiJikokuSearch = pRessyaSearch->getCentDedEkiJikoku(iEkiOrder);
		CentDedEkiJikoku aEkiJikokuSearchEstimate = pRessyaSearchEstimate->getCentDedEkiJikoku(iEkiOrder);

		if (aEkiJikokuSearchEstimate.getHatsujikoku(true).compare(sRessyaBefore->aJikoku, m_KitenJikoku) < 0)
		{
			return true;
		}
		else if (aEkiJikokuSearchEstimate.getChakujikoku(true).compare(sRessyaBefore->aJikoku, m_KitenJikoku) < 0)
		{
			//bContinueSearch = false;
			//break;
			return false;
			//Tł؂
		}
		else if (aEkiJikokuSearchEstimate.getChakujikoku(true).compare(sRessyaCurrent->aJikoku, m_KitenJikoku) < 0)
		{
			sRessyaCurrent->aJikoku = aEkiJikokuSearchEstimate.getChakujikoku(true);
			sRessyaCurrent->iRessyaidx = INT_MIN;
		}
		//else
		//{
		//	continue;
		//}
	}

	return true;
}

void CDedOperationConnecter::operationConnect()
{
	//bool bAbort = false;
	const CentDedEkiCont* pEkiCont = m_pDedRosen->getCentDedEkiCont();

	//pRessyaContA莞ԃRei쐬
	//	validate() ŁAm_pDedRosen m_pDedDia Ɋ܂܂SԂ
	//	莞 CentDedRessya 𐶐A̓eێ܂B

	//int iRessyahoukou = 0;
	//for (iRessyahoukou = Ressyahoukou_Kudari;
	//	iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++) {
	CentDedRessyaCont* pRessyaCont[2];
	pRessyaCont[0] = m_pDedDia->getCentDedRessyaCont(Ressyahoukou_Kudari);
	pRessyaCont[1] = m_pDedDia->getCentDedRessyaCont(Ressyahoukou_Nobori);
	CentDedRessyaCont aEstimateRessyaContKudari = pRessyaCont[0]->createEmptyCont();
	CentDedRessyaCont aEstimateRessyaContNobori = pRessyaCont[1]->createEmptyCont();
#pragma omp parallel sections
	{
#pragma omp section
		for (int idxRessya = 0; idxRessya < pRessyaCont[0]->size(); idxRessya++)
		{
			const CentDedRessya* pCentDedRessya = pRessyaCont[0]->getMuPtr()->get(idxRessya);
			CentDedDgrRessya aCentDedDgrRessya =
				m_CentDedDgrDia.getCentDedDgrRessyaCont(Ressyahoukou_Kudari)->get(idxRessya);
			//CentDedDgrRessya	aCentDedDgrRessya(
			//	m_pDedRosen,
			//	&m_CentDedDgrDia,
			//	pCentDedRessya);

			CentDedRessya aEstimateRessya(aEstimateRessyaContKudari.createNullRessya());
			//m_CentDedDgrDia.createEstimateRessya(
			//	&aCentDedDgrRessya,
			//	&aEstimateRessya);
			m_CentDedDgrDia.createEstimateRessya2(
				&aCentDedDgrRessya,
				&aEstimateRessya,
				pEkiCont);
			aEstimateRessyaContKudari.insert(aEstimateRessya);
		}
#pragma omp section
		for (int idxRessya = 0; idxRessya < pRessyaCont[1]->size(); idxRessya++)
		{
			const CentDedRessya* pCentDedRessya = pRessyaCont[1]->getMuPtr()->get(idxRessya);
			CentDedDgrRessya aCentDedDgrRessya = 
				m_CentDedDgrDia.getCentDedDgrRessyaCont(Ressyahoukou_Nobori)->get(idxRessya);
			//CentDedDgrRessya	aCentDedDgrRessya(
			//	m_pDedRosen,
			//	&m_CentDedDgrDia,
			//	pCentDedRessya);

			CentDedRessya aEstimateRessya(aEstimateRessyaContKudari.createNullRessya());
			//m_CentDedDgrDia.createEstimateRessya(
			//	&aCentDedDgrRessya,
			//	&aEstimateRessya);
			m_CentDedDgrDia.createEstimateRessya2(
				&aCentDedDgrRessya,
				&aEstimateRessya,
				pEkiCont);
			aEstimateRessyaContNobori.insert(aEstimateRessya);
		}
	}
#pragma omp barrier
	CentDedRessyaCont* pEstimateRessyaCont[2];
	pEstimateRessyaCont[0] = &aEstimateRessyaContKudari;
	pEstimateRessyaCont[1] = &aEstimateRessyaContNobori;
	//aEstimateRessyaCont = pRessyaCont ɐ莞ǉ܂B

	//ςݗIndex쐬
	vector<vector<bool>> contRessyaNumbered;
	contRessyaNumbered.resize(2);
	for (int idx = 0; idx < 2; idx++)
	{
		contRessyaNumbered[idx].assign(pRessyaCont[idx]->size(), false);
	}

	//Step1 nwƂo̗ԂTB
	//Step2-1 ̎nwƂ̉^ԂȂAstrOpeNumɂāA`FbNς݂ɓB
	//Step2-2 ̎nwƂɉ^ԂȂAstrOpeNumɉ^ԂāAԌɓB
	for (int iRessyahoukou = Ressyahoukou_Kudari;
		iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++)
	{
		int iSize = pRessyaCont[iRessyahoukou]->size();
#pragma omp parallel for schedule(dynamic)
		for (int idxRessya = 0; idxRessya < iSize; idxRessya++)
		{
			CentDedRessya* pCentDedRessya = pRessyaCont[iRessyahoukou]->getMuPtr()->get(idxRessya);
			CentDedRessyaTrack aCentDedRessyaTrackShihatsu =
				pCentDedRessya->getCentDedRessyaTrack(pCentDedRessya->getSihatsuEki());
			if (aCentDedRessyaTrackShihatsu.getOperation() != CentDedRessyaTrack::Operation_InOut)
			{
				continue;
			}
			else if (aCentDedRessyaTrackShihatsu.getOperationNumber().empty())
			{
				//Xgŉ^pԍɂ̂ŁAcontRessyaNumberedfalsê܂܂ɂĂA
				//ł͋ɂƂ͂ȂėǂƂB
				//pRessyaCont[iRessyahoukou]->getMuPtr()->get(idxRessya)->setOperationNumber("");
				//contRessyaNumbered[iRessyahoukou][idxRessya] = true;
				continue;
			}

			string strOperationNumber = aCentDedRessyaTrackShihatsu.getOperationNumber();
			pCentDedRessya->setOperationNumber(strOperationNumber);
			pCentDedRessya->setRessyaidxOut(idxRessya);
			pCentDedRessya->setRessyahoukouOut((ERessyahoukou)iRessyahoukou);
			contRessyaNumbered[iRessyahoukou][idxRessya] = true;

//Step3 ԌƂāAIw̎ƔԐ擾BƂȂ̏ꍇ́AƔԐ
//̏ꍇ́AƓԐ擾B
		//aCdDedJikokuTerminal OԂ̍sHI
			//CdDedJikoku aJikokuTer;
		//iTerminalTrackIndex OԂ̏IԐ {(0)͎gpȂ悤ɂB
			int iTrackIndexTer;
		//eRessyahoukouBefore OԂ̗ԕ
			//ERessyahoukou eRessyahoukouBef = pCentDedRessya->getRessyahoukou();
		//iRessyaIndexBefore OԂ̗index
			//int iRessyaidxBef = idxRessya;
		//iEkiIndexTerminal OԏIw̉wIndex
			int iEkiIndexTer = pCentDedRessya->EkiIndexOfEkiOrder(pCentDedRessya->getSyuuchakuEki());
			RessyaProperty sRessyaBefore;
			sRessyaBefore.iRessyaidx = idxRessya;
			sRessyaBefore.eRessyahoukou = pCentDedRessya->getRessyahoukou();

			CentDedRessyaTrack aRessyaTrackOutSyuuchaku =
				pCentDedRessya->getCentDedRessyaTrack(pCentDedRessya->getSyuuchakuEki());
			if (aRessyaTrackOutSyuuchaku.getOperation() == CentDedRessyaTrack::Operation_InOut)
			{
				continue;
			}
			else if (aRessyaTrackOutSyuuchaku.getOperation() == CentDedRessyaTrack::Operation_None)
			{
				//aJikokuTer = pCentDedRessya
					//->getCentDedEkiJikoku(pCentDedRessya->getSyuuchakuEki()).getChakujikoku(true);
				sRessyaBefore.aJikoku = pCentDedRessya
					->getCentDedEkiJikoku(pCentDedRessya->getSyuuchakuEki()).getChakujikoku(true);
				iTrackIndexTer = aRessyaTrackOutSyuuchaku.getRessyaTrackIndex();
				if (iTrackIndexTer == 0)
				{
					iTrackIndexTer = pEkiCont->get(iEkiIndexTer).getMainTrack(sRessyaBefore.eRessyahoukou);
				}
			}
			else if (aRessyaTrackOutSyuuchaku.getOperation() == CentDedRessyaTrack::Operation_Shunt)
			{
				if (aRessyaTrackOutSyuuchaku.getOperationChakuJikoku(true).isNull())
				{
					CdDedJikoku aCdDedJikoku = pCentDedRessya
						->getCentDedEkiJikoku(pCentDedRessya->getSyuuchakuEki()).getChakujikoku(true);
					sRessyaBefore.aJikoku = aCdDedJikoku.addSeconds(60);
				}
				else
				{
					sRessyaBefore.aJikoku = aRessyaTrackOutSyuuchaku.getOperationChakuJikoku(true);
				}

				//aJikokuTer = aJikokuOperationChaku;
				//sRessyaBefore.aJikoku = aJikokuOperationChaku;
				iTrackIndexTer = aRessyaTrackOutSyuuchaku.getShuntTrackIndex();
			}

			//CdDedJikoku aKitenJikoku = m_pDedRosen->getKitenJikoku();

			//Step4 ԒT
			//ԂƂȂƂāA
				//(1)OԂƓԐn܂
				//(2)OԂ̎(N_܂Ȃ)n܂
				//(3)OԂƎԂ̊ԂɁA̗Ԃ̔ԐgpȂ3𖞂
			//TΏۂ̗Ԃ
			//(1)iEkiIndexTerminaln̏ꍇ@Ƃ̏ꍇԐɂāAƂȂEȍꍇԐɂāAԐ擾AȂ玞擾
				//(1)b莟ԂAaJikokuTerォaJikokuAfterCurOȂAVȎb莟ԂɂB
				//AΏۂɔԍtĂȂaJikokuAfterCur㏑Ab莟Ԃ͋ɂB
				//(2)b莟Ԃ݂ꍇAaJikokuTerォaJikokuAfterCurOȂAVȎb莟ԂɂB
			//(2)iEkiIndexTerminalrw̏ꍇA܂́AnwEIw̔ԐɂāAԐ擾AȂ玞擾
				//(1)<<aJikokuTer<aJikokuAfterCurȂAցA
				//(2)<aJikokuTer<aJikokuAfterCur<ȂATł؂
				//(3)<aJikokuTer<<aJikokuAfterCurȂATł؂
				//(4)aJikokuTer<<<aJikokuAfterCurȂAaJikokuAfterCur𒅎ɂAb莟ԂɂĎ
				//(5)aJikokuTer<<aJikokuAfterCur<ȂAaJikokuAfterCur𒅎ɂAb莟ԂɂĎ
					//()̃p^[́Ab莟ԂƁATΏۂ̗Ԃ̍ݐĂ̂ŁA{Ă͂ȂȂp^[
				//(6)aJikokuTer<aJikokuAfterCur<<ȂA
			//(3)iEkiIndexTerminalȈꍇ@Ƃ̏ꍇԐɂāAƂȂ̏ꍇԐɂāAԐ擾AȂ玞擾
				//aJikokuTerォaJikokuAfterCurOȂAaJikokuAfterCur𒅎ɂAb莟ԂɂĎ
			//(3)iEkiIndexTerminal^sEoȐꍇ
				//E󗍂݂̒TŒǉ
			while (1)
			{
				//aJikokuAfterCur aCdDedJikokuTerminalƂ̒l̊ԂAT͈͂ƂȂ܂B
				//T͈͂ɗԂ݂ꍇA̗Ԃ̎ŁA̒lɏ㏑AT͈͂߂Ă܂B
				//ĺA_CON_1bOłB
				//CdDedJikoku aJikokuAfterCur = aKitenJikoku;
				//aJikokuAfterCur.addSeconds(-1);
				//iRessyaidxAfterCur b莟Ԃ̗IndexłAeRessyahoukouAfterCurƑgݍ킹Ďg܂B
				//lyюb莟Ԃ݂Ȃꍇ́AINT_MINłB
				//int iRessyaidxAfterCur = INT_MIN;
				//eRessyahoukouAfterCur b莟Ԃ̗ԕłBiRessyaidxAfterCurƑgݍ킹Ďg܂B
				//l͉(ftHg)Ab莟Ԃ݂Ȃꍇ́AsłB
				//ERessyahoukou eRessyahoukouAfterCur;
				RessyaProperty sRessyaCurrent;
				sRessyaCurrent.aJikoku = m_KitenJikoku;
				sRessyaCurrent.aJikoku.addSeconds(-1);
				sRessyaCurrent.iRessyaidx = INT_MIN;

				bool bContinueSearch = true;

				for (int iRessyahoukouSearch = Ressyahoukou_Kudari;
					iRessyahoukouSearch <= Ressyahoukou_Nobori && bContinueSearch; iRessyahoukouSearch++)
				{
					//int iEkiOrderTerminal = pEstimateRessyaContKudari->EkiOrderOfEkiIndex(iEkiIndexTer);
					//int iMainTrack = pEkiCont->get(iEkiIndexTer).getDownMain();
					//int iSizeKudariSearch = pEstimateRessyaContKudari->size();

					int iEkiOrderTerminal = pRessyaCont[iRessyahoukouSearch]->EkiOrderOfEkiIndex(iEkiIndexTer);
					int iMainTrack = pEkiCont->get(iEkiIndexTer).getMainTrack((ERessyahoukou)iRessyahoukouSearch);
					//int iMainTrack;
					//if (iRessyahoukouSearch == Ressyahoukou_Kudari)
					//{
					//	iMainTrack = pEkiCont->get(iEkiIndexTer).getDownMain();
					//}
					//else
					//{
					//	iMainTrack = pEkiCont->get(iEkiIndexTer).getUpMain();
					//}

					//EΉ iEkiIndexTerɁAEݒŌqĂwOrder߂B
					deque<int> iEkiOrderBrunchOriginSide;
					deque<int> iEkiOrderLoop;
					deque<int> iEkiOrderBrunchTerminalSide;
					int iResult = pEkiCont->getEkiOrderBrunchLoop(
						iEkiOrderTerminal,
						(ERessyahoukou)iRessyahoukouSearch,
						iEkiOrderBrunchOriginSide,
						iEkiOrderLoop,
						iEkiOrderBrunchTerminalSide);

					int iSizeSearch = pRessyaCont[iRessyahoukouSearch]->size();
					//bDeadEndtrueOԂԂȂǍ͍sȂ
					for (int idxRessyaSearch = 0;
						idxRessyaSearch < iSizeSearch && bContinueSearch;
						idxRessyaSearch++)
					{
						if (sRessyaBefore.eRessyahoukou == (ERessyahoukou)iRessyahoukouSearch && sRessyaBefore.iRessyaidx == idxRessyaSearch)
						{
							//ΏۗԂAOԂƓȂ玟
							continue;
						}
						//CentDedRessya* pRessyaSearch = pRessyaContKudari->getMuPtr()->get(idxRessyaSearch);
						CentDedRessya* pRessyaSearch = pRessyaCont[iRessyahoukouSearch]->getMuPtr()->get(idxRessyaSearch);
						CentDedRessya* pRessyaSearchEstimate = pEstimateRessyaCont[iRessyahoukouSearch]->getMuPtr()->get(idxRessyaSearch);

						//EΉ
						if (iResult == -1)
						{
							bContinueSearch = RessyaConnectCheck(
								iEkiOrderTerminal,
								pRessyaSearch,
								pRessyaSearchEstimate,
								idxRessyaSearch,
								&sRessyaBefore,
								iTrackIndexTer,
								&sRessyaCurrent,
								iMainTrack,
								contRessyaNumbered[iRessyahoukouSearch][idxRessyaSearch]);
							if (!bContinueSearch)
							{
								break;
							}
						}
						else
						{
							for (int idxo = 0; idxo < (int)iEkiOrderLoop.size() && bContinueSearch; idxo++)
							{
								bContinueSearch = RessyaConnectCheck(
									iEkiOrderLoop[idxo],
									pRessyaSearch,
									pRessyaSearchEstimate,
									idxRessyaSearch,
									&sRessyaBefore,
									iTrackIndexTer,
									&sRessyaCurrent,
									iMainTrack,
									contRessyaNumbered[iRessyahoukouSearch][idxRessyaSearch]);
							}
							for (int idxl = 0; idxl < (int)iEkiOrderBrunchTerminalSide.size() && bContinueSearch; idxl++)
							{
								bContinueSearch = RessyaConnectCheck(
									iEkiOrderBrunchTerminalSide[idxl],
									pRessyaSearch,
									pRessyaSearchEstimate,
									idxRessyaSearch,
									&sRessyaBefore,
									iTrackIndexTer,
									&sRessyaCurrent,
									iMainTrack,
									contRessyaNumbered[iRessyahoukouSearch][idxRessyaSearch]);
							}
							for (int idxt = 0; idxt < (int)iEkiOrderBrunchOriginSide.size() && bContinueSearch; idxt++)
							{
								bContinueSearch = RessyaConnectCheck(
									iEkiOrderBrunchOriginSide[idxt],
									pRessyaSearch,
									pRessyaSearchEstimate,
									idxRessyaSearch,
									&sRessyaBefore,
									iTrackIndexTer,
									&sRessyaCurrent,
									iMainTrack,
									contRessyaNumbered[iRessyahoukouSearch][idxRessyaSearch]);
							}
						}
						//if (pRessyaSearch->getSihatsuEki() == iEkiOrderTerminal)
						//{
						//	CentDedRessyaTrack aRessyaTrackSearch = pRessyaSearch->getCentDedRessyaTrack(iEkiOrderTerminal);
						//	if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_Shunt)
						//	{
						//		if (aRessyaTrackSearch.getShuntTrackIndex() != iTrackIndexTer &&
						//			aRessyaTrackSearch.getRessyaTrackIndex() != iTrackIndexTer)
						//		{
						//			continue;
						//		}
						//	}
						//	else// if(aCentDedRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_NoneorInOut)
						//	{
						//		int iRessyaTrackSearch = aRessyaTrackSearch.getRessyaTrackIndex();
						//		if (iRessyaTrackSearch == 0)
						//		{
						//			iRessyaTrackSearch = iMainTrack;
						//		}
						//		if (iRessyaTrackSearch != iTrackIndexTer)
						//		{
						//			continue;
						//		}
						//	}

						//	CentDedEkiJikoku aEkiJikokuSearch = pRessyaSearch->getCentDedEkiJikoku(iEkiOrderTerminal);

						//	if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_None ||
						//		aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_InOut)
						//	{
						//		if (aEkiJikokuSearch.getHatsujikoku(true).compare(aJikokuTer, aKitenJikoku) >= 0 &&
						//			aJikokuAfterCur.compare(aEkiJikokuSearch.getHatsujikoku(true), aKitenJikoku) > 0)
						//		{
						//			aJikokuAfterCur = aEkiJikokuSearch.getHatsujikoku(true);
						//			if (contRessyaNumbered[iRessyahoukouSearch][idxRessyaSearch])
						//			{
						//				iRessyaidxAfterCur = INT_MIN;
						//			}
						//			else
						//			{
						//				iRessyaidxAfterCur = idxRessyaSearch;
						//				eRessyahoukouAfterCur = (ERessyahoukou)iRessyahoukouSearch;
						//			}
						//		}
						//		//else
						//		//{
						//		//	continue;
						//		//}
						//	}
						//	else if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_Shunt&&
						//		aRessyaTrackSearch.getShuntTrackIndex() == iTrackIndexTer)
						//	{
						//		CdDedJikoku aJikokuOperationHatsu;
						//		if (aRessyaTrackSearch.getOperationHatsuJikoku().isNull())
						//		{
						//			aJikokuOperationHatsu = aEkiJikokuSearch.getHatsujikoku(true);
						//			aJikokuOperationHatsu.addSeconds(-60);
						//		}
						//		else
						//		{
						//			aJikokuOperationHatsu = aRessyaTrackSearch.getOperationHatsuJikoku();
						//		}

						//		if (aJikokuOperationHatsu.compare(aJikokuTer, aKitenJikoku) >= 0 &&
						//			aJikokuAfterCur.compare(aJikokuOperationHatsu, aKitenJikoku) > 0)
						//		{
						//			aJikokuAfterCur = aJikokuOperationHatsu;
						//			//if (contRessyaNumberedKudari[idxRessyaSearch])
						//			if (contRessyaNumbered[iRessyahoukouSearch][idxRessyaSearch])
						//			{
						//				iRessyaidxAfterCur = INT_MIN;
						//			}
						//			else
						//			{
						//				iRessyaidxAfterCur = idxRessyaSearch;
						//				//eRessyahoukouAfterCur = Ressyahoukou_Kudari;
						//				eRessyahoukouAfterCur = (ERessyahoukou)iRessyahoukouSearch;
						//			}
						//		}
						//		//else
						//		//{
						//		//	continue;
						//		//}
						//	}
						//	else if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_Shunt &&
						//		aRessyaTrackSearch.getRessyaTrackIndex() == iTrackIndexTer)
						//	{
						//		CdDedJikoku aJikokuOperationChaku;
						//		if (aRessyaTrackSearch.getOperationChakuJikoku(true).isNull())
						//		{
						//			aJikokuOperationChaku = aEkiJikokuSearch.getHatsujikoku(true);
						//			aJikokuOperationChaku.addSeconds(-60);
						//		}
						//		else
						//		{
						//			aJikokuOperationChaku = aRessyaTrackSearch.getOperationChakuJikoku(true);
						//		}

						//		if (aEkiJikokuSearch.getHatsujikoku(true).compare(aJikokuTer, aKitenJikoku) < 0)
						//		{
						//			//continue;
						//		}
						//		else if (aJikokuOperationChaku.compare(aJikokuTer, aKitenJikoku) < 0)
						//		{
						//			bContinueSearch = false;
						//			break;
						//			//Tł؂
						//		}
						//		else if (aJikokuOperationChaku.compare(aJikokuAfterCur, aKitenJikoku) < 0)
						//		{
						//			aJikokuAfterCur = aJikokuOperationChaku;
						//			iRessyaidxAfterCur = INT_MIN;
						//		}
						//		//else
						//		//{
						//		//	continue;
						//		//}
						//	}
						//}
						//else if (pRessyaSearch->getSyuuchakuEki() == iEkiOrderTerminal)
						//{
						//	CentDedRessyaTrack aRessyaTrackSearch = pRessyaSearch->getCentDedRessyaTrack(iEkiOrderTerminal);
						//	if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_Shunt)
						//	{
						//		if (aRessyaTrackSearch.getShuntTrackIndex() != iTrackIndexTer &&
						//			aRessyaTrackSearch.getRessyaTrackIndex() != iTrackIndexTer)
						//		{
						//			continue;
						//		}
						//	}
						//	else// if(aCentDedRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_NoneorInOut)
						//	{
						//		int iRessyaTrackSearch = aRessyaTrackSearch.getRessyaTrackIndex();
						//		if (iRessyaTrackSearch == 0)
						//		{
						//			iRessyaTrackSearch = iMainTrack;
						//		}
						//		if (iRessyaTrackSearch != iTrackIndexTer)
						//		{
						//			continue;
						//		}
						//	}

						//	CentDedEkiJikoku aEkiJikokuSearch = pRessyaSearch->getCentDedEkiJikoku(iEkiOrderTerminal);

						//	if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_None ||
						//		aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_InOut)
						//	{
						//		if (aEkiJikokuSearch.getChakujikoku(true).compare(aJikokuTer, aKitenJikoku) >= 0 &&
						//			aJikokuAfterCur.compare(aEkiJikokuSearch.getChakujikoku(true), aKitenJikoku) > 0)
						//		{
						//			aJikokuAfterCur = aEkiJikokuSearch.getChakujikoku(true);
						//			iRessyaidxAfterCur = INT_MIN;
						//		}
						//		//else
						//		//{
						//		//	continue;
						//		//}
						//	}
						//	else if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_Shunt&&
						//		aRessyaTrackSearch.getShuntTrackIndex() == iTrackIndexTer)
						//	{
						//		CdDedJikoku aJikokuOperationChaku;
						//		if (aRessyaTrackSearch.getOperationChakuJikoku(true).isNull())
						//		{
						//			aJikokuOperationChaku = aEkiJikokuSearch.getChakujikoku(true);
						//			aJikokuOperationChaku.addSeconds(60);
						//		}
						//		else
						//		{
						//			aJikokuOperationChaku = aRessyaTrackSearch.getOperationChakuJikoku(true);
						//		}

						//		if (aJikokuOperationChaku.compare(aJikokuTer, aKitenJikoku) >= 0 &&
						//			aJikokuAfterCur.compare(aJikokuOperationChaku, aKitenJikoku) > 0)
						//		{
						//			aJikokuAfterCur = aJikokuOperationChaku;
						//			iRessyaidxAfterCur = INT_MIN;
						//		}
						//		//else
						//		//{
						//		//	continue;
						//		//}
						//	}
						//	else if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_Shunt &&
						//		aRessyaTrackSearch.getRessyaTrackIndex() == iTrackIndexTer)
						//	{
						//		CdDedJikoku aJikokuOperationHatsu;
						//		if (aRessyaTrackSearch.getOperationHatsuJikoku().isNull())
						//		{
						//			aJikokuOperationHatsu = aEkiJikokuSearch.getChakujikoku(true);
						//			aJikokuOperationHatsu.addSeconds(60);
						//		}
						//		else
						//		{
						//			aJikokuOperationHatsu = aRessyaTrackSearch.getOperationHatsuJikoku();
						//		}

						//		if (aJikokuOperationHatsu.compare(aJikokuTer, aKitenJikoku) < 0)
						//		{
						//			//continue;
						//		}
						//		else if (aEkiJikokuSearch.getChakujikoku(true).compare(aJikokuTer, aKitenJikoku) < 0)
						//		{
						//			bContinueSearch = false;
						//			break;
						//			//Tł؂
						//		}
						//		else if (aEkiJikokuSearch.getChakujikoku(true).compare(aJikokuAfterCur, aKitenJikoku) < 0)
						//		{
						//			aJikokuAfterCur = aEkiJikokuSearch.getChakujikoku(true);
						//			iRessyaidxAfterCur = INT_MIN;
						//		}
						//		//else
						//		//{
						//		//	continue;
						//		//}
						//	}

						//}
						//else if (pRessyaSearch->getCentDedEkiJikoku(iEkiOrderTerminal).getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Teisya ||
						//	pRessyaSearch->getCentDedEkiJikoku(iEkiOrderTerminal).getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Tsuuka)
						//{
						//	CentDedRessyaTrack aRessyaTrackSearch = pRessyaSearch->getCentDedRessyaTrack(iEkiOrderTerminal);
						//	int iRessyaTrackSearch = aRessyaTrackSearch.getRessyaTrackIndex();
						//	if (iRessyaTrackSearch == 0)
						//	{
						//		iRessyaTrackSearch = iMainTrack;
						//	}
						//	if (iRessyaTrackSearch != iTrackIndexTer)
						//	{
						//		continue;
						//	}

						//	CentDedEkiJikoku aEkiJikokuSearch = pRessyaSearch->getCentDedEkiJikoku(iEkiOrderTerminal);

						//	CentDedRessya* pRessyaSearchEstimate = pEstimateRessyaCont[iRessyahoukouSearch]->getMuPtr()->get(idxRessyaSearch);
						//	CentDedEkiJikoku aEkiJikokuSearchEstimate = pRessyaSearchEstimate->getCentDedEkiJikoku(iEkiOrderTerminal);
						//	if (aEkiJikokuSearchEstimate.getHatsujikoku(true).compare(aJikokuTer, aKitenJikoku) < 0)
						//	{
						//		//continue;
						//	}
						//	else if (aEkiJikokuSearchEstimate.getChakujikoku(true).compare(aJikokuTer, aKitenJikoku) < 0)
						//	{
						//		bContinueSearch = false;
						//		break;
						//		//Tł؂
						//	}
						//	else if (aEkiJikokuSearchEstimate.getChakujikoku(true).compare(aJikokuAfterCur, aKitenJikoku) < 0)
						//	{
						//		aJikokuAfterCur = aEkiJikokuSearchEstimate.getChakujikoku(true);
						//		iRessyaidxAfterCur = INT_MIN;
						//	}
						//	//else
						//	//{
						//	//	continue;
						//	//}
						//}

					}

					//if (!bContinueSearch)
					//{
					//	break;
					//}
				}

				if (!bContinueSearch || sRessyaCurrent.iRessyaidx == INT_MIN)
				{
					break;
				}

				CentDedRessya* pRessyaNext = pRessyaCont[sRessyaCurrent.eRessyahoukou]->getMuPtr()->get(sRessyaCurrent.iRessyaidx);
				CentDedRessya* pRessyaBefore = pRessyaCont[sRessyaBefore.eRessyahoukou]->getMuPtr()->get(sRessyaBefore.iRessyaidx);

				//OԂ̎ԏ
				pRessyaBefore->setRessyaidxNext(sRessyaCurrent.iRessyaidx);
				pRessyaBefore->setRessyahoukouNext(sRessyaCurrent.eRessyahoukou);

				//Ԃɉ^pԍݒƁAoԏOԂRs[BԂ̎ԏĂB
				pRessyaNext->setOperationNumber(strOperationNumber);
				pRessyaNext->setRessyaidxOut(pRessyaBefore->getRessyaidxOut());
				pRessyaNext->setRessyahoukouOut(pRessyaBefore->getRessyahoukouOut());
				pRessyaNext->setRessyaidxNext(INT_MIN);

				contRessyaNumbered[sRessyaCurrent.eRessyahoukou][sRessyaCurrent.iRessyaidx] = true;

				//̂߂ɁAsRessyaBeforeB
				sRessyaBefore.eRessyahoukou = sRessyaCurrent.eRessyahoukou;// pRessyaNext->getRessyahoukou();
				sRessyaBefore.iRessyaidx = sRessyaCurrent.iRessyaidx;
				iEkiIndexTer = pRessyaNext->EkiIndexOfEkiOrder(pRessyaNext->getSyuuchakuEki());

				CentDedRessyaTrack aRessyaTrackSyuuchakuNext =
					pRessyaNext->getCentDedRessyaTrack(pRessyaNext->getSyuuchakuEki());
				if (aRessyaTrackSyuuchakuNext.getOperation() == CentDedRessyaTrack::Operation_InOut)
				{
					break;
				}
				else if (aRessyaTrackSyuuchakuNext.getOperation() == CentDedRessyaTrack::Operation_None)
				{
					sRessyaBefore.aJikoku = pRessyaNext
						->getCentDedEkiJikoku(pRessyaNext->getSyuuchakuEki()).getChakujikoku(true);
					iTrackIndexTer = aRessyaTrackSyuuchakuNext.getRessyaTrackIndex();
					if (iTrackIndexTer == 0)
					{
						iTrackIndexTer = pEkiCont->get(iEkiIndexTer).getMainTrack(sRessyaBefore.eRessyahoukou);
					}
				}
				else if (aRessyaTrackSyuuchakuNext.getOperation() == CentDedRessyaTrack::Operation_Shunt)
				{
					if (aRessyaTrackSyuuchakuNext.getOperationChakuJikoku(true).isNull())
					{
						CdDedJikoku aCdDedJikoku = pRessyaNext
							->getCentDedEkiJikoku(pRessyaNext->getSyuuchakuEki()).getChakujikoku(true);
						sRessyaBefore.aJikoku = aCdDedJikoku.addSeconds(60);
					}
					else
					{
						sRessyaBefore.aJikoku = aRessyaTrackSyuuchakuNext.getOperationChakuJikoku(true);
					}
					iTrackIndexTer = aRessyaTrackSyuuchakuNext.getShuntTrackIndex();
				}
			}

		}
	}
	for (int iRessyahoukou = Ressyahoukou_Kudari;
		iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++)
	{
		int iSize = pRessyaCont[iRessyahoukou]->size();
		for (int idxRessya = 0; idxRessya < iSize; idxRessya++)
		{
			if (!contRessyaNumbered[iRessyahoukou][idxRessya])
			{
				CentDedRessya* pCentDedRessya = pRessyaCont[iRessyahoukou]->getMuPtr()->get(idxRessya);
				pCentDedRessya->setOperationNumber("");
				pCentDedRessya->setRessyaidxOut(INT_MIN);
				pCentDedRessya->setRessyaidxNext(INT_MIN);
			}
		}
	}
};

} //namespace entDgr
