/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CVerticalTextElementBuilder.h
// ****************************************************************
*/
/** @file */
#ifndef  DcDrawLib_DcDraw_CVerticalTextElementBuilder_h
#define  DcDrawLib_DcDraw_CVerticalTextElementBuilder_h

#include "DcDraw\CVerticalTextElement.h"
#include "NsMu\Mui.h"

namespace DcDrawLib{
namespace DcDraw{
	using namespace OuLib::NsMu ;
	using namespace std ;

/**
@brief
	eLXg߂āAc̃eLXg\vf\APf[^NXłB
	
	CVerticalTextElementBuilder::scan() \bh́A͂A
	͌ʂ CVerticalTextElement ̃ReiƂč\܂B
*/
class CVerticalTextElementBuilder
{
protected:
	// ================================
	///@name ֐
	// ================================
	///@{
	/**
		(SpEp)ۂ𔻒f܂B
	@param aStr [in]
		fsw肵ĂB
	@return
		- true: aStr  (SpEp)łB
	*/
	static bool isSpace( const string& aStr );

	/**
		Ǔ_( , . AB)ۂ𔻒f܂B
	@param aStr [in]
		fsw肵ĂB
	@return
		- true: aStr  Ǔ_łB
	*/
	static bool isDelimiter( const string& aStr );
	///@}
public:
	// ********************************
	///@name CVerticalTextElementBuilder-
	// ********************************
	///@{
	/**
	  	߂āAwvfx̏W쐬AReiɒǉ܂B
	@param aStr [in]
	  	߂镶w肵ĂB
	@param pCStrElementCont [out]
	  	̊֐͂̃Rei̖ɁA aStr ߂vf
	  	ǉ܂B	
	  	̃Rei܂ŕێĂvf͔j܂B
	@param bTwoDegiLateral [in]
		- true: 2̔pA [H_HANKAKU] Ƃ܂B
		- false: 2̔pA[V_HANKAKU] Ƃ܂B
	  
	  
	  	iPj@wvfxɕ
	  	
	  	@Ass\ȍ\vfɕ܂B̕ł́A
	  	ȍ~́uss\ȍ\vfvЂƂwvfxƌĂт܂B
	  	
	  	@wvfx́Aȉ̂R̎ނɋ敪܂B
	  	
	  		- [V_ZENKAKU]  ctHggĕ`悷AASp
	  		- [V_HANKAKU]  ctHggĕ`悷AAp
	  		- [H_HANKAKU]  tHggĕ`悷APEQ̔p
	  			ȋOɔpȂƁj
	  	
	  	
	  	@ijbTwoDegiLateral=true ̏ꍇ
	  		 "s12^28`1^5́A900ɕύX" ́A
	  		ȉ́wvfxɕ܂B
	  		- ""	[V_ZENKAKU]
	  		- "s"	[V_ZENKAKU]
	  		- ""	[V_ZENKAKU]
	  		- "12" 		[H_HANKAKU]
	  		- "^" 		[V_ZENKAKU]
	  		- "28" 		[H_HANKAKU]
	  		- "`"		[V_ZENKAKU]
	  		- "1"			[H_HANKAKU]
	  		- "^"		[V_ZENKAKU]
	  		- "5" 		[H_HANKAKU]
	  		- "́A"		[V_ZENKAKU]
	  		- "900"		[V_HANKAKU]
	  		- ""	[V_ZENKAKU]
	  		- ""	[V_ZENKAKU]
	  		- ""	[V_ZENKAKU]
	  		- "X"	[V_ZENKAKU]
	  	
	  	@Ǔ_̑Oł͉sȂق]܂łB̂߁AǓ_
	  	Ó̕wvfẍꕔƂ܂B
	  	@App̓rł͉sȂق]܂łB̂߁A
	  	ApṕA́wvfxɊi[̂Ƃ܂B
	  	A󔒂Lނoꍇ́AŁwvfx
	  	ÎƂ܂B
	 */
	static void scan( 
		const std::string& aStr , 
		Mui<CVerticalTextElement>* muCVerticalTextElement ,
		bool bTwoDegiLateral = true ) ;

	///@}
};

} //namespace DcDraw
} //namespace DcDrawLib

#endif /*DcDrawLib_DcDraw_CVerticalTextElementBuilder_h*/



