/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
//****************************************************************
//	CdDrawTextFormat.h
//****************************************************************
*/
/** @file */
#ifndef  CdDrawTextFormat_h
#define  CdDrawTextFormat_h

namespace DcDrawLib{
namespace DcdCd{
namespace DcDrawProp{

// ****************************************************************
//	CdDrawTextFormat
// ****************************************************************
/**
 @brief
  eLXg`̌`w肷Af[^NXłB

  ̃NX́AvbgtH[Ɉˑ܂B
*/
class CdDrawTextFormat
{
// ********************************
//	Ci[^Cv
// ********************************
 public:
	/**	̃eLXgzu	*/
	enum EHolizontal
	{
		/**	(l)	*/
		H_LEFT ,				//	DT_LEFT 
		/**		*/
		H_CENTER ,				//	DT_CENTER , 
		/**	E	*/
		H_RIGHT ,				//	DT_RIGHT
	};
	
	/**	c̃eLXgzu	*/
	enum EVertical
	{
		/**	PsŁA	*/
		V_SINGLELINT_TOP ,		//	DT_SINGLELINE | DT_TOP
		
		/**	PsŁA(l)	*/
		V_SINGLELINT_CENTER ,	//	DT_SINGLELINE | DT_VCENTER@(
		
		/**	PsŁA	*/
		V_SINGLELINT_BOTTOM ,	//	DT_SINGLELINE | DT_BOTTOM
		
		/**	s				*/
		V_MULTILINE ,			//	0

		/**	sŁA܂Ԃ͒P̓rłs܂	*/
		V_MULTILINE_WORDBREAK ,	//	DT_WORDBREAK
		
		/**	
			sŁA܂Ԃ͒P̓rłs܂
			 DBCSi_uoCgZbg̕jŉŝh
			܂B̂߁AsK SBCS ƓɂȂ܂B
		*/
		V_NOFULLWIDTHCHARBREAK,	//	DT_WORDBREAK | DT_NOFULLWIDTHCHARBREAK
		
	};
	
	
	/**	ȗ	*/
	enum EEllipses
	{
		/**	ȗȂ(l)	*/
		NOELLIPSIS ,			//	0
		/**
		 	̍Ō̕`̈ɔ[܂؂ȂꍇA
		 	͂ݏo؂Aɏȗi...jǉ܂B
		 	̍Ōł͂ȂꏊɂPꂪ`̈悩͂ݏoꍇ́A
		 	ȗLȂŐ؂܂B 
		 */
		END_ELLIPSIS ,			//	DT_END_ELLIPSIS
		/**
		 	w肵`̈Ɏ܂悤ɁAKvɉăeLXg̓r
		 	ȗ (...) ɒu܂B~Li\j܂܂Ă
		 	eLXg̏ꍇAŌ̉~Ľ̃eLXg\Ȍێ
		 	܂B 
		 */
		PATH_ELLIPSIS ,			//	DT_PATH_ELLIPSIS
		/**
		 	`̈ɔ[܂ȂꍇA؂ŁA
		 	KȗLi...jǉ܂B 
		 */
		WORD_ELLIPSIS ,			//	DT_WORD_ELLIPSIS
	};
	
	
	/**	/E	*/
	enum EReading
	{
		/**	(l)	*/
		R_LEFT			 ,		//	0
		/**	E	*/
		R_RIGHT ,					//	DT_RTLREADING
	};
	
	/**
	 ApThu&v̉`wB

	 ApThj[jbNvtBNX(`w)Ƃ
	邩ۂw肵܂B
	̋@\́Aj[eLXg`悷ꍇɎgp܂B
	*/
	enum EAmpersand
	{
		/** & ̂܂ܕ`悵܂B(l)  */
		EAmpersand_NoPrefix ,	//DT_NOPREFIX,
		
		/** 
		& ̎ & ȊO̕ꍇA 
		& ͕`悹ɁA&̎̕ɉt^ĕ`悵܂B

		& 2AꍇA & Ȃŕ`悵܂B
		*/
		EAmpersand_NormalPrefix ,	//	0

	};
// ********************************
///@name	
// ********************************
///@{
 private:
	/**	
	̃eLXgzuB
	lH_LEFT()
	*/
	EHolizontal	m_eHolizontal ;
	
	/**	
	c̃eLXgzuB
	l V_SINGLELINT_CENTER (PsŁA)
	*/
	EVertical	m_eVertical ;

	/**	
	ȗB	
	ĺANOELLIPSIS ȗȂ(l)
	*/
	EEllipses	m_eEllipses ;

	/**	
	/EB
	l R_LEFT	()
	*/
	EReading	m_eReading ;

	/**
	ApThu&v̉`wB
	l EAmpersand_NoPrefix 
	*/
	EAmpersand m_eAmpresand ;

	
///@}

// ********************************
//	RXgN^
// ********************************
 public:
	/**
		eݒ肷RXgN^łB
	 */
	CdDrawTextFormat( 
		EHolizontal eHolizontal = H_LEFT ,
		EVertical eVertical = V_SINGLELINT_CENTER,
		EEllipses eEllipse = NOELLIPSIS ,
		EReading eReading = R_LEFT ,
		EAmpersand eAmpresand = EAmpersand_NoPrefix ) :
		m_eHolizontal( eHolizontal ) ,
		m_eVertical( eVertical ) ,
		m_eEllipses( eEllipse ) ,
		m_eReading( eReading ) ,
		m_eAmpresand( eAmpresand ) {} ;
		

// ********************************
//	CdDrawTextFormat
// ********************************
 public:
	EHolizontal getHorizontal()const 
	{	return m_eHolizontal ;};
	CdDrawTextFormat& setHorizontal( EHolizontal ev ) 
	{	m_eHolizontal = ev ;	return *this ;};
	EVertical getVertical()const 
	{	return m_eVertical ;};
	CdDrawTextFormat& setVertical( EVertical ev ) 
	{	m_eVertical = ev ;	return *this ;};
	EEllipses getEllipses()const 
	{	return m_eEllipses ;};
	CdDrawTextFormat& setEllipses( EEllipses ev ) 
	{	m_eEllipses = ev ;	return *this ;};
	
	
	EReading getReading()const{	return m_eReading ;};
	CdDrawTextFormat& setReading( EReading ev ) 
	{	m_eReading = ev ;	return *this ;};

	EAmpersand getAmpresand()const{	return m_eAmpresand ;};
	CdDrawTextFormat& setAmpersand( EAmpersand ev )
	{	m_eAmpresand = ev ;	return *this ;};


};

} //namespace DcDrawProp
} //namespace DcdCd
} //namespace DcDrawLib

#endif /*CdDrawTextFormat_h*/

