/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CdScrollbarProp.h
// $Id: CdScrollbarProp.h 327 2016-06-12 04:20:29Z okm $
// ****************************************************************
*/
/** @file */
#ifndef WinUtil_CdScrollbarProp_h
#define WinUtil_CdScrollbarProp_h


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


namespace DcDrawLib{ namespace WinUtil{

// ****************************************************************
//	CdScrollbarProp
// ****************************************************************
/**
@brief
	Pf[^NXłB
	XN[o[ێ܂B

	̃NX́ALȒlȂ NULL ԂƂł܂B

	this ͑ɑ΂āAɈȉ̕␳s܂B

	- m_iMax >= m_iMin 
	- m_iPage <= m_iMax - m_iMin + 1  
	- m_iPage >= 1 
	- m_iPos <= m_iMax 
	- m_iPos <= m_iMax - m_iPage + 1   (m_bAdjustPosByPage=truȅꍇ̂)
	- m_iPos >= m_iMin


*/
class CdScrollbarProp
{
private:
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
		XN[o[̍ŏ̈ʒuB
		NULLԂɂȂƂɂ́A̒l 0 ɏ܂B
	*/
	int m_iMin ;
	/**
		XN[o[̍ő̈ʒuB
		NULLԂɂȂƂɂ́A̒l 0 ɏ܂B
	*/
	int m_iMax ;
	/**
		ݕ\̃y[WB
		NULLԂɂȂƂɂ́A̒l 1 ɏ܂B

		m_iMin = 0  m_iMax  5  m_iPage  1 ̏ꍇ́A
		XN[o[̈ʒu 05܂ł̒lƂ܂B

		m_iMin = 0  m_iMax  5  m_iPage  2 ̏ꍇ́A
		XN[o[̈ʒu 04܂ł̒lƂ܂B

		m_iMin = 0  m_iMax  5  m_iPage  6 ̏ꍇ́A
		XN[o[͔\(܂Disable)ƂȂ܂B
	*/
	int m_iPage ;
	/**
		XN[o[̈ʒuB
		NULLԂɂȂƂɂ́A̒l 0 ɏ܂B
	*/
    int m_iPos; 

	/**
		this NULLԂȂ true łB
	*/
	bool m_bIsNull ;

	/**
		- true: XN[o[̎gpsvȏꍇ́AXN[o[𖳌ɂ܂B
		- false:(l)XN[o[̑삪svȏꍇ́AXN[o[\ɂ܂B

		̒ĺA setNull() łω܂B
	@attention
		ɑtO SIF_DISABLENOSCROLL 
		XN[o[svȈʒuw肵
		SetScrollInfo() ĂяoƁAXN[o[
		Ȃ܂B
		Ǎ  SIF_DISABLENOSCROLL E
		XN[o[KvȈʒuw肵
		SetScrollInfo() ĂяoĂA
		XN[o[͖Lɂ͂Ȃ܂B
		邽߂ɂ́A
		@code
		EnableScrollBar( (SB_HORZ or SB_VERT), ESB_ENABLE_BOTH ) ;
		@endcode
		ĂяoĂA
		SetScrollInfo()ĂяoĂB
	*/
	bool m_bDisableNoScroll ;

	/**
		y[WlKsۂ܂B

		y[WlḰAȉw܂B

		- m_iPos <= m_iMax - m_iPage + 1  

		̒ĺA setNull() łω܂B
		l true łB
	*/
	bool m_bAdjustPosByPage ;


	///@}
protected:
	// --------------------------------
	///@name ֐
	// --------------------------------
	///@{
	/**
		␳܂B
	*/
	void adjustProp() 
	{
		if ( !m_bIsNull )
		{
			if ( !( m_iMax >= m_iMin ) )
			{
				m_iMax = m_iMin ;
			}
			if ( !( m_iPage <= m_iMax - m_iMin + 1 ) )
			{
				m_iPage = m_iMax - m_iMin + 1 ;
			}
			if ( !( m_iPage >= 1 ) )
			{
				m_iPage = 1 ;
			}

			if ( !( m_iPos <= m_iMax ) )
			{
				m_iPos = m_iMax ;
			}

			if ( m_bAdjustPosByPage )
			{
				if ( !( m_iPos <= m_iMax - m_iPage + 1 ) )
				{
					m_iPos = m_iMax - m_iPage + 1 ;
				}
			}
			if ( !( m_iPos >= m_iMin ) )
			{
				m_iPos = m_iMin ;
			}
		}
	};
	///@}
public:
	// ********************************
	//	RXgN^
	// ********************************
	/**
		this NULLԂɏ܂B
	*/
	CdScrollbarProp()
		: m_iMin( 0 ) 
		, m_iMax( 0 ) 
		, m_iPage( 1 ) 
		, m_iPos( 0 )
		, m_bIsNull( true ) 
		, m_bDisableNoScroll( false ) 
		, m_bAdjustPosByPage( true ) 
	{} ;
	CdScrollbarProp(
		int iMin , 
		int iMax , 
		int iPage , 
		int iPos )
		: m_iMin( iMin ) 
		, m_iMax( iMax ) 
		, m_iPage( iPage ) 
		, m_iPos( iPos )
		, m_bIsNull( false ) 
		, m_bDisableNoScroll( false ) 
		, m_bAdjustPosByPage( true ) 
	{
		adjustProp() ;
	} ;
	CdScrollbarProp(
		int iMin , 
		int iMax , 
		int iPage , 
		int iPos , 
		bool bDisableNoScroll ,
		bool bAdjustPosByPage )
		: m_iMin( iMin ) 
		, m_iMax( iMax ) 
		, m_iPage( iPage ) 
		, m_iPos( iPos )
		, m_bIsNull( false ) 
		, m_bDisableNoScroll( bDisableNoScroll ) 
		, m_bAdjustPosByPage( bAdjustPosByPage ) 
	{
		adjustProp() ;
	} ;

public:
	// ********************************
	///@name 
	// ********************************
	///@{
	int getMin()const{	return m_iMin ;};
	int getMax()const{	return m_iMax ;};
	void setMinMax( int iMin , int iMax )
	{
		m_bIsNull = false ;
		m_iMin = iMin ;
		m_iMax = iMax ;
		adjustProp() ;
	};
	int getPage()const{	return m_iPage ;};
	void setPage( int value )
	{
		m_bIsNull = false ; 
		m_iPage = value ;
		adjustProp() ;
	};
	int getPos()const{	return m_iPos;}; 
	void setPos( int value )
	{
		m_bIsNull = false ; 
		m_iPos = value ;
		adjustProp() ;
	}; 

	bool getDisableNoScroll()const{	return m_bDisableNoScroll;};
	void setDisableNoScroll( bool value )
	{
		m_bIsNull = false ; 
		m_bDisableNoScroll = value ;
	}

	bool getAdjustPosByPage()const{	return m_bAdjustPosByPage ;};
	void setAdjustPosByPage( bool value )
	{
		m_bAdjustPosByPage = value ;
		adjustProp() ;
	}
	/** 
	@return
		-true : this  NULL B
		-false: this  NULLłȂ B
	*/
	bool isNull()const
	{
		return ( m_bIsNull ) ;
	};
	void setNull()
	{
		m_iMin = 0 ;
		m_iMax = 0 ;
		m_iPage = 1 ;
		m_iPos = 0 ;
		m_bIsNull = true ;
	};
	/**
		ׂĂ̑ݒ肵Athis  NULLƂ܂B
	@param iMin [in]
	@param iMax [in]
	@param iPage [in]
	@param iPos [in]
	*/
	void set( int iMin , int iMax , int iPage , int iPos )
	{
		m_iMin = iMin ;
		m_iMax = iMax ;
		m_iPage = iPage ;
		m_iPos = iPos ;
		m_bIsNull = false ;
		adjustProp() ;
	};
	///@}
public:
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
		Q CdScrollbarProp r܂B
	@param value [in]
		rΏۂƂȂ CdScrollbarProp w肵ĂB
	@return
		- true : CdScrollbarProp BoNULLB
	*/
	bool isEqualTo( const CdScrollbarProp& value )const
	{
		if ( m_bIsNull && value.m_bIsNull )
		{
			return true ;
		}
		return ( m_iMin == value.m_iMin
			&& m_iMax == value.m_iMax
			&& m_iPage == value.m_iPage
			&& m_iPos == value.m_iPos 
			&& m_bDisableNoScroll == value.m_bDisableNoScroll  
			&& m_bAdjustPosByPage == value.m_bAdjustPosByPage ) ;
	};
	///@}
};

} } //namespace DcDrawLib{ namespace WinUtil{ 

#endif //WinUtil_CdScrollbarProp_h
