/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CdFilenameStr.h
// ****************************************************************
*/
/** @file */
#ifndef  CdFilenameStr_h
#define  CdFilenameStr_h

#include <string>
#include <vector>
#include "str\tstring.h"

namespace OuLib{
namespace Str{

// ****************************************************************
//	CdFilenameStr
// ****************************************************************
/** @brief
* yTvz
* 	  hCuEfBNgEt@C܂񂾕ێ܂B
* 	  ̊evf͂AtpXƂ̊Ԃ̕ϊsƂł܂B
* 
* ygP|tpX̍\vf擾z
*
* PD tpX\vfɕꍇ́ÃIuWFNg𐶐A
*	tpX setFullpathFilename() œnĂB
*	  setFullpathFileName() ́AnꂽtpXt@C͂āA
*	\vfɕAvfthis̑ɐݒ肵܂B
*
* QD  setFullpathFilename() IAQƂ邱ƂɂA
*	tpX̍\vf擾ł܂B
*
* @b tpXt@Cgq擾
* @code
	CdFilenameStr	aCdFilenameStr ;
	aCdFilenameStr.setFullpathFilename( "c:\\windows\\system32\\readme.txt" ) ;
	string	strExt = aCdFilenameStr.Extension() ;
	//strExt = "txt" ƂȂ܂B
* @endcode
*
* ygQ|tpX\zz
*
* PD tpX\zꍇ́ÃIuWFNg̊eɁA
*	\vfݒ肵ĂB
*
* QD  ̌A FullpathFilename() ĂяoĂBFullpathFilename() 
*	ƂɁAtpXt@CҐĕԂ܂B
*/
class CdFilenameStr
{
// ********************************
//	Ci[^Cv
// ********************************
 public:
	/**
	*	fBNgi[邽߂̃ReiłB
	* 	fBNǵAY̏珇Ɋi[܂B
	*/
	typedef std::vector<tstring>	ContstrDir ;
// ********************************
/// @name	
// ********************************
///@{
 private:
	/**
	* 	hCułB ":" ͊܂݂܂B
	* 	hCuȂꍇ́A󕶎łB
	*
	*	:
	*	 "C:\Windows\System32\readme.txt" ̏ꍇ́A
	*	̑ "C" ƂȂ܂B
	*/
	tstring					m_strDrive ;
	
	/**
	*	fBNgAi[Ă܂B
	* 	fBNǵAY̏珇Ɋi[܂B
	*
	*	:
	*	 "C:\Windows\System32\readme.txt" ̏ꍇ́A
	*	̑
	*
	* -		[0]="Windows"
	* -		[1]="System32"
	*
	*	ƂȂ܂B
	*/
	ContstrDir			m_contstrDir ;
	
	/**
	* 	x[Xt@CłB
	* 	gq܂݂܂B
	*
	*
	*	:
	*	 "C:\Windows\System32\readme.txt" ̏ꍇ́A
	*	̑ "readme" ƂȂ܂B
	*/
	tstring					m_strBaseFilename ;
	
	/**
	* 	gqłB"."͊܂݂܂BȂꍇ́A󕶎łB
	*
	*	:
	*	 "C:\Windows\System32\readme.txt" ̏ꍇ́A
	*	̑ "txt" ƂȂ܂B
	*/
	tstring					m_strExtension ;
	
	/**
	* 	̃pX̃fBNgΎwł΋UA΃pXȂ^łB
	*
	*	:
	*	 "C:\Windows\System32\readme.txt" ̏ꍇ́A
	*	̑ true ƂȂ܂B
	*/
	bool						m_bIsRelativePath ;
	
	/**
	* 	̃pXAt@Ĉ`łȂ^łB
	* 	̏ꍇ́AԉE '\' ̉E̓t@CƂ݂Ȃ܂B
	* 	̃pXAt@ĈȂ`ł΋UłB
	* 	̏ꍇ́AԉE '\' ̉EfBNgƂ݂Ȃ܂B
	*
	*	RXgN^E܂ setIsValidFilename() ɂA炩ߖI
	*	ݒ肪KvȑłB
	*/
	bool						m_bIsValidFilename ;
///@}

// ********************************
//	RXgN^EfXgN^
// ********************************
 public:
	CdFilenameStr() ;
	/**
	* @param strFilename [in]
	* 	tpXihCuEfBNgEt@Cj
	* 	w肵ĂB
	* @param bIsValidFilename [in]
	* 	̃pXAt@Ĉ`łȂ^łB
	* 	̏ꍇ́AԉE '\' ̉E̓t@CƂ݂Ȃ܂B
	* 	̃pXAt@ĈȂ`ł΋UłB
	* 	̏ꍇ́AԉE '\' ̉EfBNgƂ݂Ȃ܂B
	*/
	CdFilenameStr( tstring strFilename , bool bIsValidFilename = true ) ;

// ********************************
//	CdFilenameStr
// ********************************
 public:
	// ********************************
	///	@name 
	// ********************************
	///@{

	/**
	* 	hCułB
	* 	hCuȂꍇ́A󕶎łB
	*/
	tstring			Drive() const ;
	CdFilenameStr& 		setDrive( const tstring& ev ) ;
	
	/**
	* 	fBNgԂ܂B
	* 	fBNǵAY̏珇Ɋi[Ă܂B
	*/
	ContstrDir		Dirs()const  ;
	CdFilenameStr& 	setDirs( const ContstrDir& ev ) ;
	
	/**
	* @return
	* 	fBNg̐iKjԂ܂B
	*/
	int DirCount()const ;
	
	/**
	* 	fBNgԂ܂B
	* @param index [in]
	* 	fBNg̊KiDirs̓YjAOȏDirCount()̐
	*	w肵ĂB
	* @return
	* 	fBNgԂ܂B
	*/
	tstring DirAt( int idx )const ;
	
	/**
	* 	fBNg𖖔ɒǉ܂B
	* @param ev [in]
	* 	ǉfBNg̖Ow肵ĂB
	*/
	CdFilenameStr& 	addDirLast( const tstring& ev ) ;
	
	/**
	* 	fBNgẅʒuɒǉ܂B
	* @param index [in]
	* 	ǉꏊAOȏDirCount()ȉ̐Ŏw肵ĂB
	* @param ev [in]
	* 	ǉfBNg̖Ow肵ĂB
	*/
	CdFilenameStr& 	addDirAt( int index , const tstring& ev ) ;
	
	/**
	* 	fBNg̖폜܂B
	*/
	CdFilenameStr& 	delDirLast() ;
	/**
	* 	fBNg폜܂B
	* @param index [in]
	* 	폜fBNgAOȏDirCount()̐Ŏw肵ĂB
	*/
	CdFilenameStr& 	delDirAt( int index ) ;
	
	
	/**
	* 	x[Xt@CłB
	* 	gq܂݂܂B
	*/
	tstring				BaseFilename() const ;
	CdFilenameStr& 			setBaseFilename( const tstring& ev ) ;
	
	/**
	* 	gqłB
	*/
	tstring					Extension() const ;
	CdFilenameStr& 				setExtension( const tstring& ev ) ;
	
	/**
	* 	̃pX΃pXł΋UA΃pXȂ^łB
	*/
	bool						IsRelativePath() const ;
	CdFilenameStr&				setIsRelativePath( bool ev ) ;
	
	/**
	* 	̃pXAt@Ĉ`łȂ^łB
	* 	̏ꍇ́AtpX͂ꍇɁA
	* 	ԉE "\" ̉Et@CƂ݂Ȃ܂B
	* 	̃pXAt@ĈȂ`ł΋UłB
	* 	̏ꍇ́AtpX͂ꍇɁA
	* 	ԉE "\" ̉EfBNgƂ݂Ȃ܂B
	*/
	bool						IsValidFilename() const ;
	CdFilenameStr&				setIsValidFilename( bool ev ) ;
	
	/**
	* @return
	* 	x[Xt@CƊgqt@CԂ܂B
	*/
	tstring 				Filename() const ;

	/**
	* @param ev [in]
	* 	x[Xt@CƊgqt@Cw肵ĂB
	* @return
	* 	̃IuWFNgԂ܂B
	*/
	CdFilenameStr& 				setFilename( tstring ev ) ;
	
	///@}
	
	// ********************************
	///	@name 
	// ********************************
	///@{
	
	/**
	* @return
	* 	tpXt@C擾邱Ƃł܂B
	* 	̊evfāAtpX쐬܂B
	* 
	* 	m_bIsValidFilename ^̏ꍇ́At@CĂȂĂA
	* 	fBNĝƂ '\' ܂B
	* 	m_bIsValidFilename Ȕꍇ́A
	* 	fBNĝƂ '\' ܂B܂At@C
	* 	o͂܂B
	*/
	tstring 				FullpathFilename() const ;
	
	/**
	* 	tpXt@C͂邱Ƃł܂B
	* @param strFilename [in]
	* 	tpXihCuEfBNgEt@Cj
	* 	w肵ĂB
	* @param bIsValidFilename [in]
	* 	̃pXAt@Ĉ`łȂ^łB
	* 	̏ꍇ́AԉE '\' ̉E̓t@CƂ݂Ȃ܂B
	* 	̃pXAt@ĈȂ`ł΋UłB
	* 	̏ꍇ́AԉE '\' ̉EfBNgƂ݂Ȃ܂B
	* 	w肵Ȃꍇ́Ã݂[hێ܂B
	* @return
	* 	̃IuWFNgԂ܂B
	*/
	CdFilenameStr& setFullpathFilename( tstring ev , 
										bool bIsValidFilename ) ;
	/** @overload */
	CdFilenameStr& setFullpathFilename( tstring ev ) ;

	/**
	* 	fBNgAevɂđΈړ܂B
	* 
	* 	   ev ̃fBNgΎwȂAthis̃fBNg
	* 	 ev ̃fBNgɂđΈړ܂B
	* 	   ev ̃fBNgΎwȂA this ̃fBNg
	* 	ev ɒu܂B
	* 	   ev ɃfBNgȊO̗vf܂܂ĂꍇA
	* 	this ̂̂ ev ̂̂ɒu܂B
	* @param ev [in]
	* 	ړw肵ĂB
	*/
	CdFilenameStr& ChangeDir( const CdFilenameStr& ev ) ;
	
	/**
	* 	  fBNgAev̑Ύwɕϊ܂B
	* 	 thisEeṽfBNǵAΎwłȂĂ͂Ȃ܂B
	* 	ǂ炩Ύwłꍇ́Å֐͎s܂B
	* 	 thisɃfBNgȊO̗vfw肳ĂꍇA
	* 	ێ܂B
	* 	  ev ɃfBNgȊO̗vfw肳Ă
	* 	 this ɑΉvfw肳ĂȂꍇ́A
	* 	 ev ̂̂ this ɃRs[܂B
	* @param ev [in]
	* 	ړw肵ĂB
	* @return
	* 	-	0:
	* 	-	-1 ;	// 	 hCuقȂ邽߁A΃pXɂ͂ł܂B
	* 	-	-2 ;	//	 this΃pXł
	* 	-	-3 ;	//	 ev΃pXł
	*/
	int ChangeToRelativeDir( const CdFilenameStr& ev ) ;
	
	///@}
	
	// ********************************
	//	Zq
	// ********************************
	
	/** FullpathFilename() Ɠł */
	operator tstring()const{	return FullpathFilename() ; } ;
};

} //namespace Str{
} //namespace OuLib{

#endif /*CdFilenameStr_h*/

