/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/** @file */
//$Id: CConvNodeContainer.h 63 2012-09-01 08:54:26Z okm $
#pragma once
#include "str\OuPropertiesText\CNodeContainer.h"
#include "str\tstring.h"

namespace OuLib{
namespace Str{
namespace OuPropertiesText{


/**
@brief
	CNodeContainer ̓eOuPropertiesText()̊Ԃ̕ϊs܂B

yErrorInfoStringz

  ErrorInfoString ́AG[̌łB
  ́̕A 

	- 1ErrReason (G[)ƁA
	- 0ȏErrProp(G[Tu)
 
 ō\܂B

  ErrReason ́A ERRREASON_ ̂̂ꂩłB

  ErrProp ́A 
 
	- =l
 
 ̌`łB́AERRPROP_ ̂̂ꂩłB
   ErrReasonErrProp̊ԁEErrPropm̊Ԃ́A^uŋ؂܂B
*/
class CConvNodeContainer  
{
public:
	// ********************************
	///@name	ErrorInfoString
	// ********************************
	///@{
	/**
		񂪃fR[hł܂B
	@param ERRPROP_Text
		ΏۂƂȂ镶
	*/
	static const TCHAR* const ERRREASON_Undecoded_Text ;
	/**
		fBNgrŕĂ܂B
	*/
	static const TCHAR* const ERRREASON_ContainerAborted ;
	/**
		fBNgĂ܂
	*/
	static const TCHAR* const ERRREASON_ContainerIsNotClosed ;

	/**
		seLXg
	*/
	static const TCHAR* const ERRPROP_Text ;
	///@}
public:
	// ********************************
	//	RXgN^
	// ********************************
	CConvNodeContainer();
	virtual ~CConvNodeContainer();

protected:
	// --------------------------------
	///@name ֐
	// --------------------------------
	///@{
	/**
		Property  Value AOuPropertiesTextpɃGXP[v܂B
			- s  "\n" 
			- "\"  "\\" 
	@param strValue [in]
		ϊO̕w肵ĂB
	@return 
		ϊ̕Ԃ܂B
	*/
	tstring encodePropertyString_escapePropertyValue( 
		const tstring& strValue ); 

	/**
		OuPropertiesTextpɃGXP[vꂽProperty  Value Aϊ܂B
			- s  "\n" 
			- "\"  "\\" 
	@param strValue [in]
		ϊO̕w肵ĂB
	@return 
		ϊ̕Ԃ܂B
	*/
	tstring decodePropertyString_unescapePropertyValue(
			const tstring& strValue ) ;

	/**
		OuPropertiesText ̎ẅʒun܂ 
		NodeContainer 1߂A̓eƂ CNodeContainer IuWFNg
		\z܂B
	@param strContent [in]
		OuPropertiesTextw肵ĂB
	@param iPosBegin [in]
		OuPropertiesText̒ł̈ʒuA0n܂CfNXŎw肵ĂB
	@param piPosNext [out]
		̊֐́A߂ɐAߏI OuPropertiesText ̈ʒu
		(ڂ܂ł߂)݂܂B
		͒ʏAOuPropertiesText ̖ADirectryI[s̐擪w܂B
		svȂNULLł܂܂B
	@param pCNodeContainer [out]
		̊֐͂̃IuWFNgɁANodeContainer ̓e
		\܂B
	@param pstrErrorInfoString [out]
		̊֐́AG[ꍇ́AErrorInfoString ݂܂B
		svłNULLw肵Ă܂܂B
	@return
		-	1 ;	//	
		-	0 ;	//	ł iPosBegin Rec̖ɂ܂B
		-	-1 ;	//	񂪃fR[hł܂B	
	*/
	int decodeNodeContainer(
		const tstring& strContent , 	int iPosBegin  , int* piPosNext , 
			CNodeContainer* pCNodeContainer ,
			tstring* pstrErrorInfoString ) ;

	/**
		OuPropertiesText ̎ẅʒun܂ 
		Property 1߂A̓eƂ CPropertyString IuWFNg
		\z܂B
	@param strContent [in]
		OuPropertiesTextw肵ĂB
	@param iPosBegin [in]
		OuPropertiesText̒ł̈ʒuA0n܂CfNXŎw肵ĂB
	@param piPosNext [out]
		̊֐́A߂ɐAߏI OuPropertiesText ̈ʒu
		(ڂ܂ł߂)݂܂B
		͒ʏAOuPropertiesText ̖ADirectryI[s̐擪w܂B
		svȂNULLł܂܂B
	@param ppCPropertyString [out]
		̊֐́A߂ɐA̓eێ CPropertyString 
		IuWFNg𐶐ÃIuWFNgւ̃AhX
		̃|C^ɏ݂܂B
	@param pstrErrorInfoString [out]
		̊֐́AG[ꍇ́AErrorInfoString ݂܂B
		svłNULLw肵Ă܂܂B
	@return
		-	1 ;	//	
		-	0 ;	//	ł iPosBegin Rec̖ɂ܂B
	*/
	int decodePropertyString(
		const tstring& strContent , 	int iPosBegin  , int* piPosNext , 
		Ou<CPropertyString>* ppCPropertyString ,
		tstring* pstrErrorInfoString ) ;

	/**
		Rec̎ẅʒun܂1s̕Ԃ܂B
	@param strContent [in]
		Recw肵ĂB
	@param iPosBegin [in]
		Rec̒ł̈ʒuA0n܂CfNXŎw肵ĂB
	@param piPosNext [out]
		̊֐́ARecł́A̍s̈ʒu݂܂B
		svȂNULLł܂܂B
	@param pstrLine [out]
		̊֐͂̃IuWFNgɁAPs̕Ԃ܂B
		s̋؂ '\n' ́A̕ɂ͊܂߂܂B
	@return
		-	1 ;	//	
		-	0 ;	//	ł iPosBegin Rec̖ɂ܂B
	*/
	int getLine( 
		const tstring& strContent , 
		int iPosBegin  , int* piPosNext , 
		tstring* pstrLine  ) ;

	///@}
public:
	// ********************************
	///@name	CConvNodeContainer  
	// ********************************
	///@{
	/**
		IfNodeContainerConst̓e𕶎(OuPropertiesText) ɕϊ܂B
	@param pIfNodeContainerConst [in]
		ϊ CNodeContainer w肵ĂB
	@return
		ϊOuPropertiesTextԂ܂B
	*/
	virtual tstring encode( 
		const IfNodeContainerConst* pIfNodeContainerConst ) ;

	/**
		CNodeContainer̓e𕶎(OuPropertiesText) ɕϊ܂B
	@param pCNodeContainer [in]
		ϊ CNodeContainer w肵ĂB
	@return
		ϊOuPropertiesTextԂ܂B
	*/
	virtual tstring encode( 
		const CNodeContainer* pCNodeContainer ) 
	{	return encode( pCNodeContainer->getIfNodeContainerConst() ) ; } ;

	/**
		(OuPropertiesText) ̓eCNodeContainerɔf܂B
	@param strContent [in]
		ϊ OuPropertiesTextB
	@param pCNodeContainer [out]
		̊֐́A CNodeContainer ɁAOuPropertiesText 
		e𔽉f܂B
		̊֐܂ŕێĂe͔j܂B
	@param pstrErrorInfoString [out]
		̊֐́AG[ꍇ́AErrorInfoString ݂܂B
		svłNULLw肵Ă܂܂B
	@return
		0ȏAG[Ȃ畉̐łB
		-	-1 ;	//	fBNgrŕĂ܂B
	*/
	virtual int decode(
		const tstring& strContent , 
		CNodeContainer* pCNodeContainer ,
		tstring* pstrErrorInfoString = NULL ) ;


	///@}

};

} //namespace OuPropertiesText{
} //namespace Str{
} //namespace OuLib{
