/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CHidemdiRootDoctmpl.cpp
// ****************************************************************
*/

#include "CHidemdiRootDoctmpl.h"
#include "CHidemdiRootFrame.h"
#include "CHidemdiRootView.h"
#include "CHidemdiApp.h" 

namespace OuMfc{
namespace Hidemdi{


// ****************************************************************
//	CHidemdiCSubdoctemplate
// ****************************************************************
// ********************************
//	RXgN^
// ********************************
CHidemdiRootDoctmpl::CHidemdiRootDoctmpl( UINT nIDResource
				, CRuntimeClass* pDocClass ) : 
	super( nIDResource , 
		pDocClass , 
		RUNTIME_CLASS(CHidemdiRootFrame) , 
		RUNTIME_CLASS(CHidemdiRootView) ) 
{
}
CHidemdiRootDoctmpl::~CHidemdiRootDoctmpl() 
{
}

// ********************************
//	CDocTemplate
// ********************************
CDocument* CHidemdiRootDoctmpl::OpenDocumentFile( LPCTSTR lpszPathName
								//, BOOL bMakeVisible )
	,BOOL bAddToMRU, BOOL bMakeVisible )
		//yI[oChz
		//	̃hLgׂĕĂA
		//	VhLg𐶐܂B
{

	CDocument*	pRv = NULL ;
	BOOL	bLSaveIsContinued = TRUE ;

	//--------------------------------
	//	[ghLgۑ
	//--------------------------------
	if ( bLSaveIsContinued ){
		bLSaveIsContinued = super::SaveAllModified() ;
			//bLSaveIsContinued = [ghLg̕ۑ
			//	LZꂽUł
	}
	if ( bLSaveIsContinued )
	{
		//--------------------------------
		//	ׂẴTuhLg
		//--------------------------------
		CloseAllSubDocuviews( FALSE ) ;

		//--------------------------------
		//	[ghLgȂȂ琶
		//	ȂA̗vfj
		//--------------------------------
		CDocument*	pDocument = ((CHidemdiApp*)AfxGetApp())->pRootDoc() ;
		if ( pDocument == NULL )
		{
			//	[gDocumentȂȂ琶
			pDocument = CreateNewDocument();

		}	else	{
			pDocument->DeleteContents() ;
		}

		//--------------------------------
		//	t@Cw肳ĂA
		//	t@CJ
		//--------------------------------
		if (lpszPathName == NULL)
		{
			// create a new document - with default document name
			SetDefaultTitle(pDocument);

			// avoid creating temporary compound file when starting up invisible
			if (!bMakeVisible)
				pDocument->m_bEmbedded = TRUE;

			if (!pDocument->OnNewDocument())
			{
				// user has be alerted to what failed in OnNewDocument
				TRACE0("CDocument::OnNewDocument returned FALSE.\n");
				//pFrame->DestroyWindow();
				return NULL;
			}

			// it worked, now bump untitled count
			m_nUntitledCount++;
		}
		else
		{
			// open an existing document
			CWaitCursor wait;
			if (!pDocument->OnOpenDocument(lpszPathName))
			{
				// user has be alerted to what failed in OnOpenDocument
				TRACE0("CDocument::OnOpenDocument returned FALSE.\n");
				//pFrame->DestroyWindow();
				return NULL;
			}
			pDocument->SetPathName(lpszPathName);
		}
		pRv = pDocument ;
	}

	return ( pRv ) ;
};
/*sankou
CDocument* CMultiDocTemplate::OpenDocumentFile(LPCTSTR lpszPathName,
	BOOL bMakeVisible)
{
	CDocument* pDocument = CreateNewDocument();
	if (pDocument == NULL)
	{
		TRACE0("CDocTemplate::CreateNewDocument returned NULL.\n");
		AfxMessageBox(AFX_IDP_FAILED_TO_CREATE_DOC);
		return NULL;
	}
	ASSERT_VALID(pDocument);

	BOOL bAutoDelete = pDocument->m_bAutoDelete;
	pDocument->m_bAutoDelete = FALSE;   // don't destroy if something goes wrong
	CFrameWnd* pFrame = CreateNewFrame(pDocument, NULL);
	pDocument->m_bAutoDelete = bAutoDelete;
	if (pFrame == NULL)
	{
		AfxMessageBox(AFX_IDP_FAILED_TO_CREATE_DOC);
		delete pDocument;       // explicit delete on error
		return NULL;
	}
	ASSERT_VALID(pFrame);

	if (lpszPathName == NULL)
	{
		// create a new document - with default document name
		SetDefaultTitle(pDocument);

		// avoid creating temporary compound file when starting up invisible
		if (!bMakeVisible)
			pDocument->m_bEmbedded = TRUE;

		if (!pDocument->OnNewDocument())
		{
			// user has be alerted to what failed in OnNewDocument
			TRACE0("CDocument::OnNewDocument returned FALSE.\n");
			pFrame->DestroyWindow();
			return NULL;
		}

		// it worked, now bump untitled count
		m_nUntitledCount++;
	}
	else
	{
		// open an existing document
		CWaitCursor wait;
		if (!pDocument->OnOpenDocument(lpszPathName))
		{
			// user has be alerted to what failed in OnOpenDocument
			TRACE0("CDocument::OnOpenDocument returned FALSE.\n");
			pFrame->DestroyWindow();
			return NULL;
		}
		pDocument->SetPathName(lpszPathName);
	}

	InitialUpdateFrame(pFrame, pDocument, bMakeVisible);
	return pDocument;
}

*/

BOOL CHidemdiRootDoctmpl::SaveAllModified( )
		//yI[oChz
		//	ׂẴTuDocviewۑĂADocviewۑ܂
{
	BOOL	bLSaveIsContinued = TRUE ;
	if ( bLSaveIsContinued ){
		bLSaveIsContinued = super::SaveAllModified() ;
	}
	return ( bLSaveIsContinued ) ;
}
	
void CHidemdiRootDoctmpl::CloseAllDocuments( BOOL bEndSession )
{
		//yI[oChz
		//	ׂẴTuDocviewCloseAllDocumentssĂA
		//	Docview܂
	CloseAllSubDocuviews( bEndSession ) ;
	super::CloseAllDocuments( bEndSession ) ;
}
// ********************************
//	CHidemdiRootDoctmpl
// ********************************
BOOL CHidemdiRootDoctmpl::SaveAllModifiedSubDocviews( )
{
	BOOL	bLSaveIsContinued = TRUE ;

	POSITION	LPosition = AfxGetApp()->GetFirstDocTemplatePosition() ;
	while( LPosition != NULL && bLSaveIsContinued ){
		CDocTemplate*	pLDocTemplate = AfxGetApp()
							->GetNextDocTemplate( LPosition ) ;

		if ( pLDocTemplate != this ){
			bLSaveIsContinued = pLDocTemplate->SaveAllModified() ;
				//bLSaveIsContinued = TuhLg̕ۑ
				//	LZꂽUł
		}
	}

	return ( bLSaveIsContinued ) ;
}

void CHidemdiRootDoctmpl::CloseAllSubDocuviews( BOOL bEndSession )
		//	ׂẴTuDocview܂
{

	POSITION	LPosition = AfxGetApp()->GetFirstDocTemplatePosition() ;
	while( LPosition != NULL ){
		CDocTemplate*	pLDocTemplate = AfxGetApp()
						->GetNextDocTemplate( LPosition ) ;

		if ( pLDocTemplate != this ){
			pLDocTemplate->CloseAllDocuments( bEndSession ) ;
		}
	}
}

} //namespace Hidemdi
} //namespace OuMfc

