/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CCalcCentDedDgrRessyasenOfPoint.h
// $Id: CCalcCentDedDgrRessyasenOfPoint.h 94 2012-09-29 12:11:37Z okm $
// ****************************************************************
*/
#ifndef  CCalcCentDedDgrRessyasenOfPoint_h
#define  CCalcCentDedDgrRessyasenOfPoint_h

/** @file */
#include "entDgr\CEnumRessyasen.h"
#include "ViewDiagram\CDcdDiagram.h"

namespace ViewDiagram{

// ****************************************************************
//	CCalcCentDedDgrRessyasenOfPoint
// ****************************************************************
/**
 @brief
	CDcdDiagram::calcCentDedDgrRessyasenOfPoint() ֐ł̂
	gpNXłB
	`̈́AwΏۓ_xʂĂԐ𒲂ׂ܂B

	ygz
	
	PD  RXgN^ŁAIuWFNg𐶐ĂB
	RXgN^̈ɂ́AԐ̏ێĂ CDcdDiagram 
	IuWFNgƁA` IfDcdTarget IuWFNgE
	wΏۓ_xw肵ĂB
	
	QD  execute() ĂяoĂB
	 execute() ́AwΏۓ_xʂԐA
	̏𑮐  m_eRessyahoukou , m_iRessyaIdx , m_iRessyasenIdx 
	ɏ݂܂B

 */
class CCalcCentDedDgrRessyasenOfPoint : public CEnumRessyasen
{
public:
	// ********************************
	//	Ci[^Cv
	// ********************************
	typedef CEnumRessyasen	super ;

private:
	// ********************************
	///@name	֘A
	// ********************************
	/**
		DcdGrid̕`sIuWFNgB 
		̃IuWFNg̔j̐Ӗ́ANX[U[ɂ܂B
		̃IuWFNǵA this ̔j܂ 
		ȂĂ͂Ȃ܂B
	*/
	CDcdDiagram*	m_pCDcdDiagram ;
	/**
		DcdGrid̕`B 
		̃IuWFNg̔j̐Ӗ́ANX[U[ɂ܂B
		̃IuWFNǵA this ̔j܂ 
		ȂĂ͂Ȃ܂B
	*/
	IfDcdTarget*	m_pIfDcdTarget ;


private:
	// ********************************
	///@name	
	// ********************************
	///@{
	/**
		wΏۓ_x(DcDrawW)
		 execute() ́A̍WʂԐA
		̏
		 m_eRessyahoukou , m_iRessyaIdx , m_iRessyasenIdx 
		ɐݒ肵܂B
	 */
	CdDcdPosXy m_CdDcdPosXy ;
	/**
		Ώۓ_ƗԐ̊Ԃ̋̍ől(DcDrawW)B
		
		̊֐́Am_CdDcdPosXy ƗԐƂ̋
		̃sNZȉł΁A
		um_CdDcdPosXy ԐʂĂvƂ݂Ȃ܂B
		0 ȂAԐWʒuSɒʂĂꍇ̂
		YԐƂ݂Ȃ܂B
	 */
	int m_iMerginPixels ;
	/**
		l͕sB
		Ԑꍇ́A̗ԕB
	 */
	ERessyahoukou m_eRessyahoukou ;
	/**
		l -1 ;
		Ԑꍇ́A̗IndexB
	 */
	int m_iRessyaIdx ;
	/**
		l -1 B
		Ԑꍇ́A̗ԐIndexB
	 */
	int m_iRessyasenIdx ;
	///@}

// ********************************
//	RXgN^
// ********************************
 public:
	/**
	 @param pCDcdDiagram [in]
		O CDcdDiagram IuWFNgƂ̊֘AłB 
		̃IuWFNg̔j̐Ӗ́ANX[U[ɂ܂B
		 ̃IuWFNǵA this ̔j܂ 
		ȂĂ͂Ȃ܂B 
	 @param pIfDcdTarget  [in] 
		`B 
		̃IuWFNg̔j̐Ӗ́ANX[U[ɂ܂B
		̃IuWFNǵA this ̔j܂ 
		ȂĂ͂Ȃ܂B
	 @param aCdDcdPosXy [in]
		Ώۂ̍WB
		 execute() ́A̍WʂԐA
		̏
		 m_eRessyahoukou , m_iRessyaIdx , m_iRessyasenIdx 
		ɐݒ肵܂B
	 @param iMerginPixels [in]
		Ώۓ_ƗԐ̊Ԃ̋̍őlB
	 @param bDisplayRessyasenKudari [in]
		Ԃ̏sۂw肵܂B
		- true ;	//	Ԃ̏sB
		- false ;	//	Ԃ̏sȂB
	 @param bDisplayRessyasenNobori [in]
		Ԃ̏sۂw肵܂B
	 */
	CCalcCentDedDgrRessyasenOfPoint( CDcdDiagram* pCDcdDiagram , 
		IfDcdTarget* pIfDcdTarget ,
		const CdDcdPosXy& aCdDcdPosXy , int iMarginPixels ,
		bool bDisplayRessyasenKudari , bool bDisplayRessyasenNobori ) ;

// ********************************
//	CDcdDiagram::CEnumRessyasen
// ********************************
 protected:
	/**
		execute()  onCentDedDgrRessya() ̏ŌĂяo
		֐łB
	
		execute() ́A`\̈ɂ
		w_COԐx CentDedDgrRessyasen IuWFNgɁA
		̊֐Ăяo܂B
		
	 @param eRessyahoukou [in]
		ԕłB
	 @param iRessyaIdx [in]
		ԃCfNXłB
	 @param aCentDedDgrRessya [in]
		w_COԁx CentDedDgrRessya IuWFNgw肵܂B
	 @param iRessyasenIdx [in]
		ԐCfNXłB
	 @param aCentDedDgrRessyasen [in]
		w_COԐx CentDedDgrRessyasen 
		IuWFNgw肵܂B
		
	 yI[oChz
		_COԐ Ώۓ_ ʂ邩𔻒肵܂B
		ʂĂꍇ́Ȃ
		 m_eRessyahoukou , m_iRessyaIdx , m_iRessyasenIdx 
		ɐݒ肵܂B
	 */
	virtual void onCentDedDgrRessyasen( 
			ERessyahoukou eRessyahoukou ,
			int iRessyaIdx ,
			const CentDedDgrRessya* pCentDedDgrRessya ,
			int iRessyasenIdx ,
			const CentDedDgrRessyasen* pCentDedDgrRessyasen ) ;
// ********************************
//	CCalcCentDedDgrRessyasenOfPoint
// ********************************
 public:
	// ********************************
	///@name CCalcCentDedDgrRessyasenOfPoint-
	// ********************************
	///@{
	ERessyahoukou getRessyahoukou()const{	return m_eRessyahoukou ;};
	int getRessyaIdx()const{ return m_iRessyaIdx ;};
	int getRessyasenIdx()const{ return m_iRessyasenIdx ;};
	///@}

};

} //namespace ViewDiagram

#endif //CCalcCentDedDgrRessyasenOfPoint_h
