/*
OuDiaSecond Copyright (C) 2017-2018 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// CDlgOperationTableExport.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "MfcUtil\MfcUtil.h"
#include "str\CsvDocument\CdCsvDocument.h"
#include "str\CsvDocument\CconvCsvDocument.h"
#include "str\strtoint.h"
#include "str\vectorToFile.h"

#include "..\diagramedit.h"
#include "..\resource.h"
#include "CDlgOperationTableCsvExport.h"
#include "..\entDed\CdDedRessyaProperty.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace ViewOperationTable {
using namespace std ;

/////////////////////////////////////////////////////////////////////////////
// CDlgOperationTableCsvExport _CAO


CDlgOperationTableCsvExport::CDlgOperationTableCsvExport(
	const CentDedRosen* pCentDedRosen,
	const CentDedDia* pCentDedDia,
	tstring  strOperationNumber,
	int iOutStationIndex,
	bool bDisplaySecondEkiJikoku,
	bool bDisplayColonEkiJikoku,
	bool bDisplayParentSyubetsu,
	CWnd* pParent )
	: CDialog(CDlgOperationTableCsvExport::IDD, pParent)
 	, m_pCentDedRosen( pCentDedRosen )
	, m_pCentDedDia(pCentDedDia)
	, m_strOperationNumber(strOperationNumber)
	, m_bDisplaySecondEkiJikoku(bDisplaySecondEkiJikoku)
	, m_bDisplayColonEkiJikoku(bDisplayColonEkiJikoku)
	, m_bDisplayParentSyubetsu(bDisplayParentSyubetsu)
	, m_iRadio(0)
	, m_strOperationNumberInput(strOperationNumber.c_str())
	, m_iTypeOfSearch(0)
	, m_iStationIndex(iOutStationIndex)
	, m_iInOrOut(0)
	, m_iOperationOrder(0)
	, m_iIncludeOuterTerminal(1)
{
	//{{AFX_DATA_INIT(CDlgOuJikokuhyouCsvExport)
	//}}AFX_DATA_INIT
}

bool CDlgOperationTableCsvExport::CheckSatisfyConditions(
	const CentDedRessya * pCentDedRessya,
	const deque<int>& iEkiIndexGroup)
{
	if (m_iRadio == 0)//\̉^p
	{
		const CentDedRessyaTrack aCentDedRessyaTrack =
			pCentDedRessya->getCentDedRessyaTrack(pCentDedRessya->getSihatsuEki());
		if (aCentDedRessyaTrack.getOperation() == CentDedRessyaTrack::Operation_None ||
			aCentDedRessyaTrack.getOperation() == CentDedRessyaTrack::Operation_Shunt)
		{
			return false;
		}
		if (m_strOperationNumber.empty())
		{
			return false;
		}
		return aCentDedRessyaTrack.getOperationNumber() == m_strOperationNumber;
	}
	else if (m_iRadio == 1)
	{
		if (m_strOperationNumberInput.IsEmpty())
		{
			return false;
		}
		const CentDedRessyaTrack aCentDedRessyaTrack =
			pCentDedRessya->getCentDedRessyaTrack(pCentDedRessya->getSihatsuEki());
		if (aCentDedRessyaTrack.getOperation() == CentDedRessyaTrack::Operation_None ||
			aCentDedRessyaTrack.getOperation() == CentDedRessyaTrack::Operation_Shunt)
		{
			return false;
		}
		if (aCentDedRessyaTrack.getOperationNumber().empty())
		{
			return false;
		}
		tstring strOperationNumber = aCentDedRessyaTrack.getOperationNumber();
		tstring strOperationNumberInput((LPCTSTR)m_strOperationNumberInput);
		if (strOperationNumber.size() < strOperationNumberInput.size())
		{
			return false;
		}
		if (m_iTypeOfSearch == 0) //v
		{
			return strOperationNumber.find(strOperationNumberInput) != tstring::npos;
		}
		else if (m_iTypeOfSearch == 1)//Sv
		{
			return strOperationNumber == strOperationNumberInput;
		}
		else if (m_iTypeOfSearch == 2)//Ov
		{
			return strOperationNumber.compare(
				0,
				strOperationNumberInput.size(),
				strOperationNumberInput) == 0;

		}
		else if (m_iTypeOfSearch == 3)//v
		{
			return strOperationNumber.compare(
				strOperationNumber.size()-strOperationNumberInput.size(),
				strOperationNumberInput.size(),
				strOperationNumberInput) == 0;

		}
	}
	else if (m_iRadio == 2)
	{
		if (m_iInOrOut == 0)
		{
			const CentDedRessyaTrack aCentDedRessyaTrack =
				pCentDedRessya->getCentDedRessyaTrack(pCentDedRessya->getSihatsuEki());
			if (aCentDedRessyaTrack.getOperation() == CentDedRessyaTrack::Operation_None ||
				aCentDedRessyaTrack.getOperation() == CentDedRessyaTrack::Operation_Shunt)
			{
				return false;
			}
			else if (aCentDedRessyaTrack.getOperation() == CentDedRessyaTrack::Operation_Outer)
			{
				if (m_iIncludeOuterTerminal == 0)
				{
					return false;
				}
			}
			if (aCentDedRessyaTrack.getOperationNumber().empty())
			{
				return false;
			}
			int iShihatsuEkiIndex = pCentDedRessya->EkiIndexOfEkiOrder(pCentDedRessya->getSihatsuEki());
			for (int idx = 0; idx < (int)iEkiIndexGroup.size(); idx++)
			{
				if (iShihatsuEkiIndex == iEkiIndexGroup[idx])
				{
					return true;
				}
			}
		}
		else if (m_iInOrOut == 1)
		{
			const CentDedRessyaTrack aCentDedRessyaTrack =
				pCentDedRessya->getCentDedRessyaTrack(pCentDedRessya->getSyuuchakuEki());
			if (aCentDedRessyaTrack.getOperation() == CentDedRessyaTrack::Operation_None ||
				aCentDedRessyaTrack.getOperation() == CentDedRessyaTrack::Operation_Shunt)
			{
				return false;
			}
			else if (aCentDedRessyaTrack.getOperation() == CentDedRessyaTrack::Operation_Outer)
			{
				if (m_iIncludeOuterTerminal == 0)
				{
					return false;
				}
			}
			if (pCentDedRessya->getRessyaidxOut() <0)
			{
				return false;
			}
			int iSyuuchakuEkiIndex = pCentDedRessya->EkiIndexOfEkiOrder(pCentDedRessya->getSyuuchakuEki());
			for (int idx = 0; idx < (int)iEkiIndexGroup.size(); idx++)
			{
				if (iSyuuchakuEkiIndex == iEkiIndexGroup[idx])
				{
					return true;
				}
			}

		}
	}
	else if (m_iRadio == 3)
	{
		const CentDedRessyaTrack aCentDedRessyaTrack =
			pCentDedRessya->getCentDedRessyaTrack(pCentDedRessya->getSihatsuEki());
		if (aCentDedRessyaTrack.getOperation() == CentDedRessyaTrack::Operation_None ||
			aCentDedRessyaTrack.getOperation() == CentDedRessyaTrack::Operation_Shunt)
		{
			return false;
		}
		if (aCentDedRessyaTrack.getOperationNumber().empty())
		{
			return false;
		}
		return true;
	}
	return false;
}


void CDlgOperationTableCsvExport::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgOuJikokuhyouCsvExport)
	//}}AFX_DATA_MAP
	DDX_Radio(pDX, IDC_OperationExport_RADIO1, m_iRadio);
	DDX_Text(pDX, IDC_OperationExport_EDIT_KeyWord, m_strOperationNumberInput);
	DDX_CBIndex(pDX, IDC_OperationExport_COMBO_TypeOfSearch, m_iTypeOfSearch);
	DDX_CBIndex(pDX, IDC_OperationExport_COMBO_Station, m_iStationIndex);
	DDX_CBIndex(pDX, IDC_OperationExport_COMBO_OutOrIn, m_iInOrOut);
	DDX_CBIndex(pDX, IDC_OperationExport_COMBO_Order, m_iOperationOrder);
	DDX_Check(pDX, IDC_OperationExport_CHECK_IncludeOuterTerminal, m_iIncludeOuterTerminal);
}


BEGIN_MESSAGE_MAP(CDlgOperationTableCsvExport, CDialog)
	//{{AFX_MSG_MAP(CDlgOuJikokuhyouCsvExport)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgOuJikokuhyouCsvExport bZ[W nh

BOOL CDlgOperationTableCsvExport::OnInitDialog()
{
	
	// --------------------------------
	int iRv = 0 ;
	const CentDedDia* pCentDedDia = NULL ;
	if ( iRv >= 0 )
	{
		//pCentDedDia = m_pCentDedRosen->getCentDedDiaCont()->getMuPtr()->get( m_iDiaIndex ) ;
		if ( m_pCentDedDia == NULL )
		{
			iRv = -11 ;	//	m_pCentDedDia słB
		}
	}
	if 	( iRv >= 0 )
	{
		const Mu<const CentDedEki*>* pCentDedEkiCont = m_pCentDedRosen->getCentDedEkiCont()->getMuPtr();

		CComboBox*	pCComboBox = (CComboBox*)GetDlgItem(IDC_OperationExport_COMBO_Station);
		for (int idx = 0; idx < pCentDedEkiCont->size(); idx++ )
		{
			const CentDedEki* pCentDedEki = pCentDedEkiCont->get(idx);
			//tstring strEkimei = stringOf(idx) + ". ";
			//strEkimei = strEkimei + pCentDedEki->getEkimei();
			tstring strEkimei =  pCentDedEki->getEkimei();
			pCComboBox->AddString(strEkimei.c_str());
		}

		//pCComboBox->SetCurSel(m_iStationIndex);
	}

	// R{{bNX
	{
		CComboBox*	pCComboBox = (CComboBox*)GetDlgItem(IDC_OperationExport_COMBO_TypeOfSearch);

		tstring strTemp = _T("ƈv");
		pCComboBox->AddString(strTemp.c_str());
		strTemp = _T("܂");
		pCComboBox->AddString(strTemp.c_str());
		strTemp = _T("Ov");
		pCComboBox->AddString(strTemp.c_str());
		strTemp = _T("v");
		pCComboBox->AddString(strTemp.c_str());
		//ƈv;܂;Ov;v;
	}
	// R{{bNX
	{
		CComboBox*	pCComboBox = (CComboBox*)GetDlgItem(IDC_OperationExport_COMBO_OutOrIn);

		tstring strTemp = _T("o");
		pCComboBox->AddString(strTemp.c_str());
		strTemp = _T("");
		pCComboBox->AddString(strTemp.c_str());
		//o;;
	}
	// R{{bNX
	{
		CComboBox*	pCComboBox = (CComboBox*)GetDlgItem(IDC_OperationExport_COMBO_Order);

		tstring strTemp = _T("^pԍɕׂ");
		pCComboBox->AddString(strTemp.c_str());
		strTemp = _T("owɕׂ");
		pCComboBox->AddString(strTemp.c_str());
		//^pԍɕׂ;owɕׂ;
	}

	CDialog::OnInitDialog();

	// --------------------------------
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CDlgOperationTableCsvExport::OnOK()
{
	int iRv = 0 ;
	UpdateData();
	CString	strError ;
	// --------------------------------
	const CentDedDia* pCentDedDia = NULL ;
	//const Mu<const CentDedRessya*>* pCentDedRessyaContGet = NULL ;
	if ( iRv >= 0 )
	{
		//pCentDedDia = m_pCentDedRosen->getCentDedDiaCont()->getMuPtr()->get( m_iDiaIndex ) ;
		if ( m_pCentDedDia == NULL )
		{
			iRv = -11 ;	//	m_iDiaIndex słB
		}
	}
	//if 	( iRv >= 0 )
	//{
	//	pCentDedRessyaContGet = pCentDedDia->getCentDedRessyaCont( m_eRessyahoukou )->getMuPtr() ;
	//}
	//pCentDedRessyaContGet = ΏۂƂȂԃRei
	
	
	// --------------------------------
	//	͒l̎擾
	// --------------------------------
	CdDedJikoku KitenJikoku = m_pCentDedRosen->getKitenJikoku();
	deque<CdDedRessyaProperty> aRessyaPropertyContTemp2;
	deque<tstring> strOperationNumberContTemp;
	//temp2 ɓĂ͂܂^pԍ̗ԂATɕׂĂ͂B
	//e^ԓłtemp1ڂւƂɁAԒʂɕבւĂB
	//aCdDedRessyaPropertyւ́Ao掞ɈڂւB
	deque<CdDedRessyaProperty> aRessyaPropertyCont;
	deque<tstring> strOperationNumberCont;

	deque<int> iEkiIndexGroup;
	if (m_iRadio == 2)
	{
		m_pCentDedRosen->getCentDedEkiCont()->getEkiIndexBrunchLoop(
			m_iStationIndex,
			iEkiIndexGroup);
	}
	const Mu<const CentDedRessya*>* pCentDedRessyaConts[2];
	for (int iRessyahoukou = Ressyahoukou_Kudari;
		iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++)
	{
		pCentDedRessyaConts[iRessyahoukou] = m_pCentDedDia->getCentDedRessyaCont((ERessyahoukou)iRessyahoukou)->getMuPtr();
	}
	for (int iRessyahoukou = Ressyahoukou_Kudari;
		iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++)
	{
		for (int iRessyaidx = 0; iRessyaidx < pCentDedRessyaConts[iRessyahoukou]->size();
			iRessyaidx++)
		{
			//ƂoŁA^pԍvԂTB
			const CentDedRessya* pCentDedRessya = pCentDedRessyaConts[iRessyahoukou]->get(iRessyaidx);
			if (pCentDedRessya->getOperationNumber().empty())
			{
				continue;
			}
			bool bRv = CheckSatisfyConditions(pCentDedRessya, iEkiIndexGroup);
			if (!bRv)
			{
				continue;
			}

			deque<CdDedRessyaProperty> aRessyaPropertyContTemp1;
			//temp1@̉^pԍ̗Ԃ܂Ƃ߂B́Ao̗Ԃ̂ݏow
			//o悪ꍇAo掞ɏo悩̌qێ܂temp2ֈڂւB
			//̎Aڈȍ~̏óANULLɂĂڂւ

			ERessyahoukou eRessyahoukouOut;
			int iRessyaidxOut;
			if (m_iRadio == 2 && m_iInOrOut == 1)
			{
				//wɒoꍇ́ApCentDedRessya2̗Ԃ̏oԂɒu
				eRessyahoukouOut = pCentDedRessya->getRessyahoukouOut();
				iRessyaidxOut = pCentDedRessya->getRessyaidxOut();
				pCentDedRessya = pCentDedRessyaConts[eRessyahoukouOut]->get(iRessyaidxOut);
			}
			else
			{
				eRessyahoukouOut = (ERessyahoukou)iRessyahoukou;
				iRessyaidxOut = iRessyaidx;
			}
			tstring strOperationNumber = pCentDedRessya->getOperationNumber();//ȈՂɍς܂
			bool bCheck = false;
			for (int idx = 0; idx < (int)strOperationNumberContTemp.size(); idx++)
			{
				//strOperationNumberTempɁA^pԍv̂(Ɍς)AԂցB
				if (strOperationNumber == strOperationNumberContTemp[idx])
				{
					bCheck = true;
					break;
				}
			}
			if (bCheck)
			{
				continue;
			}
			//vԂ́AEindexEnwsaRessyaPropertyɊi[
			CdDedRessyaProperty aRessyaProperty(
				eRessyahoukouOut,
				iRessyaidxOut,
				pCentDedRessya->getCentDedEkiJikoku(pCentDedRessya->getSihatsuEki()).getHatsujikoku(true));
			aRessyaPropertyContTemp1.push_back(aRessyaProperty);

			//getRessyaidxNext0ɂȂ܂(ԂȂ܂)AԂ̒TJԂA
			//eԂ̕EindexsRessyaPropertyɊi[Ă
			while (pCentDedRessya->getRessyaidxNext() >= 0)
			{
				ERessyahoukou eRessyahoukouNext = pCentDedRessya->getRessyahoukouNext();
				int iRessyaidxNext = pCentDedRessya->getRessyaidxNext();
				pCentDedRessya = pCentDedRessyaConts[eRessyahoukouNext]->get(iRessyaidxNext);

				CdDedRessyaProperty aRessyaPropertyNext(
					eRessyahoukouNext,
					iRessyaidxNext);
				aRessyaPropertyContTemp1.push_back(aRessyaPropertyNext);
			}

			//pTAstrOperationNumbervʃO[v̉^pTB
			//m_iRadio == 2 ̏ꍇ́AʂёւɁAŏ̏oAŌ̓`FbNāAĂ͂܂ȂȂtemp2ɓȂ
			for (int iRessyahoukou2 = Ressyahoukou_Kudari;
				iRessyahoukou2 <= Ressyahoukou_Nobori; iRessyahoukou2++)
			{
				for (int iRessyaidx2 = 0; iRessyaidx2 < pCentDedRessyaConts[iRessyahoukou2]->size();
					iRessyaidx2++)
				{
					if (iRessyahoukou2 == (int)eRessyahoukouOut && iRessyaidx2 == iRessyaidxOut)
					{
						//ŏ̒TƓԂ͍ĒTȂ悤ɂ
						continue;
					}
					//ƂoŁA^pԍvԂTB
					const CentDedRessya* pCentDedRessya2 = pCentDedRessyaConts[iRessyahoukou2]->get(iRessyaidx2);
					if (pCentDedRessya2->getOperationNumber() != strOperationNumber)
					{
						continue;
					}
					const CentDedRessyaTrack aCentDedRessyaTrack =
						pCentDedRessya2->getCentDedRessyaTrack(pCentDedRessya2->getSihatsuEki());
					if (aCentDedRessyaTrack.getOperation() == CentDedRessyaTrack::Operation_None ||
						aCentDedRessyaTrack.getOperation() == CentDedRessyaTrack::Operation_Shunt)
					{
						continue;
					}

					//vԂ́AEindexEnwsaRessyaPropertyɊi[
					CdDedRessyaProperty aRessyaProperty(
						(ERessyahoukou)iRessyahoukou2,
						iRessyaidx2,
						pCentDedRessya2->getCentDedEkiJikoku(pCentDedRessya2->getSihatsuEki()).getHatsujikoku(true));
					aRessyaPropertyContTemp1.push_back(aRessyaProperty);

					//getRessyaidxNext0ɂȂ܂(ԂȂ܂)AԂ̒TJԂA
					//eԂ̕EindexaRessyaPropertyContTemp1Ɋi[Ă
					while (pCentDedRessya2->getRessyaidxNext() >= 0)
					{
						ERessyahoukou eRessyahoukouNext = pCentDedRessya2->getRessyahoukouNext();
						int iRessyaidxNext = pCentDedRessya2->getRessyaidxNext();
						pCentDedRessya2 = pCentDedRessyaConts[eRessyahoukouNext]->get(iRessyaidxNext);

						CdDedRessyaProperty aRessyaPropertyNext(
							eRessyahoukouNext,
							iRessyaidxNext);
						aRessyaPropertyContTemp1.push_back(aRessyaPropertyNext);
					}
				}
			}
			//m_iRadio == 2̏ꍇ̃`FbN
			if (m_iRadio == 2 && m_iInOrOut == 0)
			{
				//oww̏ꍇ́AaRessyaPropertyContTemp1[0]ł^p̏ꍇOK
				//aRessyaPropertyContTemp1[0]ȊOłꍇA̗Ԃ̎nw`FbNAww̏ꍇOK
				CdDedJikoku CurrentEarlyJikoku = aRessyaPropertyContTemp1[0].getJikoku();
				int iCurrentEarlyidx = 0;
				for (int idxt = 1; idxt < (int)aRessyaPropertyContTemp1.size(); idxt++)
				{
					if (!aRessyaPropertyContTemp1[idxt].getJikoku().isNull())
					{
						if (CurrentEarlyJikoku.compare(aRessyaPropertyContTemp1[idxt].getJikoku(), KitenJikoku) > 0)
						{
							CurrentEarlyJikoku = aRessyaPropertyContTemp1[idxt].getJikoku();
							iCurrentEarlyidx = idxt;
						}
					}
				}
				if (iCurrentEarlyidx != 0)
				{
					const CentDedRessya* pCentDedRessyaEarly =
						pCentDedRessyaConts[aRessyaPropertyContTemp1[iCurrentEarlyidx].getRessyahoukou()]
						->get(aRessyaPropertyContTemp1[iCurrentEarlyidx].getRessyaIndex());
					if (pCentDedRessyaEarly->getCentDedRessyaTrack(pCentDedRessyaEarly->getSihatsuEki()).getOperation() 
						== CentDedRessyaTrack::Operation_Outer &&
						m_iIncludeOuterTerminal == 0)
					{
						continue;
					}
					int iShihatsuEkiIndex = pCentDedRessyaEarly->EkiIndexOfEkiOrder(pCentDedRessyaEarly->getSihatsuEki());
					bool bMatchShihatsu = false;
					for (int idxe = 0; idxe < (int)iEkiIndexGroup.size(); idxe++)
					{
						if (iShihatsuEkiIndex == iEkiIndexGroup[idxe])
						{
							bMatchShihatsu = true;
						}
					}
					if (!bMatchShihatsu)
					{
						continue;
					}

				}

			}
			else if (m_iRadio == 2 && m_iInOrOut == 1)
			{
				//ww̏ꍇ́AaRessyaPropertyContTemp1[0]łx^p̏ꍇOK
				//aRessyaPropertyContTemp1[0]ȊOłxꍇẢ^p̍ŏIԂ̏Iw`FbNA悩ww̏ꍇOK
				//ɂ́A掞ł̔肪KvAȈՏƂāAo掞Ŕf
				CdDedJikoku CurrentLateJikoku = aRessyaPropertyContTemp1[0].getJikoku();
				int iCurrentLateidx = 0;
				for (int idxt = 1; idxt < (int)aRessyaPropertyContTemp1.size(); idxt++)
				{
					if (!aRessyaPropertyContTemp1[idxt].getJikoku().isNull())
					{
						if (CurrentLateJikoku.compare(aRessyaPropertyContTemp1[idxt].getJikoku(), KitenJikoku) < 0)
						{
							CurrentLateJikoku = aRessyaPropertyContTemp1[idxt].getJikoku();
							iCurrentLateidx = idxt;
						}
					}
				}
				if (iCurrentLateidx != 0)
				{
					//iCurrentLateidxq^ṕAŏIԂ߂
					const CentDedRessya* pCentDedRessyaLate =
						pCentDedRessyaConts[aRessyaPropertyContTemp1[iCurrentLateidx].getRessyahoukou()]
						->get(aRessyaPropertyContTemp1[iCurrentLateidx].getRessyaIndex());

					while (pCentDedRessyaLate->getRessyaidxNext() >= 0)
					{
						ERessyahoukou eRessyahoukouNext = pCentDedRessyaLate->getRessyahoukouNext();
						int iRessyaidxNext = pCentDedRessyaLate->getRessyaidxNext();
						pCentDedRessyaLate = pCentDedRessyaConts[eRessyahoukouNext]->get(iRessyaidxNext);
					}
					int iSyuuchakuEkiIndex = pCentDedRessyaLate->getSyuuchakuEki();
					const CentDedRessyaTrack aCentDedRessyaTrack =
						pCentDedRessyaLate->getCentDedRessyaTrack(iSyuuchakuEkiIndex);
					if (aCentDedRessyaTrack.getOperation() == CentDedRessyaTrack::Operation_None ||
						aCentDedRessyaTrack.getOperation() == CentDedRessyaTrack::Operation_Shunt)
					{
						continue;
					}
					else if (aCentDedRessyaTrack.getOperation() == CentDedRessyaTrack::Operation_Outer &&
						m_iIncludeOuterTerminal == 0)
					{
						continue;
					}
					bool bMatchSyuuchaku = false;
					for (int idxe = 0; idxe < (int)iEkiIndexGroup.size(); idxe++)
					{
						if (iSyuuchakuEkiIndex == iEkiIndexGroup[idxe])
						{
							bMatchSyuuchaku = true;
						}
					}
					if (!bMatchSyuuchaku)
					{
						continue;
					}
				}
			}
			//aRessyaPropertyContTemp1ɕ̉^p܂܂Ăꍇ́AjikokuaRessyaPropertyContTemp2Ɏ߂Ă
			bool bFirstOut = true;
			strOperationNumberContTemp.push_back(strOperationNumber);
			do {
				int iCurrentEarlyidx = 0;
				CdDedJikoku CurrentEarlyJikoku = aRessyaPropertyContTemp1[0].getJikoku();
				for (int idx = 1; idx < (int)aRessyaPropertyContTemp1.size(); idx++)
				{
					if (aRessyaPropertyContTemp1[idx].getJikoku().isNull())
					{
						continue;
					}
					if (CurrentEarlyJikoku.compare(aRessyaPropertyContTemp1[idx].getJikoku(), KitenJikoku) > 0)
					{
						CurrentEarlyJikoku = aRessyaPropertyContTemp1[idx].getJikoku();
						iCurrentEarlyidx = idx;
					}
				}
				if (!bFirstOut)
				{
					aRessyaPropertyContTemp1[iCurrentEarlyidx].setJikoku(CdDedJikoku());
				}
				int idxs = iCurrentEarlyidx;
				do {
					aRessyaPropertyContTemp2.push_back(aRessyaPropertyContTemp1[idxs]);
					idxs++;
					if (idxs >= (int)aRessyaPropertyContTemp1.size())
					{
						break;
					}
				} while (aRessyaPropertyContTemp1[idxs].getJikoku().isNull());
				aRessyaPropertyContTemp1.erase(aRessyaPropertyContTemp1.begin() + iCurrentEarlyidx, aRessyaPropertyContTemp1.begin() + idxs);
				if (bFirstOut)
				{
					bFirstOut = false;
				}
			} while ((int)aRessyaPropertyContTemp1.size() > 0);

		}
	}
	if ((int)aRessyaPropertyContTemp2.size() == 0)
	{
		return;
	}
	//aRessyaPropertyContTemp2Ɏ߂ꂽ^pȀԂɕёւBʂ́A^pJn
	if (m_iOperationOrder == 0) //^pԍ~
	{
		do {

			int iCurrentEarlyidx = 0;
			int iCurrentEarlyONIndex = 0;
			int OperationNumberidx = 0;
			tstring CurrentTopOperationNumber = strOperationNumberContTemp[0];
			//CdDedJikoku CurrentEarlyJikoku = aRessyaPropertyContTemp2[0].getJikoku();
			for (int idx = 1; idx < (int)aRessyaPropertyContTemp2.size(); idx++)
			{
				if (aRessyaPropertyContTemp2[idx].getJikoku().isNull())
				{
					continue;
				}
				OperationNumberidx++;
				if (CurrentTopOperationNumber >strOperationNumberContTemp[OperationNumberidx])
				{
					CurrentTopOperationNumber = strOperationNumberContTemp[OperationNumberidx];
					//CurrentEarlyJikoku = aRessyaPropertyContTemp2[idx].getJikoku();
					iCurrentEarlyidx = idx;
					iCurrentEarlyONIndex = OperationNumberidx;
				}
			}
			strOperationNumberCont.push_back(strOperationNumberContTemp[iCurrentEarlyONIndex]);
			int idxs = iCurrentEarlyidx;
			do {
				aRessyaPropertyCont.push_back(aRessyaPropertyContTemp2[idxs]);
				idxs++;
				if (idxs >= (int)aRessyaPropertyContTemp2.size())
				{
					break;
				}
			} while (aRessyaPropertyContTemp2[idxs].getJikoku().isNull());
			aRessyaPropertyContTemp2.erase(aRessyaPropertyContTemp2.begin() + iCurrentEarlyidx, aRessyaPropertyContTemp2.begin() + idxs);
			strOperationNumberContTemp.erase(strOperationNumberContTemp.begin() + iCurrentEarlyONIndex);

		} while ((int)aRessyaPropertyContTemp2.size() > 0);
	}
	else//ow
	{
		do {
			int iCurrentEarlyidx = 0;
			int iCurrentEarlyONIndex = 0;
			int OperationNumberidx = 0;
			CdDedJikoku CurrentEarlyJikoku = aRessyaPropertyContTemp2[0].getJikoku();
			for (int idx = 1; idx < (int)aRessyaPropertyContTemp2.size(); idx++)
			{
				if (aRessyaPropertyContTemp2[idx].getJikoku().isNull())
				{
					continue;
				}
				OperationNumberidx++;
				if (CurrentEarlyJikoku.compare(aRessyaPropertyContTemp2[idx].getJikoku(), KitenJikoku) > 0)
				{
					CurrentEarlyJikoku = aRessyaPropertyContTemp2[idx].getJikoku();
					iCurrentEarlyidx = idx;
					iCurrentEarlyONIndex = OperationNumberidx;
				}
			}
			strOperationNumberCont.push_back(strOperationNumberContTemp[iCurrentEarlyONIndex]);
			int idxs = iCurrentEarlyidx;
			do {
				aRessyaPropertyCont.push_back(aRessyaPropertyContTemp2[idxs]);
				idxs++;
				if (idxs >= (int)aRessyaPropertyContTemp2.size())
				{
					break;
				}
			} while (aRessyaPropertyContTemp2[idxs].getJikoku().isNull());
			aRessyaPropertyContTemp2.erase(aRessyaPropertyContTemp2.begin() + iCurrentEarlyidx, aRessyaPropertyContTemp2.begin() + idxs);
			strOperationNumberContTemp.erase(strOperationNumberContTemp.begin() + iCurrentEarlyONIndex);
		} while ((int)aRessyaPropertyContTemp2.size() > 0);
	}

	// --------------------------------
	//	o̓t@C͒l̎擾
	// --------------------------------
	if ( iRv >= 0 )
	{
		CFileDialog aDlg( 
			FALSE , 
			_T( "csv" ) , 
			m_strCsvFilename , 
			OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
			getCDiagramEditApp()->getCFileDialogFilterCsv(), 
			this );
		if ( aDlg.DoModal() != IDOK )
		{
			iRv = -2 ;	//	Cancel܂B
		}
		else
		{
			m_strCsvFilename = aDlg.GetPathName() ;
		}
	}
	//m_strCsvFilename = w肳ꂽCSVt@C

	// --------------------------------
	//	CSVt@C̏o
	// --------------------------------
	CWaitCursor aCursor ;
	if ( iRv >= 0 )
	{
		CconvOperationTableCsv	aConv( getCDiagramEditApp()->createCconvOperationTableCsv()) ;
		CdCsvDocument	aCdCsvDocument ;
		int iResult = aConv.encode(
			*m_pCentDedRosen , 
			*m_pCentDedDia , 
			aRessyaPropertyCont,
			strOperationNumberCont,
			m_bDisplaySecondEkiJikoku,
			m_bDisplayColonEkiJikoku,
			m_bDisplayParentSyubetsu,
			&aCdCsvDocument ) ;
		//iResult = 
		//	-1 ; // iDiaIndex słB
		//	-2 ; // iRessyaIndex słB
		//	-3 ; // iRessyaCount słB 
		if ( iResult < 0 )
		{
			GetDlgItemText( IDC_TEXT_ENCODE_ERROR , strError ) ;
			//strError="CSVւ̕ϊɎs܂B"

			strError.Format( _T( "%s(%d)" ) , CString( strError ), iResult ) ; 
			iRv = iResult - 10 ;
			//	-11 ; // iDiaIndex słB
			//	-12 ; // iRessyaIndex słB
			//	-13 ; // iRessyaCount słB 
		}
		else
		{
			tstring strCsvDocument ;
			CConvCsvDocument	aCConvCsvDocument ;
			strCsvDocument = aCConvCsvDocument.encode( &aCdCsvDocument ) ;
			int iResult = stringToFile( strCsvDocument , (LPCTSTR)m_strCsvFilename ) ;
			if ( iResult < 0 )
			{
				GetDlgItemText( IDC_TEXT_FILE_SAVE_FAILED , strError ) ;
				//strError="t@Cւ̕ۑɎs܂B"

				iRv = -21 ; // t@Cւ̕ۑɎs܂B

			}
		}
	}
	//// --------------------------------
	////	Ԃ͈̔͂w肵CSVփGNX|[g
	////	ꍇ́A̗Ԕ͈͂Rg[ɐݒ
	//// --------------------------------
	//if ( iRv >= 0 )
	//{
	//	if ( iRessyaIndex + iRessyaCount <  pCentDedRessyaContGet->size() )
	//	{
	//		iRessyaIndex += iRessyaCount ;
	//		SetDlgItemText( IDC_EDIT_RESSYAINDEX , stringOf( iRessyaIndex + 1 ).c_str() ) ;
	//		SetDlgItemText( IDC_EDIT_RESSYACOUNT , stringOf( iRessyaCount ).c_str() ) ;
	//	}
	//}
	//// --------------------------------

	//if ( iRv < 0 )
	//{
	//	if ( !strError.IsEmpty() )
	//	{
	//		MessageBox( strError , NULL , MB_ICONEXCLAMATION ) ;
	//	}
	//}
	//CDialog::OnOK();
}

} //namespace ViewJikokuhyou
