/*
OuDiaSecond Copyright (C) 2017-2018 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CDedRessyaSoater_OperationNumber.cpp
// $Id: CDedRessyaSoater_OperationNumber.cpp 
// ****************************************************************
*/
/** @file */
#include "stdafx.h"
#include <algorithm>

#include "str\strtoint.h"
#include "NsMu\CMup_vector.h"
#include "NsMu\CaMui.h"
#include "CDedRessyaSoater_OperationNumber.h"

namespace entDed{

// ****************************************************************
//	CdRessyaForSort_OperationNumber
// ****************************************************************
	/**
		Mu<CentDedRessyaCont*> ̗(Index)A
		^pԍŔr֐IuWFNgłB
	*/
	class CentDedRessyaIdxCompare_OperationNumber
	{
		// ********************************
		///@name ֘A
		// ********************************
		///@{
		/**
			ԃReiB
		*/
		const Mu<const CentDedRessya*>* m_pCentDedRessyaCont  ; 

		/**
		_CON_w肵ĂB
		̊֐́A\[gɁA̒lł
		݂Ȃ܂B
		(F̎5:00w肳ꂽꍇ́A5:00<23:59<0:00<4:59 ƂĔrs܂)
		*/
		CdDedJikoku m_jikokuKitenJikoku;
		///@}
	public:
		CentDedRessyaIdxCompare_OperationNumber(
			const Mu<const CentDedRessya*>* pCentDedRessyaCont,
			const CdDedJikoku& jikokuKitenJikoku)
			: m_pCentDedRessyaCont( pCentDedRessyaCont )
			, m_jikokuKitenJikoku(jikokuKitenJikoku)
		{
		};
		/**
		@return
			*m_pCentDedRessyaCont->get(idxleft ) < *m_pCentDedRessyaCont->get(idxright ) 
			Ȃ^łB

		@note
		  r́A
			- NULLłȂ̂NULL̂̂Ƃł́ANULLłȂ̂B
			- ^pԍőB󔒂̂̂͌B
			- nwB
			- Index̏B
		*/
		bool operator()( 
			int idxleft , 
			int idxright )
		{
			const CentDedRessya& left  = *m_pCentDedRessyaCont->get(idxleft ) ;
			const CentDedRessya& right = *m_pCentDedRessyaCont->get(idxright ) ;
			// --------------------------------
			//	ЕNULL̏ꍇ̔r
			//	- NULLłȂ̂NULL̂̂Ƃł́ANULLłȂ̂B
			// --------------------------------
			if ( !left.isNull() && right.isNull() )
			{
				//	left͔NULLŁArightNULL
				return true ;
			}
			else if ( left.isNull() && !right.isNull() )
			{
				//	leftNULLŁAright͔NULL
				return false ;
			}

			// --------------------------------
			//	Е̉^pԍ󔒂̏ꍇ̔r
			//	- 󔒂łȂ̂Ƌ󔒂̂̂Ƃł́A󔒂łȂ̂B
			// --------------------------------
			if (!left.getOperationNumber().empty() && right.getOperationNumber().empty())
			{
				//	left͔󔒂ŁAright͋
				return true;
			}
			else if (left.getOperationNumber().empty() && !right.getOperationNumber().empty())
			{
				//	left͋󔒂ŁAright͔
				return false;
			}

			// --------------------------------
			//	- ^pԍőB
			// --------------------------------
			if ( left.getOperationNumber() < right.getOperationNumber() )
			{
				return true ;
			}
			else if ( left.getOperationNumber() > right.getOperationNumber() )
			{
				return false ;
			}

			// --------------------------------
			//	- nwB
			// --------------------------------
			CdDedJikoku aJikokuLeft = left.getCentDedEkiJikoku(left.getSihatsuEki()).getHatsujikoku(true);
			CdDedJikoku aJikokuRight = right.getCentDedEkiJikoku(right.getSihatsuEki()).getHatsujikoku(true);
			if (!aJikokuLeft.isNull() && aJikokuRight.isNull())
			{
				//	aJikokuLeft͔NULLŁAaJikokuRightNULL
				return true;
			}
			else if (aJikokuLeft.isNull() && !aJikokuRight.isNull())
			{
				//	aJikokuLeftNULLŁAaJikokuRight͔NULL
				return false;
			}

			if (aJikokuLeft.compare(aJikokuRight, m_jikokuKitenJikoku) < 0)
			{
				//	aJikokuLeft̕aJikokuRightO
				return true;
			}
			else if (aJikokuLeft.compare(aJikokuRight, m_jikokuKitenJikoku) > 0)
			{
				//	aJikokuRight̕aJikokuLeftO
				return false;
			}

			// --------------------------------
			//	- Index̏قB
			// --------------------------------
			if ( idxleft < idxright )
			{
				return true ;
			}
			return false ;
		}
	};



// ****************************************************************
//	CDedRessyaSoater_OperationNumber
// ****************************************************************
	// ********************************
	//@name W
	// ********************************

	// ********************************
	//@name 
	// ********************************
	// --------------------------------
	//@name ֐
	// --------------------------------
	// ********************************
	//	RXgN^
	// ********************************
CDedRessyaSoater_OperationNumber::CDedRessyaSoater_OperationNumber(
	const CdDedJikoku&  jikokuKitenJikoku)
	: m_jikokuKitenJikoku(jikokuKitenJikoku)
{
}

CDedRessyaSoater_OperationNumber::~CDedRessyaSoater_OperationNumber()
{
}
	
	// --------------------------------
	//@name sort ̉֐(templatep^[)
	// --------------------------------
void CDedRessyaSoater_OperationNumber::sortRessyaIndex(
		const CentDedRessyaCont* pRessyaCont , 
		Mui<int>* muRessyaIndexOrder , 
		IfProgress* pIfProgress ) 
{
	bool bAbort = false ;

	const Mu<const CentDedRessya*>* pCentDedRessyaCont = pRessyaCont->getMuPtr() ; 
	//pCentDedRessyaCont = CentDedRessyaCont IuWFNgւ̃|C^ێ
	//	ReiłB

	// --------------------------------
	//	\[gpw̃Rei̓eɏ]A
	//	CfNX\[g
	// --------------------------------
	{
		//	\[g std::sort g߁A
		//	CfNXRei std::vector ɈURs[
		CMup_vector<int>	contiRessyaIndexOrder ;
		CaMui<int>( &contiRessyaIndexOrder ).insert( muRessyaIndexOrder , 0 , INT_MAX ) ;

		//	std::vector ̓e\[g
		std::sort( 
			contiRessyaIndexOrder.getAdaptee()->begin() ,
			contiRessyaIndexOrder.getAdaptee()->end() ,
			CentDedRessyaIdxCompare_OperationNumber( 
					pCentDedRessyaCont ,
					m_jikokuKitenJikoku) ) ;


		//	\[gʂÃReiɖ߂
		muRessyaIndexOrder->erase( 0 , INT_MAX ) ;
		CaMui<int>( muRessyaIndexOrder ).insert( &contiRessyaIndexOrder , 0 , INT_MAX ) ;
	}

}

} //namespace entDed


