/*
OuDiaSecond Copyright (C) 2017-2018 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedDiaCont.cpp
// ****************************************************************
*/
/** @file */
#include "stdafx.h"
#include "CentDedRosen.h"
#include "CentDedDiaCont.h"
#include "NsMu/CaMui.h"
using namespace std ;

#ifdef _MFC_VER 
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#endif


namespace entDed{

// ****************************************************************
//	CentDedDiaCont
// ****************************************************************

// ********************************
//	RXgN^
// ********************************


// ********************************
//@name Mui
// ********************************

int CentDedDiaCont::insert( const CentDedDia& element , int iIndex ) 
{
	int iRv = 0 ;
	if ( iRv >= 0 ){
		if ( element.getName().empty() ){
			iRv = -2 ;	//	element ɂ̓_Cw肳Ă܂B
		}
	}
	if ( iRv >= 0 ){
		int iIndexFind = findCentDedDiaByName( element.getName() ) ;
		if ( iIndexFind >= 0 ){
			iRv = -3 ;	//	łɓ̃_C݂܂B
		}
	}
	if ( iRv >= 0 ){
		iRv = super::insert( element , iIndex ) ;
	}
	return iRv ;
}
int CentDedDiaCont::set( const CentDedDia& element , int iIndex ) 
{
	if ( iIndex == INT_MAX )
	{
		iIndex = size() - 1 ;
	}
	int iRv = setable( element , iIndex ) ;
	if ( iRv >= 0 ){
		iRv = super::insert( element , iIndex ) ;
	}
	return iRv ;
};
// ********************************
//	CentDedDiaCont
// ********************************
	// ********************************
	//@name CentDedDiaCont-
	// ********************************
int CentDedDiaCont::setable(  const CentDedDia& element , int iIndex )const 
{
	int idx ;
	if ( element.getName().length() == 0 ) 
	{
		return -2 ;	//	element ɂ̓_Cw肳Ă܂B
	}
	for ( idx = 0 ; idx < size() ; idx ++ )
	{
		const CentDedDia* pDiaExist = getMuPtr()->get( idx ) ; 
		//	قȂCfNXɁAÕ_C΁AG[ł
		if ( idx != iIndex && element.getName() == pDiaExist->getName() )
		{
			return -3 ;	//	łɓ̃_C݂܂B
		}
	}
	return 0 ;
}

int  CentDedDiaCont::getIndex( const CentDedDia* element )const 
{
	const Mu<const CentDedDia*>* pMu = getMuPtr() ;
	for ( int idx = 0 ; idx < pMu->size() ; idx ++ ){
		if ( pMu->get( idx ) == element ){	return idx ;}
	}
	return -1 ;

}

void CentDedDiaCont::adjust() 
{
	Mu<CentDedDia*>* pMu = getMuPtr() ;
	for ( int idx = 0 ; idx < pMu->size() ; idx ++ ){
		pMu->get( idx )->adjust() ;
	}
}




int CentDedDiaCont::findCentDedDiaByName( const tstring& strName )const 
{
	const Mu< const CentDedDia* >* pIfContGet = getMuPtr() ;
	int iRv = -1 ;
	for ( int idx = 0 ; iRv == -1 && idx < pIfContGet->size() ; idx ++ ){
		if ( strName == pIfContGet->get( idx )->getName() ){
			iRv = idx ;
		}
	}
	return ( iRv ) ;
}
	// ********************************
	//@name CentDedDiaCont- w̑
	// ********************************

int CentDedDiaCont::isExistRessyaOfRessyasyubetsu( 
		int iRessyasyubetsuIndex ,
		int* piDiaIndex ,
		ERessyahoukou* peRessyahoukou ,
		int* piRessyaIndex ) const
{
	int iRv = 0 ;
	int iDiaIndexFound = -1 ;
	ERessyahoukou eRessyahoukouFound = Ressyahoukou_Kudari ;
	int iRessyaIndexFound = -1 ;
	// --------------------------------
	if ( iRv >= 0 ){

		const Mu<const CentDedDia*>* pIfContGet = getMuPtr() ; 
		int iDiaIndex ;
		for ( iDiaIndex = 0 ; iRv == 0 && iDiaIndex < pIfContGet->size() ; iDiaIndex ++ ){
			const CentDedDia*	pCentDedDia = pIfContGet->get( iDiaIndex ) ;
			iRv = pCentDedDia->isExistRessyaOfRessyasyubetsu(  
					iRessyasyubetsuIndex , 
					&eRessyahoukouFound , 
					&iRessyaIndexFound )  ;
			if ( iRv == 1 ){
				iDiaIndexFound = iDiaIndex ;
			}
		}
	}
	// --------------------------------
	if ( piDiaIndex != NULL ){
		*piDiaIndex = iDiaIndexFound ;
	}
	if ( peRessyahoukou != NULL ){
		*peRessyahoukou = eRessyahoukouFound ;
	}
	if ( piRessyaIndex != NULL ){
		*piRessyaIndex = iRessyaIndexFound ;
	}

	return ( iRv ) ;
	
}
int CentDedDiaCont::isExistRessyaOfEkiTrack2(
	int iEkiIndex,
	int iEkiTrack2Index,
	int* piDiaIndex,
	ERessyahoukou* peRessyahoukou,
	int* piRessyaIndex) const
{
	int iRv = 0;
	int iDiaIndexFound = -1;
	ERessyahoukou eRessyahoukouFound = Ressyahoukou_Kudari;
	int iRessyaIndexFound = -1;
	// --------------------------------
	if (iRv >= 0) {

		const Mu<const CentDedDia*>* pIfContGet = getMuPtr();
		int iDiaIndex;
		for (iDiaIndex = 0; iRv == 0 && iDiaIndex < pIfContGet->size(); iDiaIndex++) {
			const CentDedDia*	pCentDedDia = pIfContGet->get(iDiaIndex);
			iRv = pCentDedDia->isExistRessyaOfEkiTrack2(
				iEkiIndex,
				iEkiTrack2Index,
				&eRessyahoukouFound,
				&iRessyaIndexFound);
			if (iRv == 1) {
				iDiaIndexFound = iDiaIndex;
			}
		}
	}
	// --------------------------------
	if (piDiaIndex != NULL) {
		*piDiaIndex = iDiaIndexFound;
	}
	if (peRessyahoukou != NULL) {
		*peRessyahoukou = eRessyahoukouFound;
	}
	if (piRessyaIndex != NULL) {
		*piRessyaIndex = iRessyaIndexFound;
	}

	return (iRv);

}
int CentDedDiaCont::isExistRessyaOfOuterTerminal(
	int iEkiIndex,
	int iOuterTerminalIndex,
	int* piDiaIndex,
	ERessyahoukou* peRessyahoukou,
	int* piRessyaIndex) const
{
	int iRv = 0;
	int iDiaIndexFound = -1;
	ERessyahoukou eRessyahoukouFound = Ressyahoukou_Kudari;
	int iRessyaIndexFound = -1;
	// --------------------------------
	if (iRv >= 0) {

		const Mu<const CentDedDia*>* pIfContGet = getMuPtr();
		int iDiaIndex;
		for (iDiaIndex = 0; iRv == 0 && iDiaIndex < pIfContGet->size(); iDiaIndex++) {
			const CentDedDia*	pCentDedDia = pIfContGet->get(iDiaIndex);
			iRv = pCentDedDia->isExistRessyaOfOuterTerminal(
				iEkiIndex,
				iOuterTerminalIndex,
				&eRessyahoukouFound,
				&iRessyaIndexFound);
			if (iRv == 1) {
				iDiaIndexFound = iDiaIndex;
			}
		}
	}
	// --------------------------------
	if (piDiaIndex != NULL) {
		*piDiaIndex = iDiaIndexFound;
	}
	if (peRessyahoukou != NULL) {
		*peRessyahoukou = eRessyahoukouFound;
	}
	if (piRessyaIndex != NULL) {
		*piRessyaIndex = iRessyaIndexFound;
	}

	return (iRv);

}
	// ********************************
	//@name CentDedRosen-qIuWFNg̑̒ʒm
	// ********************************
void CentDedDiaCont::onEkiInsert( int iEkiIndex )
{
	Mu<CentDedDia*>* muDia = getMuPtr() ;
	for ( int i = 0 ; i < muDia->size() ; i ++ )
	{
		CentDedDia* pDia = muDia->get( i ) ; 
		pDia->onEkiInsert( iEkiIndex ) ;
	}
}

void CentDedDiaCont::onEkiErase( int iEkiIndex  )
{
	Mu<CentDedDia*>* muDia = getMuPtr() ;
	for ( int i = 0 ; i < muDia->size() ; i ++ )
	{
		CentDedDia* pDia = muDia->get( i ) ; 
		pDia->onEkiErase( iEkiIndex ) ;
	}
}
void CentDedDiaCont::onEkiTrack2Insert(int iEkiIndex, int iEkiTrack2Index)
{
	Mu<CentDedDia*>* muDia = getMuPtr();
	for (int i = 0; i < muDia->size(); i++)
	{
		CentDedDia* pDia = muDia->get(i);
		pDia->onEkiTrack2Insert(iEkiIndex, iEkiTrack2Index);
	}
}
void CentDedDiaCont::onEkiTrack2Erase(int iEkiIndex, int iEkiTrack2Index)
{
	Mu<CentDedDia*>* muDia = getMuPtr();
	for (int i = 0; i < muDia->size(); i++)
	{
		CentDedDia* pDia = muDia->get(i);
		pDia->onEkiTrack2Erase(iEkiIndex, iEkiTrack2Index);
	}
}
void CentDedDiaCont::onRessyasyubetsuInsert( int iRessyasyubetsuIndex )
{
	Mu<CentDedDia*>* muDia = getMuPtr() ;
	for ( int i = 0 ; i < muDia->size() ; i ++ )
	{
		CentDedDia* pDia = muDia->get( i ) ; 
		pDia->onRessyasyubetsuInsert( iRessyasyubetsuIndex ) ;
	}
}
void CentDedDiaCont::onRessyasyubetsuErase( int iRessyasyubetsuIndex )
{
	Mu<CentDedDia*>* muDia = getMuPtr() ;
	for ( int i = 0 ; i < muDia->size() ; i ++ )
	{
		CentDedDia* pDia = muDia->get( i ) ; 
		pDia->onRessyasyubetsuErase( iRessyasyubetsuIndex ) ;
	}
}

void CentDedDiaCont::adjustBrunchLoopByBrunchEdit(
	int iEkiIndex, bool bOriginSide, 
	deque<int> &iEkiIndexBrunchOriginSide,
	deque<int> &iEkiIndexLoop, deque<int> &iEkiIndexBrunchTerminalSide)
{
	Mu<CentDedDia*>* muDia = getMuPtr();
	for (int i = 0; i < muDia->size(); i++)
	{
		CentDedDia* pDia = muDia->get(i);
		pDia->adjustBrunchLoopByBrunchEdit(
			iEkiIndex, bOriginSide,
			iEkiIndexBrunchOriginSide,
			iEkiIndexLoop, iEkiIndexBrunchTerminalSide);
	}
}

void CentDedDiaCont::adjustBrunchLoopByLoopEdit(
	int iEkiIndex, int iPosition,
	deque<int> &iEkiIndexBrunchOriginSide, deque<int> &iEkiIndexLoop,
	deque<int> &iEkiIndexBrunchTerminalSide)
{
	Mu<CentDedDia*>* muDia = getMuPtr();
	for (int i = 0; i < muDia->size(); i++)
	{
		CentDedDia* pDia = muDia->get(i);
		pDia->adjustBrunchLoopByLoopEdit(
			iEkiIndex, iPosition,
			iEkiIndexBrunchOriginSide, iEkiIndexLoop,
			iEkiIndexBrunchTerminalSide);
	}
}

void CentDedDiaCont::adjustBrunchLoopEkiTrack2(
	const deque<int>& iEkiIndexBrunchLoop, 
	const std::vector<int>& iEkiTrack2Map)
{
	Mu<CentDedDia*>* muDia = getMuPtr();
	for (int i = 0; i < muDia->size(); i++)
	{
		CentDedDia* pDia = muDia->get(i);
		pDia->adjustBrunchLoopEkiTrack2(
			iEkiIndexBrunchLoop,
			iEkiTrack2Map);
	}
}

void CentDedDiaCont::adjustBrunchLoopOuterTerminal(
	const int iEkiIndex,
	const std::vector<int>& iOuterTerminalEkimeiMap)
{
	Mu<CentDedDia*>* muDia = getMuPtr();
	for (int i = 0; i < muDia->size(); i++)
	{
		CentDedDia* pDia = muDia->get(i);
		pDia->adjustBrunchLoopOuterTerminal(
			iEkiIndex,
			iOuterTerminalEkimeiMap);
	}
}


	///@}
} //namespace entDed

