/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CVerticalTextElementBuilder.cpp
// ****************************************************************
*/
#include "DcDraw\CVerticalTextElementBuilder.h"
#include "LogMsg\logmsg.h"
#include "Str\Str.h"

namespace DcDrawLib{
namespace DcDraw{
	using namespace OuLib::Str;
	using namespace std ;



bool CVerticalTextElementBuilder::isSpace( const string& aStr )
{
	const char* const kyoukai[] = {
		" " , "@" ,
	};
	for ( int idx = 0 ; idx < sizeof(kyoukai) / sizeof(kyoukai[0]) ; idx ++ ){
		if ( aStr == kyoukai[idx] ) {
			return true ;
		}
	}
	return ( false ) ;
}

bool CVerticalTextElementBuilder::isDelimiter( const string& aStr )
{
	const char* const kyoukai[] = {
		"," , "C" ,
		"." , "D" ,
		      "B" , 
		      "A" , 
	};
	for ( int idx = 0 ; idx < sizeof(kyoukai) / sizeof(kyoukai[0]) ; idx ++ ){
		if ( aStr == kyoukai[idx] ) {
			return true ;
		}
	}
	return ( false ) ;
}


	// ********************************
	//@name CVerticalTextElementBuilder-
	// ********************************
void CVerticalTextElementBuilder::scan( 
		const std::string& aStr , 
		Mui<CVerticalTextElement>* muCVerticalTextElement ,
		bool bTwoDegiLateral  ) 
{
	int iRv = 0 ;

	//	̃Rei܂ŕێĂvf͔j܂B
	muCVerticalTextElement->erase( 0 , INT_MAX ) ;

	CStrCharSizeMb	aCStrCharSizeMb( aStr ) ;
	for ( int bidx = 0 ; 
			bidx < aCStrCharSizeMb.ByteLength() ; 
			bidx = aCStrCharSizeMb.BidxNextChar( bidx ) )
	{
		LogMsgL( 3 , _T("CDcdTextboxV3::StringToMojiretsuyouso")
			_T("bidx=%d CsizeOfBidx=%d") , bidx , aCStrCharSizeMb.CsizeOfBidx( bidx ) ) ;

		string strChar = aStr.substr( bidx , 
			aCStrCharSizeMb.CsizeOfBidx( bidx ) ) ;
		CVerticalTextElement	aElementPrev ;
		if ( muCVerticalTextElement->size() > 0 )
		{
			aElementPrev = muCVerticalTextElement->get( INT_MAX ) ;
		}
		//strChar = ̕B
		//aElementPrev = O̕vf

		if ( aCStrCharSizeMb.CsizeOfBidx( bidx ) == 1 )
		{
			//	͂̕PoCg

			string strCharPrev ;
			if ( !aElementPrev.isNull() ){
				strCharPrev = aElementPrev.getString().substr( 
					aElementPrev.getString().size() - 1 , 1 ) ;
			}
			//strCharPrev = O̕vf̖̕

			if ( !isSpace( strChar ) && 
				!aElementPrev.isNull() && 
				aElementPrev.getType() == aElementPrev.V_HANKAKU &&
				!isDelimiter( strCharPrev ) && !isSpace( strCharPrev ) )
			{
				//	͋̕󔒈ȊÔPoCgŁA
				//	( O̕vf V_HANKAKU A
				//	AO̕vf؂蕶󔒂ŏIĂȂ
				//	) 
				//	ꍇ́AO̕vfɕǉ܂B
				//
				aElementPrev.setString( aElementPrev.getString() + strChar );
				muCVerticalTextElement->set( aElementPrev , INT_MAX ) ;
			}
			else
			{
				//	vfǉ܂B
				CVerticalTextElement	aElement( strChar , CVerticalTextElement::V_HANKAKU ) ;

				muCVerticalTextElement->insert( aElement ) ;
			}
		}
		else if ( aCStrCharSizeMb.CsizeOfBidx( bidx ) == 2 )
		{
			//	͂̕QoCgłꍇ́Avfǉ܂B

			//	͂̕QoCg̋؂蕶ŁA
			//	( O̕vf V_ZENKAKU 
			//	) 
			//	ꍇ́AO̕vfɕǉ܂B
			//
			if ( isDelimiter( strChar ) && 
				!aElementPrev.isNull() && 
				aElementPrev.getType() == CVerticalTextElement::V_ZENKAKU )
			{
				aElementPrev.setString( aElementPrev.getString() + strChar );
				muCVerticalTextElement->set( aElementPrev , INT_MAX ) ;

			}
			else
			{
				//	Vvfǉ܂B
				CVerticalTextElement aElement( strChar , CVerticalTextElement::V_ZENKAKU ) ;
				muCVerticalTextElement->insert( aElement ) ;

			}
		}

	}
	//muCVerticalTextElement =  V_ZENKAKU  V_HANKAKU ̂Q
	//	vfɕ܂B
	//	V_ZENKAKU ́AƂđSpPłB
	//	AA[Sp][Sp؂蕶]
	//	́A[Sp+Sp؂蕶]̂P̗vfɂȂĂ܂B
	//	V_HANKAKU ́AApP̗vfƂ܂B

	// --------------------------------
	//	2ȉ̔pɂ
	// --------------------------------
	if ( bTwoDegiLateral  )
	{
		// --------------------------------	
		int idxMojiretsuyouso ;
		for ( idxMojiretsuyouso = 0 ; 
				idxMojiretsuyouso < muCVerticalTextElement->size() ;
				idxMojiretsuyouso ++ )
		{
			//	̕vfppPQ 
			//	AND 
			//	( 
			//		( O̕vf݂Ȃ)
			//		OR
			//		( O̕vfi󔒈ȊO̔p̗vfjłȂ)
			//	) 
			//	
			//	̏ꍇ́Aɔpp1E2ŕׂ܂B
			CVerticalTextElement aElementPrev ;
			if ( idxMojiretsuyouso > 0 )
			{
				aElementPrev = muCVerticalTextElement->get( idxMojiretsuyouso - 1 ) ;
			}
			CVerticalTextElement aElement = muCVerticalTextElement->get( idxMojiretsuyouso ) ;
			string strCurr = aElement.getString() ;
			if ( aElement.getType() == CVerticalTextElement::V_HANKAKU )
			{
				if ( 
					( strCurr.size() == 1 && isdigit( (unsigned char)strCurr[0] ) ) || 
					( strCurr.size() == 2 && isdigit( (unsigned char)strCurr[0] ) && isdigit( (unsigned char)strCurr[1] ) ) 
				){

					if ( aElementPrev.isNull() || 
						!(  
							aElementPrev.getType() == CVerticalTextElement::V_HANKAKU && 
							!isSpace( aElementPrev.getString() ) 
						) 
					){
						aElement.setType( CVerticalTextElement::H_HANKAKU ) ;
						muCVerticalTextElement->set( aElement , idxMojiretsuyouso ) ;
					}
				}
					
			}

		}
	}	

};

} //namespace DcDraw
} //namespace DcDrawLib





