/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	$Id: CXDcdGrid.cpp 387 2016-11-20 08:43:33Z okm $
// ****************************************************************
*/
/** @file */
#include "CWndDcdGrid.h"
#include "DcDraw\CDcdTargetGetDC.h"
#include "WinUtil\CconvWinUser.h"
#include "LogMsg\LogMsg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace DcDrawLib{
namespace DcdGrid{
namespace WndDcdGrid3{

// ----------------------------------------------------------------
//	WndDcdGrid3::CXDcdGrid
// ----------------------------------------------------------------
// ********************************
//	RXgN^
// ********************************
CXDcdGrid::CXDcdGrid( CWndDcdGrid* pCWndDcdGrid ) 
	: m_bUpdateCWndDcdGrid( true ) 
	, m_pCWndDcdGrid( pCWndDcdGrid ) 
{
}
CXDcdGrid::~CXDcdGrid() 
{
}
// ********************************
//	CDcdGrid
// ********************************
	// --------------------------------
	//@name sEEZ̏
	// --------------------------------
void CXDcdGrid::OnCreateXColumn( int iXColumnNumber , 
		CDcdGridXColumn* pCDcdGridXColumn ) 
{
	m_pCWndDcdGrid->OnCreateXColumn( iXColumnNumber , 
		pCDcdGridXColumn ) ;
}
	
void CXDcdGrid::OnDeleteXColumn( int iXColumnNumber , 
		CDcdGridXColumn* pCDcdGridXColumn ) 
{
	m_pCWndDcdGrid->OnDeleteXColumn( iXColumnNumber , 
		pCDcdGridXColumn ) ;
}

void CXDcdGrid::OnCreateYColumn( int iYColumnNumber , 
		CDcdGridYColumn* pCDcdGridYColumn ) 
{
	m_pCWndDcdGrid->OnCreateYColumn( iYColumnNumber , 
		pCDcdGridYColumn ) ;
}

void CXDcdGrid::OnDeleteYColumn( int iYColumnNumber , 
		CDcdGridYColumn* pCDcdGridYColumn ) 
{
	m_pCWndDcdGrid->OnDeleteYColumn( iYColumnNumber , 
		pCDcdGridYColumn ) ;
}

void CXDcdGrid::OnCreateCell( 
		int iXColumnNumber , int iYColumnNumber , 
		CDcdGridCell* pCDcdGridCell ) 
{
	m_pCWndDcdGrid->OnCreateCell( 
		iXColumnNumber , iYColumnNumber , 
		pCDcdGridCell ) ;
}
	
void CXDcdGrid::OnDeleteCell( 
		int iXColumnNumber , int iYColumnNumber , 
		CDcdGridCell* pCDcdGridCell ) 
{
	m_pCWndDcdGrid->OnDeleteCell( 
		iXColumnNumber , iYColumnNumber , 
		pCDcdGridCell ) ;
}
	
	// ********************************
	//	@name YEX̐
	// ********************************
int CXDcdGrid::getYColumnCount() 
{
	return CDcdGrid::getYColumnCount() ;
};
	
CDcdGrid& CXDcdGrid::setYColumnCount( int ev ) 
{
	//LogMsg( "CWndDcdGrid::setYColumnCount()" ) ;

	CDcdGrid::setYColumnCount( ev ) ;
	m_pCWndDcdGrid->InvalidateGrid() ;

	//LogMsg( "CWndDcdGrid::setYColumnCount()=" ) ;

	return *this ;
};
	
int		CXDcdGrid::getXColumnCount() 
{
	return CDcdGrid::getXColumnCount() ;
};

CDcdGrid& CXDcdGrid::setXColumnCount( int ev ) 
{
	CDcdGrid::setXColumnCount( ev ) ;
	m_pCWndDcdGrid->InvalidateGrid() ;

	return *this ;
};

	// ********************************
	//	@name YEX}/폜
	// ********************************
int CXDcdGrid::insertYColumn( int iYColumnNumber , 
		bool bFixafterColumnNumberChange ) 
{
	int iRv = CDcdGrid::insertYColumn( iYColumnNumber ) ;
	//	tH[JXʒuEXN[ʒuEIĐݒ
	m_pCWndDcdGrid->InvalidateGrid() ;

	if ( iRv >= 0 )
	{

		//	tH[JXẐE܂͂Index̏ꏊ
		//	񂪒ǉꂽꍇ́AtH[JXZ
		//	}ɂĂꂽɒǏ]܂B
		CDcdGridCell* pCell = m_pCWndDcdGrid->getCFocus()->getFocusCell() ;
		int iFocusCellXColumnNumber = getXColumnNumberOfCell( pCell ) ; 
		int iFocusCellYColumnNumber = getYColumnNumberOfCell( pCell ) ; 
		if ( iFocusCellYColumnNumber >= iYColumnNumber )
		{
			iFocusCellYColumnNumber ++ ;
			m_pCWndDcdGrid->getCFocus()->setFocusCell( 
				getCell( iFocusCellXColumnNumber , iFocusCellYColumnNumber ) ) ;
		}
	}
	return ( iRv ) ;
};
int CXDcdGrid::insertXColumn( int iXColumnNumber ,
		bool bFixafterColumnNumberChange ) 
{
	int iRv = CDcdGrid::insertXColumn( iXColumnNumber ) ;
	//	tH[JXʒuEXN[ʒuEIĐݒ
	m_pCWndDcdGrid->InvalidateGrid() ;

	if ( iRv >= 0 )
	{
		//	tH[JXẐE܂͂Index̏ꏊ
		//	񂪒ǉꂽꍇ́AtH[JXZ
		//	}ɂĂꂽɒǏ]܂B
		CDcdGridCell* pCell = m_pCWndDcdGrid->getCFocus()->getFocusCell() ;
		int iFocusCellXColumnNumber = getXColumnNumberOfCell( pCell ) ; 
		int iFocusCellYColumnNumber = getYColumnNumberOfCell( pCell ) ; 
		if ( iFocusCellXColumnNumber >= iXColumnNumber ){
			iFocusCellXColumnNumber ++ ;
			m_pCWndDcdGrid->getCFocus()->setFocusCell( 
				getCell( iFocusCellXColumnNumber , iFocusCellYColumnNumber ) ) ;
		}
	}
	return ( iRv ) ;
};

int CXDcdGrid::eraseYColumn( int iYColumnNumber ) 
{
	int iRv = CDcdGrid::eraseYColumn( iYColumnNumber ) ;
	//	tH[JXʒuEXN[ʒuEIĐݒ
	m_pCWndDcdGrid->InvalidateGrid() ;

	if ( iRv >= 0 )
	{

		CDcdGridCell* pCell = m_pCWndDcdGrid->getCFocus()->getFocusCell() ;
		//	Z̐0ɂȂ́A̖߂lNULLɂȂ܂B

		if ( pCell != NULL )
		{
			//	tH[JXẐIndex̏ꏊ
			//	񂪍폜ꂽꍇ́AtH[JXZ
			//	폜ɂĂꂽɒǏ]܂B
			int iFocusCellXColumnNumber = getXColumnNumberOfCell( pCell ) ; 
			int iFocusCellYColumnNumber = getYColumnNumberOfCell( pCell ) ; 
			if ( iFocusCellYColumnNumber > iYColumnNumber )
			{
				iFocusCellYColumnNumber -- ;
				m_pCWndDcdGrid->getCFocus()->setFocusCell( 
					getCell( iFocusCellXColumnNumber , iFocusCellYColumnNumber ) ) ;
			}
		}
		
	}
	return ( iRv ) ;
};

int CXDcdGrid::eraseXColumn( int iXColumnNumber ) 
{
	int iRv = CDcdGrid::eraseXColumn( iXColumnNumber ) ;
	//	tH[JXʒuEXN[ʒuEIĐݒ
	m_pCWndDcdGrid->InvalidateGrid() ;

	if ( iRv >= 0 )
	{

		CDcdGridCell* pCell = m_pCWndDcdGrid->getCFocus()->getFocusCell() ;
		//	Z̐0ɂȂ́A̖߂lNULLɂȂ܂B

		if ( pCell != NULL )
		{
			//	tH[JXẐIndex̏ꏊ
			//	񂪍폜ꂽꍇ́AtH[JXZ
			//	폜ɂĂꂽɒǏ]܂B
			int iFocusCellXColumnNumber = getXColumnNumberOfCell( pCell ) ; 
			int iFocusCellYColumnNumber = getYColumnNumberOfCell( pCell ) ; 
			if ( iFocusCellXColumnNumber > iXColumnNumber )
			{
				iFocusCellXColumnNumber -- ;
				m_pCWndDcdGrid->getCFocus()->setFocusCell( 
					getCell( iFocusCellXColumnNumber , iFocusCellYColumnNumber ) ) ;
			}
		}
	}
	return ( iRv ) ;
};



	// ********************************
	//	@name	XN[
	// ********************************
int	CXDcdGrid::getXFixColumnCount() 
{
	return CDcdGrid::getXFixColumnCount() ;
}
CDcdGrid& CXDcdGrid::setXFixColumnCount( int ev ) 
{
	CDcdGrid::setXFixColumnCount( ev ) ;
	if ( m_bUpdateCWndDcdGrid )
	{
		m_pCWndDcdGrid->InvalidateGrid() ;
	}
	return *this ;
}
int	CXDcdGrid::getXFixafterColumnNumber() 
{
	return CDcdGrid::getXFixafterColumnNumber() ;
}
CDcdGrid& CXDcdGrid::setXFixafterColumnNumber( int ev ) 
{
	CDcdGrid::setXFixafterColumnNumber( ev ) ;

	//	̕ύXƂɁAEChE\̍XVs܂B
	if ( m_bUpdateCWndDcdGrid )
	{
		m_pCWndDcdGrid->update() ;
	}
	return *this ;
}
int	CXDcdGrid::getYFixColumnCount() 
{
	return CDcdGrid::getYFixColumnCount() ;
}
CDcdGrid& CXDcdGrid::setYFixColumnCount( int ev ) 
{
	CDcdGrid::setYFixColumnCount( ev ) ;
	if ( m_bUpdateCWndDcdGrid )
	{
		m_pCWndDcdGrid->InvalidateGrid() ;
	}
	return *this ;
}
int	CXDcdGrid::getYFixafterColumnNumber() 
{
	return CDcdGrid::getYFixafterColumnNumber() ;
}
CDcdGrid& CXDcdGrid::setYFixafterColumnNumber( int ev ) 
{
	CDcdGrid::setYFixafterColumnNumber( ev ) ;
	
	//	̕ύXƂɁAEChE\̍XVs܂B
	if ( m_bUpdateCWndDcdGrid )
	{
		m_pCWndDcdGrid->update() ;
	}
	return *this ;
}


bool CXDcdGrid::update_adjustProp() 
{
	bool bRv = false ;

	return bRv ;
}

bool CXDcdGrid::update_updateScreen() 
{
	bool bRv = false ;
	CDcdTargetGetDC	aCDcdTarget( m_pCWndDcdGrid->GetSafeHwnd() ) ;


	// ----------------------------------------------------------------
	//	Cxĝ߂̉z֐Ăяo
	// ----------------------------------------------------------------
	if ( getXFixafterColumnNumber() != m_CdScrollbarPropX_Sid.getPos() ) 
	{
		//	Cxĝ߂̉z֐
		m_pCWndDcdGrid->OnSetXFixafterColumnNumber( getXFixafterColumnNumber() ) ;
	}
	if ( getYFixafterColumnNumber() != m_CdScrollbarPropY_Sid.getPos() ) 
	{
		//	Cxĝ߂̉z֐
		m_pCWndDcdGrid->OnSetYFixafterColumnNumber( getYFixafterColumnNumber() ) ;
	}

	// ----------------------------------------------------------------
	//	XNCAg̈XN[
	// ----------------------------------------------------------------
	if ( !m_CdScrollbarPropX_Sid.isNull() && 
		m_CdScrollbarPropX_Sid.getPos() != 
		getXFixafterColumnNumber() )
	{
		{
			// --------------------------------
			//	XN[̈߂
			// --------------------------------
			CRect	rectScroll ;
			{
				CRect	rectClient ;
				m_pCWndDcdGrid->GetClientRect( &rectClient ) ;
				rectScroll = rectClient ;
				{
					DcdSize sizeFix = getXColumnBorderZone( 
						&aCDcdTarget , getXFixColumnCount() - 1 )
						.getEndPos() ;
					rectScroll.left = sizeFix ;
				}
			}
			//rectScroll = EChEŁAXN[s̈
			//	iŒ񕔕̈j

			// --------------------------------
			//	XN[ʂ߂
			// --------------------------------
			int iAmount = 0 ;
			CRect	rectScrollSrc ;
			{
				rectScrollSrc = rectScroll ;
				if ( m_CdScrollbarPropX_Sid.getPos() < 
						getXFixafterColumnNumber() ){
					for ( int iColumnNumber = m_CdScrollbarPropX_Sid.getPos() ;
						iColumnNumber < getXFixafterColumnNumber() ;
						iColumnNumber ++ )
					{
						iAmount -= getXColumn( iColumnNumber )->getColumnSize( &aCDcdTarget ) ;
						iAmount -= getXBorder( iColumnNumber )->getColumnBorderSize( &aCDcdTarget ) ;
					}

					rectScrollSrc.left += - iAmount ;
		
				} else if ( getXFixafterColumnNumber() < 
						m_CdScrollbarPropX_Sid.getPos() ){
					for ( int iColumnNumber = m_CdScrollbarPropX_Sid.getPos() - 1 ;
						iColumnNumber >= getXFixafterColumnNumber() ;
						iColumnNumber -- )
					{
						iAmount += getXColumn( iColumnNumber )->getColumnSize( &aCDcdTarget ) ;
						iAmount += getXBorder( iColumnNumber )->getColumnBorderSize( &aCDcdTarget ) ;
					}



					rectScrollSrc.right -= iAmount ;
				}
			}
			//iAmount = XN[(͍̐/ɃXN[)
			//rectScrollSrc = XN[ňړƂȂ̈łB
			//	rectScroll ̈悩AXN[Ŕ\ɂȂ̈̂łB
			//	A̒l left >= right ɂȂꍇAXN[ňړƂȂ
			//	̈悪SȂƂ܂B
			//	̏ꍇ́AXN[̈Ŝ𖳌
			//	ĕ`s킹܂B

			// --------------------------------
			//	ʂXN[E܂͖ɂ
			//	XV
			// --------------------------------
			if ( iAmount != 0 )
			{
				if ( rectScrollSrc.left >= rectScrollSrc.right )
				{
					m_pCWndDcdGrid->InvalidateRect( rectScroll ) ;
				}
				else
				{
					//	́AɂȂȂ̈悪܂B
					//m_pCWndDcdGrid->ScrollWindow( iAmount , 0 , &rectScrollSrc ) ;
		
					m_pCWndDcdGrid->ScrollWindow( iAmount , 0 , &rectScroll , &rectScroll ) ;
				}
				bRv = true ;
			}
		}
	}
	// ----------------------------------------------------------------
	//	XXN[o[ݒ
	// ----------------------------------------------------------------
	{
		WinUtil::CdScrollbarProp	aScrollbarPropX ;

		int iPage = 
			getXColumnNumberMaxInDcdTarget( &aCDcdTarget ) - 
			getXFixafterColumnNumber() + 1 ;

		//	XN[o\ꍇAXN[o[̃y[ẂAPƂ܂B
		//
		//	y[WAŒ񐔂菬ꍇ́A
		//	XN[o[̕\KvłB
		//	̏ꍇ̓y[W1Ƃ܂B
		if ( iPage < getXColumnCount() - 
				getXFixColumnCount() ){
			//	XN[o[Kv
			iPage = 1 ;
		}

		aScrollbarPropX.set(
			getXFixColumnCount() ,
			getXColumnCount() - 1 ,
			iPage ,
			getXFixafterColumnNumber() ) ;
		if ( !m_CdScrollbarPropX_Sid.isEqualTo( aScrollbarPropX ) )
		{
			SCROLLINFO	aScrollinfo = 
				WinUtil::CconvWinUser::SCROLLINFOof( aScrollbarPropX ) ;
			m_pCWndDcdGrid->SetScrollInfo( SB_HORZ , &aScrollinfo ) ; 
		
			m_CdScrollbarPropX_Sid = aScrollbarPropX ;
			bRv = true ;
		}

	}
	// ----------------------------------------------------------------
	//	YNCAg̈XN[
	// ----------------------------------------------------------------
	if ( !m_CdScrollbarPropY_Sid.isNull() &&
		m_CdScrollbarPropY_Sid.getPos() != 
			getYFixafterColumnNumber() )
	{

		{ 
			// --------------------------------
			//	XN[̈߂
			// --------------------------------
			CRect	rectScroll ;
			{
				CRect	rectClient ;
				m_pCWndDcdGrid->GetClientRect( &rectClient ) ;
				rectScroll = rectClient ;
				{
					DcdSize sizeFix = getYColumnBorderZone( 
						&aCDcdTarget , getYFixColumnCount() - 1 )
						.getEndPos() ;
					rectScroll.top = sizeFix ;
				}
			}
			//rectScroll = EChEŁAXN[s̈
			//	iŒ񕔕̈j
		
			// --------------------------------
			//	XN[ʂ߂
			// --------------------------------
			int iAmount = 0 ;
			CRect	rectScrollSrc ;
			{
				rectScrollSrc = rectScroll ;
				if ( m_CdScrollbarPropY_Sid.getPos() < 
						getYFixafterColumnNumber() ){
					
					for ( int iColumnNumber = m_CdScrollbarPropY_Sid.getPos() ;
						iColumnNumber < getYFixafterColumnNumber() ;
						iColumnNumber ++ )
					{
						iAmount -= getYColumn( iColumnNumber )->getColumnSize( &aCDcdTarget ) ;
						iAmount -= getYBorder( iColumnNumber )->getColumnBorderSize( &aCDcdTarget ) ;
					}
							
					rectScrollSrc.top += - iAmount ;
		
				} else if ( getYFixafterColumnNumber() < 
						m_CdScrollbarPropY_Sid.getPos() ){
					for ( int iColumnNumber = m_CdScrollbarPropY_Sid.getPos() - 1 ;
						iColumnNumber >= getYFixafterColumnNumber() ;
						iColumnNumber -- )
					{
						iAmount += getYColumn( iColumnNumber )->getColumnSize( &aCDcdTarget ) ;
						iAmount += getYBorder( iColumnNumber )->getColumnBorderSize( &aCDcdTarget ) ;
					}

					rectScrollSrc.bottom -= iAmount ;
				}
			}
			//iAmount = XN[(͍̐/ɃXN[)
			//rectScrollSrc = XN[ňړƂȂ̈łB
			//	rectScroll ̈悩AXN[Ŕ\ɂȂ̈̂łB
			//	A̒l top >= bottom ɂȂꍇAXN[ňړƂȂ
			//	̈悪SȂƂ܂B
			//	̏ꍇ́AXN[̈Ŝ𖳌
			//	ĕ`s킹܂B
		
			// --------------------------------
			//	ʂXN[E܂͖ɂ
			//	XV
			// --------------------------------
			if ( iAmount != 0 ){
				if ( rectScrollSrc.top >= rectScrollSrc.bottom ){
					m_pCWndDcdGrid->InvalidateRect( rectScroll ) ;
				}	else	{
					//	́AɂȂȂ̈悪܂
					//ScrollWindow( 0 , iAmount , &rectScrollSrc ) ;	
					
					m_pCWndDcdGrid->ScrollWindow(  0 , iAmount , &rectScroll , &rectScroll ) ;
				}
				bRv = true ;
			}
		}
	}
	// ----------------------------------------------------------------
	//	YXN[o[ݒ
	// ----------------------------------------------------------------
	{
		WinUtil::CdScrollbarProp	aScrollbarPropY ;

		int iPage = 
			getYColumnNumberMaxInDcdTarget( &aCDcdTarget ) - 
			getYFixafterColumnNumber() + 1 ;

		//	XN[o\ꍇAXN[o[̃y[ẂAPƂ܂B
		//
		//	y[WAŒ񐔂菬ꍇ́A
		//	XN[o[̕\KvłB
		//	̏ꍇ̓y[W1Ƃ܂B
		if ( iPage < getYColumnCount() - 
				getYFixColumnCount() ){
			//	XN[o[Kv
			iPage = 1 ;
		}


		aScrollbarPropY.set(
			getYFixColumnCount() ,
			getYColumnCount() - 1 ,
			iPage ,
			getYFixafterColumnNumber() ) ;
		if ( !m_CdScrollbarPropY_Sid.isEqualTo( aScrollbarPropY ) )
		{
			SCROLLINFO	aScrollinfo =
				WinUtil::CconvWinUser::SCROLLINFOof( aScrollbarPropY ) ;
			m_pCWndDcdGrid->SetScrollInfo( SB_VERT , &aScrollinfo ) ; 
		
			m_CdScrollbarPropY_Sid = aScrollbarPropY ;
			bRv = true ;
		}
	}

	return bRv ;
}

void CXDcdGrid::InvalidateGrid( 
		bool bErase ) 
{
	//	Sȍĕ`̂߁AׂĂ̑OlNA܂B
	m_CdScrollbarPropX_Sid.setNull() ;
	m_CdScrollbarPropY_Sid.setNull() ;
}

// ********************************
//@name CXDcdGrid 
// ********************************
bool CXDcdGrid::getUpdateCWndDcdGrid()const 
{
	return m_bUpdateCWndDcdGrid ;
}
void CXDcdGrid::setUpdateCWndDcdGrid( bool value ) 
{
	if ( m_bUpdateCWndDcdGrid != value )
	{
		//@ false  true ɕύXꍇ́ACWndDcdGrid ŜXV܂B
		if ( value )
		{
			m_pCWndDcdGrid->update() ;
		}

		m_bUpdateCWndDcdGrid = value ;
	}
}
	// ================================
	//@name CXDcdGrid_ZoneCacheTemp ɁAcreateZoneCacheJ
	// ================================
bool CXDcdGrid::createZoneCache( IfDcdTarget* pIfDcdTarger )
{
	LogMsg(_T("CXDcdGrid::createZoneCache()") ) ;
	return CDcdGrid::createZoneCache( pIfDcdTarger ) ;
};
void CXDcdGrid::destroyZoneCache()
{
	CDcdGrid::destroyZoneCache() ;
	LogMsg(_T("CXDcdGrid::destroyZoneCache()") ) ;
};

} //namespace WndDcdGrid3
} //namespace DcdGrid
} //namespace DcDrawLib
