/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	dir\Directries.cpp
// ****************************************************************
*/

#include "Directries.h"
#include "str\strToWstr.h"
#include "str\tstring.h"
#include "str\CdFilenameStr.h"
#include <windows.h>
#include <io.h>
#include <direct.h>
#include <tchar.h>
using namespace std ;

namespace OuLib{
using namespace Str ;
namespace Dir{

int findDir( const tstring& strSearch , 
						bool bSubdirectrySearch ,
						IfDirCallback* pIfDirCallback ) 
{
	//F
	//strSearch="c:\tiny\u*"
	//	Ō̃t@ĆAChJ[h̏ꍇ܂B

	int iRv = 0 ;

	CdFilenameStr	fnSearch( strSearch , false ) ;
	//fnSearch = pXłB
	//F"c:\tiny\u*"
	
	// 	@strSearch ̖ "." ( JgfBNg ) , ".." (efBNg) 
	//	w肷邱Ƃ͂ł܂B̏ꍇ́A -1 Ԃ܂B
	if ( fnSearch.DirCount() >= 1 )
	{
		if ( fnSearch.DirAt( fnSearch.DirCount() - 1 ) == _T(".")
			|| fnSearch.DirAt( fnSearch.DirCount() - 1 ) == _T("..") )
		{
			iRv = -1 ;	//	p[^sł\n
			//			strSearch ̖ "."  , ".." w肷邱Ƃ͂ł܂B
		}
	}


	// --------------------------------
	//	w̃fBNg
	//	fBNg
	// --------------------------------
	if ( iRv >= 0 )
	{
		tstring	tstrSearch = tstringOf( fnSearch ) ;
		WIN32_FIND_DATA	aWin32FindData ;
		HANDLE	aHandle = FindFirstFile( tstrSearch.c_str() , 
										&aWin32FindData ) ;
		if ( aHandle != INVALID_HANDLE_VALUE ){
			do{
				if ( aWin32FindData.dwFileAttributes & 
											FILE_ATTRIBUTE_DIRECTORY ){
					tstring	strName = aWin32FindData.cFileName ;
					if ( strName != TEXT( "." ) && strName != TEXT( ".." ) ){
						CdFilenameStr	fnFind( fnSearch ) ;
						fnFind.delDirLast().addDirLast( tstringOf( strName ) ) ;
						
						//fnFind=݂fBNgɁApX
						//	t^܂B
						//F"c:\tiny\ufo" 
						
						pIfDirCallback->OnNameFound( fnFind ) ;
						iRv ++ ;
					}
				}
			}	while ( FindNextFile( aHandle , &aWin32FindData ) ) ;
			FindClose( aHandle ) ;
		}
	}
	// --------------------------------
	//	TufBNg
	//	fBNg
	// --------------------------------
	if ( iRv >= 0 && bSubdirectrySearch )
	{
		CdFilenameStr	fnSearchSubdir = fnSearch ;
		fnSearchSubdir.delDirLast().addDirLast(_T("*") ) ;
		//fnSearchSubdir = TufBNg镶łB
		//F"c:\tiny\*"
		
		tstring	tstrSearchSubdir = tstringOf( fnSearchSubdir ) ;
		
		WIN32_FIND_DATA	aWin32FindData ;
		HANDLE	aHandle = FindFirstFile( tstrSearchSubdir.c_str()  
										, &aWin32FindData ) ;
		if ( aHandle != INVALID_HANDLE_VALUE ){
			do{
				if ( aWin32FindData.dwFileAttributes & 
											FILE_ATTRIBUTE_DIRECTORY ){
					tstring	strName = aWin32FindData.cFileName ;
					if ( strName != TEXT( "." ) && strName != TEXT( ".." ) ){
						CdFilenameStr	fnFind = fnSearch ;
						fnFind.addDirAt( fnFind.DirCount() - 1 , 
											tstringOf( strName ) ) ;
					
						//fnFind=݂fBNgÂPO
						//	pX
						//	t^܂B
						//F"c:\tiny\ufo\u*" 
						tstring	strFind = tstringOf( fnFind );
						
						iRv += findDir( strFind , bSubdirectrySearch , 
							pIfDirCallback ) ;
					}
				}
			}	while ( FindNextFile( aHandle , &aWin32FindData ) ) ;
			FindClose( aHandle ) ;
		}
	}

	return ( iRv ) ;
}

int findFile( const tstring& strSearch , 
						bool bSubdirectrySearch ,
						IfDirCallback* pIfDirCallback ) 
{
	//F
	//strSearch="c:\tiny\u*"
	//	Ō̃t@ĆAChJ[h̏ꍇ܂B


	int iRv = 0 ;

	CdFilenameStr	fnSearch( strSearch , true ) ;
	//fnSearch = pXłB
	//F"c:\tiny\u*"
	
	// --------------------------------
	//	w̃fBNg
	//	t@C
	// --------------------------------
	{
		tstring	tstrSearch = tstringOf( fnSearch ) ;
		WIN32_FIND_DATA	aWin32FindData ;
		HANDLE	aHandle = FindFirstFile( tstrSearch.c_str() , 
										&aWin32FindData ) ;
		if ( aHandle != INVALID_HANDLE_VALUE ){
			do{
				if ( !( aWin32FindData.dwFileAttributes & 
											FILE_ATTRIBUTE_DIRECTORY ) ){
					tstring	strName = aWin32FindData.cFileName ;

						CdFilenameStr	fnFind( fnSearch ) ;
						fnFind.setFilename( tstringOf( strName ) ) ;
						
						//fnFind=݂fBNgɁApX
						//	t^܂B
						//F"c:\tiny\ufo" 
						
						pIfDirCallback->OnNameFound( fnFind ) ;
						iRv ++ ;

				}
			}	while ( FindNextFile( aHandle , &aWin32FindData ) ) ;
			FindClose( aHandle ) ;
		}
	}
	// --------------------------------
	//	TufBNg
	//	fBNg
	// --------------------------------
	if ( bSubdirectrySearch ){
		CdFilenameStr	fnSearchSubdir( fnSearch ) ;
		fnSearchSubdir.setIsValidFilename( false ).addDirLast(_T("*") ) ;
		//fnSearchSubdir = TufBNg镶łB
		//F"c:\tiny\*"
		
		tstring	tstrSearchSubdir = tstringOf( fnSearchSubdir ) ;
		
		WIN32_FIND_DATA	aWin32FindData ;
		HANDLE	aHandle = FindFirstFile( tstrSearchSubdir.c_str()  
										, &aWin32FindData ) ;
		if ( aHandle != INVALID_HANDLE_VALUE ){
			do{
				if (  aWin32FindData.dwFileAttributes & 
											FILE_ATTRIBUTE_DIRECTORY ){
					tstring	strName = aWin32FindData.cFileName ;
					if ( strName != TEXT( "." ) && strName != TEXT( ".." ) ){

						CdFilenameStr	fnFind = fnSearch ;
						fnFind.addDirLast( tstringOf( strName ) ) ;
					
						//fnFind=݂fBNgA
						//	̂PÕpX
						//	t^܂B
						//F"c:\tiny\ufo\u*" 
						tstring	strFind = tstringOf( fnFind );

						iRv += findFile( 
							strFind , bSubdirectrySearch ,
							pIfDirCallback ) ;
					}
				}
			}	while ( FindNextFile( aHandle , &aWin32FindData ) ) ;
			FindClose( aHandle ) ;
		}
	}


	return ( iRv ) ;
}
// ****************************************************************
//@name fBNg쐬
// ****************************************************************
int mkdirs( const tstring& strDir ) 
{
	int iRv = 0 ;
	CdFilenameStr	aCdFilenameStr( strDir , false ) ;
	//fnSearch = pXłB
	//F"c:\tiny\u*"

	CdFilenameStr	aCdFilenameStrCurr = aCdFilenameStr ;
	aCdFilenameStrCurr.setDirs( CdFilenameStr::ContstrDir() ) ;

	for ( int iDirCount = 1 ; 
		iRv >= 0 && iDirCount <= aCdFilenameStr.DirCount() ;  
		iDirCount ++ )
	{
		aCdFilenameStrCurr.addDirLast( aCdFilenameStr.DirAt( iDirCount - 1 ) ) ;
		tstring strDirCurr = aCdFilenameStrCurr.FullpathFilename() ;


		struct _tfinddata_t aFinddata ;
		intptr_t fHandle = _tfindfirst(
			strDirCurr.c_str() , 
			&aFinddata ) ;
		if ( fHandle == -1 )
		{
			//	fBNg܂łB
			int iResult = _tmkdir( strDirCurr.c_str() ) ;
			if ( iResult != 0 )
			{
				iRv = -1 ;	//	fBNg̍쐬Ɏs܂B
			}
			else
			{
				iRv = 1 ;	//	fBNg̍쐬ɐ܂B
			}
			_findclose( fHandle ) ;
		}
	}

	return ( iRv ) ;
}



int rmempdir( const tstring& strDir , FILE* pErrorStream ) 
{ 
	//	ĂԂ0ȏAG[Ȃ畉̐ƂȂ܂ 
	int iRv = 0 ; 

	if ( pErrorStream != NULL )
	{
		_ftprintf( pErrorStream , _T("rmempdir(%s)\n") , strDir.c_str() ) ;
	}

	// -------------------------------- 
	//	strDir ̃TufBNg̍폜s 
	// -------------------------------- 
	if ( iRv >= 0 ) 
	{ 
	   struct _tfinddata_t c_file;
	   intptr_t hFile; 

	   // Find first .c file in current directory 
	   if( (hFile = _tfindfirst( ( strDir + _T("\\*") ).c_str() ,
		   &c_file )) == -1L ) 
	   { 
	   } 
	   else 
	   { 
		   do { 
			   if ( c_file.attrib & _A_SUBDIR ) 
			   { 
				   tstring strFound = c_file.name ; 
				   if ( strFound != _T(".") && strFound != _T("..") )
				   { 
					    int iResult = rmempdir( strDir + _T("\\") + strFound , pErrorStream ) ;
						if ( iRv >= 0 ) 
					    { 
							if ( iResult == -1 ) 
							{ 
								iRv = -3 ;	//	TufBNg̍폜Ɏs܂B 
							} 
							else 
							{ 
								iRv = iResult ; 
							} 
					    } 
				   } 
			   } 
			   else 
			   { 
				    //	ʂ̃t@C܂B 
				    //	̃fBNg͍폜ł܂B 
					if ( iRv >= 0 ) 
				    { 
						if ( pErrorStream != NULL )
						{
							_ftprintf_s( pErrorStream , _T("\t̃fBNgɂ̓t@C܂B(%s)\n") ,
								c_file.name ) ; 
						}
						iRv = -2 ;	//	̃fBNgɂ̓t@C܂B 
					} 
			   } 
		   } while(_tfindnext( hFile, &c_file ) == 0 );
		  _findclose( hFile ); 
	   } 
	} 
	// -------------------------------- 
	//	strDir ȂÃfBNg̍폜s 
	// -------------------------------- 
	if ( iRv >= 0 ) 
	{ 
		if ( _trmdir( strDir.c_str() )!= 0 ) 
		{ 
			if ( pErrorStream != NULL )
			{
				_ftprintf_s( pErrorStream , _T("\tfBNg %s ̍폜Ɏs܂B\n") ,
					strDir.c_str() ) ; 
			}
			iRv = -1 ;	//	strDir̍폜Ɏs܂B 
		} 
		else 
		{ 
				_ftprintf_s( pErrorStream , _T("\tfBNg %s 폜\n") ,
					strDir.c_str()  ) ; 
			if ( pErrorStream != NULL )
			{
			}
		} 
	} 

	if ( pErrorStream != NULL )
	{
		_ftprintf_s( pErrorStream , _T("rmempdir(%s)=%d\n") , strDir.c_str() , iRv ) ;
	}
	return ( iRv ) ; 
} 


} //namespace Dir{
} //namespace OuLib{
