/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CaMuPtref.h
//	$Id: CaMuPtref.h 69 2012-09-02 07:22:31Z okm $
// ****************************************************************
*/
/** @file */
#ifndef  Mu_CaMuPtref_h
#define  Mu_CaMuPtref_h
#include "./Mu.h"

namespace OuLib{

#ifndef NO_NSMU
namespace NsMu{
#endif//NO_NSMU

// ****************************************************************
//	CaMuPtref.h
// ****************************************************************
/**
 @brief
 yTvz
   A_v^NXłB
	|C^^vfɂReiIuWFNg𑀍ΏۂƂA
	Ώۂ "Mu< PtrType >"  C^[tF[XA
	lE܂͎Qƌ^vfƂ "Mu< ValueType > 
	C^[tF[Xɕϊ܂B
 
   ̃NX̗pŕAɈȉ̂悤ȏꍇł
 i CBase ́AReiɊi[NX̗łjB
 
   IuWFNg̃|C^i[Ă A
  Mu< CBase* > C^[tF[XT|[gRei
 ̃IuWFNgɑ삳ꍇÃIuWFNgɂ
  "Mu< CBase >" nB
 
@code
	CaCont_vector< vector< CBase* > >	aCaCont_vector_ptr ;
	CaMuPtref< CBase , CBase* > aCaMuPtref( &aCaCont_vector_ptr ) ;
	//aCaMuPtref = Mu< CBase > T|[gĂ܂B
	//	̃C^[tF[XɂAaCaCont_vector_ptr ێĂ
	//	|C^vf̎QƐ̒lQƂ邱Ƃł܂
	//	ilȂ̂ŕύX͕sjB
@endcode
 
   IuWFNg̃|C^i[Ă A
  Mu< CBase* > C^[tF[XT|[gRei
 ̃IuWFNgɑ삳ꍇÃIuWFNgɂ
  "Mu< const CBase& >" nB
 
@code
	CaCont_vector< vector< CBase* > >	aCaCont_vector_ptr ;
	CaMuPtref< const CBase& , CBase* > aCaMuPtref( &aCaCont_vector_ptr ) ;
	//aCaMuPtref = Mu< const CBase& > T|[gĂ܂B
	//	̃C^[tF[XɂAaCaCont_vector_ptr ێĂ
	//	|C^vf̃IuWFNgconstQƂ擾邱Ƃł܂B
	//	iconstȂ̂ŕύX͕sjB
@endcode
 
 @param ValueType
	ϊ̗vf̌^w肵ĂB
	̌^́Al^E͎Qƌ^w肵ĂB
	̃NX́A "Mu< DataType1 >" C^[tF[X
	T|[g܂B
 @param PtrType
	ΏۃIuWFNg m_pAdaptee i[Ăvf̌^
	w肵ĂB
	̌^́A|C^^łȂĂ͂Ȃ܂B
 */
template < class ValueType  , class PtrType > class CaMuPtref : 
	public Mu< ValueType > 
{
private:
	// ********************************
	///@name ֘A
	// ********************************
	///@{
	/**
		ΏۃIuWFNgƂȂAReiłB
		̃IuWFNg̔j̐Ӗ́ANX[U[ɂ܂B
		̃IuWFNǵAthisƂ̊֘AۂĂԂ́A
		ȂĂ͂Ȃ܂B
	 */
	Mu<PtrType>*	m_pAdaptee ;
	///@}

public:
	// ********************************
	//	RXgN^
	// ********************************
	CaMuPtref( Mu<PtrType>* pAdaptee ) : 
		m_pAdaptee( pAdaptee ){};
private:
	///	Rs[͋֎~
	CaMuPtref( const CaMuPtref& value )
	{
		assert( false ) ;
	}
	///	Rs[͋֎~
	CaMuPtref& operator=( const CaMuPtref& value )
	{
		assert( false ) ;
		return *this ;
	}
public:
	
	
public:
	// ********************************
	///@name	Mu
	// ********************************
	///@{
	/**
	 @return
	 	ReiɊi[Ăvf̌Ԃ܂B
	*/
	virtual int	size()const{	return m_pAdaptee->size() ; } ;
	
	/**
	 	ReíACfNXŎw肳ꂽꏊɊi[Ă
	 	vfԂ܂B
	 @param idx [in]
	 	On܂CfNXw肵ĂB
	 	͈͂͂Oȏ size() łB
		INT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 @return
	 	CfNXŎw肳ꂽvfԂ܂B
	*/
	virtual ValueType get( int idx )const 
	{
		ValueType	pRv = 
			static_cast<ValueType>( *( m_pAdaptee->get( idx ) ) ) ;
		return ( pRv ) ;
	};
	
	///@}
public:
	// ********************************
	///@name ֘A
	// ********************************
	///@{
	Mu<PtrType>*	getAdaptee(){	return m_pAdaptee ;};
	const Mu<PtrType>*	getAdaptee()const{	return m_pAdaptee ;};
	CaMuPtref<ValueType,PtrType>& setAdaptee( Mu<PtrType>*	value )
	{
		m_pAdaptee = value ; 	return *this ;
	};
	///@}
};

#ifndef NO_NSMU
} //namespace NsMu
#endif//NO_NSMU

} //namespace OuLib

#endif /*Mu_CaMuPtref_h*/


