/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
//$Id: CConvNodeContainer.cpp 294 2016-06-11 05:10:03Z okm $

#include "str\OuPropertiesText\CConvNodeContainer.h"
#include "str\OuPropertiesText\CDirectory.h"
#include "NsOu\dynamic_castOu.h"
#include "NsOu\OuNew.h"
#include "str\strprintf.h"
#include <tchar.h>

namespace OuLib{
namespace Str{
namespace OuPropertiesText{

using namespace std ;

/**
	񂪃fR[hł܂B
@param ERRSUBPROP_Text
	ΏۂƂȂ镶
*/
const TCHAR* const CConvNodeContainer::ERRREASON_Undecoded_Text = _T("Undecoded Text.");
/**
	fBNgrŕĂ܂B
*/
const TCHAR* const CConvNodeContainer::ERRREASON_ContainerAborted = _T("Container Aborted.") ;
/**
	fBNgĂ܂
*/
const TCHAR* const CConvNodeContainer::ERRREASON_ContainerIsNotClosed = _T("Container Is Not Closed.") ;

/**
	seLXg
*/
const TCHAR* const CConvNodeContainer::ERRPROP_Text = _T("Text") ;

	// ********************************
	//	RXgN^
	// ********************************

CConvNodeContainer::CConvNodeContainer  (void)
{
}

CConvNodeContainer::~CConvNodeContainer  (void)
{
}
	// --------------------------------
	//@name ֐
	// --------------------------------

int CConvNodeContainer::decodeNodeContainer(
		const tstring& strContent , 	int iPosBegin  , int* piPosNext , 
		CNodeContainer* pCNodeContainer ,
		tstring* pstrErrorInfoString ) 
{
	int iRv = 1 ;
	tstring strLine ;
	tstring strErrorInfoString ;
	int iPosNext = iPosBegin ;


	pCNodeContainer->erase( 0 , INT_MAX ) ;

	if ( iPosBegin >= (int)strContent.size() )
	{
		iRv = 0 ;	//	ł iPosBegin Rec̖ɂ܂B
	}
	if ( iRv >= 1 )
	{
		
		for ( ;
			iRv >= 0 && 
			1 == getLine( 
				strContent , iPosBegin , &iPosNext , 
				&strLine  ) ;
			iPosBegin = iPosNext )
		{
			if ( strLine == _T("") )
			{
				continue ;
			}
			else if ( strLine == _T("." ))
			{
				//	fBNgIL
				//	iPosNext ́A"." ̍s̑OɈڂ܂B
				iPosNext = iPosBegin ;
				break ;	//	NodeContainer ̖
			}
			bool bIsParsed = false ;
			if ( !bIsParsed )
			{
				if ( strLine.find( '=' ) == tstring::npos && 
					strLine[ strLine.size() - 1 ] == '.' )
				{
					tstring strName = strLine.substr( 0 , strLine.size() -1 ) ;

					//iPosBegin= ̍sɈړ
					iPosBegin = iPosNext ;
					OuNew<CDirectory>	pCDirectory( new CDirectory( strName ) ) ; 
					int iResult = decodeNodeContainer(
						strContent , iPosBegin , &iPosNext , 
						pCDirectory->getCNodeContainer() , 
						&strErrorInfoString ) ;
					if ( iResult == 0 )
					{
						//	fBNgĂ܂
						if ( !strErrorInfoString.empty() ){	strErrorInfoString += _T("\n") ; };
						strErrorInfoString += ERRREASON_ContainerIsNotClosed ;
						iRv = -2 ;							//	fBNgĂ܂
					}
					else if ( iResult < 0 )
					{
						//	񂪃fR[hł܂B
						if ( !strErrorInfoString.empty() ){	strErrorInfoString += _T("\n") ; };
						strErrorInfoString += strprintf(_T("%s\t%s=%s") ,
							ERRREASON_Undecoded_Text , 
							ERRPROP_Text , strLine.c_str() ) ;
						iRv = -1 ;	//	񂪃fR[hł܂B	
					}
					else
					{
						pCNodeContainer->insert( pCDirectory ) ;
						//	iPosNext = fBNgIL̎̍sɈړ
						iPosBegin = iPosNext ;
						getLine( 
							strContent , iPosBegin , &iPosNext , 
							&strLine  ) ;
					}
					bIsParsed = true ;
				}
			}
			if ( !bIsParsed )
			{
				Ou<CPropertyString>	pCPropertyString ;
				if ( 1 == CConvNodeContainer::decodePropertyString(
					strContent , iPosBegin  , &iPosNext , 
					&pCPropertyString ,
					&strErrorInfoString ) )
				{
					pCNodeContainer->insert( pCPropertyString ) ;
					bIsParsed = true ;
				}
			}
			if ( !bIsParsed )
			{
				//	񂪃fR[hł܂B
				if ( !strErrorInfoString.empty() ){	strErrorInfoString += _T("\n") ; };
				strErrorInfoString += strprintf(_T("%s\t%s=%s") ,
					ERRREASON_Undecoded_Text , 
					ERRPROP_Text , strLine.c_str() ) ;
				iRv = -1 ;	//	񂪃fR[hł܂B	
			}
		}
	}
	// --------------------------------
	if ( piPosNext != NULL )
	{
		*piPosNext = iPosNext ;
	}
	if ( pstrErrorInfoString != NULL )
	{
		*pstrErrorInfoString = strErrorInfoString ;
	}
	return iRv ;
}


tstring CConvNodeContainer::encodePropertyString_escapePropertyValue(
		const tstring& strValue ) 
{
	tstring strRv ;
	strRv.reserve( strRv.length() ) ;
	for ( tstring::const_iterator ite = strValue.begin() ;
		ite != strValue.end() ;
		ite ++ )
	{
		if ( *ite == '.' )
		{
			//	'.' ̓GXP[v̑Ώۂ͂܂B
			strRv += _T(".") ;
		}
		else if ( *ite == '\n' )
		{
			strRv += _T("\\n") ;
		}
		else if ( *ite == '\\' )
		{
			strRv += _T("\\\\") ;
		}
		else
		{
			strRv += *ite ;
		}

	}
	return strRv ;
}

tstring CConvNodeContainer::decodePropertyString_unescapePropertyValue(
		const tstring& strValue ) 
{
	tstring strRv ;
	strRv.reserve( strRv.length() ) ;
	for ( tstring::const_iterator ite = strValue.begin() ;
		ite != strValue.end() ;
		ite ++ )
	{
		if ( ite + 1 != strValue.end() && *ite == '\\' )
		{
			ite ++ ;
			if ( *ite == '.' )
			{
				//	'.' ̓GXP[v̑Ώۂ͂܂B
				strRv += '\\' ;
				strRv += '.' ;
			}
			else if ( *ite == 'n' ) 
			{
				strRv += '\n' ;
			}
			else if ( *ite == '\\' )
			{
				strRv += '\\' ;
			}
			else
			{
				strRv += '\\' ;
				strRv += *ite ;
			}
		}
		else
		{
			strRv += *ite ;
		}

	}
	return strRv ;
}


int CConvNodeContainer::decodePropertyString(
		const tstring& strContent , 	int iPosBegin  , int* piPosNext , 
		Ou<CPropertyString>* ppCPropertyString ,
		tstring* pstrErrorInfoString ) 
{
	int iRv = 1 ;
	tstring strLine ;
	tstring strErrorInfoString ;
	int iPosNext = iPosBegin ;
	Ou<CPropertyString> pCPropertyString ;

		if ( 1 == getLine( 
			strContent , iPosBegin , &iPosNext , 
			&strLine  ) )
		{
			tstring	strName ;
			tstring	strValue ;
			tstring::size_type	pos = strLine.find( '=' ) ;
			if ( pos == tstring::npos )
			{
				strName = strLine ;
			}
			else
			{
				strName = strLine.substr( 0 , pos ) ;
				strValue = decodePropertyString_unescapePropertyValue( strLine.substr( pos + 1 ) ) ;
			}
			pCPropertyString = OuNew<CPropertyString>( new CPropertyString( strName , strValue  ) ) ;
		}
		else
		{
			iRv = 0 ;	//	ł iPosBegin Rec̖ɂ܂B
		}
	// --------------------------------
	if ( piPosNext != NULL )
	{
		*piPosNext = iPosNext ;
	}
	if ( ppCPropertyString != NULL )
	{
		*ppCPropertyString = pCPropertyString ;
	}
	if ( pstrErrorInfoString != NULL )
	{
		*pstrErrorInfoString = strErrorInfoString ;
	}
	return iRv ;
}


int CConvNodeContainer::getLine( 
		const tstring& strContent , 	int iPosBegin  , int* piPosNext , 
		tstring* pstrLine  ) 
{
	int iRv = 1 ;
	tstring strLine ;
	int iPosNext = iPosBegin ;

	if ( iPosBegin >= (int)strContent.size() )
	{
		iRv = 0 ;	//	ł iPosBegin Rec̖ɂ܂B
	}
	if ( iRv >= 1 )
	{

		for ( iPosNext = iPosBegin ; 
			iPosNext < (int)strContent.size() && strContent[iPosNext] != '\n' ; 
			iPosNext ++ )
		{
		}
		strLine = strContent.substr( iPosBegin , iPosNext - iPosBegin ) ;
		if ( strContent[iPosNext] == '\n' )
		{
			iPosNext ++ ;
		}
	}
	// --------------------------------
	if ( piPosNext != NULL )
	{
		*piPosNext = iPosNext ;
	}
	if ( pstrLine != NULL )
	{
		*pstrLine = strLine ;
	}
	return iRv ;
}

	// ********************************
	//@name	CConvNodeContainer  
	// ********************************

tstring CConvNodeContainer::encode( 
		const IfNodeContainerConst* pCNodeContainer ) 
{
	int iRv = 0 ;
	tstring strContent ;

	if ( iRv >= 0 )
	{
		for ( int iIndex = 0 ; iIndex < pCNodeContainer->size() ; iIndex ++ )
		{
			bool bProcessed = false ;
			tstring	strContentLine ;
			Ou<const CNode>	pCNode = pCNodeContainer->get( iIndex ) ;
			if ( !bProcessed )
			{
				Ou<const CPropertyString> pCPropertyString ;
				if ( ( pCPropertyString = dynamic_castOu<const CPropertyString>( pCNode ) ) != NULL )
				{
					strContentLine = pCPropertyString->getName() + _T("=") +
						encodePropertyString_escapePropertyValue( pCPropertyString->getValue() ) ; 
					bProcessed = true ;
				}
			}
			if ( !bProcessed )
			{
				Ou<const CDirectory> pCDirectory ;
				if ( ( pCDirectory = dynamic_castOu<const CDirectory>( pCNode ) ) != NULL )
				{
					tstring strNodeContainer = encode( pCDirectory->getIfNodeContainerConst() ) ;
					strContentLine = pCDirectory->getName() + _T(".\n") +
						strNodeContainer + 
						_T(".") ;
					bProcessed = true ;
				}
			}
			strContent += ( strContentLine + _T("\n") ) ;
		}
	}
	return strContent ;
}


int CConvNodeContainer::decode(
		const tstring& strContent , 
		CNodeContainer* pCNodeContainer ,
		tstring* pstrErrorInfoString ) 
{
	int iRv = 0 ;
	tstring strErrorInfoString ;
	if ( iRv >= 0 )
	{
		int iPosNext = 0 ; 
		int iResult = decodeNodeContainer(
				strContent , 0  , &iPosNext , 
				pCNodeContainer ,
				pstrErrorInfoString ) ;
		if ( iResult > 0 )
		{
			if ( iPosNext < (int)strContent.size() )
			{
				//	fBNgrŕĂ܂B
				if ( !strErrorInfoString.empty() ){	strErrorInfoString += _T("\n") ; };
				strErrorInfoString = ERRREASON_ContainerAborted ;
				iRv = -1 ;	//	fBNgrŕĂ܂B
			}
		}
	}
	// --------------------------------
	if ( pstrErrorInfoString != NULL )
	{
		*pstrErrorInfoString = strErrorInfoString ;
	}
	return iRv ;
}



} //namespace OuPropertiesText{
} //namespace Str{
} //namespace OuLib{
