/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// CWndSplitBarV.cpp : Cve[V t@C
//

#include "CWndSplitBarV.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace OuMfc{
namespace FrameLeftPane{

/////////////////////////////////////////////////////////////////////////////
// CWndSplitBarV

// ********************************
//@param	\z
// ********************************
BOOL CWndSplitBarV::Create( CWnd* pParentWnd, 
			CWnd* pwndLeftPane ,
			UINT nID)
{
	BOOL	bRv = TRUE ;

	m_pwndLeftPane = pwndLeftPane ;
	
	CRect	aCRect( 0 , 0 , 
		GetSystemMetrics( SM_CXEDGE ) * 2 , 
		GetSystemMetrics( SM_CYEDGE ) * 2 ) ;

	CString	strClassName = AfxRegisterWndClass( 0 , 
		LoadCursor( NULL , IDC_SIZEWE ) , 
		NULL , NULL ) ;
	
	bRv = CWnd::Create( strClassName , _T("CWndSplitBarV"), 
		WS_CHILD | WS_VISIBLE , 
		aCRect, pParentWnd, nID, NULL);

	return ( bRv ) ;
}
//SM_CXEDGE,
//SM_CYEDGE ̌ʕt̃EBhE̋E̕ƍ擾܂BSM_CXBORDER  SM_CYBORDER  3D łłB 

// ********************************
//@param	
// ********************************

void CWndSplitBarV::CMDIFrameWnd_RecalcLayout(
		CMDIFrameWnd* pCMDIFrameWnd ,
		CWnd* pwndLeftPane ,
		CWndSplitBarV* pCWndSplitBarV ,
		BOOL bNotify ) 

{
	CWnd*	wndMDIClient = pCMDIFrameWnd->GetDlgItem( AFX_IDW_PANE_FIRST ) ;
	//wndMDIClient=MDIClient ̃IuWFNg

	// --------------------------------
	//	̑sԂ́A
	//	MDIClient EChE\
	//	ȂĂȂȂ܂B
	//	Ał MDIClient 
	//	\łꍇ́ȀԂ
	//	ύX܂iPrintPreview
	//	\ĂꍇAɂ܂j
	// --------------------------------
	bool	bMDIClientMustShow = false ;
	if ( wndMDIClient != NULL ){
		if ( wndMDIClient->IsWindowVisible() ){
			wndMDIClient->ShowWindow( SW_HIDE ) ;

			bMDIClientMustShow = true ;
		}
	}
	
	// --------------------------------
	//	{NX̎ŁA
	//	MDIClient EChEzu
	// --------------------------------
	pCMDIFrameWnd->CMDIFrameWnd::RecalcLayout(bNotify);

	// --------------------------------
	if ( pwndLeftPane->GetSafeHwnd() == NULL ||
		pCWndSplitBarV->GetSafeHwnd() == NULL ){

		// --------------------------------
		//	̑sԂ́A
		//	MDIClient EChE\
		//	ȂĂȂȂ܂B
		// --------------------------------
		if ( bMDIClientMustShow ){
			wndMDIClient->ShowWindow( SW_SHOW ) ;
		}
		return ;
	}


	//	̎_ł́AMDIClient ̈ʒuƃTCÝA
	//	yCƁAXvbgo[ȂԂ
	//	̂ɂȂĂ܂B

	// --------------------------------
	//	eEChĚ݂̈ʒu擾
	// --------------------------------
	CRect	rectMDIClient ;
	{
		WINDOWPLACEMENT aWINDOWPLACEMENT ;
		aWINDOWPLACEMENT.length = sizeof(aWINDOWPLACEMENT) ;
		wndMDIClient->GetWindowPlacement( &aWINDOWPLACEMENT ) ;
		rectMDIClient = aWINDOWPLACEMENT.rcNormalPosition ;
	}
	CRect	rectLeftpane ;
	{
		WINDOWPLACEMENT aWINDOWPLACEMENT ;
		aWINDOWPLACEMENT.length = sizeof(aWINDOWPLACEMENT) ;
		pwndLeftPane->GetWindowPlacement( &aWINDOWPLACEMENT ) ;
		rectLeftpane = aWINDOWPLACEMENT.rcNormalPosition ;
	}
	CRect	rectSplitBarV ;
	{
		WINDOWPLACEMENT aWINDOWPLACEMENT ;
		aWINDOWPLACEMENT.length = sizeof(aWINDOWPLACEMENT) ;
		pCWndSplitBarV->GetWindowPlacement( &aWINDOWPLACEMENT ) ;
		rectSplitBarV = aWINDOWPLACEMENT.rcNormalPosition ;
	}
	//rectMDIClient=MDIClient ̈ʒuƃTCY
	//	(yCƁAXvbgo[Ȃ)
	//rectLeftpane = LeftPaně݂̈ʒu
	//rectSplitBarV = SplitBarV݂̌̈ʒu



	// --------------------------------
	//	eEChE̐VʒuZ
	// --------------------------------
	CRect	rectLeftpaneNew ;
	{
		rectLeftpaneNew = rectLeftpane  ;
		rectLeftpaneNew.left = rectMDIClient.left ;
		rectLeftpaneNew.right = rectLeftpaneNew.left + rectLeftpane.Width() ;
		if ( rectLeftpaneNew.right >= rectMDIClient.right - rectSplitBarV.Width() ){
			rectLeftpaneNew.right = rectMDIClient.right - rectSplitBarV.Width() ;
		}
		rectLeftpaneNew.top = rectMDIClient.top ;
		rectLeftpaneNew.bottom = rectMDIClient.bottom ;
	}
	CRect	rectSplitBarVNew ;
	{
		rectSplitBarVNew = rectSplitBarV ;
		rectSplitBarVNew.left = rectLeftpaneNew.right ;
		rectSplitBarVNew.right = rectSplitBarVNew.left + rectSplitBarV.Width() ;
		rectSplitBarVNew.top = rectMDIClient.top ;
		rectSplitBarVNew.bottom = rectMDIClient.bottom ;
	}
	CRect	rectMDIClientNew  ;
	{
		rectMDIClientNew = rectMDIClient  ;
		rectMDIClientNew.left = rectSplitBarVNew.right  ;
		if ( rectMDIClientNew.right < rectMDIClientNew.left ){
			rectMDIClientNew.right = rectMDIClientNew.left ; 
		}
		

	}
	//rectLeftpaneNew=yC ̈ʒuƃTCY
	//rectSplitBarVNew=Xvbgo[̈ʒuƃTCY
	//rectMDIClientNew=MDIClient ̈ʒuƃTCY
	//	(yCƁAXvbgo[̗̈mۂTCY)

	// --------------------------------
	//	eEChE̐Vʒuݒ
	// --------------------------------
	pwndLeftPane->SetWindowPos( NULL , 
		rectLeftpaneNew.left , 
		rectLeftpaneNew.top , 
		rectLeftpaneNew.Width() , 
		rectLeftpaneNew.Height() , 
		SWP_NOZORDER ) ;   
	pCWndSplitBarV->SetWindowPos( NULL , 
		rectSplitBarVNew.left , 
		rectSplitBarVNew.top , 
		rectSplitBarVNew.Width() , 
		rectSplitBarVNew.Height() , 
		SWP_NOZORDER ) ;   
	wndMDIClient->SetWindowPos( NULL , 
		rectMDIClientNew.left , 
		rectMDIClientNew.top , 
		rectMDIClientNew.Width() , 
		rectMDIClientNew.Height() , 
		SWP_NOZORDER ) ;   

	// --------------------------------
	//	̑sԂ́A
	//	MDIClient EChE\
	//	ȂĂȂȂ܂B
	// --------------------------------
	if ( bMDIClientMustShow ){
		wndMDIClient->ShowWindow( SW_SHOW ) ;
	}
}

// ----------------------------------------------------------------
//	MFC
// ----------------------------------------------------------------
CWndSplitBarV::CWndSplitBarV() :
	m_pwndLeftPane( NULL ) , m_iDragPosX( -1 ) 
{
}

CWndSplitBarV::~CWndSplitBarV()
{
}


BEGIN_MESSAGE_MAP(CWndSplitBarV, CWnd)
	//{{AFX_MSG_MAP(CWndSplitBarV)
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CWndSplitBarV bZ[W nh

void CWndSplitBarV::OnPaint() 
{
	CPaintDC dc(this); // `p̃foCX ReLXg
	
	CRect	rectClient ;
	GetClientRect( &rectClient ) ;
	// `pbZ[WƂ CWnd::OnPaint() ĂяoĂ͂܂

	{
		CRect	rectFill = rectClient ;
		rectClient.right = rectClient.left + 1 ;
		FillRect(  dc.GetSafeHdc() , &rectFill , GetSysColorBrush( COLOR_3DLIGHT ) ) ;
	}
	{
		CRect	rectFill = rectClient ;
		rectClient.left  = rectClient.left + 1 ;
		rectClient.right = rectClient.right - 1 ;
		FillRect(  dc.GetSafeHdc() , &rectFill , GetSysColorBrush( COLOR_3DFACE ) ) ;
	}

	{
		CRect	rectFill = rectClient ;
		rectClient.left  = rectClient.right - 1 ;
		FillRect(  dc.GetSafeHdc() , &rectFill , GetSysColorBrush( COLOR_3DSHADOW ) ) ;
	}

//COLOR_3DDKSHADOW 3D IuWFNg̈Âe̐FB 
//COLOR_3DFACE, COLOR_BTNFACE 3D IuWFNg̕\ʐFƁA_CAO{bNX̔wiFB 
//COLOR_3DHILIGHT, COLOR_3DHIGHLIGHT, COLOR_BTNHILIGHT, COLOR_BTNHIGHLIGHT 3D IuWFNg̍ł邢FiɖʂӁjB 
//COLOR_3DLIGHT 3D IuWFNg̖邢FiɖʂӁjB 
//COLOR_3DSHADOW, COLOR_BTNSHADOW 3D IuWFNg̉e̐FiɖʂĂȂӁjB 



}


void CWndSplitBarV::OnLButtonDown(UINT nFlags, CPoint point) 
{
	m_iDragPosX = point.x ;
	SetCapture() ;
	
	//CWnd::OnLButtonDown(nFlags, point);
}

void CWndSplitBarV::OnLButtonUp(UINT nFlags, CPoint point) 
{
	ReleaseCapture() ;
	m_iDragPosX = -1 ;
	
	//CWnd::OnLButtonUp(nFlags, point);
}

void CWndSplitBarV::OnMouseMove(UINT nFlags, CPoint point) 
{
	//CWnd::OnMouseMove(nFlags, point);


	if ( ( nFlags & MK_LBUTTON ) != MK_LBUTTON ){
		if ( m_iDragPosX != -1 ){
			ReleaseCapture() ;
			m_iDragPosX = -1 ;
		}
	} 
	if ( m_iDragPosX == -1 ){
		return ;
	}
	// --------------------------------
	//	eEChĚ݂̈ʒu擾
	// --------------------------------
	CWnd*	wndMDIClient = GetParent()-> GetDlgItem( AFX_IDW_PANE_FIRST ) ;

	CRect	rectMDIClient ;
	{
		WINDOWPLACEMENT aWINDOWPLACEMENT ;
		aWINDOWPLACEMENT.length = sizeof(aWINDOWPLACEMENT) ;
		wndMDIClient->GetWindowPlacement( &aWINDOWPLACEMENT ) ;
		rectMDIClient = aWINDOWPLACEMENT.rcNormalPosition ;
	}
	CRect	rectLeftpane ;
	{
		WINDOWPLACEMENT aWINDOWPLACEMENT ;
		aWINDOWPLACEMENT.length = sizeof(aWINDOWPLACEMENT) ;
		m_pwndLeftPane->GetWindowPlacement( &aWINDOWPLACEMENT ) ;
		rectLeftpane = aWINDOWPLACEMENT.rcNormalPosition ;
	}
	CRect	rectSplitBarV ;
	{
		WINDOWPLACEMENT aWINDOWPLACEMENT ;
		aWINDOWPLACEMENT.length = sizeof(aWINDOWPLACEMENT) ;
		GetWindowPlacement( &aWINDOWPLACEMENT ) ;
		rectSplitBarV = aWINDOWPLACEMENT.rcNormalPosition ;
	}
	//rectMDIClient=MDIClient ̈ʒuƃTCY
	//	(yCƁAXvbgo[Ȃ)
	//rectLeftpane = LeftPaně݂̈ʒu
	//rectSplitBarV = SplitBarV݂̌̈ʒu

	// --------------------------------
	//	eEChE̐VʒuZ
	// --------------------------------
	CRect	rectSplitBarVNew ;
	{
		rectSplitBarVNew = rectSplitBarV ;
		rectSplitBarVNew.left = rectSplitBarV.left + ( point.x - m_iDragPosX ) ;
		if ( rectSplitBarVNew.left < rectLeftpane.left ){
			rectSplitBarVNew.left = rectLeftpane.left ;
		}
		if ( rectSplitBarVNew.left > rectMDIClient.right - rectSplitBarV.Width() ){
			rectSplitBarVNew.left = rectMDIClient.right - rectSplitBarV.Width() ;
		}
		rectSplitBarVNew.right = rectSplitBarVNew.left + rectSplitBarV.Width() ;
	}
	CRect	rectLeftpaneNew ;
	{
		rectLeftpaneNew = rectLeftpane  ;
		rectLeftpaneNew.right = rectSplitBarVNew.left ;
	}
	CRect	rectMDIClientNew  ;
	{
		rectMDIClientNew = rectMDIClient  ;
		rectMDIClientNew.left = rectSplitBarVNew.right  ;
	}
	// --------------------------------
	//	eEChE̐Vʒuݒ
	// --------------------------------
	m_pwndLeftPane->SetWindowPos( NULL , 
		rectLeftpaneNew.left , 
		rectLeftpaneNew.top , 
		rectLeftpaneNew.Width() , 
		rectLeftpaneNew.Height() , 
		SWP_NOZORDER ) ;   
	SetWindowPos( NULL , 
		rectSplitBarVNew.left , 
		rectSplitBarVNew.top , 
		rectSplitBarVNew.Width() , 
		rectSplitBarVNew.Height() , 
		SWP_NOZORDER ) ;   
	wndMDIClient->SetWindowPos( NULL , 
		rectMDIClientNew.left , 
		rectMDIClientNew.top , 
		rectMDIClientNew.Width() , 
		rectMDIClientNew.Height() , 
		SWP_NOZORDER ) ;   



	
}

} //namespace FrameLeftPane
} //namespace OuMfc
